/**
 * @author      ETSI / STF462 / Alexandre Berge
 * @version     $URL: https://forge.etsi.org/svn/ITS/branches/STF462/javasrc/codec/org/etsi/ttcn/codec/its/btp/BtpHeader.java $
 *              $Id: BtpHeader.java 1133 2013-08-09 09:26:40Z berge $
 */
package org.etsi.ttcn.codec.its.btp;

import org.etsi.ttcn.codec.CodecBuffer;
import org.etsi.ttcn.codec.MainCodec;
import org.etsi.ttcn.codec.generic.Union;
import org.etsi.ttcn.tci.Type;

public class BtpHeader extends Union {

    public BtpHeader(MainCodec mainCodec) {
        super(mainCodec);
    }

    @Override
    protected void preDecode(CodecBuffer buf, Type decodingHypothesis) {

        String nhHint = mainCodec.getHint("GnNextHeader");
        String variant = "btpAHeader";

        if(nhHint != null) {
            int nh = Integer.parseInt(nhHint);
            switch(nh) {
            case 1:
                variant = "btpAHeader";
                break;
            case 2:
                variant = "btpBHeader";
                break;
            default:
                variant = "btpAHeader";
            }
        }
        mainCodec.setHint(decodingHypothesis.getName(), variant);
    }
}
