/**
 * @author      ETSI / STF462 / Alexandre Berge
 * @version     $URL: https://forge.etsi.org/svn/ITS/branches/STF462/javasrc/codec/org/etsi/ttcn/codec/its/geonetworking/BasicHeader.java $
 *              $Id: BasicHeader.java 1133 2013-08-09 09:26:40Z berge $
 */
package org.etsi.ttcn.codec.its.geonetworking;

import org.etsi.ttcn.codec.generic.Record;
import org.etsi.ttcn.codec.MainCodec;
import org.etsi.ttcn.codec.CodecBuffer;

import org.etsi.ttcn.tci.EnumeratedValue;
import org.etsi.ttcn.tci.RecordValue;
import org.etsi.ttcn.tci.Type;

public class BasicHeader extends Record {

    public BasicHeader(MainCodec mainCodec) {
        super(mainCodec);
    }

    @Override
    protected void postDecodeField(String fieldName, CodecBuffer buf, Type decodingHypothesis, RecordValue rv) {

        if(fieldName.equals("nextHeader")) {
            int nh = ((EnumeratedValue)(rv.getField(fieldName))).getInt();
            mainCodec.setHint("GnNextHeader", Integer.toString(nh));
        }
    }
}
