package org.etsi.its.configtester;

/**
 * This interface provides mandatory methods to support communication between the ETSI Test System and the configuration tester
 */
public interface IConfigTester {
    
    /**
     * Initialises resources Upper Tester component as communication resources
     * 
     * @param settings Communication settings
     * @return true on success, false otherwise
     */
    public boolean initialize(final String settings);
    
    /**
     * Uninitialises resources Upper Tester component as communication resources
     * @return true on success, false otherwise
     */
    public boolean uninitialize();
    
} // End of interface IConfigTester 
