/* Do not modify this file. Changes will be overwritten.                      */
/* Generated automatically by the ASN.1 to Wireshark dissector compiler       */
/* packet-iicp.c                                                              */
/* ../../tools/asn2wrs.py -u -p iicp -c ./iicp.cnf -s ./packet-iicp-template -D . -O ../../epan/dissectors CALMipv6.asn CALMmanagement.asn CALMllsap.asn CALMmsap.asn CALMfntp.asn CALMfsap.asn CALMlegacySupport.asn CITSapplMgmtApplReg.asn CITSapplMgmtComm.asn CITSapplMgmtIDs.asn CITSapplReq.asn TransportAddressMib.asn ProtocolManagementInformation.asn CALMiitsscu.asn */

/* Input file: packet-iicp-template.c */

#line 1 "../../asn1/calm-iicp/packet-iicp-template.c"
 /* packet-iicp.c
 * Routines for IICP packet dissection
 *
 *
 * Wireshark - Network traffic analyzer
 * By Gerald Combs <gerald@wireshark.org>
 * Copyright 1998 Gerald Combs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <glib.h>
#include <epan/packet.h>
#include <epan/asn1.h>
#include <epan/dissectors/packet-per.h>
#include <epan/prefs.h>

#include <stdio.h>
#include <string.h>

#include "packet-iicp.h"

#ifdef _MSC_VER
/* disable: "warning C4146: unary minus operator applied to unsigned type, result still unsigned" */
#pragma warning(disable:4146)
#endif

#define PNAME             "IICP Protocol (ISO 24102-4)"
#define PSNAME            "IICP (ISO 24102-4)"
#define PFNAME            "iicp"
#define IICP_PORT         1200    /* UDP port */
#define IICPP_PROTOCOL_ID 66


/*--- Included file: packet-iicp-val.h ---*/
#line 1 "../../asn1/calm-iicp/packet-iicp-val.h"
#define noFNTPfwtEntries               65535
#define noNonipServices                255
#define noChannels                     255
#define noIpServices                   255
#define noNonipContexts                255
#define noIpContexts                   255
#define noServiceDataOctets            65535
#define noIpServiceDataOctets          65535
#define noContextDataOctets            65535
#define noIpContextDataOctets          65535
#define versionNoFSAP                  0
#define oidISO                         "1.0"
#define oidETSI                        "0.4.0"
#define oidIEEE                        "1.3.3"
#define oidCEN                         "1.3.162"

typedef enum _RefINSAPDOWN_enum {
  iicp_inUnitdataRq =   0,
  iicp_inDataAckRq =   1,
  iicp_inReplyAckRq =   2,
  iicp_inReplyUpdateRq =   3
} RefINSAPDOWN_enum;

typedef enum _RefACCPARAMS_enum {
  iicp_nullAP  =   0
} RefACCPARAMS_enum;

typedef enum _RefINSAPUP_enum {
  iicp_inUnitdataInd =   0,
  iicp_inUnitdataStatusInd =   1,
  iicp_inDataAckInd =   2,
  iicp_inDataAckStatusInd =   3,
  iicp_inReplyInd =   4,
  iicp_inReplyStatusInd =   5,
  iicp_inReplyUpdateStatusInd =   6
} RefINSAPUP_enum;

typedef enum _RefCOMMDOWN_enum {
  iicp_gCsamctxConfFA =   2,
  iicp_gCregServerFA =   3,
  iicp_gCupdateServerFA =   4,
  iicp_gCderegServerFA =   5,
  iicp_gCregClientFA =   6,
  iicp_gCupdateClientFA =   7,
  iicp_gCderegClientFA =   8
} RefCOMMDOWN_enum;

typedef enum _RefCOMMUP_enum {
  iicp_gCsamctxFA =   2,
  iicp_gCregServerConfFA =   3,
  iicp_gCupdateServerConfFA =   4,
  iicp_gCderegServerConfFA =   5,
  iicp_gCregClientConfFA =   6,
  iicp_gCupdateClientConfFA =   7,
  iicp_gCderegClientConfFA =   8,
  iicp_gCsamFA =   9,
  iicp_gCctxFA =  10
} RefCOMMUP_enum;

typedef enum _RefMFCMDREQ_enum {
  iicp_simFUTcmd =   0,
  iicp_simFLTcmd =   1,
  iicp_gCsamctx =   2,
  iicp_gCsam   =   3,
  iicp_gCctx   =   4,
  iicp_lDMnotifyCmd =   5,
  iicp_legacyCICmd =   6,
  iicp_stateCInotify =   7,
  iicp_gCperiodCmd =   8,
  iicp_gCctxTxCmd =   9,
  iicp_gCdeleteCmd =  10,
  iicp_iICrequestTX =  11,
  iicp_iICresponseTX =  12,
  iicp_testMF  = 255
} RefMFCMDREQ_enum;

typedef enum _RefNFSAPUP_enum {
  iicp_fntpPortConfirm =   0,
  iicp_fntpCommConfirm =   1,
  iicp_fntpCommIndication =   2
} RefNFSAPUP_enum;

typedef enum _RefMFCMDCONF_enum {
  iicp_simFUTcmdConf =   0,
  iicp_simFLTcmdConf =   1,
  iicp_gCsamctxConf =   2,
  iicp_gCsamConf =   3,
  iicp_gCctxConf =   4,
  iicp_lDMnotifyConf =   5,
  iicp_legacyCIConf =   6,
  iicp_stateCInotifyConf =   7,
  iicp_gCperiodCmdConf =   8,
  iicp_gCctxTxCmdConf =   9,
  iicp_gCdeleteCmdConf =  10,
  iicp_iICrequestTXConf =  11,
  iicp_iICresponseTXConf =  12,
  iicp_testMFConf = 255
} RefMFCMDCONF_enum;

typedef enum _RefMFREQREQ_enum {
  iicp_simFUTreq =   0,
  iicp_simFLTreq =   1,
  iicp_iTS_S_Appl_Reg =   2,
  iicp_gCregServer =   3,
  iicp_gCupdateServer =   4,
  iicp_gCderegServer =   5,
  iicp_gCregClient =   6,
  iicp_gCupdateClient =   7,
  iicp_gCderegClient =   8,
  iicp_lDMregister =   9,
  iicp_sAMrxNot =  10,
  iicp_cTXrxNot =  11,
  iicp_iICrequestRX =  12,
  iicp_iICresponseRX =  13,
  iicp_iTS_S_Appl_ReqFinal =  14,
  iicp_testMFecho = 255
} RefMFREQREQ_enum;

typedef enum _RefNFSAPDOWN_enum {
  iicp_fntpPortRequest =   0,
  iicp_fntpCommRequest =   1
} RefNFSAPDOWN_enum;

typedef enum _RefMFREQCONF_enum {
  iicp_simFUTreqConf =   0,
  iicp_simFLTreqConf =   1,
  iicp_iTS_S_Appl_RegConf =   2,
  iicp_gCregServerConf =   3,
  iicp_gCupdateServerConf =   4,
  iicp_gCderegServerConf =   5,
  iicp_gCregClientConf =   6,
  iicp_gCupdateClientConf =   7,
  iicp_gCderegClientConf =   8,
  iicp_lDMregisterConf =   9,
  iicp_sAMrxNotConf =  10,
  iicp_cTXrxNotConf =  11,
  iicp_iICrequestRXConf =  12,
  iicp_iICresponseRXConf =  13,
  iicp_iTS_S_Appl_ReqFinalConf =  14,
  iicp_testMFechoConf = 255
} RefMFREQCONF_enum;

typedef enum _RefMNCMDREQ_enum {
  iicp_simNUTcmd =   0,
  iicp_simNLTcmd =   1,
  iicp_fWTset  =   2,
  iicp_fWTupdate =   3,
  iicp_fWTdelete =   4,
  iicp_testMN  = 255
} RefMNCMDREQ_enum;

typedef enum _RefFWT_enum {
  iicp_fntpSet =   0,
  iicp_fntpUpdate =   1,
  iicp_fntpDelete =   2
} RefFWT_enum;

typedef enum _RefMNCMDCONF_enum {
  iicp_simNUTcmdConf =   0,
  iicp_simNLTcmdConf =   1,
  iicp_fWTsetConf =   2,
  iicp_fWTupdateConf =   3,
  iicp_fWTdeletConf =   4,
  iicp_testMNConf = 255
} RefMNCMDCONF_enum;

typedef enum _RefMNREQREQ_enum {
  iicp_simNUTreq =   0,
  iicp_simNLTreq =   1,
  iicp_fWTsetNot =   2,
  iicp_fWTupdateNot =   3,
  iicp_fWTdeleteNot =   4,
  iicp_vCIcreatePeerMAC =   5,
  iicp_its_ssiPeerNot =   6,
  iicp_testMNecho = 255
} RefMNREQREQ_enum;

typedef enum _RefFWTNOT_enum {
  iicp_fntpSetNot =   0,
  iicp_fntpUpdateNot =   1,
  iicp_fntpDeleteNot =   2
} RefFWTNOT_enum;

typedef enum _RefMNREQCONF_enum {
  iicp_simNUTreqConf =   0,
  iicp_simNLTreqConf =   1,
  iicp_fWTsetNotConf =   2,
  iicp_fWTupdateNotConf =   3,
  iicp_fWTdeleteNotConf =   4,
  iicp_vCIcreatePeerMACConf =   5,
  iicp_its_ssiPeerNotConf =   6,
  iicp_testMNechoConf = 255
} RefMNREQCONF_enum;

typedef enum _RefIICP_enum {
  iicp_Request =   0,
  iicp_Response =   1
} RefIICP_enum;

typedef enum _RefIICPReq_enum {
  iicp_aliveRq =   0,
  iicp_mfRcmdRq =   1,
  iicp_mfRreqRq =   2,
  iicp_mnRcmdRq =   3,
  iicp_mnRreqRq =   4,
  iicp_miRcmdRq =   5,
  iicp_miRreqRq =   6,
  iicp_miRgetRq =   7,
  iicp_miRsetRq =   8,
  iicp_mCmdRq  =   9,
  iicp_simFutCmdRq = 244,
  iicp_simFutReqRq = 245,
  iicp_simNutCmdRq = 246,
  iicp_simNutReqRq = 247,
  iicp_simIutCmdRq = 248,
  iicp_simIutReqRq = 249,
  iicp_simFltCmdRq = 252,
  iicp_simFltReqRq = 253,
  iicp_simNltCmdRq = 254,
  iicp_simNltReqRq = 255
} RefIICPReq_enum;

typedef enum _RefMcmdRq_enum {
  iicp_pingRq  =   0,
  iicp_vCIinfoRq =   1,
  iicp_vCIupdateRq =   2,
  iicp_getParam24102Rq =   3,
  iicp_setParam24102Rq =   4,
  iicp_testIicpRq = 254,
  iicp_testConfigRq = 255
} RefMcmdRq_enum;

typedef enum _RefIICPResp_enum {
  iicp_aliveRs =   0,
  iicp_mfRcmdRs =   1,
  iicp_mfRreqRs =   2,
  iicp_mnRcmdRs =   3,
  iicp_mnRreqRs =   4,
  iicp_miRcmdRs =   5,
  iicp_miRreqRs =   6,
  iicp_miRgetRs =   7,
  iicp_miRsetRs =   8,
  iicp_mCmdRs  =   9,
  iicp_simAutCmdRs = 242,
  iicp_simAutReqRs = 243,
  iicp_simFutCmdRs = 244,
  iicp_simFutReqRs = 245,
  iicp_simNutCmdRs = 246,
  iicp_simNutReqRs = 247,
  iicp_simIutCmdRs = 248,
  iicp_simIutReqRs = 249,
  iicp_simAltCmdRs = 250,
  iicp_simAltReqRs = 251,
  iicp_simFltCmdRs = 252,
  iicp_simFltReqRs = 253,
  iicp_simNltCmdRs = 254,
  iicp_simNltReqRs = 255
} RefIICPResp_enum;

typedef enum _RefMcmdRs_enum {
  iicp_pingRs  =   0,
  iicp_vCIinfoRs =   1,
  iicp_vCIupdateRs =   2,
  iicp_getParam24102Rs =   3,
  iicp_setParam24102Rs =   4,
  iicp_testIicpRs = 254,
  iicp_testConfigRs = 255
} RefMcmdRs_enum;

/*--- End of included file: packet-iicp-val.h ---*/
#line 51 "../../asn1/calm-iicp/packet-iicp-template.c"

/* Initialize the protocol and registered fields */
static int proto_iicp       = -1;
static int global_iicp_port = IICP_PORT;
static dissector_handle_t iicp_handle = NULL;

/* Dissector tables */
static dissector_table_t iicp_pdu_type_dissector_table;
static dissector_table_t iicp_pdu_request_dissector_table;
static dissector_table_t iicp_pdu_response_dissector_table;
static dissector_table_t iicp_mcmdrq_dissector_table;
static dissector_table_t iicp_mcmdrs_dissector_table;

static dissector_table_t msap_fa_sap_primitives_down_dissector_table;
static dissector_table_t msap_fa_sap_primitives_up_dissector_table;
static dissector_table_t msap_mf_command_request_dissector_table;
static dissector_table_t msap_mf_command_confirm_dissector_table;
static dissector_table_t msap_mf_request_request_dissector_table;
static dissector_table_t msap_mf_request_confirm_dissector_table;
static dissector_table_t msap_mn_command_request_dissector_table;
static dissector_table_t msap_mn_command_confirm_dissector_table;
static dissector_table_t msap_mn_request_request_dissector_table;
static dissector_table_t msap_mn_request_confirm_dissector_table;
static dissector_table_t msap_fwt_dissector_table;
static dissector_table_t msap_fwtnot_dissector_table;

static dissector_table_t fntp_nf_sap_primitives_down_dissector_table;
static dissector_table_t fntp_nf_sap_primitives_up_dissector_table;

static dissector_table_t llsap_in_sap_primitives_down_dissector_table;
static dissector_table_t llsap_in_sap_primitives_up_dissector_table;

static dissector_table_t llsap_acc_params_dissector_table;

/* Used to identify IICP/refIICP field 
   Set by 'dissect_iicp_pdu_type' function 
 */
static guint32 Ref_IICP; 
/* Used to identify IICPrequest/iicpReq field 
   Set by 'dissect_iicp_pdu_type_request' function 
*/
static guint32 Ref_IICPReq; 
/* Used to identify IICPresponse/iicpResp field 
   Set by 'dissect_iicp_pdu_type_response' function 
*/
static guint32 Ref_IICPResp; 
/* Used to identify McmdRq/mcmd field
   Set by 'dissect_iicp_mcmd_request' function 
 */
static guint32 Ref_McmdRq; 
/* Used to identify McmdRs/mcmd field
   Set by 'dissect_iicp_mcmd_response' function 
 */
static guint32 Ref_McmdRs; 
static guint32 Ref_COMMDOWN; 
static guint32 Ref_COMMUP; 
static guint32 Ref_MFCMDREQ; 
static guint32 Ref_MFCMDCONF; 
static guint32 Ref_MFREQREQ; 
static guint32 Ref_MFREQCONF; 
static guint32 Ref_MNCMDREQ; 
static guint32 Ref_MNCMDCONF; 
static guint32 Ref_MNREQREQ; 
static guint32 Ref_MNREQCONF; 
static guint32 Ref_FWT;
static guint32 Ref_FWTNOT;
static guint32 Ref_NFSAPDOWN; 
static guint32 Ref_NFSAPUP; 
static guint32 Ref_INSAPDOWN; 
static guint32 Ref_INSAPUP; 
static guint32 Ref_ACCPARAMS;

/* Dissector for IICP/refIICP field */
static int dissect_iicp_pdu_type(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_);
/* Dissector for IICPrequest/iicpReq field */
static int dissect_iicp_pdu_request(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_);
/* Dissector for IICPresponse/iicpResp field */
static int dissect_iicp_pdu_response(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_);
/* Dissector for McmdRq/mcmd field */
static int dissect_iicp_mcmd_request(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_);
/* Dissector for McmdRs/mcmd field */
static int dissect_iicp_mcmd_response(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_);

static int dissect_msap_fa_sap_primitives_down(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_);
static int dissect_msap_fa_sap_primitives_up(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_);
static int dissect_msap_mf_command_request(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_);
static int dissect_msap_mf_command_confirm(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_);
static int dissect_msap_mf_request_request(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_);
static int dissect_msap_mf_request_confirm(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_);
static int dissect_msap_mn_command_request(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_);
static int dissect_msap_mn_command_confirm(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_);
static int dissect_msap_mn_request_request(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_);
static int dissect_msap_mn_request_confirm(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_);
static int dissect_msap_fwt(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_);
static int dissect_msap_fwtnot(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_);

static int dissect_fntp_nf_sap_primitives_down(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_);
static int dissect_fntp_nf_sap_primitives_up(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_);

static int dissect_llsap_in_sap_primitives_down(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_);
static int dissect_llsap_in_sap_primitives_up(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_);

static int dissect_llsap_acc_params(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_);

static int dissect_iicp_FNTPNPDU(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_);
static int dissect_iicp_SAM(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_);

void proto_reg_handoff_iicp(void);


/*--- Included file: packet-iicp-hf.c ---*/
#line 1 "../../asn1/calm-iicp/packet-iicp-hf.c"
static int hf_iicp_ITS_scuId_PDU = -1;            /* ITS_scuId */
static int hf_iicp_Param24102_PDU = -1;           /* Param24102 */
static int hf_iicp_Param24102No_PDU = -1;         /* Param24102No */
static int hf_iicp_IN_UNITDATA_request_PDU = -1;  /* IN_UNITDATA_request */
static int hf_iicp_IN_DATA_ACK_request_PDU = -1;  /* IN_DATA_ACK_request */
static int hf_iicp_IN_REPLY_ACK_request_PDU = -1;  /* IN_REPLY_ACK_request */
static int hf_iicp_IN_REPLY_UPDATE_request_PDU = -1;  /* IN_REPLY_UPDATE_request */
static int hf_iicp_IN_UNITDATA_indication_PDU = -1;  /* IN_UNITDATA_indication */
static int hf_iicp_IN_UNITDATA_STATUS_indication_PDU = -1;  /* IN_UNITDATA_STATUS_indication */
static int hf_iicp_IN_DATA_ACK_indication_PDU = -1;  /* IN_DATA_ACK_indication */
static int hf_iicp_IN_DATA_ACK_STATUS_indication_PDU = -1;  /* IN_DATA_ACK_STATUS_indication */
static int hf_iicp_IN_REPLY_indication_PDU = -1;  /* IN_REPLY_indication */
static int hf_iicp_IN_REPLY_STATUS_indication_PDU = -1;  /* IN_REPLY_STATUS_indication */
static int hf_iicp_IN_REPLY_UPDATE_STATUS_indication_PDU = -1;  /* IN_REPLY_UPDATE_STATUS_indication */
static int hf_iicp_NullType_PDU = -1;             /* NullType */
static int hf_iicp_MF_Command_request_PDU = -1;   /* MF_Command_request */
static int hf_iicp_TestMF_PDU = -1;               /* TestMF */
static int hf_iicp_SimFUTcmd_PDU = -1;            /* SimFUTcmd */
static int hf_iicp_SimFLTcmd_PDU = -1;            /* SimFLTcmd */
static int hf_iicp_LDMnotify_PDU = -1;            /* LDMnotify */
static int hf_iicp_LegacyCIreq_PDU = -1;          /* LegacyCIreq */
static int hf_iicp_StateCInotify_PDU = -1;        /* StateCInotify */
static int hf_iicp_MF_Command_confirm_PDU = -1;   /* MF_Command_confirm */
static int hf_iicp_MF_Request_request_PDU = -1;   /* MF_Request_request */
static int hf_iicp_SimFUTreq_PDU = -1;            /* SimFUTreq */
static int hf_iicp_SimFLTreq_PDU = -1;            /* SimFLTreq */
static int hf_iicp_LDMregister_PDU = -1;          /* LDMregister */
static int hf_iicp_TestMFecho_PDU = -1;           /* TestMFecho */
static int hf_iicp_MF_Request_confirm_PDU = -1;   /* MF_Request_confirm */
static int hf_iicp_MN_Command_request_PDU = -1;   /* MN_Command_request */
static int hf_iicp_TestMN_PDU = -1;               /* TestMN */
static int hf_iicp_SimNUTcmd_PDU = -1;            /* SimNUTcmd */
static int hf_iicp_SimNLTcmd_PDU = -1;            /* SimNLTcmd */
static int hf_iicp_FWTset_PDU = -1;               /* FWTset */
static int hf_iicp_FWTupdate_PDU = -1;            /* FWTupdate */
static int hf_iicp_FWTdelete_PDU = -1;            /* FWTdelete */
static int hf_iicp_MN_Command_confirm_PDU = -1;   /* MN_Command_confirm */
static int hf_iicp_FWTsetConf_PDU = -1;           /* FWTsetConf */
static int hf_iicp_FWTupdateConf_PDU = -1;        /* FWTupdateConf */
static int hf_iicp_FWTdeleteConf_PDU = -1;        /* FWTdeleteConf */
static int hf_iicp_MN_Request_request_PDU = -1;   /* MN_Request_request */
static int hf_iicp_SimNUTreq_PDU = -1;            /* SimNUTreq */
static int hf_iicp_SimNLTreq_PDU = -1;            /* SimNLTreq */
static int hf_iicp_FWTsetNot_PDU = -1;            /* FWTsetNot */
static int hf_iicp_FWTupdateNot_PDU = -1;         /* FWTupdateNot */
static int hf_iicp_FWTdeleteNot_PDU = -1;         /* FWTdeleteNot */
static int hf_iicp_VCIcreatePeerMAC_PDU = -1;     /* VCIcreatePeerMAC */
static int hf_iicp_Its_ssiPeerNot_PDU = -1;       /* Its_ssiPeerNot */
static int hf_iicp_TestMNecho_PDU = -1;           /* TestMNecho */
static int hf_iicp_MN_Request_confirm_PDU = -1;   /* MN_Request_confirm */
static int hf_iicp_VCIPeerMAC_PDU = -1;           /* VCIPeerMAC */
static int hf_iicp_MI_Command_request_PDU = -1;   /* MI_Command_request */
static int hf_iicp_SimIUTcmd_PDU = -1;            /* SimIUTcmd */
static int hf_iicp_MI_Command_confirm_PDU = -1;   /* MI_Command_confirm */
static int hf_iicp_MI_Request_request_PDU = -1;   /* MI_Request_request */
static int hf_iicp_SimIUTreq_PDU = -1;            /* SimIUTreq */
static int hf_iicp_MI_Request_confirm_PDU = -1;   /* MI_Request_confirm */
static int hf_iicp_MI_Set_request_PDU = -1;       /* MI_Set_request */
static int hf_iicp_MI_Set_confirm_PDU = -1;       /* MI_Set_confirm */
static int hf_iicp_MI_Get_request_PDU = -1;       /* MI_Get_request */
static int hf_iicp_MI_Get_confirm_PDU = -1;       /* MI_Get_confirm */
static int hf_iicp_ErrStatus_PDU = -1;            /* ErrStatus */
static int hf_iicp_DeleteFNTP_PDU = -1;           /* DeleteFNTP */
static int hf_iicp_DeleteNotFNTP_PDU = -1;        /* DeleteNotFNTP */
static int hf_iicp_SetFNTP_PDU = -1;              /* SetFNTP */
static int hf_iicp_HostServiceInfo_PDU = -1;      /* HostServiceInfo */
static int hf_iicp_SetNotFNTP_PDU = -1;           /* SetNotFNTP */
static int hf_iicp_UpdateFNTP_PDU = -1;           /* UpdateFNTP */
static int hf_iicp_UpdateNotFNTP_PDU = -1;        /* UpdateNotFNTP */
static int hf_iicp_NFfntpPortRequest_PDU = -1;    /* NFfntpPortRequest */
static int hf_iicp_NFfntpPortConfirm_PDU = -1;    /* NFfntpPortConfirm */
static int hf_iicp_NFfntpCommRequest_PDU = -1;    /* NFfntpCommRequest */
static int hf_iicp_NFfntpCommConfirm_PDU = -1;    /* NFfntpCommConfirm */
static int hf_iicp_NFfntpCommIndication_PDU = -1;  /* NFfntpCommIndication */
static int hf_iicp_GCctxTxCmd_PDU = -1;           /* GCctxTxCmd */
static int hf_iicp_GCperiodCmd_PDU = -1;          /* GCperiodCmd */
static int hf_iicp_GCsamctx_PDU = -1;             /* GCsamctx */
static int hf_iicp_GCsamctxConf_PDU = -1;         /* GCsamctxConf */
static int hf_iicp_GCdeleteCmd_PDU = -1;          /* GCdeleteCmd */
static int hf_iicp_CTXrxNot_PDU = -1;             /* CTXrxNot */
static int hf_iicp_SAMrxNot_PDU = -1;             /* SAMrxNot */
static int hf_iicp_GCsam_PDU = -1;                /* GCsam */
static int hf_iicp_GCctx_PDU = -1;                /* GCctx */
static int hf_iicp_GCregServer_PDU = -1;          /* GCregServer */
static int hf_iicp_GCupdateServer_PDU = -1;       /* GCupdateServer */
static int hf_iicp_GCderegServer_PDU = -1;        /* GCderegServer */
static int hf_iicp_GCregClient_PDU = -1;          /* GCregClient */
static int hf_iicp_GCupdateClient_PDU = -1;       /* GCupdateClient */
static int hf_iicp_GCderegClient_PDU = -1;        /* GCderegClient */
static int hf_iicp_GCregServerConf_PDU = -1;      /* GCregServerConf */
static int hf_iicp_GCupdateServerConf_PDU = -1;   /* GCupdateServerConf */
static int hf_iicp_GCderegServerConf_PDU = -1;    /* GCderegServerConf */
static int hf_iicp_GCregClientConf_PDU = -1;      /* GCregClientConf */
static int hf_iicp_GCupdateClientConf_PDU = -1;   /* GCupdateClientConf */
static int hf_iicp_GCderegClientConf_PDU = -1;    /* GCderegClientConf */
static int hf_iicp_ITS_S_Appl_Reg_PDU = -1;       /* ITS_S_Appl_Reg */
static int hf_iicp_IIC_Request_PDU = -1;          /* IIC_Request */
static int hf_iicp_IICPrequest_PDU = -1;          /* IICPrequest */
static int hf_iicp_ITS_SCUalive_PDU = -1;         /* ITS_SCUalive */
static int hf_iicp_McmdRq_PDU = -1;               /* McmdRq */
static int hf_iicp_PingIICP_PDU = -1;             /* PingIICP */
static int hf_iicp_VCI_info_req_PDU = -1;         /* VCI_info_req */
static int hf_iicp_VCI_update_req_PDU = -1;       /* VCI_update_req */
static int hf_iicp_TestIicp_PDU = -1;             /* TestIicp */
static int hf_iicp_TestConfigIICP_PDU = -1;       /* TestConfigIICP */
static int hf_iicp_IIC_Response_PDU = -1;         /* IIC_Response */
static int hf_iicp_IICPresponse_PDU = -1;         /* IICPresponse */
static int hf_iicp_McmdRs_PDU = -1;               /* McmdRs */
static int hf_iicp_VCI_info_res_PDU = -1;         /* VCI_info_res */
static int hf_iicp_IICrequestTX_PDU = -1;         /* IICrequestTX */
static int hf_iicp_IICresponseTX_PDU = -1;        /* IICresponseTX */
static int hf_iicp_IICrequestRX_PDU = -1;         /* IICrequestRX */
static int hf_iicp_IICresponseRX_PDU = -1;        /* IICresponseRX */
static int hf_iicp_reference = -1;                /* INTEGER_0_65535 */
static int hf_iicp_remoteIP = -1;                 /* IpAddressInfo */
static int hf_iicp_ciid = -1;                     /* Link_ID */
static int hf_iicp_ciStatus = -1;                 /* CIstatus */
static int hf_iicp_localIP = -1;                  /* IpAddressInfo */
static int hf_iicp_priority = -1;                 /* UserPriority */
static int hf_iicp_timeout = -1;                  /* IPv6timeout */
static int hf_iicp_fill = -1;                     /* BIT_STRING_SIZE_2 */
static int hf_iicp_hostITS_scuId = -1;            /* ITS_scuId */
static int hf_iicp_seqNumber = -1;                /* ServiceRef */
static int hf_iicp_CrCiPrioList_item = -1;        /* CrCiPrioReq */
static int hf_iicp_linkId = -1;                   /* Link_ID */
static int hf_iicp_timeout_01 = -1;               /* INTEGER_0_255 */
static int hf_iicp_request = -1;                  /* CCPrequest */
static int hf_iicp_interferer = -1;               /* SEQUENCE_OF_CCPpotInt */
static int hf_iicp_interferer_item = -1;          /* CCPpotInt */
static int hf_iicp_CCPrequest_item = -1;          /* CCPrequest_item */
static int hf_iicp_reqNo = -1;                    /* INTEGER_0_255 */
static int hf_iicp_status = -1;                   /* CCPstatus */
static int hf_iicp_linkID = -1;                   /* Link_ID */
static int hf_iicp_iTS_scuId6 = -1;               /* ITS_scuId */
static int hf_iicp_its_scuType = -1;              /* ITS_SCUtype */
static int hf_iicp_time = -1;                     /* GeneralizedTime */
static int hf_iicp_uniqueID = -1;                 /* PrintableString */
static int hf_iicp_stationType = -1;              /* StationType */
static int hf_iicp_stationID = -1;                /* StationID */
static int hf_iicp_stationPosition = -1;          /* KineVectOut */
static int hf_iicp_paramNo = -1;                  /* T_paramNo */
static int hf_iicp_param = -1;                    /* T_param */
static int hf_iicp_VciList_item = -1;             /* VciListEntry */
static int hf_iicp_medType = -1;                  /* MedType */
static int hf_iicp_status_01 = -1;                /* CIstatus */
static int hf_iicp_connect = -1;                  /* Connect */
static int hf_iicp_macAddress = -1;               /* MACaddress */
static int hf_iicp_VCIperformList_item = -1;      /* VCIperformance */
static int hf_iicp_channelType = -1;              /* LogicalChannelType */
static int hf_iicp_channelNo = -1;                /* INTEGER_0_255 */
static int hf_iicp_minUserPrio = -1;              /* UserPriority */
static int hf_iicp_dataRateNW = -1;               /* DataRate */
static int hf_iicp_dataRatesNW = -1;              /* DataRatesNW */
static int hf_iicp_directivity = -1;              /* Directivity */
static int hf_iicp_commRangeRef = -1;             /* INTEGER_0_65535 */
static int hf_iicp_cost = -1;                     /* MediumCost */
static int hf_iicp_reliability = -1;              /* INTEGER_0_255 */
static int hf_iicp_remoteCIID = -1;               /* EUI64 */
static int hf_iicp_localCIID = -1;                /* EUI64 */
static int hf_iicp_CommProfile_item = -1;         /* I_Parameter */
static int hf_iicp_minimum = -1;                  /* DataRate */
static int hf_iicp_maximum = -1;                  /* DataRate */
static int hf_iicp_mode = -1;                     /* DirMode */
static int hf_iicp_dirPredef = -1;                /* INTEGER_0_255 */
static int hf_iicp_fill_01 = -1;                  /* BIT_STRING_SIZE_7 */
static int hf_iicp_dirVar = -1;                   /* SEQUENCE_SIZE_0_1_OF_DirVar */
static int hf_iicp_dirVar_item = -1;              /* DirVar */
static int hf_iicp_bsAzimuth = -1;                /* INTEGER_M32768_32767 */
static int hf_iicp_bsElevation = -1;              /* INTEGER_M128_127 */
static int hf_iicp_openHorizontal = -1;           /* INTEGER_0_255 */
static int hf_iicp_openVertical = -1;             /* INTEGER_0_255 */
static int hf_iicp_Errors_item = -1;              /* SingleError */
static int hf_iicp_paramNo_01 = -1;               /* INTEGER_0_255 */
static int hf_iicp_errStatus = -1;                /* ErrStatus */
static int hf_iicp_dut = -1;                      /* Time48IAT */
static int hf_iicp_lat = -1;                      /* Lat */
static int hf_iicp_lon = -1;                      /* Lon */
static int hf_iicp_alt = -1;                      /* Alt */
static int hf_iicp_gs = -1;                       /* Gs */
static int hf_iicp_tta = -1;                      /* Tta */
static int hf_iicp_fill_02 = -1;                  /* BIT_STRING_SIZE_5 */
static int hf_iicp_options = -1;                  /* SEQUENCE_SIZE_0_5_OF_KineVectOptions */
static int hf_iicp_options_item = -1;             /* KineVectOptions */
static int hf_iicp_csap = -1;                     /* IN_SAPaddress */
static int hf_iicp_receive = -1;                  /* INTEGER_0_255 */
static int hf_iicp_transmit = -1;                 /* INTEGER_0_255 */
static int hf_iicp_value = -1;                    /* INTEGER_0_1023 */
static int hf_iicp_unit = -1;                     /* TimeUnit */
static int hf_iicp_Notify_item = -1;              /* INTEGER_0_255 */
static int hf_iicp_paramNo_02 = -1;               /* T_paramNo_01 */
static int hf_iicp_parameter = -1;                /* T_parameter */
static int hf_iicp_LogicalChannels_item = -1;     /* LogicalChannelType */
static int hf_iicp_Properties_item = -1;          /* I_Parameter */
static int hf_iicp_provName = -1;                 /* OCTET_STRING_SIZE_0_255 */
static int hf_iicp_apn = -1;                      /* OCTET_STRING_SIZE_0_255 */
static int hf_iicp_username = -1;                 /* OCTET_STRING_SIZE_0_255 */
static int hf_iicp_password = -1;                 /* OCTET_STRING_SIZE_0_255 */
static int hf_iicp_level = -1;                    /* QueueValue */
static int hf_iicp_status_02 = -1;                /* RegInfoStatus */
static int hf_iicp_limits = -1;                   /* RegulatoryScheme */
static int hf_iicp_reguIdent = -1;                /* T_reguIdent */
static int hf_iicp_reguInfo = -1;                 /* T_reguInfo */
static int hf_iicp_VirtualCIs_item = -1;          /* RemoteCIID */
static int hf_iicp_spRef = -1;                    /* RefINSAPDOWN */
static int hf_iicp_servPrimitive = -1;            /* T_servPrimitive */
static int hf_iicp_source_addr = -1;              /* LLserviceAddr */
static int hf_iicp_dest_addr = -1;                /* LLserviceAddr */
static int hf_iicp_data = -1;                     /* INdata */
static int hf_iicp_accessParams = -1;             /* AccessParameters */
static int hf_iicp_serviceClass = -1;             /* MACServiceClass */
static int hf_iicp_spRef_01 = -1;                 /* RefINSAPUP */
static int hf_iicp_servPrimitive_01 = -1;         /* T_servPrimitive_01 */
static int hf_iicp_txStatus = -1;                 /* INtxStatus */
static int hf_iicp_status_03 = -1;                /* INtxStatus */
static int hf_iicp_apRef = -1;                    /* RefACCPARAMS */
static int hf_iicp_aParameter = -1;               /* T_aParameter */
static int hf_iicp_selector1 = -1;                /* OneOCTETones */
static int hf_iicp_iTS_scuId = -1;                /* ITS_scuId */
static int hf_iicp_selector2 = -1;                /* TwoOCTETones */
static int hf_iicp_medID = -1;                    /* MedID */
static int hf_iicp_vciSerialNumber = -1;          /* VCIserialNumber */
static int hf_iicp_oui = -1;                      /* MACoui */
static int hf_iicp_ext = -1;                      /* MACext */
static int hf_iicp_uoi1 = -1;                     /* INTEGER_0_63 */
static int hf_iicp_ulBit = -1;                    /* BOOLEAN */
static int hf_iicp_igBIT = -1;                    /* BOOLEAN */
static int hf_iicp_uoi2 = -1;                     /* OCTET_STRING_SIZE_2 */
static int hf_iicp_ucgc = -1;                     /* INTEGER_0_63 */
static int hf_iicp_mc = -1;                       /* T_mc */
static int hf_iicp_serial = -1;                   /* OCTET_STRING_SIZE_2 */
static int hf_iicp_spRef_02 = -1;                 /* RefCOMMDOWN */
static int hf_iicp_servPrimitive_02 = -1;         /* T_servPrimitive_02 */
static int hf_iicp_spRef_03 = -1;                 /* RefCOMMUP */
static int hf_iicp_servPrimitive_03 = -1;         /* T_servPrimitive_03 */
static int hf_iicp_commandRef = -1;               /* CommandRef */
static int hf_iicp_ref = -1;                      /* RefMFCMDREQ */
static int hf_iicp_command_param = -1;            /* T_command_param */
static int hf_iicp_LDMnotify_item = -1;           /* RadarView */
static int hf_iicp_peerITS_SSI = -1;              /* ITS_SSI */
static int hf_iicp_cIclass = -1;                  /* CIclass */
static int hf_iicp_legacyOption = -1;             /* INTEGER_0_255 */
static int hf_iicp_cIstatus = -1;                 /* CIstatus */
static int hf_iicp_ref_01 = -1;                   /* RefMFCMDCONF */
static int hf_iicp_cmdConfirm_param = -1;         /* T_cmdConfirm_param */
static int hf_iicp_ref_02 = -1;                   /* RefMFREQREQ */
static int hf_iicp_request_param = -1;            /* T_request_param */
static int hf_iicp_iTS_scuId4 = -1;               /* ITS_scuId */
static int hf_iicp_reference_01 = -1;             /* OCTET_STRING_SIZE_0_65535 */
static int hf_iicp_sap = -1;                      /* T_sap */
static int hf_iicp_info = -1;                     /* OCTET_STRING_SIZE_0_255 */
static int hf_iicp_ref_03 = -1;                   /* RefMFREQCONF */
static int hf_iicp_reqConfirm_param = -1;         /* T_reqConfirm_param */
static int hf_iicp_ref_04 = -1;                   /* RefMNCMDREQ */
static int hf_iicp_command_param_01 = -1;         /* T_command_param_01 */
static int hf_iicp_fwtNo = -1;                    /* RefFWT */
static int hf_iicp_fwt = -1;                      /* T_fwt */
static int hf_iicp_fwt_01 = -1;                   /* T_fwt_01 */
static int hf_iicp_fwt_02 = -1;                   /* T_fwt_02 */
static int hf_iicp_ref_05 = -1;                   /* RefMNCMDCONF */
static int hf_iicp_cmdConfirm_param_01 = -1;      /* T_cmdConfirm_param_01 */
static int hf_iicp_fwtNo_01 = -1;                 /* T_fwtNo */
static int hf_iicp_fwt_03 = -1;                   /* T_fwt_03 */
static int hf_iicp_fwtNo_02 = -1;                 /* T_fwtNo_01 */
static int hf_iicp_fwt_04 = -1;                   /* T_fwt_04 */
static int hf_iicp_fwtNo_03 = -1;                 /* T_fwtNo_02 */
static int hf_iicp_fwt_05 = -1;                   /* T_fwt_05 */
static int hf_iicp_ref_06 = -1;                   /* RefMNREQREQ */
static int hf_iicp_request_param_01 = -1;         /* T_request_param_01 */
static int hf_iicp_fwtNo_04 = -1;                 /* RefFWTNOT */
static int hf_iicp_fwt_06 = -1;                   /* T_fwt_06 */
static int hf_iicp_fwt_07 = -1;                   /* T_fwt_07 */
static int hf_iicp_fwt_08 = -1;                   /* T_fwt_08 */
static int hf_iicp_reference_02 = -1;             /* INTEGER_0_255 */
static int hf_iicp_peerMac = -1;                  /* MACaddress */
static int hf_iicp_sap_01 = -1;                   /* INTEGER_0_255 */
static int hf_iicp_mACaddress = -1;               /* MACaddress */
static int hf_iicp_its_ssiData = -1;              /* ITS_SSI */
static int hf_iicp_sap_02 = -1;                   /* T_sap_01 */
static int hf_iicp_ref_07 = -1;                   /* RefMNREQCONF */
static int hf_iicp_reqConfirm_param_01 = -1;      /* T_reqConfirm_param_01 */
static int hf_iicp_ref_08 = -1;                   /* T_ref */
static int hf_iicp_command_param_02 = -1;         /* T_command_param_02 */
static int hf_iicp_scuId = -1;                    /* ITS_scuId */
static int hf_iicp_reqID = -1;                    /* ReqID */
static int hf_iicp_seqNo = -1;                    /* INTEGER_0_255 */
static int hf_iicp_status_04 = -1;                /* T_status */
static int hf_iicp_status_05 = -1;                /* T_status_01 */
static int hf_iicp_ri = -1;                       /* RI */
static int hf_iicp_VciCmd_item = -1;              /* VciCmd_item */
static int hf_iicp_alive = -1;                    /* BOOLEAN */
static int hf_iicp_Monitor_item = -1;             /* Monitor_item */
static int hf_iicp_active = -1;                   /* T_active */
static int hf_iicp_sourceAddr = -1;               /* Link_ID */
static int hf_iicp_destAddr = -1;                 /* Link_ID */
static int hf_iicp_data_01 = -1;                  /* OCTET_STRING_SIZE_0_65535 */
static int hf_iicp_parameter_01 = -1;             /* OCTET_STRING_SIZE_0_65535 */
static int hf_iicp_ref_09 = -1;                   /* T_ref_01 */
static int hf_iicp_request_param_02 = -1;         /* T_request_param_02 */
static int hf_iicp_interferers = -1;              /* Interferers */
static int hf_iicp_Interferers_item = -1;         /* MedType */
static int hf_iicp_status_06 = -1;                /* T_status_02 */
static int hf_iicp_status_07 = -1;                /* T_status_03 */
static int hf_iicp_riAccess = -1;                 /* RIaccess */
static int hf_iicp_eventNo = -1;                  /* T_eventNo */
static int hf_iicp_event = -1;                    /* T_event */
static int hf_iicp_sap_03 = -1;                   /* T_sap_02 */
static int hf_iicp_set_param = -1;                /* SEQUENCE_OF_I_Parameter */
static int hf_iicp_set_param_item = -1;           /* I_Parameter */
static int hf_iicp_set_param_01 = -1;             /* SEQUENCE_OF_Errors */
static int hf_iicp_set_param_item_01 = -1;        /* Errors */
static int hf_iicp_get_param_no = -1;             /* SEQUENCE_OF_I_ParamNo */
static int hf_iicp_get_param_no_item = -1;        /* I_ParamNo */
static int hf_iicp_ref_10 = -1;                   /* T_ref_02 */
static int hf_iicp_command_param_03 = -1;         /* T_command_param_03 */
static int hf_iicp_ref_11 = -1;                   /* T_ref_03 */
static int hf_iicp_cmdConfirm_param_02 = -1;      /* T_cmdConfirm_param_02 */
static int hf_iicp_ref_12 = -1;                   /* T_ref_04 */
static int hf_iicp_request_param_03 = -1;         /* T_request_param_03 */
static int hf_iicp_sap_04 = -1;                   /* T_sap_03 */
static int hf_iicp_ref_13 = -1;                   /* T_ref_05 */
static int hf_iicp_reqConfirm_param_02 = -1;      /* T_reqConfirm_param_02 */
static int hf_iicp_ref_14 = -1;                   /* T_ref_06 */
static int hf_iicp_command_param_04 = -1;         /* T_command_param_04 */
static int hf_iicp_ref_15 = -1;                   /* T_ref_07 */
static int hf_iicp_cmdConfirm_param_03 = -1;      /* T_cmdConfirm_param_03 */
static int hf_iicp_ref_16 = -1;                   /* T_ref_08 */
static int hf_iicp_request_param_04 = -1;         /* T_request_param_04 */
static int hf_iicp_sap_05 = -1;                   /* T_sap_04 */
static int hf_iicp_ref_17 = -1;                   /* T_ref_09 */
static int hf_iicp_reqConfirm_param_03 = -1;      /* T_reqConfirm_param_03 */
static int hf_iicp_header = -1;                   /* FNTPHeader */
static int hf_iicp_body = -1;                     /* ITSfpdu */
static int hf_iicp_sourcePort = -1;               /* PortNumber */
static int hf_iicp_destinationPort = -1;          /* PortNumber */
static int hf_iicp_options_01 = -1;               /* FntpOptions */
static int hf_iicp_intForw = -1;                  /* FNTPintForwarding */
static int hf_iicp_sec = -1;                      /* FNTPsecurity */
static int hf_iicp_hops = -1;                     /* FNTPhopCount */
static int hf_iicp_lpp = -1;                      /* FNTPlpp */
static int hf_iicp_cip = -1;                      /* FNTPCIPheader */
static int hf_iicp_opt5 = -1;                     /* NULL */
static int hf_iicp_opt6 = -1;                     /* NULL */
static int hf_iicp_opt7 = -1;                     /* NULL */
static int hf_iicp_link = -1;                     /* Link_ID */
static int hf_iicp_counter = -1;                  /* FNTPpacketCounter */
static int hf_iicp_rxCIP = -1;                    /* RXcip */
static int hf_iicp_txCIP = -1;                    /* TXcip */
static int hf_iicp_reference_03 = -1;             /* INTEGER_0_noFNTPfwtEntries */
static int hf_iicp_remotePort = -1;               /* PortNumber */
static int hf_iicp_linkPort = -1;                 /* PortNumber */
static int hf_iicp_serviceInfo = -1;              /* HostServiceInfo */
static int hf_iicp_timeout_02 = -1;               /* NTtimeout */
static int hf_iicp_servicePort = -1;              /* PortNumber */
static int hf_iicp_hostITSscu = -1;               /* ITS_scuId */
static int hf_iicp_servicePriority = -1;          /* UserPriority */
static int hf_iicp_fill_03 = -1;                  /* BIT_STRING_SIZE_1 */
static int hf_iicp_spRef_04 = -1;                 /* RefNFSAPDOWN */
static int hf_iicp_servPrimitive_04 = -1;         /* T_servPrimitive_04 */
static int hf_iicp_spRef_05 = -1;                 /* RefNFSAPUP */
static int hf_iicp_servPrimitive_05 = -1;         /* T_servPrimitive_05 */
static int hf_iicp_serviceRef = -1;               /* ServiceRef */
static int hf_iicp_operation = -1;                /* PortOp */
static int hf_iicp_portno = -1;                   /* PortNumber */
static int hf_iicp_commRef = -1;                  /* INTEGER_0_255 */
static int hf_iicp_data_02 = -1;                  /* ITSfpdu */
static int hf_iicp_controlField = -1;             /* FntpOptions */
static int hf_iicp_errStatus_01 = -1;             /* FNTPerrorStatus */
static int hf_iicp_portShort = -1;                /* INTEGER_0_127 */
static int hf_iicp_portLong = -1;                 /* INTEGER_0_32767 */
static int hf_iicp_fmtID = -1;                    /* FmtID */
static int hf_iicp_version = -1;                  /* VersionFSAP */
static int hf_iicp_serverID = -1;                 /* StationID */
static int hf_iicp_serviceList = -1;              /* ServiceList */
static int hf_iicp_channelList = -1;              /* ChannelList */
static int hf_iicp_ipServList = -1;               /* IpServList */
static int hf_iicp_ServiceList_item = -1;         /* NonipService */
static int hf_iicp_ChannelList_item = -1;         /* SessionChannel */
static int hf_iicp_IpServList_item = -1;          /* IpService */
static int hf_iicp_serviceID = -1;                /* ITSaid */
static int hf_iicp_serviceData = -1;              /* ServiceData */
static int hf_iicp_serverPort = -1;               /* PortNumber */
static int hf_iicp_sessionChannel = -1;           /* INTEGER_0_noChannels */
static int hf_iicp_serviceChannel = -1;           /* INTEGER_0_255 */
static int hf_iicp_medium = -1;                   /* MedType */
static int hf_iicp_schParams = -1;                /* OCTET_STRING */
static int hf_iicp_serviceData_01 = -1;           /* IpServiceData */
static int hf_iicp_ipInfo = -1;                   /* IpInfo */
static int hf_iicp_clientID = -1;                 /* StationID */
static int hf_iicp_servContextList = -1;          /* ServContextList */
static int hf_iicp_ipContextList = -1;            /* IpContextList */
static int hf_iicp_ServContextList_item = -1;     /* NonipContext */
static int hf_iicp_IpContextList_item = -1;       /* IpContext */
static int hf_iicp_contextData = -1;              /* IpContextData */
static int hf_iicp_link_01 = -1;                  /* LLserviceAddr */
static int hf_iicp_ctx = -1;                      /* CTX */
static int hf_iicp_applicationID = -1;            /* ApplicationID */
static int hf_iicp_bcVCIs = -1;                   /* SEQUENCE_SIZE_1_256_OF_LLserviceAddr */
static int hf_iicp_bcVCIs_item = -1;              /* LLserviceAddr */
static int hf_iicp_gcInterval = -1;               /* GcInterval */
static int hf_iicp_serviceDataReg = -1;           /* ServiceDataReg */
static int hf_iicp_serviceInfo_01 = -1;           /* ServiceInfo */
static int hf_iicp_port = -1;                     /* PortNumber */
static int hf_iicp_info_01 = -1;                  /* T_info */
static int hf_iicp_nonipService = -1;             /* NonipSAMctx */
static int hf_iicp_ipService = -1;                /* IpSAMctx */
static int hf_iicp_providerPort = -1;             /* PortNumber */
static int hf_iicp_sam = -1;                      /* SAM */
static int hf_iicp_serviceData_02 = -1;           /* SAMserviceData */
static int hf_iicp_servData = -1;                 /* T_servData */
static int hf_iicp_nonipService_01 = -1;          /* NonipSAM */
static int hf_iicp_ipService_01 = -1;             /* IpSAM */
static int hf_iicp_sessionChannel_01 = -1;        /* SessionChannel */
static int hf_iicp_serviceContext = -1;           /* CTXserviceData */
static int hf_iicp_servData_01 = -1;              /* T_servData_01 */
static int hf_iicp_nonipContext = -1;             /* NonipContext */
static int hf_iicp_ipContext = -1;                /* IpContext */
static int hf_iicp_contextData_01 = -1;           /* ContextData */
static int hf_iicp_userPort = -1;                 /* PortNumber */
static int hf_iicp_gCschedule = -1;               /* GCschedule */
static int hf_iicp_serviceDataReg_01 = -1;        /* SEQUENCE_SIZE_0_1_OF_ServiceDataReg */
static int hf_iicp_serviceDataReg_item = -1;      /* ServiceDataReg */
static int hf_iicp_GCschedule_item = -1;          /* GCsched */
static int hf_iicp_datareg = -1;                  /* T_datareg */
static int hf_iicp_nonipData = -1;                /* NonipServiceReg */
static int hf_iicp_ipData = -1;                   /* IpServiceReg */
static int hf_iicp_serviceData_03 = -1;           /* OCTET_STRING_SIZE_0_noServiceDataOctets */
static int hf_iicp_serviceData_04 = -1;           /* OCTET_STRING_SIZE_0_noIpServiceDataOctets */
static int hf_iicp_address = -1;                  /* IpAddressInfo */
static int hf_iicp_addressType = -1;              /* TransportAddressType */
static int hf_iicp_address_01 = -1;               /* TransportAddress */
static int hf_iicp_params = -1;                   /* T_params */
static int hf_iicp_portPM = -1;                   /* PortNumber */
static int hf_iicp_ITSapObRegistry_item = -1;     /* ITSapOb */
static int hf_iicp_iTSaid = -1;                   /* ITSaid */
static int hf_iicp_iTSapObName = -1;              /* ITSObName */
static int hf_iicp_iTSapObType = -1;              /* ITSapObType */
static int hf_iicp_iTSapObOwner = -1;             /* ITSObOwner */
static int hf_iicp_iTSapObCert = -1;              /* ITSapObCertificate */
static int hf_iicp_iTSapObPorts = -1;             /* ITSapObPorts */
static int hf_iicp_ITSapObPorts_item = -1;        /* ITSapObPorts_item */
static int hf_iicp_portNo = -1;                   /* ITSSappRxTxPortNo */
static int hf_iicp_rules = -1;                    /* SEQUENCE_OF_ITSapObPort */
static int hf_iicp_rules_item = -1;               /* ITSapObPort */
static int hf_iicp_ITSapObPort_item = -1;         /* ITSapObPortRule */
static int hf_iicp_ruleNo = -1;                   /* T_ruleNo */
static int hf_iicp_rule = -1;                     /* T_rule */
static int hf_iicp_lch = -1;                      /* LogicalChannelType */
static int hf_iicp_prio = -1;                     /* UserPriority */
static int hf_iicp_ownerName = -1;                /* ITSObOwnerName */
static int hf_iicp_ownerType = -1;                /* ITSObOwnerType */
static int hf_iicp_ownerOID = -1;                 /* OBJECT_IDENTIFIER */
static int hf_iicp_issuingSA = -1;                /* IssuingSA */
static int hf_iicp_startDate = -1;                /* CertStartDate */
static int hf_iicp_endDate = -1;                  /* CertEndDate */
static int hf_iicp_status_08 = -1;                /* CertStatus */
static int hf_iicp_name = -1;                     /* SAname */
static int hf_iicp_saOID = -1;                    /* OBJECT_IDENTIFIER */
static int hf_iicp_csd = -1;                      /* T_csd */
static int hf_iicp_inactive = -1;                 /* NULL */
static int hf_iicp_date = -1;                     /* NumericString_SIZE_8 */
static int hf_iicp_fill_04 = -1;                  /* BIT_STRING_SIZE_6 */
static int hf_iicp_ced = -1;                      /* T_ced */
static int hf_iicp_never = -1;                    /* NULL */
static int hf_iicp_cs = -1;                       /* T_cs */
static int hf_iicp_active_01 = -1;                /* NULL */
static int hf_iicp_testActiv = -1;                /* NULL */
static int hf_iicp_blocked = -1;                  /* CertBlocked */
static int hf_iicp_ITSmsgSetRegistry_item = -1;   /* ITSmsgSet */
static int hf_iicp_iTSmsID = -1;                  /* ITSmsgSetID */
static int hf_iicp_iTSmsName = -1;                /* ITSObName */
static int hf_iicp_iTSmsOwner = -1;               /* ITSObOwner */
static int hf_iicp_ITSregRegionRegistry_item = -1;  /* ITSregRegion */
static int hf_iicp_regID = -1;                    /* ITSrrID */
static int hf_iicp_regAuthority = -1;             /* ITS_RegPolicyAuthority */
static int hf_iicp_regArea = -1;                  /* ITS_RParea */
static int hf_iicp_name_01 = -1;                  /* ITSObOwnerName */
static int hf_iicp_url = -1;                      /* URLreg */
static int hf_iicp_areaTypeNo = -1;               /* T_areaTypeNo */
static int hf_iicp_areaType = -1;                 /* T_areaType */
static int hf_iicp_GeoPolygon_item = -1;          /* GeoCoordinates */
static int hf_iicp_long = -1;                     /* Lon */
static int hf_iicp_ITSpolRegionRegistry_item = -1;  /* ITSpolRegion */
static int hf_iicp_polID = -1;                    /* ITSprID */
static int hf_iicp_polAuthority = -1;             /* ITS_RegPolicyAuthority */
static int hf_iicp_polArea = -1;                  /* ITS_RParea */
static int hf_iicp_ITSportNumberRegistry_item = -1;  /* ITSportNumber */
static int hf_iicp_pn = -1;                       /* PortNumber */
static int hf_iicp_ntProt = -1;                   /* NTprotocol */
static int hf_iicp_itssAp = -1;                   /* ItsAppInfo */
static int hf_iicp_itsAid = -1;                   /* ITSaid */
static int hf_iicp_rxTxPortNo = -1;               /* ITSSappRxTxPortNo */
static int hf_iicp_name_02 = -1;                  /* OCTET_STRING_SIZE_0_255 */
static int hf_iicp_protRef = -1;                  /* ProtocolReference */
static int hf_iicp_sdo = -1;                      /* OCTET_STRING_SIZE_0_255 */
static int hf_iicp_docNo = -1;                    /* OCTET_STRING_SIZE_0_255 */
static int hf_iicp_ITSflowTypeRegistry_item = -1;  /* ITSflowType */
static int hf_iicp_id = -1;                       /* FlowTypeID */
static int hf_iicp_req = -1;                      /* ITSSappCPReqReg */
static int hf_iicp_ITSlchRegistry_item = -1;      /* ITSlch */
static int hf_iicp_lchID = -1;                    /* LogicalChannelType */
static int hf_iicp_lchPurpose = -1;               /* OCTET_STRING_SIZE_0_255 */
static int hf_iicp_ITSsuRegistry_item = -1;       /* ITSsu */
static int hf_iicp_itssuID = -1;                  /* ITSsuID */
static int hf_iicp_ITSscuRegistry_item = -1;      /* ITSscu */
static int hf_iicp_itsscuID = -1;                 /* ITSscuID */
static int hf_iicp_ITSSappRegistry_item = -1;     /* ITSSapPrPr */
static int hf_iicp_itssappID = -1;                /* ITSSappid */
static int hf_iicp_itssapProv = -1;               /* RegEntryOwner */
static int hf_iicp_ownerName_01 = -1;             /* OCTET_STRING_SIZE_0_255 */
static int hf_iicp_ownerAddress = -1;             /* OCTET_STRING_SIZE_0_255 */
static int hf_iicp_ownerURL = -1;                 /* URLreg */
static int hf_iicp_ITSemRegistry_item = -1;       /* ITSem */
static int hf_iicp_itsemID = -1;                  /* ITSemID */
static int hf_iicp_equipManu = -1;                /* RegEntryOwner */
static int hf_iicp_ITSaooRegistry_item = -1;      /* ITSaoo */
static int hf_iicp_itsaooID = -1;                 /* ITSaooID */
static int hf_iicp_aoo = -1;                      /* RegEntryOwner */
static int hf_iicp_Registry_item = -1;            /* ITSmso */
static int hf_iicp_iTSmsoID = -1;                 /* ITSmsoID */
static int hf_iicp_mso = -1;                      /* RegEntryOwner */
static int hf_iicp_ITSSapdRegistry_item = -1;     /* ITSSapd */
static int hf_iicp_itssapdID = -1;                /* ITSSapdID */
static int hf_iicp_ad = -1;                       /* RegEntryOwner */
static int hf_iicp_suID = -1;                     /* VarLengthNumber */
static int hf_iicp_scuID = -1;                    /* ITSscuID */
static int hf_iicp_emID = -1;                     /* ITSemID */
static int hf_iicp_serialNo = -1;                 /* VarLengthNumber */
static int hf_iicp_content = -1;                  /* INTEGER_0_127 */
static int hf_iicp_extension = -1;                /* Ext1 */
static int hf_iicp_content_01 = -1;               /* INTEGER_128_16511 */
static int hf_iicp_extension_01 = -1;             /* Ext2 */
static int hf_iicp_content_02 = -1;               /* INTEGER_16512_2113663 */
static int hf_iicp_extension_02 = -1;             /* Ext3 */
static int hf_iicp_shortNo = -1;                  /* INTEGER_0_127 */
static int hf_iicp_longNo = -1;                   /* INTEGER_0_32767 */
static int hf_iicp_rxTxPort = -1;                 /* ITSSappRxTxPort */
static int hf_iicp_requirements = -1;             /* ITSSappReq */
static int hf_iicp_portType = -1;                 /* ITSSappRxTxPortType */
static int hf_iicp_itsaid = -1;                   /* ITSaid */
static int hf_iicp_instance = -1;                 /* INTEGER_0_255 */
static int hf_iicp_flowNo = -1;                   /* FlowNo */
static int hf_iicp_confDetails = -1;              /* ITSSappReqConf */
static int hf_iicp_ITSSappReq_item = -1;          /* ITSSappReq_item */
static int hf_iicp_refNo = -1;                    /* T_refNo */
static int hf_iicp_param_01 = -1;                 /* T_param_01 */
static int hf_iicp_ITSSappReqConf_item = -1;      /* ITSSappReqConf_item */
static int hf_iicp_refNo_01 = -1;                 /* T_refNo_01 */
static int hf_iicp_param_02 = -1;                 /* T_param_02 */
static int hf_iicp_final = -1;                    /* Logic */
static int hf_iicp_type = -1;                     /* DestType */
static int hf_iicp_addressType_01 = -1;           /* AddressBasedType */
static int hf_iicp_geoLocType = -1;               /* GeoLocationBasedType */
static int hf_iicp_type_01 = -1;                  /* T_type */
static int hf_iicp_mcGroups = -1;                 /* SEQUENCE_SIZE_0_255_OF_MCgroup */
static int hf_iicp_mcGroups_item = -1;            /* MCgroup */
static int hf_iicp_type_02 = -1;                  /* T_type_01 */
static int hf_iicp_duration = -1;                 /* TimDurationValue */
static int hf_iicp_interrupt = -1;                /* Logic */
static int hf_iicp_repeat = -1;                   /* INTEGER_0_255 */
static int hf_iicp_interval = -1;                 /* TimDurationValue */
static int hf_iicp_minDistance = -1;              /* INTEGER_0_65535 */
static int hf_iicp_cost_01 = -1;                  /* CostObjective */
static int hf_iicp_hops_01 = -1;                  /* INTEGER_0_255 */
static int hf_iicp_minThP = -1;                   /* DataRate */
static int hf_iicp_lat_01 = -1;                   /* T_lat */
static int hf_iicp_Policies_item = -1;            /* Policies_item */
static int hf_iicp_refNo_02 = -1;                 /* T_refNo_02 */
static int hf_iicp_param_03 = -1;                 /* T_param_03 */
static int hf_iicp_costClass = -1;                /* CostClass */
static int hf_iicp_costAmount = -1;               /* CostAmount */
static int hf_iicp_timeUnit = -1;                 /* CostTimeUnit */
static int hf_iicp_amountUnit = -1;               /* CostAmountUnit */
static int hf_iicp_currency = -1;                 /* INTEGER_0_1023 */
static int hf_iicp_value_01 = -1;                 /* CostValue */
static int hf_iicp_main = -1;                     /* INTEGER_0_4095 */
static int hf_iicp_fraction = -1;                 /* INTEGER_0_1023 */
static int hf_iicp_ITS_S_Appl_Reg_item = -1;      /* ITSSappCPReqReg */
static int hf_iicp_ITS_S_Appl_RegConf_item = -1;  /* ITSSappCPReqConf */
static int hf_iicp_selectionOfCommunicationSysyem = -1;  /* SelectionOfCommunicationSystem */
static int hf_iicp_applicationIdentifiers = -1;   /* ApplicationIdentifiers */
static int hf_iicp_address_02 = -1;               /* Address */
static int hf_iicp_priority_01 = -1;              /* Priority */
static int hf_iicp_security = -1;                 /* Security */
static int hf_iicp_applicationExecution = -1;     /* ApplicationExecution */
static int hf_iicp_responsiveness = -1;           /* Responsiveness */
static int hf_iicp_directionality = -1;           /* Directionality */
static int hf_iicp_usageEnvironment = -1;         /* UsageEnvironment */
static int hf_iicp_serviceArea = -1;              /* ServiceArea */
static int hf_iicp_serviceTime = -1;              /* ServiceTime */
static int hf_iicp_bandwidth = -1;                /* Bandwidth */
static int hf_iicp_connectionCost = -1;           /* ConnectionCost */
static int hf_iicp_messageIdentifier = -1;        /* EXTERNAL */
static int hf_iicp_messageNumber = -1;            /* INTEGER */
static int hf_iicp_timeOfMessageTransmission = -1;  /* GeneralizedTime */
static int hf_iicp_addressOfOrigin = -1;          /* EXTERNAL */
static int hf_iicp_addressOfDestination = -1;     /* EXTERNAL */
static int hf_iicp_interruptHandling = -1;        /* T_interruptHandling */
static int hf_iicp_interruptHandlingLevel = -1;   /* INTEGER */
static int hf_iicp_queueControl = -1;             /* T_queueControl */
static int hf_iicp_validTime = -1;                /* ValidTime */
static int hf_iicp_timeStamp = -1;                /* GeneralizedTime */
static int hf_iicp_targetArea = -1;               /* TargetArea */
static int hf_iicp_responsivenessCode = -1;       /* T_responsivenessCode */
static int hf_iicp_responsivenessValue = -1;      /* UTCTime */
static int hf_iicp_meansOfTransportation = -1;    /* T_meansOfTransportation */
static int hf_iicp_speed = -1;                    /* T_speed */
static int hf_iicp_speedValue = -1;               /* EXTERNAL */
static int hf_iicp_serviceAreaCode = -1;          /* T_serviceAreaCode */
static int hf_iicp_serviceAreaValue = -1;         /* EXTERNAL */
static int hf_iicp_serviceTimeCode = -1;          /* T_serviceTimeCode */
static int hf_iicp_serviceTimeValue = -1;         /* EXTERNAL */
static int hf_iicp_capacityOfTransmissionValue = -1;  /* INTEGER */
static int hf_iicp_dataExpressionCode = -1;       /* T_dataExpressionCode */
static int hf_iicp_maximumCostRequirement = -1;   /* T_maximumCostRequirement */
static int hf_iicp_maximumCostValue = -1;         /* EXTERNAL */
static int hf_iicp_validTimeCode = -1;            /* T_validTimeCode */
static int hf_iicp_validTimeValue = -1;           /* EXTERNAL */
static int hf_iicp_targetAreaCode = -1;           /* T_targetAreaCode */
static int hf_iicp_targetAreaValue = -1;          /* EXTERNAL */
static int hf_iicp_sourceITS_scuId = -1;          /* ITS_scuId */
static int hf_iicp_destinationITS_scuId = -1;     /* ITS_scuId */
static int hf_iicp_pduCounter = -1;               /* PduCounter */
static int hf_iicp_pduRequest = -1;               /* IICPpdu */
static int hf_iicp_secRq = -1;                    /* SecRq */
static int hf_iicp_pduRef = -1;                   /* RefIICP */
static int hf_iicp_iicpPDU = -1;                  /* T_iicpPDU */
static int hf_iicp_iicpReqRef = -1;               /* RefIICPReq */
static int hf_iicp_iicpReq = -1;                  /* T_iicpReq */
static int hf_iicp_message = -1;                  /* AliveMessage */
static int hf_iicp_mCmdRef = -1;                  /* RefMcmdRq */
static int hf_iicp_mcmd = -1;                     /* T_mcmd */
static int hf_iicp_ciaClass = -1;                 /* CIaClass */
static int hf_iicp_ciClass = -1;                  /* CIclass */
static int hf_iicp_VCI_update_req_item = -1;      /* VCI_Info */
static int hf_iicp_action = -1;                   /* T_action */
static int hf_iicp_mfRcmd = -1;                   /* MFrcmd */
static int hf_iicp_mnRcmd = -1;                   /* MNrcmd */
static int hf_iicp_miRcmd = -1;                   /* MIrcmd */
static int hf_iicp_destination = -1;              /* ITS_scuId */
static int hf_iicp_cmd = -1;                      /* MF_Command_request */
static int hf_iicp_cmd_01 = -1;                   /* MN_Command_request */
static int hf_iicp_location = -1;                 /* BIT_STRING_SIZE_6 */
static int hf_iicp_lowerLayers = -1;              /* BIT_STRING_SIZE_1 */
static int hf_iicp_testMode = -1;                 /* BIT_STRING_SIZE_1 */
static int hf_iicp_pduResponse = -1;              /* T_pduResponse */
static int hf_iicp_iICPpdu = -1;                  /* IICPpdu */
static int hf_iicp_errorStatus = -1;              /* T_errorStatus */
static int hf_iicp_secRs = -1;                    /* SecRs */
static int hf_iicp_iicpResRef = -1;               /* RefIICPResp */
static int hf_iicp_iicpRes = -1;                  /* T_iicpRes */
static int hf_iicp_mCmdRef_01 = -1;               /* RefMcmdRs */
static int hf_iicp_mcmd_01 = -1;                  /* T_mcmd_01 */
static int hf_iicp_VCI_info_res_item = -1;        /* VCI_Info */
/* named bits */
static int hf_iicp_Security_userAuthentication = -1;
static int hf_iicp_Security_terminalAuthentication = -1;
static int hf_iicp_Security_dataAuthentication = -1;
static int hf_iicp_Security_consealment = -1;
static int hf_iicp_T_meansOfTransportation_undefined = -1;
static int hf_iicp_T_meansOfTransportation_vehicle = -1;
static int hf_iicp_T_meansOfTransportation_publicTransport = -1;
static int hf_iicp_T_meansOfTransportation_foot = -1;
static int hf_iicp_T_meansOfTransportation_bicycle = -1;
static int hf_iicp_T_meansOfTransportation_motorCycle = -1;
static int hf_iicp_T_meansOfTransportation_moped = -1;
static int hf_iicp_T_meansOfTransportation_car = -1;
static int hf_iicp_T_meansOfTransportation_truck = -1;
static int hf_iicp_T_meansOfTransportation_emergencyVehicle = -1;
static int hf_iicp_T_meansOfTransportation_buss = -1;
static int hf_iicp_T_meansOfTransportation_tram = -1;
static int hf_iicp_T_meansOfTransportation_train = -1;
static int hf_iicp_T_meansOfTransportation_ferry = -1;
static int hf_iicp_T_meansOfTransportation_taxi = -1;
static int hf_iicp_T_meansOfTransportation_other = -1;
static int hf_iicp_T_dataExpressionCode_undefined = -1;
static int hf_iicp_T_dataExpressionCode_text = -1;
static int hf_iicp_T_dataExpressionCode_audio = -1;
static int hf_iicp_T_dataExpressionCode_simpleGraphic = -1;
static int hf_iicp_T_dataExpressionCode_stillImage = -1;
static int hf_iicp_T_dataExpressionCode_video = -1;
static int hf_iicp_T_dataExpressionCode_other = -1;

/*--- End of included file: packet-iicp-hf.c ---*/
#line 161 "../../asn1/calm-iicp/packet-iicp-template.c"

/* Initialize the subtree pointers */
static int ett_iicp = -1;


/*--- Included file: packet-iicp-ett.c ---*/
#line 1 "../../asn1/calm-iicp/packet-iicp-ett.c"
static gint ett_iicp_DeleteIPv6 = -1;
static gint ett_iicp_DeleteNotIPv6 = -1;
static gint ett_iicp_SetConfIPv6 = -1;
static gint ett_iicp_SetIPv6 = -1;
static gint ett_iicp_SetNotIPv6 = -1;
static gint ett_iicp_UpdateIPv6 = -1;
static gint ett_iicp_UpdateNotIPv6 = -1;
static gint ett_iicp_ApplicationID = -1;
static gint ett_iicp_CrCiPrioList = -1;
static gint ett_iicp_CrCiPrioReq = -1;
static gint ett_iicp_SEQUENCE_OF_CCPpotInt = -1;
static gint ett_iicp_CCPrequest = -1;
static gint ett_iicp_CCPrequest_item = -1;
static gint ett_iicp_CCPpotInt = -1;
static gint ett_iicp_ITS_scuList = -1;
static gint ett_iicp_ITS_SSI = -1;
static gint ett_iicp_Param24102 = -1;
static gint ett_iicp_VciList = -1;
static gint ett_iicp_VciListEntry = -1;
static gint ett_iicp_VCIperformList = -1;
static gint ett_iicp_VCIperformance = -1;
static gint ett_iicp_Link_ID = -1;
static gint ett_iicp_CommProfile = -1;
static gint ett_iicp_DataRatesNW = -1;
static gint ett_iicp_Directivity = -1;
static gint ett_iicp_SEQUENCE_SIZE_0_1_OF_DirVar = -1;
static gint ett_iicp_DirVar = -1;
static gint ett_iicp_Errors = -1;
static gint ett_iicp_SingleError = -1;
static gint ett_iicp_KineVectIn = -1;
static gint ett_iicp_KineVectOut = -1;
static gint ett_iicp_SEQUENCE_SIZE_0_5_OF_KineVectOptions = -1;
static gint ett_iicp_KineVectOptions = -1;
static gint ett_iicp_LLserviceAddr = -1;
static gint ett_iicp_MediumUsage = -1;
static gint ett_iicp_MedUseObsTime = -1;
static gint ett_iicp_Notify = -1;
static gint ett_iicp_I_Parameter = -1;
static gint ett_iicp_LogicalChannels = -1;
static gint ett_iicp_Properties = -1;
static gint ett_iicp_ProviderInfo = -1;
static gint ett_iicp_QueueLevel = -1;
static gint ett_iicp_RegInfo = -1;
static gint ett_iicp_RegulatoryScheme = -1;
static gint ett_iicp_VirtualCIs = -1;
static gint ett_iicp_INsapPrimitivesDown = -1;
static gint ett_iicp_IN_UNITDATA_request = -1;
static gint ett_iicp_IN_DATA_ACK_request = -1;
static gint ett_iicp_IN_REPLY_ACK_request = -1;
static gint ett_iicp_IN_REPLY_UPDATE_request = -1;
static gint ett_iicp_INsapPrimitivesUp = -1;
static gint ett_iicp_IN_UNITDATA_indication = -1;
static gint ett_iicp_IN_UNITDATA_STATUS_indication = -1;
static gint ett_iicp_IN_DATA_ACK_indication = -1;
static gint ett_iicp_IN_DATA_ACK_STATUS_indication = -1;
static gint ett_iicp_IN_REPLY_indication = -1;
static gint ett_iicp_IN_REPLY_STATUS_indication = -1;
static gint ett_iicp_IN_REPLY_UPDATE_STATUS_indication = -1;
static gint ett_iicp_AccessParameters = -1;
static gint ett_iicp_LegacyCIID = -1;
static gint ett_iicp_EUI64MAC48 = -1;
static gint ett_iicp_MACoui = -1;
static gint ett_iicp_MACmcID = -1;
static gint ett_iicp_FAsapPrimitivesDown = -1;
static gint ett_iicp_FAsapPrimitivesUp = -1;
static gint ett_iicp_MF_Command_request = -1;
static gint ett_iicp_LDMnotify = -1;
static gint ett_iicp_RadarView = -1;
static gint ett_iicp_LegacyCIreq = -1;
static gint ett_iicp_StateCInotify = -1;
static gint ett_iicp_MF_Command_confirm = -1;
static gint ett_iicp_MF_Request_request = -1;
static gint ett_iicp_LDMregister = -1;
static gint ett_iicp_TestMFecho = -1;
static gint ett_iicp_MF_Request_confirm = -1;
static gint ett_iicp_MN_Command_request = -1;
static gint ett_iicp_FWTset = -1;
static gint ett_iicp_FWTupdate = -1;
static gint ett_iicp_FWTdelete = -1;
static gint ett_iicp_MN_Command_confirm = -1;
static gint ett_iicp_FWTsetConf = -1;
static gint ett_iicp_FWTupdateConf = -1;
static gint ett_iicp_FWTdeleteConf = -1;
static gint ett_iicp_MN_Request_request = -1;
static gint ett_iicp_FWTsetNot = -1;
static gint ett_iicp_FWTupdateNot = -1;
static gint ett_iicp_FWTdeleteNot = -1;
static gint ett_iicp_VCIcreatePeerMAC = -1;
static gint ett_iicp_Its_ssiPeerNot = -1;
static gint ett_iicp_TestMNecho = -1;
static gint ett_iicp_MN_Request_confirm = -1;
static gint ett_iicp_VCIPeerMAC = -1;
static gint ett_iicp_MI_Command_request = -1;
static gint ett_iicp_RegCmd = -1;
static gint ett_iicp_RTScmd = -1;
static gint ett_iicp_ReqID = -1;
static gint ett_iicp_RTSackCmd = -1;
static gint ett_iicp_RIcmd = -1;
static gint ett_iicp_VciCmd = -1;
static gint ett_iicp_VciCmd_item = -1;
static gint ett_iicp_Monitor = -1;
static gint ett_iicp_Monitor_item = -1;
static gint ett_iicp_UnitData = -1;
static gint ett_iicp_MI_Command_confirm = -1;
static gint ett_iicp_MI_Request_request = -1;
static gint ett_iicp_RegReq = -1;
static gint ett_iicp_PrioReg = -1;
static gint ett_iicp_Interferers = -1;
static gint ett_iicp_RTSreq = -1;
static gint ett_iicp_RTSackReq = -1;
static gint ett_iicp_RIreq = -1;
static gint ett_iicp_Events21218 = -1;
static gint ett_iicp_E21218_0 = -1;
static gint ett_iicp_TestMIecho = -1;
static gint ett_iicp_MI_Request_confirm = -1;
static gint ett_iicp_MI_Set_request = -1;
static gint ett_iicp_SEQUENCE_OF_I_Parameter = -1;
static gint ett_iicp_MI_Set_confirm = -1;
static gint ett_iicp_SEQUENCE_OF_Errors = -1;
static gint ett_iicp_MI_Get_request = -1;
static gint ett_iicp_SEQUENCE_OF_I_ParamNo = -1;
static gint ett_iicp_MI_Get_confirm = -1;
static gint ett_iicp_MS_Command_request = -1;
static gint ett_iicp_MS_Command_confirm = -1;
static gint ett_iicp_MS_Request_request = -1;
static gint ett_iicp_TestMSecho = -1;
static gint ett_iicp_MS_Request_confirm = -1;
static gint ett_iicp_MA_Command_request = -1;
static gint ett_iicp_MA_Command_confirm = -1;
static gint ett_iicp_MA_Request_request = -1;
static gint ett_iicp_TestMAecho = -1;
static gint ett_iicp_MA_Request_confirm = -1;
static gint ett_iicp_FNTPNPDU = -1;
static gint ett_iicp_FNTPHeader = -1;
static gint ett_iicp_FntpOptions = -1;
static gint ett_iicp_FNTPintForwarding = -1;
static gint ett_iicp_FNTPCIPheader = -1;
static gint ett_iicp_DeleteFNTP = -1;
static gint ett_iicp_DeleteNotFNTP = -1;
static gint ett_iicp_SetFNTP = -1;
static gint ett_iicp_SetConfFNTP = -1;
static gint ett_iicp_HostServiceInfo = -1;
static gint ett_iicp_SetNotFNTP = -1;
static gint ett_iicp_UpdateFNTP = -1;
static gint ett_iicp_UpdateNotFNTP = -1;
static gint ett_iicp_NFsapPrimitivesDown = -1;
static gint ett_iicp_NFsapPrimitivesUp = -1;
static gint ett_iicp_NFfntpPortRequest = -1;
static gint ett_iicp_NFfntpPortConfirm = -1;
static gint ett_iicp_NFfntpCommRequest = -1;
static gint ett_iicp_NFfntpCommConfirm = -1;
static gint ett_iicp_NFfntpCommIndication = -1;
static gint ett_iicp_PortNumber = -1;
static gint ett_iicp_SAM = -1;
static gint ett_iicp_ServiceList = -1;
static gint ett_iicp_ChannelList = -1;
static gint ett_iicp_IpServList = -1;
static gint ett_iicp_NonipService = -1;
static gint ett_iicp_SessionChannel = -1;
static gint ett_iicp_IpService = -1;
static gint ett_iicp_CTX = -1;
static gint ett_iicp_ServContextList = -1;
static gint ett_iicp_IpContextList = -1;
static gint ett_iicp_IpContext = -1;
static gint ett_iicp_GCctxTxCmd = -1;
static gint ett_iicp_GCperiodCmd = -1;
static gint ett_iicp_SEQUENCE_SIZE_1_256_OF_LLserviceAddr = -1;
static gint ett_iicp_GCsamctx = -1;
static gint ett_iicp_GCsamctxConf = -1;
static gint ett_iicp_GCdeleteCmd = -1;
static gint ett_iicp_ServiceInfo = -1;
static gint ett_iicp_T_info = -1;
static gint ett_iicp_NonipSAMctx = -1;
static gint ett_iicp_IpSAMctx = -1;
static gint ett_iicp_CTXrxNot = -1;
static gint ett_iicp_SAMrxNot = -1;
static gint ett_iicp_GCsam = -1;
static gint ett_iicp_SAMserviceData = -1;
static gint ett_iicp_T_servData = -1;
static gint ett_iicp_NonipSAM = -1;
static gint ett_iicp_IpSAM = -1;
static gint ett_iicp_GCctx = -1;
static gint ett_iicp_CTXserviceData = -1;
static gint ett_iicp_T_servData_01 = -1;
static gint ett_iicp_NonipContext = -1;
static gint ett_iicp_GCregServer = -1;
static gint ett_iicp_GCupdateServer = -1;
static gint ett_iicp_SEQUENCE_SIZE_0_1_OF_ServiceDataReg = -1;
static gint ett_iicp_GCderegServer = -1;
static gint ett_iicp_GCregClient = -1;
static gint ett_iicp_GCupdateClient = -1;
static gint ett_iicp_GCderegClient = -1;
static gint ett_iicp_GCregServerConf = -1;
static gint ett_iicp_GCupdateServerConf = -1;
static gint ett_iicp_GCderegServerConf = -1;
static gint ett_iicp_GCregClientConf = -1;
static gint ett_iicp_GCupdateClientConf = -1;
static gint ett_iicp_GCderegClientConf = -1;
static gint ett_iicp_GCschedule = -1;
static gint ett_iicp_GCsched = -1;
static gint ett_iicp_ServiceDataReg = -1;
static gint ett_iicp_T_datareg = -1;
static gint ett_iicp_NonipServiceReg = -1;
static gint ett_iicp_IpServiceReg = -1;
static gint ett_iicp_IpInfo = -1;
static gint ett_iicp_IpAddressInfo = -1;
static gint ett_iicp_Param15628 = -1;
static gint ett_iicp_T_params = -1;
static gint ett_iicp_ITSapObRegistry = -1;
static gint ett_iicp_ITSapOb = -1;
static gint ett_iicp_ITSapObPorts = -1;
static gint ett_iicp_ITSapObPorts_item = -1;
static gint ett_iicp_SEQUENCE_OF_ITSapObPort = -1;
static gint ett_iicp_ITSapObPort = -1;
static gint ett_iicp_ITSapObPortRule = -1;
static gint ett_iicp_LogicalChannelPrio = -1;
static gint ett_iicp_ITSObOwner = -1;
static gint ett_iicp_ITSapObCertificate = -1;
static gint ett_iicp_IssuingSA = -1;
static gint ett_iicp_CertStartDate = -1;
static gint ett_iicp_T_csd = -1;
static gint ett_iicp_CertEndDate = -1;
static gint ett_iicp_T_ced = -1;
static gint ett_iicp_CertStatus = -1;
static gint ett_iicp_T_cs = -1;
static gint ett_iicp_CertBlocked = -1;
static gint ett_iicp_ITSmsgSetRegistry = -1;
static gint ett_iicp_ITSmsgSet = -1;
static gint ett_iicp_ITSregRegionRegistry = -1;
static gint ett_iicp_ITSregRegion = -1;
static gint ett_iicp_ITS_RegPolicyAuthority = -1;
static gint ett_iicp_ITS_RParea = -1;
static gint ett_iicp_GeoPolygon = -1;
static gint ett_iicp_GeoCoordinates = -1;
static gint ett_iicp_ITSpolRegionRegistry = -1;
static gint ett_iicp_ITSpolRegion = -1;
static gint ett_iicp_ITSportNumberRegistry = -1;
static gint ett_iicp_ITSportNumber = -1;
static gint ett_iicp_ItsAppInfo = -1;
static gint ett_iicp_NTprotocol = -1;
static gint ett_iicp_ProtocolReference = -1;
static gint ett_iicp_ITSflowTypeRegistry = -1;
static gint ett_iicp_ITSflowType = -1;
static gint ett_iicp_ITSlchRegistry = -1;
static gint ett_iicp_ITSlch = -1;
static gint ett_iicp_ITSsuRegistry = -1;
static gint ett_iicp_ITSsu = -1;
static gint ett_iicp_ITSscuRegistry = -1;
static gint ett_iicp_ITSscu = -1;
static gint ett_iicp_ITSSappRegistry = -1;
static gint ett_iicp_ITSSapPrPr = -1;
static gint ett_iicp_RegEntryOwner = -1;
static gint ett_iicp_ITSemRegistry = -1;
static gint ett_iicp_ITSem = -1;
static gint ett_iicp_ITSaooRegistry = -1;
static gint ett_iicp_ITSaoo = -1;
static gint ett_iicp_Registry = -1;
static gint ett_iicp_ITSmso = -1;
static gint ett_iicp_ITSSapdRegistry = -1;
static gint ett_iicp_ITSSapd = -1;
static gint ett_iicp_ITSsuID = -1;
static gint ett_iicp_ITSscuID = -1;
static gint ett_iicp_VarLengthNumber = -1;
static gint ett_iicp_Ext1 = -1;
static gint ett_iicp_Ext2 = -1;
static gint ett_iicp_VarLengthNumber2 = -1;
static gint ett_iicp_ITSSappCPReqReg = -1;
static gint ett_iicp_ITSSappRxTxPort = -1;
static gint ett_iicp_ServiceRef = -1;
static gint ett_iicp_ITSSappCPReqConf = -1;
static gint ett_iicp_ITSSappReq = -1;
static gint ett_iicp_ITSSappReq_item = -1;
static gint ett_iicp_ITSSappReqConf = -1;
static gint ett_iicp_ITSSappReqConf_item = -1;
static gint ett_iicp_ITSSappCPFinal = -1;
static gint ett_iicp_DestinationType = -1;
static gint ett_iicp_DestType = -1;
static gint ett_iicp_AddressBasedType = -1;
static gint ett_iicp_SEQUENCE_SIZE_0_255_OF_MCgroup = -1;
static gint ett_iicp_GeoLocationBasedType = -1;
static gint ett_iicp_ContConnect = -1;
static gint ett_iicp_TimDurationValue = -1;
static gint ett_iicp_NxRepeat = -1;
static gint ett_iicp_CommDistance = -1;
static gint ett_iicp_MultiHop = -1;
static gint ett_iicp_MinThP = -1;
static gint ett_iicp_MaxLat = -1;
static gint ett_iicp_Policies = -1;
static gint ett_iicp_Policies_item = -1;
static gint ett_iicp_MediumCost = -1;
static gint ett_iicp_CostAmount = -1;
static gint ett_iicp_CostValue = -1;
static gint ett_iicp_CostTimeUnit = -1;
static gint ett_iicp_ITS_S_Appl_Reg = -1;
static gint ett_iicp_ITS_S_Appl_RegConf = -1;
static gint ett_iicp_ProtocolManagementInformation = -1;
static gint ett_iicp_SelectionOfCommunicationSystem = -1;
static gint ett_iicp_ApplicationIdentifiers = -1;
static gint ett_iicp_Address = -1;
static gint ett_iicp_Priority = -1;
static gint ett_iicp_Security = -1;
static gint ett_iicp_ApplicationExecution = -1;
static gint ett_iicp_Responsiveness = -1;
static gint ett_iicp_UsageEnvironment = -1;
static gint ett_iicp_T_meansOfTransportation = -1;
static gint ett_iicp_ServiceArea = -1;
static gint ett_iicp_ServiceTime = -1;
static gint ett_iicp_Bandwidth = -1;
static gint ett_iicp_T_dataExpressionCode = -1;
static gint ett_iicp_ConnectionCost = -1;
static gint ett_iicp_ValidTime = -1;
static gint ett_iicp_TargetArea = -1;
static gint ett_iicp_IIC_Request = -1;
static gint ett_iicp_IICPpdu = -1;
static gint ett_iicp_IICPrequest = -1;
static gint ett_iicp_ITS_SCUalive = -1;
static gint ett_iicp_McmdRq = -1;
static gint ett_iicp_VCI_info_req = -1;
static gint ett_iicp_VCI_update_req = -1;
static gint ett_iicp_VCI_Info = -1;
static gint ett_iicp_TestIicp = -1;
static gint ett_iicp_T_action = -1;
static gint ett_iicp_MFrcmd = -1;
static gint ett_iicp_MNrcmd = -1;
static gint ett_iicp_MIrcmd = -1;
static gint ett_iicp_TestConfigIICP = -1;
static gint ett_iicp_IIC_Response = -1;
static gint ett_iicp_T_pduResponse = -1;
static gint ett_iicp_IICPresponse = -1;
static gint ett_iicp_McmdRs = -1;
static gint ett_iicp_VCI_info_res = -1;

/*--- End of included file: packet-iicp-ett.c ---*/
#line 166 "../../asn1/calm-iicp/packet-iicp-template.c"


/*--- Included file: packet-iicp-fn.c ---*/
#line 1 "../../asn1/calm-iicp/packet-iicp-fn.c"


static int
dissect_iicp_INTEGER_0_65535(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 65535U, NULL, FALSE);

  return offset;
}


static const per_sequence_t DeleteIPv6_sequence[] = {
  { &hf_iicp_reference      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_65535 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_DeleteIPv6(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_DeleteIPv6, DeleteIPv6_sequence);

  return offset;
}


static const per_sequence_t DeleteNotIPv6_sequence[] = {
  { &hf_iicp_reference      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_65535 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_DeleteNotIPv6(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_DeleteNotIPv6, DeleteNotIPv6_sequence);

  return offset;
}


static const per_sequence_t SetConfIPv6_sequence[] = {
  { &hf_iicp_reference      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_65535 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_SetConfIPv6(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_SetConfIPv6, SetConfIPv6_sequence);

  return offset;
}



static int
dissect_iicp_TransportAddressType(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       6, 6, FALSE, NULL);

  return offset;
}



static int
dissect_iicp_TransportAddress(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       6, 6, FALSE, NULL);

  return offset;
}


static const per_sequence_t IpAddressInfo_sequence[] = {
  { &hf_iicp_addressType    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_TransportAddressType },
  { &hf_iicp_address_01     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_TransportAddress },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_IpAddressInfo(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_IpAddressInfo, IpAddressInfo_sequence);

  return offset;
}



static int
dissect_iicp_EUI64(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       8, 8, FALSE, NULL);

  return offset;
}


static const per_sequence_t Link_ID_sequence[] = {
  { &hf_iicp_remoteCIID     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_EUI64 },
  { &hf_iicp_localCIID      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_EUI64 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_Link_ID(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_Link_ID, Link_ID_sequence);

  return offset;
}


static const value_string iicp_CIstatus_vals[] = {
  {   0, "not-existent" },
  {   1, "existent" },
  {   2, "unknown" },
  {   4, "registered" },
  {   8, "active" },
  {  16, "connected" },
  {  64, "suspended" },
  { 128, "inactive" },
  { 0, NULL }
};


static int
dissect_iicp_CIstatus(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_UserPriority(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_IPv6timeout(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 65535U, NULL, FALSE);

  return offset;
}


static const per_sequence_t SetIPv6_sequence[] = {
  { &hf_iicp_reference      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_65535 },
  { &hf_iicp_remoteIP       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_IpAddressInfo },
  { &hf_iicp_ciid           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Link_ID },
  { &hf_iicp_ciStatus       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CIstatus },
  { &hf_iicp_localIP        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_IpAddressInfo },
  { &hf_iicp_priority       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_UserPriority },
  { &hf_iicp_timeout        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_IPv6timeout },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_SetIPv6(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_SetIPv6, SetIPv6_sequence);

  return offset;
}


static const per_sequence_t SetNotIPv6_sequence[] = {
  { &hf_iicp_reference      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_65535 },
  { &hf_iicp_remoteIP       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_IpAddressInfo },
  { &hf_iicp_ciid           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Link_ID },
  { &hf_iicp_ciStatus       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CIstatus },
  { &hf_iicp_localIP        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_IpAddressInfo },
  { &hf_iicp_priority       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_UserPriority },
  { &hf_iicp_timeout        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_IPv6timeout },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_SetNotIPv6(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_SetNotIPv6, SetNotIPv6_sequence);

  return offset;
}



static int
dissect_iicp_BIT_STRING_SIZE_2(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     2, 2, FALSE, NULL);

  return offset;
}


static const per_sequence_t UpdateIPv6_sequence[] = {
  { &hf_iicp_fill           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_BIT_STRING_SIZE_2 },
  { &hf_iicp_reference      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_65535 },
  { &hf_iicp_remoteIP       , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_IpAddressInfo },
  { &hf_iicp_ciid           , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_Link_ID },
  { &hf_iicp_ciStatus       , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_CIstatus },
  { &hf_iicp_localIP        , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_IpAddressInfo },
  { &hf_iicp_priority       , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_UserPriority },
  { &hf_iicp_timeout        , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_IPv6timeout },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_UpdateIPv6(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_UpdateIPv6, UpdateIPv6_sequence);

  return offset;
}


static const per_sequence_t UpdateNotIPv6_sequence[] = {
  { &hf_iicp_fill           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_BIT_STRING_SIZE_2 },
  { &hf_iicp_reference      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_65535 },
  { &hf_iicp_remoteIP       , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_IpAddressInfo },
  { &hf_iicp_ciid           , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_Link_ID },
  { &hf_iicp_ciStatus       , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_CIstatus },
  { &hf_iicp_localIP        , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_IpAddressInfo },
  { &hf_iicp_priority       , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_UserPriority },
  { &hf_iicp_timeout        , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_IPv6timeout },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_UpdateNotIPv6(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_UpdateNotIPv6, UpdateNotIPv6_sequence);

  return offset;
}



static int
dissect_iicp_ITS_scuId(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 65535U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_INTEGER_0_127(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 127U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_INTEGER_128_16511(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            128U, 16511U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_INTEGER_16512_2113663(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            16512U, 2113663U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_Ext3(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            211664U, 270549119U, NULL, TRUE);

  return offset;
}


static const value_string iicp_Ext2_vals[] = {
  {   0, "content" },
  {   1, "extension" },
  { 0, NULL }
};

static const per_choice_t Ext2_choice[] = {
  {   0, &hf_iicp_content_02     , ASN1_NO_EXTENSIONS     , dissect_iicp_INTEGER_16512_2113663 },
  {   1, &hf_iicp_extension_02   , ASN1_NO_EXTENSIONS     , dissect_iicp_Ext3 },
  { 0, NULL, 0, NULL }
};

static int
dissect_iicp_Ext2(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_iicp_Ext2, Ext2_choice,
                                 NULL);

  return offset;
}


static const value_string iicp_Ext1_vals[] = {
  {   0, "content" },
  {   1, "extension" },
  { 0, NULL }
};

static const per_choice_t Ext1_choice[] = {
  {   0, &hf_iicp_content_01     , ASN1_NO_EXTENSIONS     , dissect_iicp_INTEGER_128_16511 },
  {   1, &hf_iicp_extension_01   , ASN1_NO_EXTENSIONS     , dissect_iicp_Ext2 },
  { 0, NULL, 0, NULL }
};

static int
dissect_iicp_Ext1(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_iicp_Ext1, Ext1_choice,
                                 NULL);

  return offset;
}


static const value_string iicp_VarLengthNumber_vals[] = {
  {   0, "content" },
  {   1, "extension" },
  { 0, NULL }
};

static const per_choice_t VarLengthNumber_choice[] = {
  {   0, &hf_iicp_content        , ASN1_NO_EXTENSIONS     , dissect_iicp_INTEGER_0_127 },
  {   1, &hf_iicp_extension      , ASN1_NO_EXTENSIONS     , dissect_iicp_Ext1 },
  { 0, NULL, 0, NULL }
};

static int
dissect_iicp_VarLengthNumber(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_iicp_VarLengthNumber, VarLengthNumber_choice,
                                 NULL);

  return offset;
}



static int
dissect_iicp_ITSaid(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_VarLengthNumber(tvb, offset, actx, tree, hf_index);

  return offset;
}



static int
dissect_iicp_INTEGER_0_255(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_FlowNo(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}


static const per_sequence_t ServiceRef_sequence[] = {
  { &hf_iicp_itsaid         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSaid },
  { &hf_iicp_instance       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_255 },
  { &hf_iicp_flowNo         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_FlowNo },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ServiceRef(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ServiceRef, ServiceRef_sequence);

  return offset;
}


static const per_sequence_t ApplicationID_sequence[] = {
  { &hf_iicp_hostITS_scuId  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITS_scuId },
  { &hf_iicp_seqNumber      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ServiceRef },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ApplicationID(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ApplicationID, ApplicationID_sequence);

  return offset;
}



static int
dissect_iicp_INTEGER_0_32767(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 32767U, NULL, FALSE);

  return offset;
}


static const value_string iicp_VarLengthNumber2_vals[] = {
  {   0, "shortNo" },
  {   1, "longNo" },
  { 0, NULL }
};

static const per_choice_t VarLengthNumber2_choice[] = {
  {   0, &hf_iicp_shortNo        , ASN1_NO_EXTENSIONS     , dissect_iicp_INTEGER_0_127 },
  {   1, &hf_iicp_longNo         , ASN1_NO_EXTENSIONS     , dissect_iicp_INTEGER_0_32767 },
  { 0, NULL, 0, NULL }
};

static int
dissect_iicp_VarLengthNumber2(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_iicp_VarLengthNumber2, VarLengthNumber2_choice,
                                 NULL);

  return offset;
}



static int
dissect_iicp_ITSSappRxTxPortNo(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_VarLengthNumber2(tvb, offset, actx, tree, hf_index);

  return offset;
}


static const value_string iicp_ITSSappRxTxPortType_vals[] = {
  {   0, "rxPort" },
  { 255, "txPort" },
  { 0, NULL }
};


static int
dissect_iicp_ITSSappRxTxPortType(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}


static const per_sequence_t ITSSappRxTxPort_sequence[] = {
  { &hf_iicp_portNo         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSSappRxTxPortNo },
  { &hf_iicp_portType       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSSappRxTxPortType },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ITSSappRxTxPort(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ITSSappRxTxPort, ITSSappRxTxPort_sequence);

  return offset;
}



static int
dissect_iicp_T_refNo(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_integer(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}



static int
dissect_iicp_T_param_01(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}


static const per_sequence_t ITSSappReq_item_sequence[] = {
  { &hf_iicp_refNo          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_refNo },
  { &hf_iicp_param_01       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_param_01 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ITSSappReq_item(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ITSSappReq_item, ITSSappReq_item_sequence);

  return offset;
}


static const per_sequence_t ITSSappReq_sequence_of[1] = {
  { &hf_iicp_ITSSappReq_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSSappReq_item },
};

static int
dissect_iicp_ITSSappReq(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence_of(tvb, offset, actx, tree, hf_index,
                                      ett_iicp_ITSSappReq, ITSSappReq_sequence_of);

  return offset;
}


static const per_sequence_t ITSSappCPReqReg_sequence[] = {
  { &hf_iicp_applicationID  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ApplicationID },
  { &hf_iicp_rxTxPort       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSSappRxTxPort },
  { &hf_iicp_requirements   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSSappReq },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ITSSappCPReqReg(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ITSSappCPReqReg, ITSSappCPReqReg_sequence);

  return offset;
}



static int
dissect_iicp_ApplReqList(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_ITSSappCPReqReg(tvb, offset, actx, tree, hf_index);

  return offset;
}


static const value_string iicp_CCPstatus_vals[] = {
  {   0, "released" },
  {  16, "requestd" },
  {  64, "ignored" },
  { 128, "granted" },
  { 0, NULL }
};


static int
dissect_iicp_CCPstatus(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_integer(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}


static const per_sequence_t CCPrequest_item_sequence[] = {
  { &hf_iicp_reqNo          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_255 },
  { &hf_iicp_priority       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_UserPriority },
  { &hf_iicp_status         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CCPstatus },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_CCPrequest_item(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_CCPrequest_item, CCPrequest_item_sequence);

  return offset;
}


static const per_sequence_t CCPrequest_sequence_of[1] = {
  { &hf_iicp_CCPrequest_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CCPrequest_item },
};

static int
dissect_iicp_CCPrequest(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_iicp_CCPrequest, CCPrequest_sequence_of,
                                                  0, 255, FALSE);

  return offset;
}


static const per_sequence_t CCPpotInt_sequence[] = {
  { &hf_iicp_linkID         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Link_ID },
  { &hf_iicp_status         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CCPstatus },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_CCPpotInt(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_CCPpotInt, CCPpotInt_sequence);

  return offset;
}


static const per_sequence_t SEQUENCE_OF_CCPpotInt_sequence_of[1] = {
  { &hf_iicp_interferer_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CCPpotInt },
};

static int
dissect_iicp_SEQUENCE_OF_CCPpotInt(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence_of(tvb, offset, actx, tree, hf_index,
                                      ett_iicp_SEQUENCE_OF_CCPpotInt, SEQUENCE_OF_CCPpotInt_sequence_of);

  return offset;
}


static const per_sequence_t CrCiPrioReq_sequence[] = {
  { &hf_iicp_linkId         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Link_ID },
  { &hf_iicp_timeout_01     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_255 },
  { &hf_iicp_request        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CCPrequest },
  { &hf_iicp_interferer     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_SEQUENCE_OF_CCPpotInt },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_CrCiPrioReq(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_CrCiPrioReq, CrCiPrioReq_sequence);

  return offset;
}


static const per_sequence_t CrCiPrioList_sequence_of[1] = {
  { &hf_iicp_CrCiPrioList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CrCiPrioReq },
};

static int
dissect_iicp_CrCiPrioList(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_iicp_CrCiPrioList, CrCiPrioList_sequence_of,
                                                  0, 255, FALSE);

  return offset;
}


static const value_string iicp_ITS_SCUtype_vals[] = {
  {   1, "host" },
  {   2, "router" },
  {   3, "itsTestSystem" },
  { 255, "any" },
  { 0, NULL }
};


static int
dissect_iicp_ITS_SCUtype(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_GeneralizedTime(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_VisibleString(tvb, offset, actx, tree, hf_index,
                                        NO_BOUND, NO_BOUND, FALSE);

  return offset;
}



static int
dissect_iicp_PrintableString(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_PrintableString(tvb, offset, actx, tree, hf_index,
                                          NO_BOUND, NO_BOUND, FALSE);

  return offset;
}


static const per_sequence_t ITS_scuList_sequence[] = {
  { &hf_iicp_iTS_scuId6     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITS_scuId },
  { &hf_iicp_its_scuType    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITS_SCUtype },
  { &hf_iicp_time           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_GeneralizedTime },
  { &hf_iicp_uniqueID       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_PrintableString },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ITS_scuList(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ITS_scuList, ITS_scuList_sequence);

  return offset;
}


static const value_string iicp_StationType_vals[] = {
  {   0, "mobile" },
  {   1, "fixed" },
  {   2, "portable" },
  { 254, "infrastructure" },
  { 255, "unknown" },
  { 0, NULL }
};


static int
dissect_iicp_StationType(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_StationID(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       4, 4, FALSE, NULL);

  return offset;
}


static const value_string iicp_Time48IAT_vals[] = {
  {   0, "utcStartOf2004" },
  {   1, "oneMillisecAfterUTCStartOf2004" },
  { 0, NULL }
};


static int
dissect_iicp_Time48IAT(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
#line 48 "../../asn1/calm-iicp/iicp.cnf"
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index, G_MININT32, 214748367U, NULL, FALSE);


  return offset;
}



static int
dissect_iicp_BIT_STRING_SIZE_5(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     5, 5, FALSE, NULL);

  return offset;
}



static int
dissect_iicp_Lat(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            G_MININT32, 2147483647U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_Lon(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            G_MININT32, 2147483647U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_Alt(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 65535U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_Gs(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 65535U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_Tta(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 65535U, NULL, FALSE);

  return offset;
}


static const value_string iicp_KineVectOptions_vals[] = {
  {   0, "lat" },
  {   1, "lon" },
  {   2, "alt" },
  {   3, "gs" },
  {   4, "tta" },
  { 0, NULL }
};

static const per_choice_t KineVectOptions_choice[] = {
  {   0, &hf_iicp_lat            , ASN1_NO_EXTENSIONS     , dissect_iicp_Lat },
  {   1, &hf_iicp_lon            , ASN1_NO_EXTENSIONS     , dissect_iicp_Lon },
  {   2, &hf_iicp_alt            , ASN1_NO_EXTENSIONS     , dissect_iicp_Alt },
  {   3, &hf_iicp_gs             , ASN1_NO_EXTENSIONS     , dissect_iicp_Gs },
  {   4, &hf_iicp_tta            , ASN1_NO_EXTENSIONS     , dissect_iicp_Tta },
  { 0, NULL, 0, NULL }
};

static int
dissect_iicp_KineVectOptions(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_iicp_KineVectOptions, KineVectOptions_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_0_5_OF_KineVectOptions_sequence_of[1] = {
  { &hf_iicp_options_item   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_KineVectOptions },
};

static int
dissect_iicp_SEQUENCE_SIZE_0_5_OF_KineVectOptions(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_iicp_SEQUENCE_SIZE_0_5_OF_KineVectOptions, SEQUENCE_SIZE_0_5_OF_KineVectOptions_sequence_of,
                                                  0, 5, FALSE);

  return offset;
}


static const per_sequence_t KineVectOut_sequence[] = {
  { &hf_iicp_dut            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Time48IAT },
  { &hf_iicp_fill_02        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_BIT_STRING_SIZE_5 },
  { &hf_iicp_options        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_SEQUENCE_SIZE_0_5_OF_KineVectOptions },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_KineVectOut(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_KineVectOut, KineVectOut_sequence);

  return offset;
}


static const per_sequence_t ITS_SSI_sequence[] = {
  { &hf_iicp_stationType    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_StationType },
  { &hf_iicp_stationID      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_StationID },
  { &hf_iicp_stationPosition, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_KineVectOut },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ITS_SSI(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ITS_SSI, ITS_SSI_sequence);

  return offset;
}



static int
dissect_iicp_T_paramNo(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_integer(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}



static int
dissect_iicp_T_param(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}


static const per_sequence_t Param24102_sequence[] = {
  { &hf_iicp_paramNo        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_paramNo },
  { &hf_iicp_param          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_param },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_Param24102(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_Param24102, Param24102_sequence);

  return offset;
}


static const value_string iicp_Param24102No_vals[] = {
  {   0, "stationID" },
  {   1, "minPrioCrossCI" },
  {   2, "stationPosition" },
  {   3, "iTS-scuId5" },
  {   4, "vciList" },
  {   5, "crCiPrioList" },
  {   6, "timerITS-SSI" },
  {   7, "its-ssi" },
  {   8, "applReqList" },
  {   9, "vCIperformList" },
  {  10, "talive" },
  {  11, "iTS-scuList" },
  { 0, NULL }
};


static int
dissect_iicp_Param24102No(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_Talive(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 65535U, NULL, FALSE);

  return offset;
}


static const value_string iicp_MedType_vals[] = {
  {   0, "unknown" },
  {   1, "any" },
  {   2, "iso21212" },
  {   3, "iso21213" },
  {   4, "iso21214" },
  {   5, "iso21215" },
  {   6, "iso21216" },
  {   7, "iso25112" },
  {   8, "iso25113" },
  {   9, "iso29283" },
  {  10, "iso17515" },
  { 128, "iso15628" },
  { 254, "can" },
  { 255, "ethernet" },
  { 0, NULL }
};


static int
dissect_iicp_MedType(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}


static const value_string iicp_Connect_vals[] = {
  {   0, "automatic" },
  { 255, "manual" },
  { 0, NULL }
};


static int
dissect_iicp_Connect(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_MACaddress(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       6, 6, FALSE, NULL);

  return offset;
}


static const per_sequence_t VciListEntry_sequence[] = {
  { &hf_iicp_linkId         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Link_ID },
  { &hf_iicp_medType        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_MedType },
  { &hf_iicp_status_01      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CIstatus },
  { &hf_iicp_connect        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Connect },
  { &hf_iicp_macAddress     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_MACaddress },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_VciListEntry(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_VciListEntry, VciListEntry_sequence);

  return offset;
}


static const per_sequence_t VciList_sequence_of[1] = {
  { &hf_iicp_VciList_item   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_VciListEntry },
};

static int
dissect_iicp_VciList(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_iicp_VciList, VciList_sequence_of,
                                                  0, 255, FALSE);

  return offset;
}



static int
dissect_iicp_LogicalChannelType(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_VarLengthNumber2(tvb, offset, actx, tree, hf_index);

  return offset;
}



static int
dissect_iicp_DataRate(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 4294967295U, NULL, FALSE);

  return offset;
}


static const per_sequence_t DataRatesNW_sequence[] = {
  { &hf_iicp_minimum        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_DataRate },
  { &hf_iicp_maximum        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_DataRate },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_DataRatesNW(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_DataRatesNW, DataRatesNW_sequence);

  return offset;
}


static const value_string iicp_DirMode_vals[] = {
  {   0, "fixed" },
  { 255, "tracking" },
  { 0, NULL }
};


static int
dissect_iicp_DirMode(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_BIT_STRING_SIZE_7(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     7, 7, FALSE, NULL);

  return offset;
}



static int
dissect_iicp_INTEGER_M32768_32767(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            -32768, 32767U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_INTEGER_M128_127(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            -128, 127U, NULL, FALSE);

  return offset;
}


static const per_sequence_t DirVar_sequence[] = {
  { &hf_iicp_bsAzimuth      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_M32768_32767 },
  { &hf_iicp_bsElevation    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_M128_127 },
  { &hf_iicp_openHorizontal , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_255 },
  { &hf_iicp_openVertical   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_255 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_DirVar(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_DirVar, DirVar_sequence);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_0_1_OF_DirVar_sequence_of[1] = {
  { &hf_iicp_dirVar_item    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_DirVar },
};

static int
dissect_iicp_SEQUENCE_SIZE_0_1_OF_DirVar(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_iicp_SEQUENCE_SIZE_0_1_OF_DirVar, SEQUENCE_SIZE_0_1_OF_DirVar_sequence_of,
                                                  0, 1, FALSE);

  return offset;
}


static const per_sequence_t Directivity_sequence[] = {
  { &hf_iicp_mode           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_DirMode },
  { &hf_iicp_dirPredef      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_255 },
  { &hf_iicp_fill_01        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_BIT_STRING_SIZE_7 },
  { &hf_iicp_dirVar         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_SEQUENCE_SIZE_0_1_OF_DirVar },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_Directivity(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_Directivity, Directivity_sequence);

  return offset;
}


static const value_string iicp_CostClass_vals[] = {
  {   0, "tempUnavailable" },
  {   1, "noCharge" },
  {   2, "flatRate" },
  {   3, "perTime" },
  {   4, "perAmount" },
  {   5, "perConnection" },
  { 0, NULL }
};


static int
dissect_iicp_CostClass(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 7U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_INTEGER_0_1023(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 1023U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_INTEGER_0_4095(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 4095U, NULL, FALSE);

  return offset;
}


static const per_sequence_t CostValue_sequence[] = {
  { &hf_iicp_main           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_4095 },
  { &hf_iicp_fraction       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_1023 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_CostValue(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_CostValue, CostValue_sequence);

  return offset;
}


static const per_sequence_t CostAmount_sequence[] = {
  { &hf_iicp_currency       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_1023 },
  { &hf_iicp_value_01       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CostValue },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_CostAmount(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_CostAmount, CostAmount_sequence);

  return offset;
}



static int
dissect_iicp_BIT_STRING_SIZE_1(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     1, 1, FALSE, NULL);

  return offset;
}


static const value_string iicp_TimeUnit_vals[] = {
  {   0, "microseconds" },
  {   1, "milliseconds" },
  {   2, "seconds" },
  {   3, "minutes" },
  {   4, "hours" },
  {   5, "days" },
  {   6, "weeks" },
  {   7, "months" },
  {   8, "years" },
  { 0, NULL }
};


static int
dissect_iicp_TimeUnit(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 63U, NULL, FALSE);

  return offset;
}


static const per_sequence_t CostTimeUnit_sequence[] = {
  { &hf_iicp_value          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_1023 },
  { &hf_iicp_fill_03        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_BIT_STRING_SIZE_1 },
  { &hf_iicp_unit           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_TimeUnit },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_CostTimeUnit(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_CostTimeUnit, CostTimeUnit_sequence);

  return offset;
}


static const value_string iicp_CostAmountUnit_vals[] = {
  {   0, "tempUnavailable1" },
  {   1, "kbyte" },
  {   2, "tkbyte" },
  {   4, "hkbyte" },
  {   8, "mbyte" },
  {  16, "tmbyte" },
  {  32, "hmbyte" },
  {  64, "gbyte" },
  { 128, "tgbyte" },
  { 0, NULL }
};


static int
dissect_iicp_CostAmountUnit(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}


static const per_sequence_t MediumCost_sequence[] = {
  { &hf_iicp_fill           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_BIT_STRING_SIZE_2 },
  { &hf_iicp_costClass      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CostClass },
  { &hf_iicp_costAmount     , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_CostAmount },
  { &hf_iicp_timeUnit       , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_CostTimeUnit },
  { &hf_iicp_amountUnit     , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_CostAmountUnit },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_MediumCost(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_MediumCost, MediumCost_sequence);

  return offset;
}


static const per_sequence_t VCIperformance_sequence[] = {
  { &hf_iicp_linkId         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Link_ID },
  { &hf_iicp_channelType    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_LogicalChannelType },
  { &hf_iicp_channelNo      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_255 },
  { &hf_iicp_minUserPrio    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_UserPriority },
  { &hf_iicp_dataRateNW     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_DataRate },
  { &hf_iicp_dataRatesNW    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_DataRatesNW },
  { &hf_iicp_directivity    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Directivity },
  { &hf_iicp_commRangeRef   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_65535 },
  { &hf_iicp_cost           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_MediumCost },
  { &hf_iicp_reliability    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_255 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_VCIperformance(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_VCIperformance, VCIperformance_sequence);

  return offset;
}


static const per_sequence_t VCIperformList_sequence_of[1] = {
  { &hf_iicp_VCIperformList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_VCIperformance },
};

static int
dissect_iicp_VCIperformList(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_iicp_VCIperformList, VCIperformList_sequence_of,
                                                  0, 255, FALSE);

  return offset;
}


static const value_string iicp_CIaClass_vals[] = {
  {   0, "unknown" },
  {   1, "ciac-1" },
  {   2, "ciac-2" },
  {   3, "ciac-3" },
  { 0, NULL }
};


static int
dissect_iicp_CIaClass(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}


static const value_string iicp_CIclass_vals[] = {
  {   0, "unknown" },
  {   1, "cic-l1" },
  {   2, "cic-l2" },
  {   3, "cic-l3" },
  {   4, "cic-l4" },
  {   5, "cic-l5" },
  { 254, "cic-il1" },
  { 255, "cic-il2" },
  { 0, NULL }
};


static int
dissect_iicp_CIclass(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_T_paramNo_01(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_integer(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}



static int
dissect_iicp_T_parameter(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}


static const per_sequence_t I_Parameter_sequence[] = {
  { &hf_iicp_paramNo_02     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_paramNo_01 },
  { &hf_iicp_parameter      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_parameter },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_I_Parameter(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_I_Parameter, I_Parameter_sequence);

  return offset;
}


static const per_sequence_t CommProfile_sequence_of[1] = {
  { &hf_iicp_CommProfile_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_I_Parameter },
};

static int
dissect_iicp_CommProfile(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_iicp_CommProfile, CommProfile_sequence_of,
                                                  0, 255, FALSE);

  return offset;
}



static int
dissect_iicp_IN_SAPaddress(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_TxPowMax(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}


static const value_string iicp_ErrStatus_vals[] = {
  {   0, "success" },
  {   1, "unspecFailure" },
  {   2, "invalParamNo" },
  {   3, "invalParamVal" },
  {   4, "riViolation" },
  {   5, "cmdReqNo" },
  {   6, "cmdReqVal" },
  {   7, "accessViolation" },
  {   8, "invalidType" },
  {   9, "sequenceError" },
  {  10, "nonavailValue" },
  { 255, "hardwareFailure" },
  { 0, NULL }
};


static int
dissect_iicp_ErrStatus(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}


static const per_sequence_t SingleError_sequence[] = {
  { &hf_iicp_paramNo_01     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_255 },
  { &hf_iicp_errStatus      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ErrStatus },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_SingleError(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_SingleError, SingleError_sequence);

  return offset;
}


static const per_sequence_t Errors_sequence_of[1] = {
  { &hf_iicp_Errors_item    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_SingleError },
};

static int
dissect_iicp_Errors(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_iicp_Errors, Errors_sequence_of,
                                                  0, 255, FALSE);

  return offset;
}


static const per_sequence_t KineVectIn_sequence[] = {
  { &hf_iicp_dut            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Time48IAT },
  { &hf_iicp_lat            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Lat },
  { &hf_iicp_lon            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Lon },
  { &hf_iicp_alt            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Alt },
  { &hf_iicp_gs             , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Gs },
  { &hf_iicp_tta            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Tta },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_KineVectIn(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_KineVectIn, KineVectIn_sequence);

  return offset;
}


static const per_sequence_t LLserviceAddr_sequence[] = {
  { &hf_iicp_csap           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_IN_SAPaddress },
  { &hf_iicp_linkID         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Link_ID },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_LLserviceAddr(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_LLserviceAddr, LLserviceAddr_sequence);

  return offset;
}


static const per_sequence_t MediumUsage_sequence[] = {
  { &hf_iicp_receive        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_255 },
  { &hf_iicp_transmit       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_255 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_MediumUsage(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_MediumUsage, MediumUsage_sequence);

  return offset;
}


static const per_sequence_t MedUseObsTime_sequence[] = {
  { &hf_iicp_value          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_1023 },
  { &hf_iicp_unit           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_TimeUnit },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_MedUseObsTime(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_MedUseObsTime, MedUseObsTime_sequence);

  return offset;
}


static const per_sequence_t Notify_sequence_of[1] = {
  { &hf_iicp_Notify_item    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_255 },
};

static int
dissect_iicp_Notify(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_iicp_Notify, Notify_sequence_of,
                                                  0, 255, FALSE);

  return offset;
}



static int
dissect_iicp_PeerRXpower(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}


static const value_string iicp_I_ParamNo_vals[] = {
  {   0, "errors" },
  {   1, "commProfile" },
  {   2, "properties" },
  {   3, "manuDeviceID" },
  {   4, "iTS-scuId3" },
  {   5, "medID" },
  {   6, "localCIID" },
  {   7, "timeoutReg" },
  {   8, "macAddress" },
  {   9, "macAddrTemp" },
  {  10, "ciClass" },
  {  11, "ciaClass" },
  {  12, "ciStatus" },
  {  13, "notify" },
  {  14, "medType" },
  {  15, "regInfo" },
  {  16, "connect" },
  {  17, "simPin" },
  {  18, "providerInfo" },
  {  19, "minUserPriority" },
  {  20, "queueLevel" },
  {  21, "queueLowTh" },
  {  22, "queueAlarmTh" },
  {  23, "distancePeer" },
  {  24, "commRangeRef" },
  {  25, "timeOfLastRecep" },
  {  26, "inactTimeLimit" },
  {  27, "mediumUsage" },
  {  28, "medUseObsTime" },
  {  29, "peerMAC" },
  {  30, "virtualCI" },
  {  31, "minPrioCrossCI" },
  {  32, "rxSens" },
  {  33, "txPower" },
  {  34, "txPowMax" },
  {  35, "peerRXpower" },
  {  36, "dataRate" },
  {  37, "dataRateNW" },
  {  38, "dataRatesNW" },
  {  39, "dataRateNWreq" },
  {  40, "directivity" },
  {  41, "blockLength" },
  {  42, "freeAirTime" },
  {  43, "frameLengthMax" },
  {  44, "kineVectIn" },
  {  45, "kineVectOut" },
  {  46, "cost" },
  {  47, "reliability" },
  {  51, "logicalChannel" },
  { 0, NULL }
};


static int
dissect_iicp_I_ParamNo(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_SimPin(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       NO_BOUND, NO_BOUND, FALSE, NULL);

  return offset;
}


static const per_sequence_t LogicalChannels_sequence_of[1] = {
  { &hf_iicp_LogicalChannels_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_LogicalChannelType },
};

static int
dissect_iicp_LogicalChannels(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_iicp_LogicalChannels, LogicalChannels_sequence_of,
                                                  0, 255, FALSE);

  return offset;
}



static int
dissect_iicp_Distance(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 65535U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_MedID(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}


static const per_sequence_t Properties_sequence_of[1] = {
  { &hf_iicp_Properties_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_I_Parameter },
};

static int
dissect_iicp_Properties(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_iicp_Properties, Properties_sequence_of,
                                                  0, 255, FALSE);

  return offset;
}



static int
dissect_iicp_OCTET_STRING_SIZE_0_255(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       0, 255, FALSE, NULL);

  return offset;
}


static const per_sequence_t ProviderInfo_sequence[] = {
  { &hf_iicp_provName       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_OCTET_STRING_SIZE_0_255 },
  { &hf_iicp_apn            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_OCTET_STRING_SIZE_0_255 },
  { &hf_iicp_username       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_OCTET_STRING_SIZE_0_255 },
  { &hf_iicp_password       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_OCTET_STRING_SIZE_0_255 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ProviderInfo(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ProviderInfo, ProviderInfo_sequence);

  return offset;
}



static int
dissect_iicp_QueueValue(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}


static const per_sequence_t QueueLevel_sequence[] = {
  { &hf_iicp_priority       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_UserPriority },
  { &hf_iicp_level          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_QueueValue },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_QueueLevel(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_QueueLevel, QueueLevel_sequence);

  return offset;
}


static const value_string iicp_RegInfoStatus_vals[] = {
  {   0, "notApplicable" },
  {   1, "invalid" },
  { 254, "new" },
  { 255, "valid" },
  { 0, NULL }
};


static int
dissect_iicp_RegInfoStatus(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_T_reguIdent(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_integer(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}



static int
dissect_iicp_T_reguInfo(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}


static const per_sequence_t RegulatoryScheme_sequence[] = {
  { &hf_iicp_reguIdent      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_reguIdent },
  { &hf_iicp_reguInfo       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_reguInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_RegulatoryScheme(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_RegulatoryScheme, RegulatoryScheme_sequence);

  return offset;
}


static const per_sequence_t RegInfo_sequence[] = {
  { &hf_iicp_status_02      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RegInfoStatus },
  { &hf_iicp_limits         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RegulatoryScheme },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_RegInfo(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_RegInfo, RegInfo_sequence);

  return offset;
}



static int
dissect_iicp_RemoteCIID(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_EUI64(tvb, offset, actx, tree, hf_index);

  return offset;
}


static const per_sequence_t VirtualCIs_sequence_of[1] = {
  { &hf_iicp_VirtualCIs_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RemoteCIID },
};

static int
dissect_iicp_VirtualCIs(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_iicp_VirtualCIs, VirtualCIs_sequence_of,
                                                  0, 65535, FALSE);

  return offset;
}


static const value_string iicp_RefINSAPDOWN_vals[] = {
  { iicp_inUnitdataRq, "iicp-inUnitdataRq" },
  { iicp_inDataAckRq, "iicp-inDataAckRq" },
  { iicp_inReplyAckRq, "iicp-inReplyAckRq" },
  { iicp_inReplyUpdateRq, "iicp-inReplyUpdateRq" },
  { 0, NULL }
};


static int
dissect_iicp_RefINSAPDOWN(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, &Ref_INSAPDOWN, FALSE);

#line 288 "../../asn1/calm-iicp/iicp.cnf"
  if (tree) {
    proto_item_append_text(proto_item_get_parent_nth(actx->created_item, 2), ": %s", val_to_str(Ref_INSAPDOWN, VALS(iicp_RefINSAPDOWN_vals), "unknown (%d)"));
  }

  return offset;
}



static int
dissect_iicp_T_servPrimitive(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type_pdu_new(tvb, offset, actx, tree, hf_index, dissect_llsap_in_sap_primitives_down);

  return offset;
}


static const per_sequence_t INsapPrimitivesDown_sequence[] = {
  { &hf_iicp_spRef          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RefINSAPDOWN },
  { &hf_iicp_servPrimitive  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_servPrimitive },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_INsapPrimitivesDown(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_INsapPrimitivesDown, INsapPrimitivesDown_sequence);

  return offset;
}



static int
dissect_iicp_INdata(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
#line 52 "../../asn1/calm-iicp/iicp.cnf"
  tvbuff_t *inData_tvb = NULL;
  proto_tree *subtree = NULL;
  proto_item *item = NULL;
  guint16 tvb_len = -1;

  offset = dissect_per_octet_string(tvb, offset, actx, tree, -1, 0, 65535, FALSE, &inData_tvb);
  if (inData_tvb == NULL) {
    return offset;
  }
  tvb_len = tvb_length(inData_tvb);
  item = proto_tree_add_item(tree, hf_index, inData_tvb, 0, tvb_len, FALSE);
  subtree = proto_item_add_subtree(item, ett_iicp_FNTPNPDU);
  
  dissect_iicp_FNTPNPDU(inData_tvb, 0, actx, subtree, 0);
  proto_item_set_text(subtree->first_child, "FNTPNPDU");



  return offset;
}


static const value_string iicp_RefACCPARAMS_vals[] = {
  { iicp_nullAP, "iicp-nullAP" },
  { 0, NULL }
};


static int
dissect_iicp_RefACCPARAMS(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, &Ref_ACCPARAMS, FALSE);

#line 306 "../../asn1/calm-iicp/iicp.cnf"
  if (tree) {
    proto_item_append_text(proto_item_get_parent_nth(actx->created_item, 2), ": %s", val_to_str(Ref_ACCPARAMS, VALS(iicp_RefACCPARAMS_vals), "unknown (%d)"));
  }

  return offset;
}



static int
dissect_iicp_T_aParameter(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type_pdu_new(tvb, offset, actx, tree, hf_index, dissect_llsap_acc_params);

  return offset;
}


static const per_sequence_t AccessParameters_sequence[] = {
  { &hf_iicp_apRef          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RefACCPARAMS },
  { &hf_iicp_aParameter     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_aParameter },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_AccessParameters(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_AccessParameters, AccessParameters_sequence);

  return offset;
}


static const per_sequence_t IN_UNITDATA_request_sequence[] = {
  { &hf_iicp_source_addr    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_LLserviceAddr },
  { &hf_iicp_dest_addr      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_LLserviceAddr },
  { &hf_iicp_data           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INdata },
  { &hf_iicp_priority       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_UserPriority },
  { &hf_iicp_accessParams   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_AccessParameters },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_IN_UNITDATA_request(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
#line 447 "../../asn1/calm-iicp/iicp.cnf"
  col_append_fstr(actx->pinfo->cinfo, COL_INFO, " (IN-UNITDATA-request)");

    offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_IN_UNITDATA_request, IN_UNITDATA_request_sequence);




  return offset;
}


static const value_string iicp_MACServiceClass_vals[] = {
  {   0, "macAckNotUsed" },
  { 255, "macAckUsed" },
  { 0, NULL }
};


static int
dissect_iicp_MACServiceClass(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}


static const per_sequence_t IN_DATA_ACK_request_sequence[] = {
  { &hf_iicp_source_addr    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_LLserviceAddr },
  { &hf_iicp_dest_addr      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_LLserviceAddr },
  { &hf_iicp_data           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INdata },
  { &hf_iicp_priority       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_UserPriority },
  { &hf_iicp_serviceClass   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_MACServiceClass },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_IN_DATA_ACK_request(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
#line 452 "../../asn1/calm-iicp/iicp.cnf"
  col_append_fstr(actx->pinfo->cinfo, COL_INFO, " (IN-DATA-ACK-request)");

    offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_IN_DATA_ACK_request, IN_DATA_ACK_request_sequence);




  return offset;
}


static const per_sequence_t IN_REPLY_ACK_request_sequence[] = {
  { &hf_iicp_source_addr    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_LLserviceAddr },
  { &hf_iicp_dest_addr      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_LLserviceAddr },
  { &hf_iicp_data           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INdata },
  { &hf_iicp_priority       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_UserPriority },
  { &hf_iicp_serviceClass   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_MACServiceClass },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_IN_REPLY_ACK_request(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
#line 457 "../../asn1/calm-iicp/iicp.cnf"
  col_append_fstr(actx->pinfo->cinfo, COL_INFO, " (IN-REPLY-ACK-request)");

    offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_IN_REPLY_ACK_request, IN_REPLY_ACK_request_sequence);




  return offset;
}


static const per_sequence_t IN_REPLY_UPDATE_request_sequence[] = {
  { &hf_iicp_source_addr    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_LLserviceAddr },
  { &hf_iicp_data           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INdata },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_IN_REPLY_UPDATE_request(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
#line 462 "../../asn1/calm-iicp/iicp.cnf"
  col_append_fstr(actx->pinfo->cinfo, COL_INFO, " (IN-REPLY-UPDATE-request)");

    offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_IN_REPLY_UPDATE_request, IN_REPLY_UPDATE_request_sequence);




  return offset;
}


static const value_string iicp_RefINSAPUP_vals[] = {
  { iicp_inUnitdataInd, "iicp-inUnitdataInd" },
  { iicp_inUnitdataStatusInd, "iicp-inUnitdataStatusInd" },
  { iicp_inDataAckInd, "iicp-inDataAckInd" },
  { iicp_inDataAckStatusInd, "iicp-inDataAckStatusInd" },
  { iicp_inReplyInd, "iicp-inReplyInd" },
  { iicp_inReplyStatusInd, "iicp-inReplyStatusInd" },
  { iicp_inReplyUpdateStatusInd, "iicp-inReplyUpdateStatusInd" },
  { 0, NULL }
};


static int
dissect_iicp_RefINSAPUP(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, &Ref_INSAPUP, FALSE);

#line 297 "../../asn1/calm-iicp/iicp.cnf"
  if (tree) {
    proto_item_append_text(proto_item_get_parent_nth(actx->created_item, 2), ": %s", val_to_str(Ref_INSAPUP, VALS(iicp_RefINSAPUP_vals), "unknown (%d)"));
  }

  return offset;
}



static int
dissect_iicp_T_servPrimitive_01(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type_pdu_new(tvb, offset, actx, tree, hf_index, dissect_llsap_in_sap_primitives_up);

  return offset;
}


static const per_sequence_t INsapPrimitivesUp_sequence[] = {
  { &hf_iicp_spRef_01       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RefINSAPUP },
  { &hf_iicp_servPrimitive_01, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_servPrimitive_01 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_INsapPrimitivesUp(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_INsapPrimitivesUp, INsapPrimitivesUp_sequence);

  return offset;
}


static const per_sequence_t IN_UNITDATA_indication_sequence[] = {
  { &hf_iicp_source_addr    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_LLserviceAddr },
  { &hf_iicp_dest_addr      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_LLserviceAddr },
  { &hf_iicp_data           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INdata },
  { &hf_iicp_priority       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_UserPriority },
  { &hf_iicp_accessParams   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_AccessParameters },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_IN_UNITDATA_indication(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_IN_UNITDATA_indication, IN_UNITDATA_indication_sequence);

  return offset;
}


static const value_string iicp_INtxStatus_vals[] = {
  {   0, "success" },
  {   1, "queueFull" },
  {   2, "timeout" },
  { 255, "unspecFailure" },
  { 0, NULL }
};


static int
dissect_iicp_INtxStatus(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}


static const per_sequence_t IN_UNITDATA_STATUS_indication_sequence[] = {
  { &hf_iicp_source_addr    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_LLserviceAddr },
  { &hf_iicp_dest_addr      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_LLserviceAddr },
  { &hf_iicp_data           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INdata },
  { &hf_iicp_priority       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_UserPriority },
  { &hf_iicp_accessParams   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_AccessParameters },
  { &hf_iicp_txStatus       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INtxStatus },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_IN_UNITDATA_STATUS_indication(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_IN_UNITDATA_STATUS_indication, IN_UNITDATA_STATUS_indication_sequence);

  return offset;
}


static const per_sequence_t IN_DATA_ACK_indication_sequence[] = {
  { &hf_iicp_source_addr    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_LLserviceAddr },
  { &hf_iicp_dest_addr      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_LLserviceAddr },
  { &hf_iicp_data           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INdata },
  { &hf_iicp_priority       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_UserPriority },
  { &hf_iicp_serviceClass   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_MACServiceClass },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_IN_DATA_ACK_indication(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_IN_DATA_ACK_indication, IN_DATA_ACK_indication_sequence);

  return offset;
}


static const per_sequence_t IN_DATA_ACK_STATUS_indication_sequence[] = {
  { &hf_iicp_source_addr    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_LLserviceAddr },
  { &hf_iicp_dest_addr      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_LLserviceAddr },
  { &hf_iicp_data           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INdata },
  { &hf_iicp_priority       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_UserPriority },
  { &hf_iicp_serviceClass   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_MACServiceClass },
  { &hf_iicp_status_03      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INtxStatus },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_IN_DATA_ACK_STATUS_indication(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_IN_DATA_ACK_STATUS_indication, IN_DATA_ACK_STATUS_indication_sequence);

  return offset;
}


static const per_sequence_t IN_REPLY_indication_sequence[] = {
  { &hf_iicp_source_addr    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_LLserviceAddr },
  { &hf_iicp_dest_addr      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_LLserviceAddr },
  { &hf_iicp_data           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INdata },
  { &hf_iicp_priority       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_UserPriority },
  { &hf_iicp_serviceClass   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_MACServiceClass },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_IN_REPLY_indication(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_IN_REPLY_indication, IN_REPLY_indication_sequence);

  return offset;
}


static const per_sequence_t IN_REPLY_STATUS_indication_sequence[] = {
  { &hf_iicp_source_addr    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_LLserviceAddr },
  { &hf_iicp_status_03      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INtxStatus },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_IN_REPLY_STATUS_indication(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_IN_REPLY_STATUS_indication, IN_REPLY_STATUS_indication_sequence);

  return offset;
}


static const per_sequence_t IN_REPLY_UPDATE_STATUS_indication_sequence[] = {
  { &hf_iicp_source_addr    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_LLserviceAddr },
  { &hf_iicp_data           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INdata },
  { &hf_iicp_priority       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_UserPriority },
  { &hf_iicp_accessParams   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_AccessParameters },
  { &hf_iicp_txStatus       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INtxStatus },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_IN_REPLY_UPDATE_STATUS_indication(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_IN_REPLY_UPDATE_STATUS_indication, IN_REPLY_UPDATE_STATUS_indication_sequence);

  return offset;
}



static int
dissect_iicp_NullType(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_null(tvb, offset, actx, tree, hf_index);

  return offset;
}



static int
dissect_iicp_VCIserialNumber(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 65535U, NULL, FALSE);

  return offset;
}


static const value_string iicp_OneOCTETones_vals[] = {
  { 255, "all" },
  { 0, NULL }
};


static int
dissect_iicp_OneOCTETones(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}


static const value_string iicp_TwoOCTETones_vals[] = {
  { 65535, "all" },
  { 0, NULL }
};


static int
dissect_iicp_TwoOCTETones(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 65535U, NULL, FALSE);

  return offset;
}


static const per_sequence_t LegacyCIID_sequence[] = {
  { &hf_iicp_selector1      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_OneOCTETones },
  { &hf_iicp_iTS_scuId      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITS_scuId },
  { &hf_iicp_selector2      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_TwoOCTETones },
  { &hf_iicp_medID          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_MedID },
  { &hf_iicp_vciSerialNumber, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_VCIserialNumber },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_LegacyCIID(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_LegacyCIID, LegacyCIID_sequence);

  return offset;
}



static int
dissect_iicp_INTEGER_0_63(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 63U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_BOOLEAN(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_boolean(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}



static int
dissect_iicp_OCTET_STRING_SIZE_2(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       2, 2, FALSE, NULL);

  return offset;
}


static const per_sequence_t MACoui_sequence[] = {
  { &hf_iicp_uoi1           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_63 },
  { &hf_iicp_ulBit          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_BOOLEAN },
  { &hf_iicp_igBIT          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_BOOLEAN },
  { &hf_iicp_uoi2           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_OCTET_STRING_SIZE_2 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_MACoui(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_MACoui, MACoui_sequence);

  return offset;
}



static int
dissect_iicp_MACext(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       3, 3, FALSE, NULL);

  return offset;
}


static const per_sequence_t EUI64MAC48_sequence[] = {
  { &hf_iicp_oui            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_MACoui },
  { &hf_iicp_selector2      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_TwoOCTETones },
  { &hf_iicp_ext            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_MACext },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_EUI64MAC48(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_EUI64MAC48, EUI64MAC48_sequence);

  return offset;
}


static const value_string iicp_T_mc_vals[] = {
  {   3, "all" },
  { 0, NULL }
};


static int
dissect_iicp_T_mc(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 3U, NULL, FALSE);

  return offset;
}


static const per_sequence_t MACmcID_sequence[] = {
  { &hf_iicp_ucgc           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_63 },
  { &hf_iicp_mc             , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_mc },
  { &hf_iicp_serial         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_OCTET_STRING_SIZE_2 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_MACmcID(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_MACmcID, MACmcID_sequence);

  return offset;
}


static const value_string iicp_RefCOMMDOWN_vals[] = {
  { iicp_gCsamctxConfFA, "iicp-gCsamctxConfFA" },
  { iicp_gCregServerFA, "iicp-gCregServerFA" },
  { iicp_gCupdateServerFA, "iicp-gCupdateServerFA" },
  { iicp_gCderegServerFA, "iicp-gCderegServerFA" },
  { iicp_gCregClientFA, "iicp-gCregClientFA" },
  { iicp_gCupdateClientFA, "iicp-gCupdateClientFA" },
  { iicp_gCderegClientFA, "iicp-gCderegClientFA" },
  { 0, NULL }
};


static int
dissect_iicp_RefCOMMDOWN(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, &Ref_COMMDOWN, FALSE);

#line 158 "../../asn1/calm-iicp/iicp.cnf"
  if (tree) {
    proto_item_append_text(proto_item_get_parent_nth(actx->created_item, 2), ": %s", val_to_str(Ref_COMMDOWN, VALS(iicp_RefCOMMDOWN_vals), "unknown (%d)"));
  }

  return offset;
}



static int
dissect_iicp_T_servPrimitive_02(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type_pdu_new(tvb, offset, actx, tree, hf_index, dissect_msap_fa_sap_primitives_down);

  return offset;
}


static const per_sequence_t FAsapPrimitivesDown_sequence[] = {
  { &hf_iicp_spRef_02       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RefCOMMDOWN },
  { &hf_iicp_servPrimitive_02, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_servPrimitive_02 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_FAsapPrimitivesDown(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_FAsapPrimitivesDown, FAsapPrimitivesDown_sequence);

  return offset;
}


static const value_string iicp_RefCOMMUP_vals[] = {
  { iicp_gCsamctxFA, "iicp-gCsamctxFA" },
  { iicp_gCregServerConfFA, "iicp-gCregServerConfFA" },
  { iicp_gCupdateServerConfFA, "iicp-gCupdateServerConfFA" },
  { iicp_gCderegServerConfFA, "iicp-gCderegServerConfFA" },
  { iicp_gCregClientConfFA, "iicp-gCregClientConfFA" },
  { iicp_gCupdateClientConfFA, "iicp-gCupdateClientConfFA" },
  { iicp_gCderegClientConfFA, "iicp-gCderegClientConfFA" },
  { iicp_gCsamFA, "iicp-gCsamFA" },
  { iicp_gCctxFA, "iicp-gCctxFA" },
  { 0, NULL }
};


static int
dissect_iicp_RefCOMMUP(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, &Ref_COMMUP, FALSE);

#line 167 "../../asn1/calm-iicp/iicp.cnf"
  if (tree) {
    proto_item_append_text(proto_item_get_parent_nth(actx->created_item, 2), ": %s", val_to_str(Ref_COMMUP, VALS(iicp_RefCOMMUP_vals), "unknown (%d)"));
  }

  return offset;
}



static int
dissect_iicp_T_servPrimitive_03(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type_pdu_new(tvb, offset, actx, tree, hf_index, dissect_msap_fa_sap_primitives_up);

  return offset;
}


static const per_sequence_t FAsapPrimitivesUp_sequence[] = {
  { &hf_iicp_spRef_03       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RefCOMMUP },
  { &hf_iicp_servPrimitive_03, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_servPrimitive_03 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_FAsapPrimitivesUp(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_FAsapPrimitivesUp, FAsapPrimitivesUp_sequence);

  return offset;
}


static const value_string iicp_RefMFCMDREQ_vals[] = {
  { iicp_simFUTcmd, "iicp-simFUTcmd" },
  { iicp_simFLTcmd, "iicp-simFLTcmd" },
  { iicp_gCsamctx, "iicp-gCsamctx" },
  { iicp_gCsam, "iicp-gCsam" },
  { iicp_gCctx, "iicp-gCctx" },
  { iicp_lDMnotifyCmd, "iicp-lDMnotifyCmd" },
  { iicp_legacyCICmd, "iicp-legacyCICmd" },
  { iicp_stateCInotify, "iicp-stateCInotify" },
  { iicp_gCperiodCmd, "iicp-gCperiodCmd" },
  { iicp_gCctxTxCmd, "iicp-gCctxTxCmd" },
  { iicp_gCdeleteCmd, "iicp-gCdeleteCmd" },
  { iicp_iICrequestTX, "iicp-iICrequestTX" },
  { iicp_iICresponseTX, "iicp-iICresponseTX" },
  { iicp_testMF, "iicp-testMF" },
  { 0, NULL }
};


static int
dissect_iicp_RefMFCMDREQ(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, &Ref_MFCMDREQ, FALSE);

#line 176 "../../asn1/calm-iicp/iicp.cnf"
  if (tree) {
    proto_item_append_text(proto_item_get_parent_nth(actx->created_item, 2), ": %s", val_to_str(Ref_MFCMDREQ, VALS(iicp_RefMFCMDREQ_vals), "unknown (%d)"));
  }

  return offset;
}



static int
dissect_iicp_CommandRef(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 65535U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_T_command_param(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type_pdu_new(tvb, offset, actx, tree, hf_index, dissect_msap_mf_command_request);

  return offset;
}


static const per_sequence_t MF_Command_request_sequence[] = {
  { &hf_iicp_commandRef     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CommandRef },
  { &hf_iicp_ref            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RefMFCMDREQ },
  { &hf_iicp_command_param  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_command_param },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_MF_Command_request(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_MF_Command_request, MF_Command_request_sequence);

  return offset;
}



static int
dissect_iicp_TestMF(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       0, 255, FALSE, NULL);

  return offset;
}



static int
dissect_iicp_SimFUTcmd(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
#line 327 "../../asn1/calm-iicp/iicp.cnf"
  col_set_str(actx->pinfo->cinfo, COL_INFO, "IICP Facilities UT command ");

    offset = dissect_iicp_FAsapPrimitivesDown(tvb, offset, actx, tree, hf_index);




  return offset;
}


static const value_string iicp_RefNFSAPUP_vals[] = {
  { iicp_fntpPortConfirm, "iicp-fntpPortConfirm" },
  { iicp_fntpCommConfirm, "iicp-fntpCommConfirm" },
  { iicp_fntpCommIndication, "iicp-fntpCommIndication" },
  { 0, NULL }
};


static int
dissect_iicp_RefNFSAPUP(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, &Ref_NFSAPUP, FALSE);

#line 279 "../../asn1/calm-iicp/iicp.cnf"
  if (tree) {
    proto_item_append_text(proto_item_get_parent_nth(actx->created_item, 2), ": %s", val_to_str(Ref_NFSAPUP, VALS(iicp_RefNFSAPUP_vals), "unknown (%d)"));
  }

  return offset;
}



static int
dissect_iicp_T_servPrimitive_05(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type_pdu_new(tvb, offset, actx, tree, hf_index, dissect_fntp_nf_sap_primitives_up);

  return offset;
}


static const per_sequence_t NFsapPrimitivesUp_sequence[] = {
  { &hf_iicp_spRef_05       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RefNFSAPUP },
  { &hf_iicp_servPrimitive_05, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_servPrimitive_05 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_NFsapPrimitivesUp(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_NFsapPrimitivesUp, NFsapPrimitivesUp_sequence);

  return offset;
}



static int
dissect_iicp_SimFLTcmd(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_NFsapPrimitivesUp(tvb, offset, actx, tree, hf_index);

  return offset;
}


static const per_sequence_t RadarView_sequence[] = {
  { &hf_iicp_peerITS_SSI    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITS_SSI },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_RadarView(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_RadarView, RadarView_sequence);

  return offset;
}


static const per_sequence_t LDMnotify_sequence_of[1] = {
  { &hf_iicp_LDMnotify_item , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RadarView },
};

static int
dissect_iicp_LDMnotify(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_iicp_LDMnotify, LDMnotify_sequence_of,
                                                  0, 255, FALSE);

  return offset;
}


static const per_sequence_t LegacyCIreq_sequence[] = {
  { &hf_iicp_cIclass        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CIclass },
  { &hf_iicp_legacyOption   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_255 },
  { &hf_iicp_linkId         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Link_ID },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_LegacyCIreq(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_LegacyCIreq, LegacyCIreq_sequence);

  return offset;
}


static const per_sequence_t StateCInotify_sequence[] = {
  { &hf_iicp_linkId         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Link_ID },
  { &hf_iicp_cIstatus       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CIstatus },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_StateCInotify(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_StateCInotify, StateCInotify_sequence);

  return offset;
}


static const value_string iicp_RefMFCMDCONF_vals[] = {
  { iicp_simFUTcmdConf, "iicp-simFUTcmdConf" },
  { iicp_simFLTcmdConf, "iicp-simFLTcmdConf" },
  { iicp_gCsamctxConf, "iicp-gCsamctxConf" },
  { iicp_gCsamConf, "iicp-gCsamConf" },
  { iicp_gCctxConf, "iicp-gCctxConf" },
  { iicp_lDMnotifyConf, "iicp-lDMnotifyConf" },
  { iicp_legacyCIConf, "iicp-legacyCIConf" },
  { iicp_stateCInotifyConf, "iicp-stateCInotifyConf" },
  { iicp_gCperiodCmdConf, "iicp-gCperiodCmdConf" },
  { iicp_gCctxTxCmdConf, "iicp-gCctxTxCmdConf" },
  { iicp_gCdeleteCmdConf, "iicp-gCdeleteCmdConf" },
  { iicp_iICrequestTXConf, "iicp-iICrequestTXConf" },
  { iicp_iICresponseTXConf, "iicp-iICresponseTXConf" },
  { iicp_testMFConf, "iicp-testMFConf" },
  { 0, NULL }
};


static int
dissect_iicp_RefMFCMDCONF(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, &Ref_MFCMDCONF, FALSE);

#line 185 "../../asn1/calm-iicp/iicp.cnf"
  if (tree) {
    proto_item_append_text(proto_item_get_parent_nth(actx->created_item, 2), ": %s", val_to_str(Ref_MFCMDCONF, VALS(iicp_RefMFCMDCONF_vals), "unknown (%d)"));
  }

  return offset;
}



static int
dissect_iicp_T_cmdConfirm_param(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type_pdu_new(tvb, offset, actx, tree, hf_index, dissect_msap_mf_command_confirm);

  return offset;
}


static const per_sequence_t MF_Command_confirm_sequence[] = {
  { &hf_iicp_commandRef     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CommandRef },
  { &hf_iicp_ref_01         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RefMFCMDCONF },
  { &hf_iicp_cmdConfirm_param, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_cmdConfirm_param },
  { &hf_iicp_errStatus      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ErrStatus },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_MF_Command_confirm(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_MF_Command_confirm, MF_Command_confirm_sequence);

  return offset;
}


static const value_string iicp_RefMFREQREQ_vals[] = {
  { iicp_simFUTreq, "iicp-simFUTreq" },
  { iicp_simFLTreq, "iicp-simFLTreq" },
  { iicp_iTS_S_Appl_Reg, "iicp-iTS-S-Appl-Reg" },
  { iicp_gCregServer, "iicp-gCregServer" },
  { iicp_gCupdateServer, "iicp-gCupdateServer" },
  { iicp_gCderegServer, "iicp-gCderegServer" },
  { iicp_gCregClient, "iicp-gCregClient" },
  { iicp_gCupdateClient, "iicp-gCupdateClient" },
  { iicp_gCderegClient, "iicp-gCderegClient" },
  { iicp_lDMregister, "iicp-lDMregister" },
  { iicp_sAMrxNot, "iicp-sAMrxNot" },
  { iicp_cTXrxNot, "iicp-cTXrxNot" },
  { iicp_iICrequestRX, "iicp-iICrequestRX" },
  { iicp_iICresponseRX, "iicp-iICresponseRX" },
  { iicp_iTS_S_Appl_ReqFinal, "iicp-iTS-S-Appl-ReqFinal" },
  { iicp_testMFecho, "iicp-testMFecho" },
  { 0, NULL }
};


static int
dissect_iicp_RefMFREQREQ(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, &Ref_MFREQREQ, FALSE);

#line 194 "../../asn1/calm-iicp/iicp.cnf"
  if (tree) {
    proto_item_append_text(proto_item_get_parent_nth(actx->created_item, 2), ": %s", val_to_str(Ref_MFREQREQ, VALS(iicp_RefMFREQREQ_vals), "unknown (%d)"));
  }

  return offset;
}



static int
dissect_iicp_T_request_param(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type_pdu_new(tvb, offset, actx, tree, hf_index, dissect_msap_mf_request_request);

  return offset;
}


static const per_sequence_t MF_Request_request_sequence[] = {
  { &hf_iicp_commandRef     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CommandRef },
  { &hf_iicp_ref_02         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RefMFREQREQ },
  { &hf_iicp_request_param  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_request_param },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_MF_Request_request(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_MF_Request_request, MF_Request_request_sequence);

  return offset;
}



static int
dissect_iicp_SimFUTreq(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
#line 332 "../../asn1/calm-iicp/iicp.cnf"
  col_set_str(actx->pinfo->cinfo, COL_INFO, "IICP Facilities UT request ");

    offset = dissect_iicp_FAsapPrimitivesUp(tvb, offset, actx, tree, hf_index);




  return offset;
}


static const value_string iicp_RefNFSAPDOWN_vals[] = {
  { iicp_fntpPortRequest, "iicp-fntpPortRequest" },
  { iicp_fntpCommRequest, "iicp-fntpCommRequest" },
  { 0, NULL }
};


static int
dissect_iicp_RefNFSAPDOWN(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, &Ref_NFSAPDOWN, FALSE);

#line 270 "../../asn1/calm-iicp/iicp.cnf"
  if (tree) {
    proto_item_append_text(proto_item_get_parent_nth(actx->created_item, 2), ": %s", val_to_str(Ref_NFSAPDOWN, VALS(iicp_RefNFSAPDOWN_vals), "unknown (%d)"));
  }

  return offset;
}



static int
dissect_iicp_T_servPrimitive_04(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type_pdu_new(tvb, offset, actx, tree, hf_index, dissect_fntp_nf_sap_primitives_down);

  return offset;
}


static const per_sequence_t NFsapPrimitivesDown_sequence[] = {
  { &hf_iicp_spRef_04       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RefNFSAPDOWN },
  { &hf_iicp_servPrimitive_04, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_servPrimitive_04 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_NFsapPrimitivesDown(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_NFsapPrimitivesDown, NFsapPrimitivesDown_sequence);

  return offset;
}



static int
dissect_iicp_SimFLTreq(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_NFsapPrimitivesDown(tvb, offset, actx, tree, hf_index);

  return offset;
}



static int
dissect_iicp_OCTET_STRING_SIZE_0_65535(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       0, 65535, FALSE, NULL);

  return offset;
}


static const per_sequence_t LDMregister_sequence[] = {
  { &hf_iicp_iTS_scuId4     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITS_scuId },
  { &hf_iicp_reference_01   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_OCTET_STRING_SIZE_0_65535 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_LDMregister(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_LDMregister, LDMregister_sequence);

  return offset;
}


static const value_string iicp_T_sap_vals[] = {
  {  70, "f" },
  { 0, NULL }
};


static int
dissect_iicp_T_sap(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}


static const per_sequence_t TestMFecho_sequence[] = {
  { &hf_iicp_sap            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_sap },
  { &hf_iicp_info           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_OCTET_STRING_SIZE_0_255 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_TestMFecho(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_TestMFecho, TestMFecho_sequence);

  return offset;
}


static const value_string iicp_RefMFREQCONF_vals[] = {
  { iicp_simFUTreqConf, "iicp-simFUTreqConf" },
  { iicp_simFLTreqConf, "iicp-simFLTreqConf" },
  { iicp_iTS_S_Appl_RegConf, "iicp-iTS-S-Appl-RegConf" },
  { iicp_gCregServerConf, "iicp-gCregServerConf" },
  { iicp_gCupdateServerConf, "iicp-gCupdateServerConf" },
  { iicp_gCderegServerConf, "iicp-gCderegServerConf" },
  { iicp_gCregClientConf, "iicp-gCregClientConf" },
  { iicp_gCupdateClientConf, "iicp-gCupdateClientConf" },
  { iicp_gCderegClientConf, "iicp-gCderegClientConf" },
  { iicp_lDMregisterConf, "iicp-lDMregisterConf" },
  { iicp_sAMrxNotConf, "iicp-sAMrxNotConf" },
  { iicp_cTXrxNotConf, "iicp-cTXrxNotConf" },
  { iicp_iICrequestRXConf, "iicp-iICrequestRXConf" },
  { iicp_iICresponseRXConf, "iicp-iICresponseRXConf" },
  { iicp_iTS_S_Appl_ReqFinalConf, "iicp-iTS-S-Appl-ReqFinalConf" },
  { iicp_testMFechoConf, "iicp-testMFechoConf" },
  { 0, NULL }
};


static int
dissect_iicp_RefMFREQCONF(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, &Ref_MFREQCONF, FALSE);

#line 203 "../../asn1/calm-iicp/iicp.cnf"
  if (tree) {
    proto_item_append_text(proto_item_get_parent_nth(actx->created_item, 2), ": %s", val_to_str(Ref_MFREQCONF, VALS(iicp_RefMFREQCONF_vals), "unknown (%d)"));
  }

  return offset;
}



static int
dissect_iicp_T_reqConfirm_param(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type_pdu_new(tvb, offset, actx, tree, hf_index, dissect_msap_mf_request_confirm);

  return offset;
}


static const per_sequence_t MF_Request_confirm_sequence[] = {
  { &hf_iicp_commandRef     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CommandRef },
  { &hf_iicp_ref_03         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RefMFREQCONF },
  { &hf_iicp_reqConfirm_param, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_reqConfirm_param },
  { &hf_iicp_errStatus      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ErrStatus },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_MF_Request_confirm(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_MF_Request_confirm, MF_Request_confirm_sequence);

  return offset;
}


static const value_string iicp_RefMNCMDREQ_vals[] = {
  { iicp_simNUTcmd, "iicp-simNUTcmd" },
  { iicp_simNLTcmd, "iicp-simNLTcmd" },
  { iicp_fWTset, "iicp-fWTset" },
  { iicp_fWTupdate, "iicp-fWTupdate" },
  { iicp_fWTdelete, "iicp-fWTdelete" },
  { iicp_testMN, "iicp-testMN" },
  { 0, NULL }
};


static int
dissect_iicp_RefMNCMDREQ(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, &Ref_MNCMDREQ, FALSE);

#line 212 "../../asn1/calm-iicp/iicp.cnf"
  if (tree) {
    proto_item_append_text(proto_item_get_parent_nth(actx->created_item, 2), ": %s", val_to_str(Ref_MNCMDREQ, VALS(iicp_RefMNCMDREQ_vals), "unknown (%d)"));
  }

  return offset;
}



static int
dissect_iicp_T_command_param_01(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type_pdu_new(tvb, offset, actx, tree, hf_index, dissect_msap_mn_command_request);

  return offset;
}


static const per_sequence_t MN_Command_request_sequence[] = {
  { &hf_iicp_commandRef     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CommandRef },
  { &hf_iicp_ref_04         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RefMNCMDREQ },
  { &hf_iicp_command_param_01, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_command_param_01 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_MN_Command_request(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
#line 357 "../../asn1/calm-iicp/iicp.cnf"
  col_set_str(actx->pinfo->cinfo, COL_INFO, "IICP MN-Command-request");

    offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_MN_Command_request, MN_Command_request_sequence);




  return offset;
}



static int
dissect_iicp_TestMN(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       0, 255, FALSE, NULL);

  return offset;
}



static int
dissect_iicp_SimNUTcmd(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
#line 337 "../../asn1/calm-iicp/iicp.cnf"
  col_set_str(actx->pinfo->cinfo, COL_INFO, "IICP Network UT command ");

    offset = dissect_iicp_NFsapPrimitivesDown(tvb, offset, actx, tree, hf_index);




  return offset;
}



static int
dissect_iicp_SimNLTcmd(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
#line 347 "../../asn1/calm-iicp/iicp.cnf"
  col_set_str(actx->pinfo->cinfo, COL_INFO, "IICP Access Layer command ");

    offset = dissect_iicp_INsapPrimitivesUp(tvb, offset, actx, tree, hf_index);




  return offset;
}


static const value_string iicp_RefFWT_vals[] = {
  { iicp_fntpSet, "iicp-fntpSet" },
  { iicp_fntpUpdate, "iicp-fntpUpdate" },
  { iicp_fntpDelete, "iicp-fntpDelete" },
  { 0, NULL }
};


static int
dissect_iicp_RefFWT(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, &Ref_FWT, FALSE);

#line 248 "../../asn1/calm-iicp/iicp.cnf"
  if (tree) {
    proto_item_append_text(proto_item_get_parent_nth(actx->created_item, 2), ": %s", val_to_str(Ref_FWT, VALS(iicp_RefFWT_vals), "unknown (%d)"));
  }

  return offset;
}



static int
dissect_iicp_T_fwt(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type_pdu_new(tvb, offset, actx, tree, hf_index, dissect_msap_fwt);

  return offset;
}


static const per_sequence_t FWTset_sequence[] = {
  { &hf_iicp_fwtNo          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RefFWT },
  { &hf_iicp_fwt            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_fwt },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_FWTset(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_FWTset, FWTset_sequence);

  return offset;
}



static int
dissect_iicp_T_fwt_01(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type_pdu_new(tvb, offset, actx, tree, hf_index, dissect_msap_fwt);

  return offset;
}


static const per_sequence_t FWTupdate_sequence[] = {
  { &hf_iicp_fwtNo          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RefFWT },
  { &hf_iicp_fwt_01         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_fwt_01 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_FWTupdate(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_FWTupdate, FWTupdate_sequence);

  return offset;
}



static int
dissect_iicp_T_fwt_02(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type_pdu_new(tvb, offset, actx, tree, hf_index, dissect_msap_fwt);

  return offset;
}


static const per_sequence_t FWTdelete_sequence[] = {
  { &hf_iicp_fwtNo          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RefFWT },
  { &hf_iicp_fwt_02         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_fwt_02 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_FWTdelete(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_FWTdelete, FWTdelete_sequence);

  return offset;
}


static const value_string iicp_RefMNCMDCONF_vals[] = {
  { iicp_simNUTcmdConf, "iicp-simNUTcmdConf" },
  { iicp_simNLTcmdConf, "iicp-simNLTcmdConf" },
  { iicp_fWTsetConf, "iicp-fWTsetConf" },
  { iicp_fWTupdateConf, "iicp-fWTupdateConf" },
  { iicp_fWTdeletConf, "iicp-fWTdeletConf" },
  { iicp_testMNConf, "iicp-testMNConf" },
  { 0, NULL }
};


static int
dissect_iicp_RefMNCMDCONF(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, &Ref_MNCMDCONF, FALSE);

#line 221 "../../asn1/calm-iicp/iicp.cnf"
  if (tree) {
    proto_item_append_text(proto_item_get_parent_nth(actx->created_item, 2), ": %s", val_to_str(Ref_MNCMDCONF, VALS(iicp_RefMNCMDCONF_vals), "unknown (%d)"));
  }

  return offset;
}



static int
dissect_iicp_T_cmdConfirm_param_01(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type_pdu_new(tvb, offset, actx, tree, hf_index, dissect_msap_mn_command_confirm);

  return offset;
}


static const per_sequence_t MN_Command_confirm_sequence[] = {
  { &hf_iicp_commandRef     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CommandRef },
  { &hf_iicp_ref_05         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RefMNCMDCONF },
  { &hf_iicp_cmdConfirm_param_01, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_cmdConfirm_param_01 },
  { &hf_iicp_errStatus      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ErrStatus },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_MN_Command_confirm(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
#line 362 "../../asn1/calm-iicp/iicp.cnf"
  col_set_str(actx->pinfo->cinfo, COL_INFO, "IICP MN-Command-confirm");

    offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_MN_Command_confirm, MN_Command_confirm_sequence);




  return offset;
}



static int
dissect_iicp_T_fwtNo(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_integer(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}



static int
dissect_iicp_T_fwt_03(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}


static const per_sequence_t FWTsetConf_sequence[] = {
  { &hf_iicp_fwtNo_01       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_fwtNo },
  { &hf_iicp_fwt_03         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_fwt_03 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_FWTsetConf(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_FWTsetConf, FWTsetConf_sequence);

  return offset;
}



static int
dissect_iicp_T_fwtNo_01(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_integer(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}



static int
dissect_iicp_T_fwt_04(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}


static const per_sequence_t FWTupdateConf_sequence[] = {
  { &hf_iicp_fwtNo_02       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_fwtNo_01 },
  { &hf_iicp_fwt_04         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_fwt_04 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_FWTupdateConf(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_FWTupdateConf, FWTupdateConf_sequence);

  return offset;
}



static int
dissect_iicp_T_fwtNo_02(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_integer(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}



static int
dissect_iicp_T_fwt_05(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}


static const per_sequence_t FWTdeleteConf_sequence[] = {
  { &hf_iicp_fwtNo_03       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_fwtNo_02 },
  { &hf_iicp_fwt_05         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_fwt_05 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_FWTdeleteConf(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_FWTdeleteConf, FWTdeleteConf_sequence);

  return offset;
}


static const value_string iicp_RefMNREQREQ_vals[] = {
  { iicp_simNUTreq, "iicp-simNUTreq" },
  { iicp_simNLTreq, "iicp-simNLTreq" },
  { iicp_fWTsetNot, "iicp-fWTsetNot" },
  { iicp_fWTupdateNot, "iicp-fWTupdateNot" },
  { iicp_fWTdeleteNot, "iicp-fWTdeleteNot" },
  { iicp_vCIcreatePeerMAC, "iicp-vCIcreatePeerMAC" },
  { iicp_its_ssiPeerNot, "iicp-its-ssiPeerNot" },
  { iicp_testMNecho, "iicp-testMNecho" },
  { 0, NULL }
};


static int
dissect_iicp_RefMNREQREQ(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, &Ref_MNREQREQ, FALSE);

#line 230 "../../asn1/calm-iicp/iicp.cnf"
  if (tree) {
    proto_item_append_text(proto_item_get_parent_nth(actx->created_item, 2), ": %s", val_to_str(Ref_MNREQREQ, VALS(iicp_RefMNREQREQ_vals), "unknown (%d)"));
  }

  return offset;
}



static int
dissect_iicp_T_request_param_01(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type_pdu_new(tvb, offset, actx, tree, hf_index, dissect_msap_mn_request_request);

  return offset;
}


static const per_sequence_t MN_Request_request_sequence[] = {
  { &hf_iicp_commandRef     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CommandRef },
  { &hf_iicp_ref_06         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RefMNREQREQ },
  { &hf_iicp_request_param_01, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_request_param_01 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_MN_Request_request(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
#line 367 "../../asn1/calm-iicp/iicp.cnf"
  col_set_str(actx->pinfo->cinfo, COL_INFO, "IICP MN-Request-request");

    offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_MN_Request_request, MN_Request_request_sequence);




  return offset;
}



static int
dissect_iicp_SimNUTreq(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
#line 342 "../../asn1/calm-iicp/iicp.cnf"
  col_set_str(actx->pinfo->cinfo, COL_INFO, "IICP Network UT request ");

    offset = dissect_iicp_NFsapPrimitivesUp(tvb, offset, actx, tree, hf_index);




  return offset;
}



static int
dissect_iicp_SimNLTreq(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
#line 352 "../../asn1/calm-iicp/iicp.cnf"
  col_set_str(actx->pinfo->cinfo, COL_INFO, "IICP Access Layer request ");

    offset = dissect_iicp_INsapPrimitivesDown(tvb, offset, actx, tree, hf_index);




  return offset;
}


static const value_string iicp_RefFWTNOT_vals[] = {
  { iicp_fntpSetNot, "iicp-fntpSetNot" },
  { iicp_fntpUpdateNot, "iicp-fntpUpdateNot" },
  { iicp_fntpDeleteNot, "iicp-fntpDeleteNot" },
  { 0, NULL }
};


static int
dissect_iicp_RefFWTNOT(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, &Ref_FWTNOT, FALSE);

#line 259 "../../asn1/calm-iicp/iicp.cnf"
  if (tree) {
    proto_item_append_text(proto_item_get_parent_nth(actx->created_item, 2), ": %s", val_to_str(Ref_FWTNOT, VALS(iicp_RefFWTNOT_vals), "unknown (%d)"));
  }

  return offset;
}



static int
dissect_iicp_T_fwt_06(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type_pdu_new(tvb, offset, actx, tree, hf_index, dissect_msap_fwtnot);

  return offset;
}


static const per_sequence_t FWTsetNot_sequence[] = {
  { &hf_iicp_fwtNo_04       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RefFWTNOT },
  { &hf_iicp_fwt_06         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_fwt_06 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_FWTsetNot(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
#line 417 "../../asn1/calm-iicp/iicp.cnf"
  col_append_fstr(actx->pinfo->cinfo, COL_INFO, " (SetNotFntp)");

    offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_FWTsetNot, FWTsetNot_sequence);




  return offset;
}



static int
dissect_iicp_T_fwt_07(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type_pdu_new(tvb, offset, actx, tree, hf_index, dissect_msap_fwtnot);

  return offset;
}


static const per_sequence_t FWTupdateNot_sequence[] = {
  { &hf_iicp_fwtNo_04       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RefFWTNOT },
  { &hf_iicp_fwt_07         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_fwt_07 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_FWTupdateNot(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_FWTupdateNot, FWTupdateNot_sequence);

  return offset;
}



static int
dissect_iicp_T_fwt_08(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type_pdu_new(tvb, offset, actx, tree, hf_index, dissect_msap_fwtnot);

  return offset;
}


static const per_sequence_t FWTdeleteNot_sequence[] = {
  { &hf_iicp_fwtNo_04       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RefFWTNOT },
  { &hf_iicp_fwt_08         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_fwt_08 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_FWTdeleteNot(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_FWTdeleteNot, FWTdeleteNot_sequence);

  return offset;
}


static const per_sequence_t VCIcreatePeerMAC_sequence[] = {
  { &hf_iicp_reference_02   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_255 },
  { &hf_iicp_linkId         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Link_ID },
  { &hf_iicp_peerMac        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_MACaddress },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_VCIcreatePeerMAC(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_VCIcreatePeerMAC, VCIcreatePeerMAC_sequence);

  return offset;
}


static const per_sequence_t Its_ssiPeerNot_sequence[] = {
  { &hf_iicp_sap_01         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_255 },
  { &hf_iicp_mACaddress     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_MACaddress },
  { &hf_iicp_linkId         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Link_ID },
  { &hf_iicp_its_ssiData    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITS_SSI },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_Its_ssiPeerNot(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_Its_ssiPeerNot, Its_ssiPeerNot_sequence);

  return offset;
}


static const value_string iicp_T_sap_01_vals[] = {
  {  78, "n" },
  { 0, NULL }
};


static int
dissect_iicp_T_sap_01(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}


static const per_sequence_t TestMNecho_sequence[] = {
  { &hf_iicp_sap_02         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_sap_01 },
  { &hf_iicp_info           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_OCTET_STRING_SIZE_0_255 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_TestMNecho(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_TestMNecho, TestMNecho_sequence);

  return offset;
}


static const value_string iicp_RefMNREQCONF_vals[] = {
  { iicp_simNUTreqConf, "iicp-simNUTreqConf" },
  { iicp_simNLTreqConf, "iicp-simNLTreqConf" },
  { iicp_fWTsetNotConf, "iicp-fWTsetNotConf" },
  { iicp_fWTupdateNotConf, "iicp-fWTupdateNotConf" },
  { iicp_fWTdeleteNotConf, "iicp-fWTdeleteNotConf" },
  { iicp_vCIcreatePeerMACConf, "iicp-vCIcreatePeerMACConf" },
  { iicp_its_ssiPeerNotConf, "iicp-its-ssiPeerNotConf" },
  { iicp_testMNechoConf, "iicp-testMNechoConf" },
  { 0, NULL }
};


static int
dissect_iicp_RefMNREQCONF(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, &Ref_MNREQCONF, FALSE);

#line 239 "../../asn1/calm-iicp/iicp.cnf"
  if (tree) {
    proto_item_append_text(proto_item_get_parent_nth(actx->created_item, 2), ": %s", val_to_str(Ref_MNREQCONF, VALS(iicp_RefMNREQCONF_vals), "unknown (%d)"));
  }

  return offset;
}



static int
dissect_iicp_T_reqConfirm_param_01(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type_pdu_new(tvb, offset, actx, tree, hf_index, dissect_msap_mn_request_confirm);

  return offset;
}


static const per_sequence_t MN_Request_confirm_sequence[] = {
  { &hf_iicp_commandRef     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CommandRef },
  { &hf_iicp_ref_07         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RefMNREQCONF },
  { &hf_iicp_reqConfirm_param_01, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_reqConfirm_param_01 },
  { &hf_iicp_errStatus      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ErrStatus },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_MN_Request_confirm(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
#line 372 "../../asn1/calm-iicp/iicp.cnf"
  col_set_str(actx->pinfo->cinfo, COL_INFO, "IICP MN-Request-confirm");

    offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_MN_Request_confirm, MN_Request_confirm_sequence);




  return offset;
}


static const per_sequence_t VCIPeerMAC_sequence[] = {
  { &hf_iicp_reference_02   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_255 },
  { &hf_iicp_linkId         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Link_ID },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_VCIPeerMAC(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_VCIPeerMAC, VCIPeerMAC_sequence);

  return offset;
}



static int
dissect_iicp_T_ref(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_integer(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}



static int
dissect_iicp_T_command_param_02(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}


static const per_sequence_t MI_Command_request_sequence[] = {
  { &hf_iicp_linkID         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Link_ID },
  { &hf_iicp_commandRef     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CommandRef },
  { &hf_iicp_ref_08         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_ref },
  { &hf_iicp_command_param_02, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_command_param_02 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_MI_Command_request(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_MI_Command_request, MI_Command_request_sequence);

  return offset;
}



static int
dissect_iicp_SimIUTcmd(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_INsapPrimitivesDown(tvb, offset, actx, tree, hf_index);

  return offset;
}


static const per_sequence_t RegCmd_sequence[] = {
  { &hf_iicp_scuId          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITS_scuId },
  { &hf_iicp_medID          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_MedID },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_RegCmd(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_RegCmd, RegCmd_sequence);

  return offset;
}


static const value_string iicp_CIstateChng_vals[] = {
  {   0, "deregister" },
  {   4, "activate" },
  {   8, "resume" },
  {  16, "connect" },
  {  32, "disconnect" },
  {  64, "suspend" },
  { 128, "inactivate" },
  { 0, NULL }
};


static int
dissect_iicp_CIstateChng(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_WakeUp(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}


static const per_sequence_t ReqID_sequence[] = {
  { &hf_iicp_linkID         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Link_ID },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ReqID(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ReqID, ReqID_sequence);

  return offset;
}


static const value_string iicp_T_status_vals[] = {
  {   0, "release" },
  {  16, "request" },
  { 0, NULL }
};


static int
dissect_iicp_T_status(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}


static const per_sequence_t RTScmd_sequence[] = {
  { &hf_iicp_reqID          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ReqID },
  { &hf_iicp_priority       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_UserPriority },
  { &hf_iicp_seqNo          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_255 },
  { &hf_iicp_status_04      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_status },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_RTScmd(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_RTScmd, RTScmd_sequence);

  return offset;
}


static const value_string iicp_T_status_01_vals[] = {
  {  64, "ignored" },
  { 128, "granted" },
  { 0, NULL }
};


static int
dissect_iicp_T_status_01(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}


static const per_sequence_t RTSackCmd_sequence[] = {
  { &hf_iicp_priority       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_UserPriority },
  { &hf_iicp_seqNo          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_255 },
  { &hf_iicp_status_05      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_status_01 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_RTSackCmd(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_RTSackCmd, RTSackCmd_sequence);

  return offset;
}


static const value_string iicp_CONcmd_vals[] = {
  {   0, "deleteAC" },
  {   1, "connect" },
  { 255, "disconnect" },
  { 0, NULL }
};


static int
dissect_iicp_CONcmd(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_RI(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       0, 65535, FALSE, NULL);

  return offset;
}


static const per_sequence_t RIcmd_sequence[] = {
  { &hf_iicp_linkID         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Link_ID },
  { &hf_iicp_ri             , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RI },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_RIcmd(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_RIcmd, RIcmd_sequence);

  return offset;
}


static const per_sequence_t VciCmd_item_sequence[] = {
  { &hf_iicp_fill_01        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_BIT_STRING_SIZE_7 },
  { &hf_iicp_linkID         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Link_ID },
  { &hf_iicp_alive          , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_BOOLEAN },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_VciCmd_item(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_VciCmd_item, VciCmd_item_sequence);

  return offset;
}


static const per_sequence_t VciCmd_sequence_of[1] = {
  { &hf_iicp_VciCmd_item    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_VciCmd_item },
};

static int
dissect_iicp_VciCmd(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_iicp_VciCmd, VciCmd_sequence_of,
                                                  0, 65535, FALSE);

  return offset;
}


static const value_string iicp_T_active_vals[] = {
  {   0, "stop" },
  { 255, "start" },
  { 0, NULL }
};


static int
dissect_iicp_T_active(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}


static const per_sequence_t Monitor_item_sequence[] = {
  { &hf_iicp_paramNo_01     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_255 },
  { &hf_iicp_active         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_active },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_Monitor_item(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_Monitor_item, Monitor_item_sequence);

  return offset;
}


static const per_sequence_t Monitor_sequence_of[1] = {
  { &hf_iicp_Monitor_item   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Monitor_item },
};

static int
dissect_iicp_Monitor(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_iicp_Monitor, Monitor_sequence_of,
                                                  0, 255, FALSE);

  return offset;
}


static const per_sequence_t UnitData_sequence[] = {
  { &hf_iicp_sourceAddr     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Link_ID },
  { &hf_iicp_destAddr       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Link_ID },
  { &hf_iicp_data_01        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_OCTET_STRING_SIZE_0_65535 },
  { &hf_iicp_priority       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_UserPriority },
  { &hf_iicp_parameter_01   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_OCTET_STRING_SIZE_0_65535 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_UnitData(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_UnitData, UnitData_sequence);

  return offset;
}


static const per_sequence_t MI_Command_confirm_sequence[] = {
  { &hf_iicp_linkID         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Link_ID },
  { &hf_iicp_commandRef     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CommandRef },
  { &hf_iicp_errStatus      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ErrStatus },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_MI_Command_confirm(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_MI_Command_confirm, MI_Command_confirm_sequence);

  return offset;
}



static int
dissect_iicp_T_ref_01(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_integer(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}



static int
dissect_iicp_T_request_param_02(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}


static const per_sequence_t MI_Request_request_sequence[] = {
  { &hf_iicp_linkID         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Link_ID },
  { &hf_iicp_commandRef     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CommandRef },
  { &hf_iicp_ref_09         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_ref_01 },
  { &hf_iicp_request_param_02, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_request_param_02 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_MI_Request_request(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_MI_Request_request, MI_Request_request_sequence);

  return offset;
}



static int
dissect_iicp_SimIUTreq(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_INsapPrimitivesUp(tvb, offset, actx, tree, hf_index);

  return offset;
}


static const per_sequence_t RegReq_sequence[] = {
  { &hf_iicp_medType        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_MedType },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_RegReq(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_RegReq, RegReq_sequence);

  return offset;
}


static const per_sequence_t Interferers_sequence_of[1] = {
  { &hf_iicp_Interferers_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_MedType },
};

static int
dissect_iicp_Interferers(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_iicp_Interferers, Interferers_sequence_of,
                                                  0, 255, FALSE);

  return offset;
}


static const per_sequence_t PrioReg_sequence[] = {
  { &hf_iicp_interferers    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Interferers },
  { &hf_iicp_timeout_01     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_255 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_PrioReg(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_PrioReg, PrioReg_sequence);

  return offset;
}


static const value_string iicp_T_status_02_vals[] = {
  {   0, "release" },
  {  16, "request" },
  { 0, NULL }
};


static int
dissect_iicp_T_status_02(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}


static const per_sequence_t RTSreq_sequence[] = {
  { &hf_iicp_priority       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_UserPriority },
  { &hf_iicp_seqNo          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_255 },
  { &hf_iicp_status_06      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_status_02 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_RTSreq(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_RTSreq, RTSreq_sequence);

  return offset;
}


static const value_string iicp_T_status_03_vals[] = {
  {  64, "ignored" },
  { 128, "granted" },
  { 0, NULL }
};


static int
dissect_iicp_T_status_03(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}


static const per_sequence_t RTSackReq_sequence[] = {
  { &hf_iicp_reqID          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ReqID },
  { &hf_iicp_seqNo          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_255 },
  { &hf_iicp_status_07      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_status_03 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_RTSackReq(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_RTSackReq, RTSackReq_sequence);

  return offset;
}



static int
dissect_iicp_RIaccess(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       0, 65535, FALSE, NULL);

  return offset;
}


static const per_sequence_t RIreq_sequence[] = {
  { &hf_iicp_medType        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_MedType },
  { &hf_iicp_riAccess       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RIaccess },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_RIreq(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_RIreq, RIreq_sequence);

  return offset;
}



static int
dissect_iicp_T_eventNo(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_integer(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}



static int
dissect_iicp_T_event(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}


static const per_sequence_t Events21218_sequence[] = {
  { &hf_iicp_eventNo        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_eventNo },
  { &hf_iicp_event          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_event },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_Events21218(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_Events21218, Events21218_sequence);

  return offset;
}


static const per_sequence_t E21218_0_sequence[] = {
  { &hf_iicp_priority       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_UserPriority },
  { &hf_iicp_linkID         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Link_ID },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_E21218_0(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_E21218_0, E21218_0_sequence);

  return offset;
}



static int
dissect_iicp_E21218_1(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_UserPriority(tvb, offset, actx, tree, hf_index);

  return offset;
}



static int
dissect_iicp_E21218_2(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_UserPriority(tvb, offset, actx, tree, hf_index);

  return offset;
}



static int
dissect_iicp_E21218_3(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_Link_ID(tvb, offset, actx, tree, hf_index);

  return offset;
}



static int
dissect_iicp_E21218_4(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_Link_ID(tvb, offset, actx, tree, hf_index);

  return offset;
}



static int
dissect_iicp_E21218_5(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_I_Parameter(tvb, offset, actx, tree, hf_index);

  return offset;
}



static int
dissect_iicp_E21218_6(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_UserPriority(tvb, offset, actx, tree, hf_index);

  return offset;
}



static int
dissect_iicp_E21218_7(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_Link_ID(tvb, offset, actx, tree, hf_index);

  return offset;
}



static int
dissect_iicp_PosUpdateReq(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 65535U, NULL, FALSE);

  return offset;
}


static const value_string iicp_T_sap_02_vals[] = {
  {  73, "i" },
  { 0, NULL }
};


static int
dissect_iicp_T_sap_02(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}


static const per_sequence_t TestMIecho_sequence[] = {
  { &hf_iicp_sap_03         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_sap_02 },
  { &hf_iicp_info           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_OCTET_STRING_SIZE_0_255 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_TestMIecho(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_TestMIecho, TestMIecho_sequence);

  return offset;
}


static const per_sequence_t MI_Request_confirm_sequence[] = {
  { &hf_iicp_linkID         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Link_ID },
  { &hf_iicp_commandRef     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CommandRef },
  { &hf_iicp_errStatus      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ErrStatus },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_MI_Request_confirm(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_MI_Request_confirm, MI_Request_confirm_sequence);

  return offset;
}


static const per_sequence_t SEQUENCE_OF_I_Parameter_sequence_of[1] = {
  { &hf_iicp_set_param_item , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_I_Parameter },
};

static int
dissect_iicp_SEQUENCE_OF_I_Parameter(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence_of(tvb, offset, actx, tree, hf_index,
                                      ett_iicp_SEQUENCE_OF_I_Parameter, SEQUENCE_OF_I_Parameter_sequence_of);

  return offset;
}


static const per_sequence_t MI_Set_request_sequence[] = {
  { &hf_iicp_linkID         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Link_ID },
  { &hf_iicp_commandRef     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CommandRef },
  { &hf_iicp_set_param      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_SEQUENCE_OF_I_Parameter },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_MI_Set_request(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_MI_Set_request, MI_Set_request_sequence);

  return offset;
}


static const per_sequence_t SEQUENCE_OF_Errors_sequence_of[1] = {
  { &hf_iicp_set_param_item_01, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Errors },
};

static int
dissect_iicp_SEQUENCE_OF_Errors(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence_of(tvb, offset, actx, tree, hf_index,
                                      ett_iicp_SEQUENCE_OF_Errors, SEQUENCE_OF_Errors_sequence_of);

  return offset;
}


static const per_sequence_t MI_Set_confirm_sequence[] = {
  { &hf_iicp_linkID         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Link_ID },
  { &hf_iicp_commandRef     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CommandRef },
  { &hf_iicp_set_param_01   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_SEQUENCE_OF_Errors },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_MI_Set_confirm(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_MI_Set_confirm, MI_Set_confirm_sequence);

  return offset;
}


static const per_sequence_t SEQUENCE_OF_I_ParamNo_sequence_of[1] = {
  { &hf_iicp_get_param_no_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_I_ParamNo },
};

static int
dissect_iicp_SEQUENCE_OF_I_ParamNo(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence_of(tvb, offset, actx, tree, hf_index,
                                      ett_iicp_SEQUENCE_OF_I_ParamNo, SEQUENCE_OF_I_ParamNo_sequence_of);

  return offset;
}


static const per_sequence_t MI_Get_request_sequence[] = {
  { &hf_iicp_linkID         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Link_ID },
  { &hf_iicp_commandRef     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CommandRef },
  { &hf_iicp_get_param_no   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_SEQUENCE_OF_I_ParamNo },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_MI_Get_request(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_MI_Get_request, MI_Get_request_sequence);

  return offset;
}


static const per_sequence_t MI_Get_confirm_sequence[] = {
  { &hf_iicp_linkID         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Link_ID },
  { &hf_iicp_commandRef     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CommandRef },
  { &hf_iicp_set_param      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_SEQUENCE_OF_I_Parameter },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_MI_Get_confirm(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_MI_Get_confirm, MI_Get_confirm_sequence);

  return offset;
}



static int
dissect_iicp_T_ref_02(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_integer(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}



static int
dissect_iicp_T_command_param_03(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}


static const per_sequence_t MS_Command_request_sequence[] = {
  { &hf_iicp_commandRef     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CommandRef },
  { &hf_iicp_ref_10         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_ref_02 },
  { &hf_iicp_command_param_03, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_command_param_03 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_MS_Command_request(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_MS_Command_request, MS_Command_request_sequence);

  return offset;
}



static int
dissect_iicp_T_ref_03(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_integer(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}



static int
dissect_iicp_T_cmdConfirm_param_02(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}


static const per_sequence_t MS_Command_confirm_sequence[] = {
  { &hf_iicp_commandRef     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CommandRef },
  { &hf_iicp_ref_11         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_ref_03 },
  { &hf_iicp_cmdConfirm_param_02, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_cmdConfirm_param_02 },
  { &hf_iicp_errStatus      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ErrStatus },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_MS_Command_confirm(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_MS_Command_confirm, MS_Command_confirm_sequence);

  return offset;
}



static int
dissect_iicp_T_ref_04(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_integer(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}



static int
dissect_iicp_T_request_param_03(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}


static const per_sequence_t MS_Request_request_sequence[] = {
  { &hf_iicp_commandRef     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CommandRef },
  { &hf_iicp_ref_12         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_ref_04 },
  { &hf_iicp_request_param_03, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_request_param_03 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_MS_Request_request(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_MS_Request_request, MS_Request_request_sequence);

  return offset;
}


static const value_string iicp_T_sap_03_vals[] = {
  {  83, "s" },
  { 0, NULL }
};


static int
dissect_iicp_T_sap_03(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}


static const per_sequence_t TestMSecho_sequence[] = {
  { &hf_iicp_sap_04         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_sap_03 },
  { &hf_iicp_info           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_OCTET_STRING_SIZE_0_255 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_TestMSecho(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_TestMSecho, TestMSecho_sequence);

  return offset;
}



static int
dissect_iicp_T_ref_05(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_integer(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}



static int
dissect_iicp_T_reqConfirm_param_02(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}


static const per_sequence_t MS_Request_confirm_sequence[] = {
  { &hf_iicp_commandRef     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CommandRef },
  { &hf_iicp_ref_13         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_ref_05 },
  { &hf_iicp_reqConfirm_param_02, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_reqConfirm_param_02 },
  { &hf_iicp_errStatus      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ErrStatus },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_MS_Request_confirm(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_MS_Request_confirm, MS_Request_confirm_sequence);

  return offset;
}



static int
dissect_iicp_T_ref_06(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_integer(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}



static int
dissect_iicp_T_command_param_04(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}


static const per_sequence_t MA_Command_request_sequence[] = {
  { &hf_iicp_commandRef     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CommandRef },
  { &hf_iicp_ref_14         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_ref_06 },
  { &hf_iicp_command_param_04, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_command_param_04 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_MA_Command_request(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_MA_Command_request, MA_Command_request_sequence);

  return offset;
}



static int
dissect_iicp_T_ref_07(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_integer(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}



static int
dissect_iicp_T_cmdConfirm_param_03(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}


static const per_sequence_t MA_Command_confirm_sequence[] = {
  { &hf_iicp_commandRef     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CommandRef },
  { &hf_iicp_ref_15         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_ref_07 },
  { &hf_iicp_cmdConfirm_param_03, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_cmdConfirm_param_03 },
  { &hf_iicp_errStatus      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ErrStatus },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_MA_Command_confirm(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_MA_Command_confirm, MA_Command_confirm_sequence);

  return offset;
}



static int
dissect_iicp_T_ref_08(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_integer(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}



static int
dissect_iicp_T_request_param_04(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}


static const per_sequence_t MA_Request_request_sequence[] = {
  { &hf_iicp_commandRef     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CommandRef },
  { &hf_iicp_ref_16         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_ref_08 },
  { &hf_iicp_request_param_04, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_request_param_04 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_MA_Request_request(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_MA_Request_request, MA_Request_request_sequence);

  return offset;
}


static const value_string iicp_T_sap_04_vals[] = {
  {  65, "a" },
  { 0, NULL }
};


static int
dissect_iicp_T_sap_04(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}


static const per_sequence_t TestMAecho_sequence[] = {
  { &hf_iicp_sap_05         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_sap_04 },
  { &hf_iicp_info           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_OCTET_STRING_SIZE_0_255 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_TestMAecho(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_TestMAecho, TestMAecho_sequence);

  return offset;
}



static int
dissect_iicp_T_ref_09(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_integer(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}



static int
dissect_iicp_T_reqConfirm_param_03(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}


static const per_sequence_t MA_Request_confirm_sequence[] = {
  { &hf_iicp_commandRef     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CommandRef },
  { &hf_iicp_ref_17         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_ref_09 },
  { &hf_iicp_reqConfirm_param_03, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_reqConfirm_param_03 },
  { &hf_iicp_errStatus      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ErrStatus },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_MA_Request_confirm(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_MA_Request_confirm, MA_Request_confirm_sequence);

  return offset;
}


static const value_string iicp_PortNumber_vals[] = {
  {   0, "portShort" },
  {   1, "portLong" },
  { 0, NULL }
};

static const per_choice_t PortNumber_choice[] = {
  {   0, &hf_iicp_portShort      , ASN1_NO_EXTENSIONS     , dissect_iicp_INTEGER_0_127 },
  {   1, &hf_iicp_portLong       , ASN1_NO_EXTENSIONS     , dissect_iicp_INTEGER_0_32767 },
  { 0, NULL, 0, NULL }
};

static int
dissect_iicp_PortNumber(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_iicp_PortNumber, PortNumber_choice,
                                 NULL);

  return offset;
}



static int
dissect_iicp_FNTPpacketCounter(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}


static const per_sequence_t FNTPintForwarding_sequence[] = {
  { &hf_iicp_hostITS_scuId  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITS_scuId },
  { &hf_iicp_link           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Link_ID },
  { &hf_iicp_counter        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_FNTPpacketCounter },
  { &hf_iicp_sourcePort     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_PortNumber },
  { &hf_iicp_destinationPort, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_PortNumber },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_FNTPintForwarding(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_FNTPintForwarding, FNTPintForwarding_sequence);

  return offset;
}



static int
dissect_iicp_FNTPsecurity(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       0, 65535, FALSE, NULL);

  return offset;
}



static int
dissect_iicp_FNTPhopCount(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_FNTPlpp(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       0, 65535, FALSE, NULL);

  return offset;
}



static int
dissect_iicp_RXcip(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       0, 255, FALSE, NULL);

  return offset;
}



static int
dissect_iicp_TXcip(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       0, 255, FALSE, NULL);

  return offset;
}


static const per_sequence_t FNTPCIPheader_sequence[] = {
  { &hf_iicp_rxCIP          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RXcip },
  { &hf_iicp_txCIP          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_TXcip },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_FNTPCIPheader(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_FNTPCIPheader, FNTPCIPheader_sequence);

  return offset;
}



static int
dissect_iicp_NULL(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_null(tvb, offset, actx, tree, hf_index);

  return offset;
}


static const per_sequence_t FntpOptions_sequence[] = {
  { &hf_iicp_intForw        , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_FNTPintForwarding },
  { &hf_iicp_sec            , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_FNTPsecurity },
  { &hf_iicp_hops           , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_FNTPhopCount },
  { &hf_iicp_lpp            , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_FNTPlpp },
  { &hf_iicp_cip            , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_FNTPCIPheader },
  { &hf_iicp_opt5           , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_NULL },
  { &hf_iicp_opt6           , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_NULL },
  { &hf_iicp_opt7           , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_NULL },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_FntpOptions(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_FntpOptions, FntpOptions_sequence);

  return offset;
}


static const per_sequence_t FNTPHeader_sequence[] = {
  { &hf_iicp_sourcePort     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_PortNumber },
  { &hf_iicp_destinationPort, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_PortNumber },
  { &hf_iicp_options_01     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_FntpOptions },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_FNTPHeader(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_FNTPHeader, FNTPHeader_sequence);

  return offset;
}



static int
dissect_iicp_ITSfpdu(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
#line 71 "../../asn1/calm-iicp/iicp.cnf"
  tvbuff_t *fpdu_tvb = NULL;
  proto_tree *subtree = NULL;
  proto_item *item = NULL;
  guint16 tvb_len = -1;
  guint8 ch = 0xff;

  offset = dissect_per_octet_string(tvb, offset, actx, tree, -1, 0, 65535, FALSE, &fpdu_tvb);
  if (fpdu_tvb == NULL) {
    return offset;
  }

  ch = tvb_get_guint8(fpdu_tvb, 0);
  if (ch == 0x00) { // SAM message
    tvb_len = tvb_length(fpdu_tvb);
    item = proto_tree_add_item(tree, hf_index, fpdu_tvb, 0, tvb_len, FALSE);
    subtree = proto_item_add_subtree(item, ett_iicp_FNTPNPDU);
    dissect_iicp_SAM(fpdu_tvb, 0, actx, subtree, 0);
    proto_item_set_text(subtree->first_child, "SAM");
  } else if (ch == 0x01) { /* CAM or DENM: ITS-Container { itu-t (0) identified-organization (4) etsi (0) itsDomain (5) wg1 (1) ts (102894) cdd (2) version (1) } */
    guint8 messageType;

    messageType = tvb_get_guint8(fpdu_tvb, 1);
    tvb_len = tvb_length(fpdu_tvb);
    item = proto_tree_add_item(tree, hf_index, fpdu_tvb, 0, tvb_len, FALSE);
    subtree = proto_item_add_subtree(item, ett_iicp_FNTPNPDU);
    printf("dissect_iicp_ITSfpdu: %d - 0x%02x - 0x%02x\n", tvb_len, ch, messageType);
    if (messageType == 0x02) {
      // TODO Call CAM dissector
    } else if (messageType == 0x01) {
      // TODO Call DENM dissector 
    }
//    dissect_iicp_SAM(fpdu_tvb, 0, actx, subtree, 0);
//    proto_item_set_text(subtree->first_child, "SAM");
  }


  return offset;
}


static const per_sequence_t FNTPNPDU_sequence[] = {
  { &hf_iicp_header         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_FNTPHeader },
  { &hf_iicp_body           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSfpdu },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_FNTPNPDU(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_FNTPNPDU, FNTPNPDU_sequence);

  return offset;
}



static int
dissect_iicp_INTEGER_0_noFNTPfwtEntries(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, noFNTPfwtEntries, NULL, FALSE);

  return offset;
}


static const per_sequence_t DeleteFNTP_sequence[] = {
  { &hf_iicp_reference_03   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_noFNTPfwtEntries },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_DeleteFNTP(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_DeleteFNTP, DeleteFNTP_sequence);

  return offset;
}


static const per_sequence_t DeleteNotFNTP_sequence[] = {
  { &hf_iicp_reference_03   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_noFNTPfwtEntries },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_DeleteNotFNTP(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_DeleteNotFNTP, DeleteNotFNTP_sequence);

  return offset;
}


static const per_sequence_t HostServiceInfo_sequence[] = {
  { &hf_iicp_servicePort    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_PortNumber },
  { &hf_iicp_hostITSscu     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITS_scuId },
  { &hf_iicp_servicePriority, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_UserPriority },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_HostServiceInfo(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_HostServiceInfo, HostServiceInfo_sequence);

  return offset;
}



static int
dissect_iicp_NTtimeout(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 65535U, NULL, FALSE);

  return offset;
}


static const per_sequence_t SetFNTP_sequence[] = {
  { &hf_iicp_remotePort     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_PortNumber },
  { &hf_iicp_linkID         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Link_ID },
  { &hf_iicp_ciStatus       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CIstatus },
  { &hf_iicp_linkPort       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_PortNumber },
  { &hf_iicp_serviceInfo    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_HostServiceInfo },
  { &hf_iicp_priority       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_UserPriority },
  { &hf_iicp_timeout_02     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_NTtimeout },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_SetFNTP(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_SetFNTP, SetFNTP_sequence);

  return offset;
}


static const per_sequence_t SetConfFNTP_sequence[] = {
  { &hf_iicp_reference_03   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_noFNTPfwtEntries },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_SetConfFNTP(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_SetConfFNTP, SetConfFNTP_sequence);

  return offset;
}


static const per_sequence_t SetNotFNTP_sequence[] = {
  { &hf_iicp_reference_03   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_noFNTPfwtEntries },
  { &hf_iicp_remotePort     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_PortNumber },
  { &hf_iicp_linkID         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Link_ID },
  { &hf_iicp_ciStatus       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CIstatus },
  { &hf_iicp_linkPort       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_PortNumber },
  { &hf_iicp_serviceInfo    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_HostServiceInfo },
  { &hf_iicp_priority       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_UserPriority },
  { &hf_iicp_timeout_02     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_NTtimeout },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_SetNotFNTP(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_SetNotFNTP, SetNotFNTP_sequence);

  return offset;
}


static const per_sequence_t UpdateFNTP_sequence[] = {
  { &hf_iicp_fill_03        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_BIT_STRING_SIZE_1 },
  { &hf_iicp_reference_03   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_noFNTPfwtEntries },
  { &hf_iicp_remotePort     , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_PortNumber },
  { &hf_iicp_linkID         , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_Link_ID },
  { &hf_iicp_ciStatus       , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_CIstatus },
  { &hf_iicp_linkPort       , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_PortNumber },
  { &hf_iicp_serviceInfo    , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_HostServiceInfo },
  { &hf_iicp_priority       , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_UserPriority },
  { &hf_iicp_timeout_02     , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_NTtimeout },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_UpdateFNTP(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_UpdateFNTP, UpdateFNTP_sequence);

  return offset;
}


static const per_sequence_t UpdateNotFNTP_sequence[] = {
  { &hf_iicp_fill_03        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_BIT_STRING_SIZE_1 },
  { &hf_iicp_reference_03   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_noFNTPfwtEntries },
  { &hf_iicp_remotePort     , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_PortNumber },
  { &hf_iicp_linkID         , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_Link_ID },
  { &hf_iicp_ciStatus       , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_CIstatus },
  { &hf_iicp_linkPort       , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_PortNumber },
  { &hf_iicp_serviceInfo    , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_HostServiceInfo },
  { &hf_iicp_priority       , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_UserPriority },
  { &hf_iicp_timeout_02     , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_NTtimeout },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_UpdateNotFNTP(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_UpdateNotFNTP, UpdateNotFNTP_sequence);

  return offset;
}


static const value_string iicp_PortOp_vals[] = {
  {   0, "delete" },
  { 255, "create" },
  { 0, NULL }
};


static int
dissect_iicp_PortOp(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}


static const per_sequence_t NFfntpPortRequest_sequence[] = {
  { &hf_iicp_serviceRef     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ServiceRef },
  { &hf_iicp_operation      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_PortOp },
  { &hf_iicp_portno         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_PortNumber },
  { &hf_iicp_priority       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_UserPriority },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_NFfntpPortRequest(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
#line 422 "../../asn1/calm-iicp/iicp.cnf"
  col_append_fstr(actx->pinfo->cinfo, COL_INFO, " (NFfntpPortRequest)");

    offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_NFfntpPortRequest, NFfntpPortRequest_sequence);




  return offset;
}


static const per_sequence_t NFfntpPortConfirm_sequence[] = {
  { &hf_iicp_serviceRef     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ServiceRef },
  { &hf_iicp_servicePort    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_PortNumber },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_NFfntpPortConfirm(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
#line 427 "../../asn1/calm-iicp/iicp.cnf"
  col_append_fstr(actx->pinfo->cinfo, COL_INFO, " (NFfntpPortConfirm)");

    offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_NFfntpPortConfirm, NFfntpPortConfirm_sequence);




  return offset;
}


static const per_sequence_t NFfntpCommRequest_sequence[] = {
  { &hf_iicp_commRef        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_255 },
  { &hf_iicp_servicePort    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_PortNumber },
  { &hf_iicp_remotePort     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_PortNumber },
  { &hf_iicp_linkID         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Link_ID },
  { &hf_iicp_data_02        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSfpdu },
  { &hf_iicp_priority       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_UserPriority },
  { &hf_iicp_controlField   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_FntpOptions },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_NFfntpCommRequest(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
#line 432 "../../asn1/calm-iicp/iicp.cnf"
  col_append_fstr(actx->pinfo->cinfo, COL_INFO, " (NFfntpCommRequest)");

    offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_NFfntpCommRequest, NFfntpCommRequest_sequence);




  return offset;
}


static const value_string iicp_FNTPerrorStatus_vals[] = {
  {   0, "success" },
  {   1, "unspecFailure" },
  {   2, "ciBusyTX" },
  { 254, "noForwardInfo" },
  { 255, "ciSuspend" },
  { 0, NULL }
};


static int
dissect_iicp_FNTPerrorStatus(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}


static const per_sequence_t NFfntpCommConfirm_sequence[] = {
  { &hf_iicp_commRef        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_255 },
  { &hf_iicp_servicePort    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_PortNumber },
  { &hf_iicp_errStatus_01   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_FNTPerrorStatus },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_NFfntpCommConfirm(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
#line 437 "../../asn1/calm-iicp/iicp.cnf"
  col_append_fstr(actx->pinfo->cinfo, COL_INFO, " (NFfntpCommConfirm)");

    offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_NFfntpCommConfirm, NFfntpCommConfirm_sequence);




  return offset;
}


static const per_sequence_t NFfntpCommIndication_sequence[] = {
  { &hf_iicp_servicePort    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_PortNumber },
  { &hf_iicp_remotePort     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_PortNumber },
  { &hf_iicp_linkID         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Link_ID },
  { &hf_iicp_data_02        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSfpdu },
  { &hf_iicp_priority       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_UserPriority },
  { &hf_iicp_controlField   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_FntpOptions },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_NFfntpCommIndication(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
#line 442 "../../asn1/calm-iicp/iicp.cnf"
  col_append_fstr(actx->pinfo->cinfo, COL_INFO, " (NFfntpCommIndication)");

    offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_NFfntpCommIndication, NFfntpCommIndication_sequence);




  return offset;
}


static const value_string iicp_FmtID_vals[] = {
  {   0, "sam" },
  {   1, "ctx" },
  { 0, NULL }
};


static int
dissect_iicp_FmtID(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 15U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_VersionFSAP(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 15U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_ServiceData(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       0, noServiceDataOctets, FALSE, NULL);

  return offset;
}



static int
dissect_iicp_INTEGER_0_noChannels(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, noChannels, NULL, FALSE);

  return offset;
}


static const per_sequence_t NonipService_sequence[] = {
  { &hf_iicp_serviceID      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSaid },
  { &hf_iicp_serviceData    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ServiceData },
  { &hf_iicp_serverPort     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_PortNumber },
  { &hf_iicp_sessionChannel , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_noChannels },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_NonipService(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_NonipService, NonipService_sequence);

  return offset;
}


static const per_sequence_t ServiceList_sequence_of[1] = {
  { &hf_iicp_ServiceList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_NonipService },
};

static int
dissect_iicp_ServiceList(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_iicp_ServiceList, ServiceList_sequence_of,
                                                  0, noNonipServices, FALSE);

  return offset;
}



static int
dissect_iicp_OCTET_STRING(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       NO_BOUND, NO_BOUND, FALSE, NULL);

  return offset;
}


static const per_sequence_t SessionChannel_sequence[] = {
  { &hf_iicp_serviceChannel , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_255 },
  { &hf_iicp_medium         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_MedType },
  { &hf_iicp_schParams      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_OCTET_STRING },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_SessionChannel(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_SessionChannel, SessionChannel_sequence);

  return offset;
}


static const per_sequence_t ChannelList_sequence_of[1] = {
  { &hf_iicp_ChannelList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_SessionChannel },
};

static int
dissect_iicp_ChannelList(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_iicp_ChannelList, ChannelList_sequence_of,
                                                  0, noChannels, FALSE);

  return offset;
}



static int
dissect_iicp_IpServiceData(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       0, noIpServiceDataOctets, FALSE, NULL);

  return offset;
}


static const per_sequence_t IpInfo_sequence[] = {
  { &hf_iicp_address        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_IpAddressInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_IpInfo(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_IpInfo, IpInfo_sequence);

  return offset;
}


static const per_sequence_t IpService_sequence[] = {
  { &hf_iicp_serviceID      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSaid },
  { &hf_iicp_serviceData_01 , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_IpServiceData },
  { &hf_iicp_ipInfo         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_IpInfo },
  { &hf_iicp_sessionChannel , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_noChannels },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_IpService(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_IpService, IpService_sequence);

  return offset;
}


static const per_sequence_t IpServList_sequence_of[1] = {
  { &hf_iicp_IpServList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_IpService },
};

static int
dissect_iicp_IpServList(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_iicp_IpServList, IpServList_sequence_of,
                                                  0, noIpServices, FALSE);

  return offset;
}


static const per_sequence_t SAM_sequence[] = {
  { &hf_iicp_fmtID          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_FmtID },
  { &hf_iicp_version        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_VersionFSAP },
  { &hf_iicp_serverID       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_StationID },
  { &hf_iicp_serviceList    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ServiceList },
  { &hf_iicp_channelList    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ChannelList },
  { &hf_iicp_ipServList     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_IpServList },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_SAM(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_SAM, SAM_sequence);

  return offset;
}



static int
dissect_iicp_ContextData(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       0, noContextDataOctets, FALSE, NULL);

  return offset;
}


static const per_sequence_t NonipContext_sequence[] = {
  { &hf_iicp_serviceID      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSaid },
  { &hf_iicp_contextData_01 , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ContextData },
  { &hf_iicp_userPort       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_PortNumber },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_NonipContext(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_NonipContext, NonipContext_sequence);

  return offset;
}


static const per_sequence_t ServContextList_sequence_of[1] = {
  { &hf_iicp_ServContextList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_NonipContext },
};

static int
dissect_iicp_ServContextList(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_iicp_ServContextList, ServContextList_sequence_of,
                                                  0, noNonipContexts, FALSE);

  return offset;
}



static int
dissect_iicp_IpContextData(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       0, noIpContextDataOctets, FALSE, NULL);

  return offset;
}


static const per_sequence_t IpContext_sequence[] = {
  { &hf_iicp_serviceID      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSaid },
  { &hf_iicp_contextData    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_IpContextData },
  { &hf_iicp_ipInfo         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_IpInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_IpContext(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_IpContext, IpContext_sequence);

  return offset;
}


static const per_sequence_t IpContextList_sequence_of[1] = {
  { &hf_iicp_IpContextList_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_IpContext },
};

static int
dissect_iicp_IpContextList(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_iicp_IpContextList, IpContextList_sequence_of,
                                                  0, noIpContexts, FALSE);

  return offset;
}


static const per_sequence_t CTX_sequence[] = {
  { &hf_iicp_fmtID          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_FmtID },
  { &hf_iicp_version        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_VersionFSAP },
  { &hf_iicp_clientID       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_StationID },
  { &hf_iicp_servContextList, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ServContextList },
  { &hf_iicp_ipContextList  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_IpContextList },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_CTX(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_CTX, CTX_sequence);

  return offset;
}


static const per_sequence_t GCctxTxCmd_sequence[] = {
  { &hf_iicp_link_01        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_LLserviceAddr },
  { &hf_iicp_ctx            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CTX },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_GCctxTxCmd(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_GCctxTxCmd, GCctxTxCmd_sequence);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_1_256_OF_LLserviceAddr_sequence_of[1] = {
  { &hf_iicp_bcVCIs_item    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_LLserviceAddr },
};

static int
dissect_iicp_SEQUENCE_SIZE_1_256_OF_LLserviceAddr(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_iicp_SEQUENCE_SIZE_1_256_OF_LLserviceAddr, SEQUENCE_SIZE_1_256_OF_LLserviceAddr_sequence_of,
                                                  1, 256, FALSE);

  return offset;
}



static int
dissect_iicp_GcInterval(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 65535U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_OCTET_STRING_SIZE_0_noServiceDataOctets(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       0, noServiceDataOctets, FALSE, NULL);

  return offset;
}


static const per_sequence_t NonipServiceReg_sequence[] = {
  { &hf_iicp_serviceID      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSaid },
  { &hf_iicp_timeout_02     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_NTtimeout },
  { &hf_iicp_serviceData_03 , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_OCTET_STRING_SIZE_0_noServiceDataOctets },
  { &hf_iicp_providerPort   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_PortNumber },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_NonipServiceReg(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_NonipServiceReg, NonipServiceReg_sequence);

  return offset;
}



static int
dissect_iicp_OCTET_STRING_SIZE_0_noIpServiceDataOctets(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       0, noIpServiceDataOctets, FALSE, NULL);

  return offset;
}


static const per_sequence_t IpServiceReg_sequence[] = {
  { &hf_iicp_serviceID      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSaid },
  { &hf_iicp_serviceData_04 , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_OCTET_STRING_SIZE_0_noIpServiceDataOctets },
  { &hf_iicp_ipInfo         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_IpInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_IpServiceReg(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_IpServiceReg, IpServiceReg_sequence);

  return offset;
}


static const value_string iicp_T_datareg_vals[] = {
  {   0, "nonipData" },
  {   1, "ipData" },
  { 0, NULL }
};

static const per_choice_t T_datareg_choice[] = {
  {   0, &hf_iicp_nonipData      , ASN1_NO_EXTENSIONS     , dissect_iicp_NonipServiceReg },
  {   1, &hf_iicp_ipData         , ASN1_NO_EXTENSIONS     , dissect_iicp_IpServiceReg },
  { 0, NULL, 0, NULL }
};

static int
dissect_iicp_T_datareg(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_iicp_T_datareg, T_datareg_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t ServiceDataReg_sequence[] = {
  { &hf_iicp_fill_01        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_BIT_STRING_SIZE_7 },
  { &hf_iicp_datareg        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_datareg },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ServiceDataReg(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ServiceDataReg, ServiceDataReg_sequence);

  return offset;
}


static const per_sequence_t GCperiodCmd_sequence[] = {
  { &hf_iicp_applicationID  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ApplicationID },
  { &hf_iicp_bcVCIs         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_SEQUENCE_SIZE_1_256_OF_LLserviceAddr },
  { &hf_iicp_gcInterval     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_GcInterval },
  { &hf_iicp_priority       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_UserPriority },
  { &hf_iicp_serviceDataReg , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ServiceDataReg },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_GCperiodCmd(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_GCperiodCmd, GCperiodCmd_sequence);

  return offset;
}


static const per_sequence_t NonipSAMctx_sequence[] = {
  { &hf_iicp_serviceID      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSaid },
  { &hf_iicp_providerPort   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_PortNumber },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_NonipSAMctx(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_NonipSAMctx, NonipSAMctx_sequence);

  return offset;
}


static const per_sequence_t IpSAMctx_sequence[] = {
  { &hf_iicp_serviceID      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSaid },
  { &hf_iicp_ipInfo         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_IpInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_IpSAMctx(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_IpSAMctx, IpSAMctx_sequence);

  return offset;
}


static const value_string iicp_T_info_vals[] = {
  {   0, "nonipService" },
  {   1, "ipService" },
  { 0, NULL }
};

static const per_choice_t T_info_choice[] = {
  {   0, &hf_iicp_nonipService   , ASN1_NO_EXTENSIONS     , dissect_iicp_NonipSAMctx },
  {   1, &hf_iicp_ipService      , ASN1_NO_EXTENSIONS     , dissect_iicp_IpSAMctx },
  { 0, NULL, 0, NULL }
};

static int
dissect_iicp_T_info(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_iicp_T_info, T_info_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t ServiceInfo_sequence[] = {
  { &hf_iicp_fill_01        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_BIT_STRING_SIZE_7 },
  { &hf_iicp_info_01        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_info },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ServiceInfo(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ServiceInfo, ServiceInfo_sequence);

  return offset;
}


static const per_sequence_t GCsamctx_sequence[] = {
  { &hf_iicp_applicationID  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ApplicationID },
  { &hf_iicp_serverID       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_StationID },
  { &hf_iicp_serviceInfo_01 , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ServiceInfo },
  { &hf_iicp_link_01        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_LLserviceAddr },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_GCsamctx(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_GCsamctx, GCsamctx_sequence);

  return offset;
}


static const per_sequence_t GCsamctxConf_sequence[] = {
  { &hf_iicp_port           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_PortNumber },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_GCsamctxConf(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_GCsamctxConf, GCsamctxConf_sequence);

  return offset;
}


static const per_sequence_t GCdeleteCmd_sequence[] = {
  { &hf_iicp_applicationID  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ApplicationID },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_GCdeleteCmd(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_GCdeleteCmd, GCdeleteCmd_sequence);

  return offset;
}


static const per_sequence_t CTXrxNot_sequence[] = {
  { &hf_iicp_link_01        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_LLserviceAddr },
  { &hf_iicp_ctx            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CTX },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_CTXrxNot(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_CTXrxNot, CTXrxNot_sequence);

  return offset;
}


static const per_sequence_t SAMrxNot_sequence[] = {
  { &hf_iicp_link_01        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_LLserviceAddr },
  { &hf_iicp_sam            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_SAM },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_SAMrxNot(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_SAMrxNot, SAMrxNot_sequence);

  return offset;
}


static const per_sequence_t NonipSAM_sequence[] = {
  { &hf_iicp_serviceID      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSaid },
  { &hf_iicp_serviceData    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ServiceData },
  { &hf_iicp_providerPort   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_PortNumber },
  { &hf_iicp_sessionChannel_01, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_SessionChannel },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_NonipSAM(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_NonipSAM, NonipSAM_sequence);

  return offset;
}


static const per_sequence_t IpSAM_sequence[] = {
  { &hf_iicp_serviceID      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSaid },
  { &hf_iicp_serviceData_01 , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_IpServiceData },
  { &hf_iicp_ipInfo         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_IpInfo },
  { &hf_iicp_sessionChannel_01, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_SessionChannel },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_IpSAM(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_IpSAM, IpSAM_sequence);

  return offset;
}


static const value_string iicp_T_servData_vals[] = {
  {   0, "nonipService" },
  {   1, "ipService" },
  { 0, NULL }
};

static const per_choice_t T_servData_choice[] = {
  {   0, &hf_iicp_nonipService_01, ASN1_NO_EXTENSIONS     , dissect_iicp_NonipSAM },
  {   1, &hf_iicp_ipService_01   , ASN1_NO_EXTENSIONS     , dissect_iicp_IpSAM },
  { 0, NULL, 0, NULL }
};

static int
dissect_iicp_T_servData(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_iicp_T_servData, T_servData_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t SAMserviceData_sequence[] = {
  { &hf_iicp_fill_01        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_BIT_STRING_SIZE_7 },
  { &hf_iicp_servData       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_servData },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_SAMserviceData(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_SAMserviceData, SAMserviceData_sequence);

  return offset;
}


static const per_sequence_t GCsam_sequence[] = {
  { &hf_iicp_applicationID  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ApplicationID },
  { &hf_iicp_serverID       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_StationID },
  { &hf_iicp_serviceData_02 , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_SAMserviceData },
  { &hf_iicp_link_01        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_LLserviceAddr },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_GCsam(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_GCsam, GCsam_sequence);

  return offset;
}


static const value_string iicp_T_servData_01_vals[] = {
  {   0, "nonipContext" },
  {   1, "ipContext" },
  { 0, NULL }
};

static const per_choice_t T_servData_01_choice[] = {
  {   0, &hf_iicp_nonipContext   , ASN1_NO_EXTENSIONS     , dissect_iicp_NonipContext },
  {   1, &hf_iicp_ipContext      , ASN1_NO_EXTENSIONS     , dissect_iicp_IpContext },
  { 0, NULL, 0, NULL }
};

static int
dissect_iicp_T_servData_01(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_iicp_T_servData_01, T_servData_01_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t CTXserviceData_sequence[] = {
  { &hf_iicp_fill_01        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_BIT_STRING_SIZE_7 },
  { &hf_iicp_servData_01    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_servData_01 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_CTXserviceData(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_CTXserviceData, CTXserviceData_sequence);

  return offset;
}


static const per_sequence_t GCctx_sequence[] = {
  { &hf_iicp_applicationID  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ApplicationID },
  { &hf_iicp_clientID       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_StationID },
  { &hf_iicp_serviceContext , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CTXserviceData },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_GCctx(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_GCctx, GCctx_sequence);

  return offset;
}


static const per_sequence_t GCsched_sequence[] = {
  { &hf_iicp_medium         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_MedType },
  { &hf_iicp_directivity    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Directivity },
  { &hf_iicp_gcInterval     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_GcInterval },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_GCsched(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_GCsched, GCsched_sequence);

  return offset;
}


static const per_sequence_t GCschedule_sequence_of[1] = {
  { &hf_iicp_GCschedule_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_GCsched },
};

static int
dissect_iicp_GCschedule(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_iicp_GCschedule, GCschedule_sequence_of,
                                                  0, 255, FALSE);

  return offset;
}


static const per_sequence_t GCregServer_sequence[] = {
  { &hf_iicp_applicationID  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ApplicationID },
  { &hf_iicp_gCschedule     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_GCschedule },
  { &hf_iicp_priority       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_UserPriority },
  { &hf_iicp_serviceDataReg , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ServiceDataReg },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_GCregServer(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
#line 377 "../../asn1/calm-iicp/iicp.cnf"
  col_append_fstr(actx->pinfo->cinfo, COL_INFO, " (GCregServer request)");

    offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_GCregServer, GCregServer_sequence);




  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_0_1_OF_ServiceDataReg_sequence_of[1] = {
  { &hf_iicp_serviceDataReg_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ServiceDataReg },
};

static int
dissect_iicp_SEQUENCE_SIZE_0_1_OF_ServiceDataReg(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_iicp_SEQUENCE_SIZE_0_1_OF_ServiceDataReg, SEQUENCE_SIZE_0_1_OF_ServiceDataReg_sequence_of,
                                                  0, 1, FALSE);

  return offset;
}


static const per_sequence_t GCupdateServer_sequence[] = {
  { &hf_iicp_applicationID  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ApplicationID },
  { &hf_iicp_gCschedule     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_GCschedule },
  { &hf_iicp_fill_01        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_BIT_STRING_SIZE_7 },
  { &hf_iicp_serviceDataReg_01, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_SEQUENCE_SIZE_0_1_OF_ServiceDataReg },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_GCupdateServer(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_GCupdateServer, GCupdateServer_sequence);

  return offset;
}


static const per_sequence_t GCderegServer_sequence[] = {
  { &hf_iicp_applicationID  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ApplicationID },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_GCderegServer(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
#line 387 "../../asn1/calm-iicp/iicp.cnf"
  col_append_fstr(actx->pinfo->cinfo, COL_INFO, " (GCderegServer request)");

    offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_GCderegServer, GCderegServer_sequence);




  return offset;
}


static const per_sequence_t GCregClient_sequence[] = {
  { &hf_iicp_applicationID  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ApplicationID },
  { &hf_iicp_priority       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_UserPriority },
  { &hf_iicp_serviceID      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSaid },
  { &hf_iicp_contextData_01 , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ContextData },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_GCregClient(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
#line 397 "../../asn1/calm-iicp/iicp.cnf"
  col_append_fstr(actx->pinfo->cinfo, COL_INFO, " (GCregClient request)");

    offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_GCregClient, GCregClient_sequence);




  return offset;
}


static const per_sequence_t GCupdateClient_sequence[] = {
  { &hf_iicp_applicationID  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ApplicationID },
  { &hf_iicp_serviceID      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSaid },
  { &hf_iicp_contextData_01 , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ContextData },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_GCupdateClient(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_GCupdateClient, GCupdateClient_sequence);

  return offset;
}


static const per_sequence_t GCderegClient_sequence[] = {
  { &hf_iicp_applicationID  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ApplicationID },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_GCderegClient(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
#line 407 "../../asn1/calm-iicp/iicp.cnf"
  col_append_fstr(actx->pinfo->cinfo, COL_INFO, " (GCregClient request)");

    offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_GCderegClient, GCderegClient_sequence);




  return offset;
}


static const per_sequence_t GCregServerConf_sequence[] = {
  { &hf_iicp_applicationID  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ApplicationID },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_GCregServerConf(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
#line 382 "../../asn1/calm-iicp/iicp.cnf"
  col_append_fstr(actx->pinfo->cinfo, COL_INFO, " (GCregServer confirm)");

    offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_GCregServerConf, GCregServerConf_sequence);




  return offset;
}


static const per_sequence_t GCupdateServerConf_sequence[] = {
  { &hf_iicp_applicationID  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ApplicationID },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_GCupdateServerConf(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_GCupdateServerConf, GCupdateServerConf_sequence);

  return offset;
}


static const per_sequence_t GCderegServerConf_sequence[] = {
  { &hf_iicp_applicationID  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ApplicationID },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_GCderegServerConf(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
#line 392 "../../asn1/calm-iicp/iicp.cnf"
  col_append_fstr(actx->pinfo->cinfo, COL_INFO, " (GCderegServer confirm)");

    offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_GCderegServerConf, GCderegServerConf_sequence);




  return offset;
}


static const per_sequence_t GCregClientConf_sequence[] = {
  { &hf_iicp_applicationID  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ApplicationID },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_GCregClientConf(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
#line 402 "../../asn1/calm-iicp/iicp.cnf"
  col_append_fstr(actx->pinfo->cinfo, COL_INFO, " (GCregClient confirm)");

    offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_GCregClientConf, GCregClientConf_sequence);




  return offset;
}


static const per_sequence_t GCupdateClientConf_sequence[] = {
  { &hf_iicp_applicationID  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ApplicationID },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_GCupdateClientConf(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_GCupdateClientConf, GCupdateClientConf_sequence);

  return offset;
}


static const per_sequence_t GCderegClientConf_sequence[] = {
  { &hf_iicp_applicationID  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ApplicationID },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_GCderegClientConf(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
#line 412 "../../asn1/calm-iicp/iicp.cnf"
  col_append_fstr(actx->pinfo->cinfo, COL_INFO, " (GCregClient confirm)");

    offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_GCderegClientConf, GCderegClientConf_sequence);




  return offset;
}


static const value_string iicp_T_params_vals[] = {
  {   0, "legacyOption" },
  {   1, "portPM" },
  { 0, NULL }
};

static const per_choice_t T_params_choice[] = {
  {   0, &hf_iicp_legacyOption   , ASN1_NO_EXTENSIONS     , dissect_iicp_INTEGER_0_255 },
  {   1, &hf_iicp_portPM         , ASN1_NO_EXTENSIONS     , dissect_iicp_PortNumber },
  { 0, NULL, 0, NULL }
};

static int
dissect_iicp_T_params(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_iicp_T_params, T_params_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t Param15628_sequence[] = {
  { &hf_iicp_fill_01        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_BIT_STRING_SIZE_7 },
  { &hf_iicp_params         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_params },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_Param15628(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_Param15628, Param15628_sequence);

  return offset;
}



static int
dissect_iicp_ITSObName(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       0, 255, FALSE, NULL);

  return offset;
}


static const value_string iicp_ITSapObType_vals[] = {
  {   0, "appClass" },
  {   1, "application" },
  { 0, NULL }
};


static int
dissect_iicp_ITSapObType(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_ITSObOwnerName(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       0, 255, FALSE, NULL);

  return offset;
}


static const value_string iicp_ITSObOwnerType_vals[] = {
  {   0, "standard" },
  {   1, "private" },
  { 0, NULL }
};


static int
dissect_iicp_ITSObOwnerType(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_OBJECT_IDENTIFIER(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_object_identifier(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}


static const per_sequence_t ITSObOwner_sequence[] = {
  { &hf_iicp_ownerName      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSObOwnerName },
  { &hf_iicp_ownerType      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSObOwnerType },
  { &hf_iicp_ownerOID       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_OBJECT_IDENTIFIER },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ITSObOwner(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ITSObOwner, ITSObOwner_sequence);

  return offset;
}



static int
dissect_iicp_SAname(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       0, 255, FALSE, NULL);

  return offset;
}


static const per_sequence_t IssuingSA_sequence[] = {
  { &hf_iicp_name           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_SAname },
  { &hf_iicp_saOID          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_OBJECT_IDENTIFIER },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_IssuingSA(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_IssuingSA, IssuingSA_sequence);

  return offset;
}



static int
dissect_iicp_NumericString_SIZE_8(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_NumericString(tvb, offset, actx, tree, hf_index,
                                          8, 8, FALSE);

  return offset;
}


static const value_string iicp_T_csd_vals[] = {
  {   0, "inactive" },
  {   1, "date" },
  { 0, NULL }
};

static const per_choice_t T_csd_choice[] = {
  {   0, &hf_iicp_inactive       , ASN1_NO_EXTENSIONS     , dissect_iicp_NULL },
  {   1, &hf_iicp_date           , ASN1_NO_EXTENSIONS     , dissect_iicp_NumericString_SIZE_8 },
  { 0, NULL, 0, NULL }
};

static int
dissect_iicp_T_csd(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_iicp_T_csd, T_csd_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t CertStartDate_sequence[] = {
  { &hf_iicp_fill_01        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_BIT_STRING_SIZE_7 },
  { &hf_iicp_csd            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_csd },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_CertStartDate(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_CertStartDate, CertStartDate_sequence);

  return offset;
}



static int
dissect_iicp_BIT_STRING_SIZE_6(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     6, 6, FALSE, NULL);

  return offset;
}


static const value_string iicp_T_ced_vals[] = {
  {   0, "inactive" },
  {   1, "date" },
  {   2, "never" },
  { 0, NULL }
};

static const per_choice_t T_ced_choice[] = {
  {   0, &hf_iicp_inactive       , ASN1_NO_EXTENSIONS     , dissect_iicp_NULL },
  {   1, &hf_iicp_date           , ASN1_NO_EXTENSIONS     , dissect_iicp_NumericString_SIZE_8 },
  {   2, &hf_iicp_never          , ASN1_NO_EXTENSIONS     , dissect_iicp_NULL },
  { 0, NULL, 0, NULL }
};

static int
dissect_iicp_T_ced(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_iicp_T_ced, T_ced_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t CertEndDate_sequence[] = {
  { &hf_iicp_fill_04        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_BIT_STRING_SIZE_6 },
  { &hf_iicp_ced            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_ced },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_CertEndDate(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_CertEndDate, CertEndDate_sequence);

  return offset;
}


static const per_sequence_t CertBlocked_sequence[] = {
  { &hf_iicp_date           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_NumericString_SIZE_8 },
  { &hf_iicp_issuingSA      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_IssuingSA },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_CertBlocked(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_CertBlocked, CertBlocked_sequence);

  return offset;
}


static const value_string iicp_T_cs_vals[] = {
  {   0, "active" },
  {   1, "inactive" },
  {   2, "testActiv" },
  {   3, "blocked" },
  { 0, NULL }
};

static const per_choice_t T_cs_choice[] = {
  {   0, &hf_iicp_active_01      , ASN1_NO_EXTENSIONS     , dissect_iicp_NULL },
  {   1, &hf_iicp_inactive       , ASN1_NO_EXTENSIONS     , dissect_iicp_NULL },
  {   2, &hf_iicp_testActiv      , ASN1_NO_EXTENSIONS     , dissect_iicp_NULL },
  {   3, &hf_iicp_blocked        , ASN1_NO_EXTENSIONS     , dissect_iicp_CertBlocked },
  { 0, NULL, 0, NULL }
};

static int
dissect_iicp_T_cs(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_iicp_T_cs, T_cs_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t CertStatus_sequence[] = {
  { &hf_iicp_fill_04        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_BIT_STRING_SIZE_6 },
  { &hf_iicp_cs             , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_cs },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_CertStatus(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_CertStatus, CertStatus_sequence);

  return offset;
}


static const per_sequence_t ITSapObCertificate_sequence[] = {
  { &hf_iicp_issuingSA      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_IssuingSA },
  { &hf_iicp_startDate      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CertStartDate },
  { &hf_iicp_endDate        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CertEndDate },
  { &hf_iicp_status_08      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CertStatus },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ITSapObCertificate(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ITSapObCertificate, ITSapObCertificate_sequence);

  return offset;
}



static int
dissect_iicp_T_ruleNo(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_integer(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}



static int
dissect_iicp_T_rule(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}


static const per_sequence_t ITSapObPortRule_sequence[] = {
  { &hf_iicp_ruleNo         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_ruleNo },
  { &hf_iicp_rule           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_rule },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ITSapObPortRule(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ITSapObPortRule, ITSapObPortRule_sequence);

  return offset;
}


static const per_sequence_t ITSapObPort_sequence_of[1] = {
  { &hf_iicp_ITSapObPort_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSapObPortRule },
};

static int
dissect_iicp_ITSapObPort(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence_of(tvb, offset, actx, tree, hf_index,
                                      ett_iicp_ITSapObPort, ITSapObPort_sequence_of);

  return offset;
}


static const per_sequence_t SEQUENCE_OF_ITSapObPort_sequence_of[1] = {
  { &hf_iicp_rules_item     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSapObPort },
};

static int
dissect_iicp_SEQUENCE_OF_ITSapObPort(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence_of(tvb, offset, actx, tree, hf_index,
                                      ett_iicp_SEQUENCE_OF_ITSapObPort, SEQUENCE_OF_ITSapObPort_sequence_of);

  return offset;
}


static const per_sequence_t ITSapObPorts_item_sequence[] = {
  { &hf_iicp_portNo         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSSappRxTxPortNo },
  { &hf_iicp_rules          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_SEQUENCE_OF_ITSapObPort },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ITSapObPorts_item(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ITSapObPorts_item, ITSapObPorts_item_sequence);

  return offset;
}


static const per_sequence_t ITSapObPorts_sequence_of[1] = {
  { &hf_iicp_ITSapObPorts_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSapObPorts_item },
};

static int
dissect_iicp_ITSapObPorts(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence_of(tvb, offset, actx, tree, hf_index,
                                      ett_iicp_ITSapObPorts, ITSapObPorts_sequence_of);

  return offset;
}


static const per_sequence_t ITSapOb_sequence[] = {
  { &hf_iicp_iTSaid         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSaid },
  { &hf_iicp_iTSapObName    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSObName },
  { &hf_iicp_iTSapObType    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSapObType },
  { &hf_iicp_iTSapObOwner   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSObOwner },
  { &hf_iicp_iTSapObCert    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSapObCertificate },
  { &hf_iicp_iTSapObPorts   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSapObPorts },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ITSapOb(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ITSapOb, ITSapOb_sequence);

  return offset;
}


static const per_sequence_t ITSapObRegistry_sequence_of[1] = {
  { &hf_iicp_ITSapObRegistry_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSapOb },
};

static int
dissect_iicp_ITSapObRegistry(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence_of(tvb, offset, actx, tree, hf_index,
                                      ett_iicp_ITSapObRegistry, ITSapObRegistry_sequence_of);

  return offset;
}


static const value_string iicp_PortRxTx_vals[] = {
  {   0, "rxPort" },
  { 255, "txPort" },
  { 0, NULL }
};


static int
dissect_iicp_PortRxTx(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}


static const per_sequence_t LogicalChannelPrio_sequence[] = {
  { &hf_iicp_lch            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_LogicalChannelType },
  { &hf_iicp_prio           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_UserPriority },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_LogicalChannelPrio(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_LogicalChannelPrio, LogicalChannelPrio_sequence);

  return offset;
}



static int
dissect_iicp_ITSapObPriority(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_UserPriority(tvb, offset, actx, tree, hf_index);

  return offset;
}



static int
dissect_iicp_ITSmsgSetID(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_VarLengthNumber(tvb, offset, actx, tree, hf_index);

  return offset;
}


static const per_sequence_t ITSmsgSet_sequence[] = {
  { &hf_iicp_iTSmsID        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSmsgSetID },
  { &hf_iicp_iTSmsName      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSObName },
  { &hf_iicp_iTSmsOwner     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSObOwner },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ITSmsgSet(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ITSmsgSet, ITSmsgSet_sequence);

  return offset;
}


static const per_sequence_t ITSmsgSetRegistry_sequence_of[1] = {
  { &hf_iicp_ITSmsgSetRegistry_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSmsgSet },
};

static int
dissect_iicp_ITSmsgSetRegistry(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence_of(tvb, offset, actx, tree, hf_index,
                                      ett_iicp_ITSmsgSetRegistry, ITSmsgSetRegistry_sequence_of);

  return offset;
}



static int
dissect_iicp_ITSrrID(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_VarLengthNumber(tvb, offset, actx, tree, hf_index);

  return offset;
}



static int
dissect_iicp_URLreg(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       0, 256, FALSE, NULL);

  return offset;
}


static const per_sequence_t ITS_RegPolicyAuthority_sequence[] = {
  { &hf_iicp_name_01        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSObOwnerName },
  { &hf_iicp_url            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_URLreg },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ITS_RegPolicyAuthority(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ITS_RegPolicyAuthority, ITS_RegPolicyAuthority_sequence);

  return offset;
}



static int
dissect_iicp_T_areaTypeNo(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_integer(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}



static int
dissect_iicp_T_areaType(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}


static const per_sequence_t ITS_RParea_sequence[] = {
  { &hf_iicp_areaTypeNo     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_areaTypeNo },
  { &hf_iicp_areaType       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_areaType },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ITS_RParea(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ITS_RParea, ITS_RParea_sequence);

  return offset;
}


static const per_sequence_t ITSregRegion_sequence[] = {
  { &hf_iicp_regID          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSrrID },
  { &hf_iicp_regAuthority   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITS_RegPolicyAuthority },
  { &hf_iicp_fill_01        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_BIT_STRING_SIZE_7 },
  { &hf_iicp_regArea        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITS_RParea },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ITSregRegion(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ITSregRegion, ITSregRegion_sequence);

  return offset;
}


static const per_sequence_t ITSregRegionRegistry_sequence_of[1] = {
  { &hf_iicp_ITSregRegionRegistry_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSregRegion },
};

static int
dissect_iicp_ITSregRegionRegistry(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence_of(tvb, offset, actx, tree, hf_index,
                                      ett_iicp_ITSregRegionRegistry, ITSregRegionRegistry_sequence_of);

  return offset;
}


static const per_sequence_t GeoCoordinates_sequence[] = {
  { &hf_iicp_lat            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Lat },
  { &hf_iicp_long           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Lon },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_GeoCoordinates(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_GeoCoordinates, GeoCoordinates_sequence);

  return offset;
}


static const per_sequence_t GeoPolygon_sequence_of[1] = {
  { &hf_iicp_GeoPolygon_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_GeoCoordinates },
};

static int
dissect_iicp_GeoPolygon(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_iicp_GeoPolygon, GeoPolygon_sequence_of,
                                                  0, 65535, FALSE);

  return offset;
}



static int
dissect_iicp_CountryCode(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       3, 3, FALSE, NULL);

  return offset;
}



static int
dissect_iicp_ITSprID(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_VarLengthNumber(tvb, offset, actx, tree, hf_index);

  return offset;
}


static const per_sequence_t ITSpolRegion_sequence[] = {
  { &hf_iicp_polID          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSprID },
  { &hf_iicp_polAuthority   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITS_RegPolicyAuthority },
  { &hf_iicp_fill_01        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_BIT_STRING_SIZE_7 },
  { &hf_iicp_polArea        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITS_RParea },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ITSpolRegion(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ITSpolRegion, ITSpolRegion_sequence);

  return offset;
}


static const per_sequence_t ITSpolRegionRegistry_sequence_of[1] = {
  { &hf_iicp_ITSpolRegionRegistry_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSpolRegion },
};

static int
dissect_iicp_ITSpolRegionRegistry(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence_of(tvb, offset, actx, tree, hf_index,
                                      ett_iicp_ITSpolRegionRegistry, ITSpolRegionRegistry_sequence_of);

  return offset;
}


static const per_sequence_t ProtocolReference_sequence[] = {
  { &hf_iicp_sdo            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_OCTET_STRING_SIZE_0_255 },
  { &hf_iicp_docNo          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_OCTET_STRING_SIZE_0_255 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ProtocolReference(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ProtocolReference, ProtocolReference_sequence);

  return offset;
}


static const per_sequence_t NTprotocol_sequence[] = {
  { &hf_iicp_name_02        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_OCTET_STRING_SIZE_0_255 },
  { &hf_iicp_protRef        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ProtocolReference },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_NTprotocol(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_NTprotocol, NTprotocol_sequence);

  return offset;
}


static const per_sequence_t ItsAppInfo_sequence[] = {
  { &hf_iicp_itsAid         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSaid },
  { &hf_iicp_rxTxPortNo     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSSappRxTxPortNo },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ItsAppInfo(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ItsAppInfo, ItsAppInfo_sequence);

  return offset;
}


static const per_sequence_t ITSportNumber_sequence[] = {
  { &hf_iicp_pn             , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_PortNumber },
  { &hf_iicp_ntProt         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_NTprotocol },
  { &hf_iicp_itssAp         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ItsAppInfo },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ITSportNumber(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ITSportNumber, ITSportNumber_sequence);

  return offset;
}


static const per_sequence_t ITSportNumberRegistry_sequence_of[1] = {
  { &hf_iicp_ITSportNumberRegistry_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSportNumber },
};

static int
dissect_iicp_ITSportNumberRegistry(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence_of(tvb, offset, actx, tree, hf_index,
                                      ett_iicp_ITSportNumberRegistry, ITSportNumberRegistry_sequence_of);

  return offset;
}



static int
dissect_iicp_FlowTypeID(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_VarLengthNumber2(tvb, offset, actx, tree, hf_index);

  return offset;
}


static const per_sequence_t ITSflowType_sequence[] = {
  { &hf_iicp_id             , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_FlowTypeID },
  { &hf_iicp_req            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSSappCPReqReg },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ITSflowType(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ITSflowType, ITSflowType_sequence);

  return offset;
}


static const per_sequence_t ITSflowTypeRegistry_sequence_of[1] = {
  { &hf_iicp_ITSflowTypeRegistry_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSflowType },
};

static int
dissect_iicp_ITSflowTypeRegistry(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence_of(tvb, offset, actx, tree, hf_index,
                                      ett_iicp_ITSflowTypeRegistry, ITSflowTypeRegistry_sequence_of);

  return offset;
}


static const per_sequence_t ITSlch_sequence[] = {
  { &hf_iicp_lchID          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_LogicalChannelType },
  { &hf_iicp_lchPurpose     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_OCTET_STRING_SIZE_0_255 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ITSlch(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ITSlch, ITSlch_sequence);

  return offset;
}


static const per_sequence_t ITSlchRegistry_sequence_of[1] = {
  { &hf_iicp_ITSlchRegistry_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSlch },
};

static int
dissect_iicp_ITSlchRegistry(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence_of(tvb, offset, actx, tree, hf_index,
                                      ett_iicp_ITSlchRegistry, ITSlchRegistry_sequence_of);

  return offset;
}



static int
dissect_iicp_ITSemID(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_VarLengthNumber2(tvb, offset, actx, tree, hf_index);

  return offset;
}


static const per_sequence_t ITSscuID_sequence[] = {
  { &hf_iicp_emID           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSemID },
  { &hf_iicp_serialNo       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_VarLengthNumber },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ITSscuID(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ITSscuID, ITSscuID_sequence);

  return offset;
}


static const per_sequence_t ITSsuID_sequence[] = {
  { &hf_iicp_suID           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_VarLengthNumber },
  { &hf_iicp_scuID          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSscuID },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ITSsuID(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ITSsuID, ITSsuID_sequence);

  return offset;
}


static const per_sequence_t ITSsu_sequence[] = {
  { &hf_iicp_itssuID        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSsuID },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ITSsu(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ITSsu, ITSsu_sequence);

  return offset;
}


static const per_sequence_t ITSsuRegistry_sequence_of[1] = {
  { &hf_iicp_ITSsuRegistry_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSsu },
};

static int
dissect_iicp_ITSsuRegistry(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence_of(tvb, offset, actx, tree, hf_index,
                                      ett_iicp_ITSsuRegistry, ITSsuRegistry_sequence_of);

  return offset;
}


static const per_sequence_t ITSscu_sequence[] = {
  { &hf_iicp_itsscuID       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSscuID },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ITSscu(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ITSscu, ITSscu_sequence);

  return offset;
}


static const per_sequence_t ITSscuRegistry_sequence_of[1] = {
  { &hf_iicp_ITSscuRegistry_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSscu },
};

static int
dissect_iicp_ITSscuRegistry(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence_of(tvb, offset, actx, tree, hf_index,
                                      ett_iicp_ITSscuRegistry, ITSscuRegistry_sequence_of);

  return offset;
}



static int
dissect_iicp_ITSSappid(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_VarLengthNumber(tvb, offset, actx, tree, hf_index);

  return offset;
}


static const per_sequence_t RegEntryOwner_sequence[] = {
  { &hf_iicp_ownerName_01   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_OCTET_STRING_SIZE_0_255 },
  { &hf_iicp_ownerAddress   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_OCTET_STRING_SIZE_0_255 },
  { &hf_iicp_ownerURL       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_URLreg },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_RegEntryOwner(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_RegEntryOwner, RegEntryOwner_sequence);

  return offset;
}


static const per_sequence_t ITSSapPrPr_sequence[] = {
  { &hf_iicp_itssappID      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSSappid },
  { &hf_iicp_itssapProv     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RegEntryOwner },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ITSSapPrPr(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ITSSapPrPr, ITSSapPrPr_sequence);

  return offset;
}


static const per_sequence_t ITSSappRegistry_sequence_of[1] = {
  { &hf_iicp_ITSSappRegistry_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSSapPrPr },
};

static int
dissect_iicp_ITSSappRegistry(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence_of(tvb, offset, actx, tree, hf_index,
                                      ett_iicp_ITSSappRegistry, ITSSappRegistry_sequence_of);

  return offset;
}


static const per_sequence_t ITSem_sequence[] = {
  { &hf_iicp_itsemID        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSemID },
  { &hf_iicp_equipManu      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RegEntryOwner },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ITSem(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ITSem, ITSem_sequence);

  return offset;
}


static const per_sequence_t ITSemRegistry_sequence_of[1] = {
  { &hf_iicp_ITSemRegistry_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSem },
};

static int
dissect_iicp_ITSemRegistry(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence_of(tvb, offset, actx, tree, hf_index,
                                      ett_iicp_ITSemRegistry, ITSemRegistry_sequence_of);

  return offset;
}



static int
dissect_iicp_ITSaooID(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_VarLengthNumber(tvb, offset, actx, tree, hf_index);

  return offset;
}


static const per_sequence_t ITSaoo_sequence[] = {
  { &hf_iicp_itsaooID       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSaooID },
  { &hf_iicp_aoo            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RegEntryOwner },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ITSaoo(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ITSaoo, ITSaoo_sequence);

  return offset;
}


static const per_sequence_t ITSaooRegistry_sequence_of[1] = {
  { &hf_iicp_ITSaooRegistry_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSaoo },
};

static int
dissect_iicp_ITSaooRegistry(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence_of(tvb, offset, actx, tree, hf_index,
                                      ett_iicp_ITSaooRegistry, ITSaooRegistry_sequence_of);

  return offset;
}



static int
dissect_iicp_ITSmsoID(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_VarLengthNumber2(tvb, offset, actx, tree, hf_index);

  return offset;
}


static const per_sequence_t ITSmso_sequence[] = {
  { &hf_iicp_iTSmsoID       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSmsoID },
  { &hf_iicp_mso            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RegEntryOwner },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ITSmso(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ITSmso, ITSmso_sequence);

  return offset;
}


static const per_sequence_t Registry_sequence_of[1] = {
  { &hf_iicp_Registry_item  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSmso },
};

static int
dissect_iicp_Registry(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence_of(tvb, offset, actx, tree, hf_index,
                                      ett_iicp_Registry, Registry_sequence_of);

  return offset;
}



static int
dissect_iicp_ITSSapdID(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_VarLengthNumber(tvb, offset, actx, tree, hf_index);

  return offset;
}


static const per_sequence_t ITSSapd_sequence[] = {
  { &hf_iicp_itssapdID      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSSapdID },
  { &hf_iicp_ad             , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RegEntryOwner },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ITSSapd(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ITSSapd, ITSSapd_sequence);

  return offset;
}


static const per_sequence_t ITSSapdRegistry_sequence_of[1] = {
  { &hf_iicp_ITSSapdRegistry_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSSapd },
};

static int
dissect_iicp_ITSSapdRegistry(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence_of(tvb, offset, actx, tree, hf_index,
                                      ett_iicp_ITSSapdRegistry, ITSSapdRegistry_sequence_of);

  return offset;
}



static int
dissect_iicp_MCgroup(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_VarLengthNumber(tvb, offset, actx, tree, hf_index);

  return offset;
}



static int
dissect_iicp_ITSprotocolStackID(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_VarLengthNumber(tvb, offset, actx, tree, hf_index);

  return offset;
}



static int
dissect_iicp_T_refNo_01(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_integer(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}



static int
dissect_iicp_T_param_02(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}


static const per_sequence_t ITSSappReqConf_item_sequence[] = {
  { &hf_iicp_refNo_01       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_refNo_01 },
  { &hf_iicp_param_02       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_param_02 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ITSSappReqConf_item(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ITSSappReqConf_item, ITSSappReqConf_item_sequence);

  return offset;
}


static const per_sequence_t ITSSappReqConf_sequence_of[1] = {
  { &hf_iicp_ITSSappReqConf_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSSappReqConf_item },
};

static int
dissect_iicp_ITSSappReqConf(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence_of(tvb, offset, actx, tree, hf_index,
                                      ett_iicp_ITSSappReqConf, ITSSappReqConf_sequence_of);

  return offset;
}


static const per_sequence_t ITSSappCPReqConf_sequence[] = {
  { &hf_iicp_applicationID  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ApplicationID },
  { &hf_iicp_rxTxPort       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSSappRxTxPort },
  { &hf_iicp_confDetails    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSSappReqConf },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ITSSappCPReqConf(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ITSSappCPReqConf, ITSSappCPReqConf_sequence);

  return offset;
}


static const value_string iicp_Logic_vals[] = {
  {   0, "false" },
  { 255, "true" },
  { 0, NULL }
};


static int
dissect_iicp_Logic(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}


static const per_sequence_t ITSSappCPFinal_sequence[] = {
  { &hf_iicp_applicationID  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ApplicationID },
  { &hf_iicp_final          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Logic },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ITSSappCPFinal(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ITSSappCPFinal, ITSSappCPFinal_sequence);

  return offset;
}


static const value_string iicp_T_type_vals[] = {
  {   0, "broadCast" },
  {   1, "multiCast" },
  {   2, "unicast" },
  { 0, NULL }
};


static int
dissect_iicp_T_type(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 127U, NULL, FALSE);

  return offset;
}


static const per_sequence_t SEQUENCE_SIZE_0_255_OF_MCgroup_sequence_of[1] = {
  { &hf_iicp_mcGroups_item  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_MCgroup },
};

static int
dissect_iicp_SEQUENCE_SIZE_0_255_OF_MCgroup(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_iicp_SEQUENCE_SIZE_0_255_OF_MCgroup, SEQUENCE_SIZE_0_255_OF_MCgroup_sequence_of,
                                                  0, 255, FALSE);

  return offset;
}


static const per_sequence_t AddressBasedType_sequence[] = {
  { &hf_iicp_type_01        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_type },
  { &hf_iicp_mcGroups       , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_SEQUENCE_SIZE_0_255_OF_MCgroup },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_AddressBasedType(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_AddressBasedType, AddressBasedType_sequence);

  return offset;
}


static const value_string iicp_T_type_01_vals[] = {
  {   0, "geoUnicast" },
  {   1, "geoAnycast" },
  {   2, "geoMulticast" },
  {   4, "geoBroadcast" },
  { 0, NULL }
};


static int
dissect_iicp_T_type_01(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 127U, NULL, FALSE);

  return offset;
}


static const per_sequence_t GeoLocationBasedType_sequence[] = {
  { &hf_iicp_type_02        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_type_01 },
  { &hf_iicp_mcGroups       , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_SEQUENCE_SIZE_0_255_OF_MCgroup },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_GeoLocationBasedType(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_GeoLocationBasedType, GeoLocationBasedType_sequence);

  return offset;
}


static const value_string iicp_DestType_vals[] = {
  {   0, "addressType" },
  {   1, "geoLocType" },
  { 0, NULL }
};

static const per_choice_t DestType_choice[] = {
  {   0, &hf_iicp_addressType_01 , ASN1_NO_EXTENSIONS     , dissect_iicp_AddressBasedType },
  {   1, &hf_iicp_geoLocType     , ASN1_NO_EXTENSIONS     , dissect_iicp_GeoLocationBasedType },
  { 0, NULL, 0, NULL }
};

static int
dissect_iicp_DestType(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_iicp_DestType, DestType_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t DestinationType_sequence[] = {
  { &hf_iicp_fill_01        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_BIT_STRING_SIZE_7 },
  { &hf_iicp_type           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_DestType },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_DestinationType(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_DestinationType, DestinationType_sequence);

  return offset;
}


static const value_string iicp_DestDomain_vals[] = {
  {   0, "stationInternal" },
  {   1, "linkLocal" },
  {   2, "siteLocal" },
  {   4, "itsNWlocal" },
  {   8, "global" },
  { 0, NULL }
};


static int
dissect_iicp_DestDomain(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_MaxADU(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 65535U, NULL, FALSE);

  return offset;
}


static const per_sequence_t TimDurationValue_sequence[] = {
  { &hf_iicp_value          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_1023 },
  { &hf_iicp_unit           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_TimeUnit },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_TimDurationValue(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_TimDurationValue, TimDurationValue_sequence);

  return offset;
}


static const per_sequence_t ContConnect_sequence[] = {
  { &hf_iicp_duration       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_TimDurationValue },
  { &hf_iicp_interrupt      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Logic },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ContConnect(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ContConnect, ContConnect_sequence);

  return offset;
}


static const per_sequence_t NxRepeat_sequence[] = {
  { &hf_iicp_repeat         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_255 },
  { &hf_iicp_interval       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_TimDurationValue },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_NxRepeat(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_NxRepeat, NxRepeat_sequence);

  return offset;
}



static int
dissect_iicp_StoreForward(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_TimDurationValue(tvb, offset, actx, tree, hf_index);

  return offset;
}



static int
dissect_iicp_CostObjective(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}


static const per_sequence_t CommDistance_sequence[] = {
  { &hf_iicp_minDistance    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_65535 },
  { &hf_iicp_cost_01        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CostObjective },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_CommDistance(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_CommDistance, CommDistance_sequence);

  return offset;
}


static const per_sequence_t MultiHop_sequence[] = {
  { &hf_iicp_hops_01        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_INTEGER_0_255 },
  { &hf_iicp_cost_01        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CostObjective },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_MultiHop(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_MultiHop, MultiHop_sequence);

  return offset;
}



static int
dissect_iicp_Resilience(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_CostObjective(tvb, offset, actx, tree, hf_index);

  return offset;
}


static const per_sequence_t MinThP_sequence[] = {
  { &hf_iicp_minThP         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_DataRate },
  { &hf_iicp_cost_01        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CostObjective },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_MinThP(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_MinThP, MinThP_sequence);

  return offset;
}


static const value_string iicp_T_lat_vals[] = {
  {   0, "unknown" },
  {   1, "any" },
  {   2, "ms" },
  {   4, "ms10" },
  {   8, "ms100" },
  {  16, "sec" },
  {  32, "sec10" },
  {  64, "min" },
  { 128, "min10" },
  { 0, NULL }
};


static int
dissect_iicp_T_lat(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}


static const per_sequence_t MaxLat_sequence[] = {
  { &hf_iicp_lat_01         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_lat },
  { &hf_iicp_cost_01        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CostObjective },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_MaxLat(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_MaxLat, MaxLat_sequence);

  return offset;
}



static int
dissect_iicp_ProtocolReq(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_ITSprotocolStackID(tvb, offset, actx, tree, hf_index);

  return offset;
}


static const value_string iicp_ConfValue_vals[] = {
  {   0, "ok" },
  {   1, "alternative" },
  {   2, "nok" },
  { 0, NULL }
};


static int
dissect_iicp_ConfValue(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_DataConfidentiality(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_ConfValue(tvb, offset, actx, tree, hf_index);

  return offset;
}



static int
dissect_iicp_DataIntegrity(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_ConfValue(tvb, offset, actx, tree, hf_index);

  return offset;
}



static int
dissect_iicp_ReqNonrepudiation(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_ConfValue(tvb, offset, actx, tree, hf_index);

  return offset;
}



static int
dissect_iicp_DataAuthentication(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_ConfValue(tvb, offset, actx, tree, hf_index);

  return offset;
}



static int
dissect_iicp_T_refNo_02(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_integer(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}



static int
dissect_iicp_T_param_03(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}


static const per_sequence_t Policies_item_sequence[] = {
  { &hf_iicp_refNo_02       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_refNo_02 },
  { &hf_iicp_param_03       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_param_03 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_Policies_item(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_Policies_item, Policies_item_sequence);

  return offset;
}


static const per_sequence_t Policies_sequence_of[1] = {
  { &hf_iicp_Policies_item  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Policies_item },
};

static int
dissect_iicp_Policies(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence_of(tvb, offset, actx, tree, hf_index,
                                      ett_iicp_Policies, Policies_sequence_of);

  return offset;
}



static int
dissect_iicp_LocPrivacy(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_ConfValue(tvb, offset, actx, tree, hf_index);

  return offset;
}



static int
dissect_iicp_Anonymity(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_ConfValue(tvb, offset, actx, tree, hf_index);

  return offset;
}


static const per_sequence_t ITS_S_Appl_Reg_sequence_of[1] = {
  { &hf_iicp_ITS_S_Appl_Reg_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSSappCPReqReg },
};

static int
dissect_iicp_ITS_S_Appl_Reg(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence_of(tvb, offset, actx, tree, hf_index,
                                      ett_iicp_ITS_S_Appl_Reg, ITS_S_Appl_Reg_sequence_of);

  return offset;
}


static const per_sequence_t ITS_S_Appl_RegConf_sequence_of[1] = {
  { &hf_iicp_ITS_S_Appl_RegConf_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITSSappCPReqConf },
};

static int
dissect_iicp_ITS_S_Appl_RegConf(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence_of(tvb, offset, actx, tree, hf_index,
                                      ett_iicp_ITS_S_Appl_RegConf, ITS_S_Appl_RegConf_sequence_of);

  return offset;
}



static int
dissect_iicp_ITS_S_Appl_RegFinal(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_ITSSappCPFinal(tvb, offset, actx, tree, hf_index);

  return offset;
}


static const value_string iicp_T_responsivenessCode_vals[] = {
  {   0, "undefined" },
  {   1, "within1Sec" },
  {   2, "within30Sec" },
  {   3, "oneMinute" },
  {   4, "fifteenMinute" },
  {   5, "other" },
  {   6, "error" },
  { 0, NULL }
};


static int
dissect_iicp_T_responsivenessCode(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_integer(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}



static int
dissect_iicp_UTCTime(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_VisibleString(tvb, offset, actx, tree, hf_index,
                                        NO_BOUND, NO_BOUND, FALSE);

  return offset;
}


static const per_sequence_t Responsiveness_sequence[] = {
  { &hf_iicp_responsivenessCode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_responsivenessCode },
  { &hf_iicp_responsivenessValue, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_UTCTime },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_Responsiveness(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_Responsiveness, Responsiveness_sequence);

  return offset;
}


static const value_string iicp_Directionality_vals[] = {
  {   0, "undefined" },
  {   1, "unidirectional" },
  {   2, "bidirectional-Symmetric" },
  {   3, "bidirectional-UpLarger" },
  {   4, "bidirectional-DownLarger" },
  { 0, NULL }
};


static int
dissect_iicp_Directionality(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_integer(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}



static int
dissect_iicp_T_meansOfTransportation(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     NO_BOUND, NO_BOUND, FALSE, NULL);

  return offset;
}


static const value_string iicp_T_speed_vals[] = {
  {   0, "undefined" },
  {   1, "fast" },
  {   2, "middle" },
  {   3, "slow" },
  {   4, "stopped" },
  {   5, "other" },
  { 0, NULL }
};


static int
dissect_iicp_T_speed(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_integer(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}



static int
dissect_iicp_EXTERNAL(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_external_type(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}


static const per_sequence_t UsageEnvironment_sequence[] = {
  { &hf_iicp_meansOfTransportation, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_meansOfTransportation },
  { &hf_iicp_speed          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_speed },
  { &hf_iicp_speedValue     , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_EXTERNAL },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_UsageEnvironment(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_UsageEnvironment, UsageEnvironment_sequence);

  return offset;
}


static const value_string iicp_T_serviceAreaCode_vals[] = {
  {   0, "undefined" },
  {   1, "continuous" },
  {   2, "non-continuous" },
  { 0, NULL }
};


static int
dissect_iicp_T_serviceAreaCode(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_integer(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}


static const per_sequence_t ServiceArea_sequence[] = {
  { &hf_iicp_serviceAreaCode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_serviceAreaCode },
  { &hf_iicp_serviceAreaValue, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_EXTERNAL },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ServiceArea(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ServiceArea, ServiceArea_sequence);

  return offset;
}


static const value_string iicp_T_serviceTimeCode_vals[] = {
  {   0, "undefined" },
  {   1, "start-StopTime" },
  {   2, "startTime" },
  {   3, "stopTime" },
  {   4, "continuous" },
  { 0, NULL }
};


static int
dissect_iicp_T_serviceTimeCode(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_integer(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}


static const per_sequence_t ServiceTime_sequence[] = {
  { &hf_iicp_serviceTimeCode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_serviceTimeCode },
  { &hf_iicp_serviceTimeValue, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_EXTERNAL },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ServiceTime(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ServiceTime, ServiceTime_sequence);

  return offset;
}



static int
dissect_iicp_INTEGER(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_integer(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}



static int
dissect_iicp_T_dataExpressionCode(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     NO_BOUND, NO_BOUND, FALSE, NULL);

  return offset;
}


static const per_sequence_t Bandwidth_sequence[] = {
  { &hf_iicp_capacityOfTransmissionValue, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_INTEGER },
  { &hf_iicp_dataExpressionCode, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_dataExpressionCode },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_Bandwidth(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_Bandwidth, Bandwidth_sequence);

  return offset;
}


static const value_string iicp_T_maximumCostRequirement_vals[] = {
  {   0, "undefined" },
  {   1, "totalCost" },
  {   2, "timeUnitPrice" },
  {   3, "bitUnitPrice" },
  {   4, "other" },
  { 0, NULL }
};


static int
dissect_iicp_T_maximumCostRequirement(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_integer(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}


static const per_sequence_t ConnectionCost_sequence[] = {
  { &hf_iicp_maximumCostRequirement, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_maximumCostRequirement },
  { &hf_iicp_maximumCostValue, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_EXTERNAL },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ConnectionCost(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ConnectionCost, ConnectionCost_sequence);

  return offset;
}


static const per_sequence_t SelectionOfCommunicationSystem_sequence[] = {
  { &hf_iicp_responsiveness , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_Responsiveness },
  { &hf_iicp_directionality , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_Directionality },
  { &hf_iicp_usageEnvironment, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_UsageEnvironment },
  { &hf_iicp_serviceArea    , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_ServiceArea },
  { &hf_iicp_serviceTime    , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_ServiceTime },
  { &hf_iicp_bandwidth      , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_Bandwidth },
  { &hf_iicp_connectionCost , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_ConnectionCost },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_SelectionOfCommunicationSystem(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_SelectionOfCommunicationSystem, SelectionOfCommunicationSystem_sequence);

  return offset;
}


static const per_sequence_t ApplicationIdentifiers_sequence[] = {
  { &hf_iicp_messageIdentifier, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_EXTERNAL },
  { &hf_iicp_messageNumber  , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_INTEGER },
  { &hf_iicp_timeOfMessageTransmission, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_GeneralizedTime },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ApplicationIdentifiers(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ApplicationIdentifiers, ApplicationIdentifiers_sequence);

  return offset;
}


static const per_sequence_t Address_sequence[] = {
  { &hf_iicp_addressOfOrigin, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_EXTERNAL },
  { &hf_iicp_addressOfDestination, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_EXTERNAL },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_Address(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_Address, Address_sequence);

  return offset;
}


static const value_string iicp_T_interruptHandling_vals[] = {
  {   0, "undefined" },
  {   1, "lowPriority" },
  {   2, "middlePriority" },
  {   3, "highPriority" },
  { 0, NULL }
};


static int
dissect_iicp_T_interruptHandling(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_integer(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}


static const value_string iicp_T_queueControl_vals[] = {
  {   0, "undefined-FIFO" },
  {   1, "lIFO" },
  {   2, "random" },
  {   3, "re-try" },
  {   4, "errorNotification" },
  { 0, NULL }
};


static int
dissect_iicp_T_queueControl(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_integer(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}


static const per_sequence_t Priority_sequence[] = {
  { &hf_iicp_interruptHandling, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_interruptHandling },
  { &hf_iicp_interruptHandlingLevel, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_INTEGER },
  { &hf_iicp_queueControl   , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_queueControl },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_Priority(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_Priority, Priority_sequence);

  return offset;
}



static int
dissect_iicp_Security(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_bit_string(tvb, offset, actx, tree, hf_index,
                                     NO_BOUND, NO_BOUND, FALSE, NULL);

  return offset;
}


static const value_string iicp_T_validTimeCode_vals[] = {
  {   0, "undefined" },
  {   1, "duringReceptionOnly" },
  {   2, "timeDesignated" },
  {   3, "untilUpdated" },
  {   4, "other" },
  { 0, NULL }
};


static int
dissect_iicp_T_validTimeCode(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_integer(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}


static const per_sequence_t ValidTime_sequence[] = {
  { &hf_iicp_validTimeCode  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_validTimeCode },
  { &hf_iicp_validTimeValue , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_EXTERNAL },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ValidTime(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ValidTime, ValidTime_sequence);

  return offset;
}


static const value_string iicp_T_targetAreaCode_vals[] = {
  {   0, "undefined" },
  {   1, "spot" },
  {   2, "zone" },
  {   3, "interval" },
  {   4, "region" },
  {   5, "wideArea" },
  {   6, "other" },
  { 0, NULL }
};


static int
dissect_iicp_T_targetAreaCode(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_integer(tvb, offset, actx, tree, hf_index, NULL);

  return offset;
}


static const per_sequence_t TargetArea_sequence[] = {
  { &hf_iicp_targetAreaCode , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_targetAreaCode },
  { &hf_iicp_targetAreaValue, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_EXTERNAL },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_TargetArea(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_TargetArea, TargetArea_sequence);

  return offset;
}


static const per_sequence_t ApplicationExecution_sequence[] = {
  { &hf_iicp_validTime      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ValidTime },
  { &hf_iicp_timeStamp      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_GeneralizedTime },
  { &hf_iicp_targetArea     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_TargetArea },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ApplicationExecution(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ApplicationExecution, ApplicationExecution_sequence);

  return offset;
}


static const per_sequence_t ProtocolManagementInformation_sequence[] = {
  { &hf_iicp_selectionOfCommunicationSysyem, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_SelectionOfCommunicationSystem },
  { &hf_iicp_applicationIdentifiers, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_ApplicationIdentifiers },
  { &hf_iicp_address_02     , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_Address },
  { &hf_iicp_priority_01    , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_Priority },
  { &hf_iicp_security       , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_Security },
  { &hf_iicp_applicationExecution, ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iicp_ApplicationExecution },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ProtocolManagementInformation(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ProtocolManagementInformation, ProtocolManagementInformation_sequence);

  return offset;
}



static int
dissect_iicp_PduCounter(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 65535U, NULL, FALSE);

  return offset;
}


static const value_string iicp_RefIICP_vals[] = {
  { iicp_Request, "iicp-Request" },
  { iicp_Response, "iicp-Response" },
  { 0, NULL }
};


static int
dissect_iicp_RefIICP(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, &Ref_IICP, FALSE);

#line 110 "../../asn1/calm-iicp/iicp.cnf"
  if (tree) {
    proto_item_append_text(proto_item_get_parent_nth(actx->created_item, 2), ": %s", val_to_str(Ref_IICP, VALS(iicp_RefIICP_vals), "unknown (%d)"));
  }

  return offset;
}



static int
dissect_iicp_T_iicpPDU(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type_pdu_new(tvb, offset, actx, tree, hf_index, dissect_iicp_pdu_type);

  return offset;
}


static const per_sequence_t IICPpdu_sequence[] = {
  { &hf_iicp_pduRef         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RefIICP },
  { &hf_iicp_iicpPDU        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_iicpPDU },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_IICPpdu(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_IICPpdu, IICPpdu_sequence);

  return offset;
}



static int
dissect_iicp_SecRq(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       0, 65535, FALSE, NULL);

  return offset;
}


static const per_sequence_t IIC_Request_sequence[] = {
  { &hf_iicp_sourceITS_scuId, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITS_scuId },
  { &hf_iicp_destinationITS_scuId, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITS_scuId },
  { &hf_iicp_pduCounter     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_PduCounter },
  { &hf_iicp_pduRequest     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_IICPpdu },
  { &hf_iicp_secRq          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_SecRq },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_IIC_Request(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_IIC_Request, IIC_Request_sequence);

  return offset;
}


static const value_string iicp_RefIICPReq_vals[] = {
  { iicp_aliveRq, "iicp-aliveRq" },
  { iicp_mfRcmdRq, "iicp-mfRcmdRq" },
  { iicp_mfRreqRq, "iicp-mfRreqRq" },
  { iicp_mnRcmdRq, "iicp-mnRcmdRq" },
  { iicp_mnRreqRq, "iicp-mnRreqRq" },
  { iicp_miRcmdRq, "iicp-miRcmdRq" },
  { iicp_miRreqRq, "iicp-miRreqRq" },
  { iicp_miRgetRq, "iicp-miRgetRq" },
  { iicp_miRsetRq, "iicp-miRsetRq" },
  { iicp_mCmdRq, "iicp-mCmdRq" },
  { iicp_simFutCmdRq, "iicp-simFutCmdRq" },
  { iicp_simFutReqRq, "iicp-simFutReqRq" },
  { iicp_simNutCmdRq, "iicp-simNutCmdRq" },
  { iicp_simNutReqRq, "iicp-simNutReqRq" },
  { iicp_simIutCmdRq, "iicp-simIutCmdRq" },
  { iicp_simIutReqRq, "iicp-simIutReqRq" },
  { iicp_simFltCmdRq, "iicp-simFltCmdRq" },
  { iicp_simFltReqRq, "iicp-simFltReqRq" },
  { iicp_simNltCmdRq, "iicp-simNltCmdRq" },
  { iicp_simNltReqRq, "iicp-simNltReqRq" },
  { 0, NULL }
};


static int
dissect_iicp_RefIICPReq(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, &Ref_IICPReq, FALSE);

#line 120 "../../asn1/calm-iicp/iicp.cnf"
  if (tree) {
    proto_item_append_text(proto_item_get_parent_nth(actx->created_item, 2), ": %s", val_to_str(Ref_IICPReq, VALS(iicp_RefIICPReq_vals), "unknown (%d)"));
  }

  return offset;
}



static int
dissect_iicp_T_iicpReq(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type_pdu_new(tvb, offset, actx, tree, hf_index, dissect_iicp_pdu_request);

  return offset;
}


static const per_sequence_t IICPrequest_sequence[] = {
  { &hf_iicp_iicpReqRef     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RefIICPReq },
  { &hf_iicp_iicpReq        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_iicpReq },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_IICPrequest(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_IICPrequest, IICPrequest_sequence);

  return offset;
}


static const value_string iicp_AliveMessage_vals[] = {
  {   0, "alive" },
  {   1, "delete" },
  { 255, "new" },
  { 0, NULL }
};


static int
dissect_iicp_AliveMessage(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}


static const per_sequence_t ITS_SCUalive_sequence[] = {
  { &hf_iicp_message        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_AliveMessage },
  { &hf_iicp_its_scuType    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITS_SCUtype },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_ITS_SCUalive(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_ITS_SCUalive, ITS_SCUalive_sequence);

  return offset;
}


static const value_string iicp_RefMcmdRq_vals[] = {
  { iicp_pingRq, "iicp-pingRq" },
  { iicp_vCIinfoRq, "iicp-vCIinfoRq" },
  { iicp_vCIupdateRq, "iicp-vCIupdateRq" },
  { iicp_getParam24102Rq, "iicp-getParam24102Rq" },
  { iicp_setParam24102Rq, "iicp-setParam24102Rq" },
  { iicp_testIicpRq, "iicp-testIicpRq" },
  { iicp_testConfigRq, "iicp-testConfigRq" },
  { 0, NULL }
};


static int
dissect_iicp_RefMcmdRq(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, &Ref_McmdRq, FALSE);

#line 140 "../../asn1/calm-iicp/iicp.cnf"
  if (tree) {
    proto_item_append_text(proto_item_get_parent_nth(actx->created_item, 2), ": %s", val_to_str(Ref_McmdRq, VALS(iicp_RefMcmdRq_vals), "unknown (%d)"));
  }

  return offset;
}



static int
dissect_iicp_T_mcmd(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type_pdu_new(tvb, offset, actx, tree, hf_index, dissect_iicp_mcmd_request);

  return offset;
}


static const per_sequence_t McmdRq_sequence[] = {
  { &hf_iicp_mCmdRef        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RefMcmdRq },
  { &hf_iicp_mcmd           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_mcmd },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_McmdRq(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_McmdRq, McmdRq_sequence);

  return offset;
}



static int
dissect_iicp_PingIICP(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       0, 255, FALSE, NULL);

  return offset;
}


static const per_sequence_t VCI_info_req_sequence[] = {
  { &hf_iicp_medType        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_MedType },
  { &hf_iicp_ciaClass       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CIaClass },
  { &hf_iicp_ciClass        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CIclass },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_VCI_info_req(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_VCI_info_req, VCI_info_req_sequence);

  return offset;
}


static const per_sequence_t VCI_Info_sequence[] = {
  { &hf_iicp_linkId         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_Link_ID },
  { &hf_iicp_medType        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_MedType },
  { &hf_iicp_ciaClass       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CIaClass },
  { &hf_iicp_ciClass        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CIclass },
  { &hf_iicp_status_01      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_CIstatus },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_VCI_Info(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_VCI_Info, VCI_Info_sequence);

  return offset;
}


static const per_sequence_t VCI_update_req_sequence_of[1] = {
  { &hf_iicp_VCI_update_req_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_VCI_Info },
};

static int
dissect_iicp_VCI_update_req(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_iicp_VCI_update_req, VCI_update_req_sequence_of,
                                                  0, 255, FALSE);

  return offset;
}


static const per_sequence_t MFrcmd_sequence[] = {
  { &hf_iicp_destination    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITS_scuId },
  { &hf_iicp_cmd            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_MF_Command_request },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_MFrcmd(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_MFrcmd, MFrcmd_sequence);

  return offset;
}


static const per_sequence_t MNrcmd_sequence[] = {
  { &hf_iicp_destination    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITS_scuId },
  { &hf_iicp_cmd_01         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_MN_Command_request },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_MNrcmd(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_MNrcmd, MNrcmd_sequence);

  return offset;
}


static const per_sequence_t MIrcmd_sequence[] = {
  { &hf_iicp_destination    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITS_scuId },
  { &hf_iicp_cmd            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_MF_Command_request },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_MIrcmd(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_MIrcmd, MIrcmd_sequence);

  return offset;
}


static const value_string iicp_T_action_vals[] = {
  {   0, "mfRcmd" },
  {   1, "mnRcmd" },
  {   2, "miRcmd" },
  { 0, NULL }
};

static const per_choice_t T_action_choice[] = {
  {   0, &hf_iicp_mfRcmd         , ASN1_NO_EXTENSIONS     , dissect_iicp_MFrcmd },
  {   1, &hf_iicp_mnRcmd         , ASN1_NO_EXTENSIONS     , dissect_iicp_MNrcmd },
  {   2, &hf_iicp_miRcmd         , ASN1_NO_EXTENSIONS     , dissect_iicp_MIrcmd },
  { 0, NULL, 0, NULL }
};

static int
dissect_iicp_T_action(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_choice(tvb, offset, actx, tree, hf_index,
                                 ett_iicp_T_action, T_action_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t TestIicp_sequence[] = {
  { &hf_iicp_fill_02        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_BIT_STRING_SIZE_5 },
  { &hf_iicp_action         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_action },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_TestIicp(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_TestIicp, TestIicp_sequence);

  return offset;
}


static const per_sequence_t TestConfigIICP_sequence[] = {
  { &hf_iicp_location       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_BIT_STRING_SIZE_6 },
  { &hf_iicp_lowerLayers    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_BIT_STRING_SIZE_1 },
  { &hf_iicp_testMode       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_BIT_STRING_SIZE_1 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_TestConfigIICP(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
#line 322 "../../asn1/calm-iicp/iicp.cnf"
  col_set_str(actx->pinfo->cinfo, COL_INFO, "IICP TestConfig Request");

    offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_TestConfigIICP, TestConfigIICP_sequence);




  return offset;
}


static const value_string iicp_PduErrStatus_vals[] = {
  {   0, "success" },
  {   1, "pduUnknown" },
  {   2, "duplicateITS-scuId" },
  {   3, "invalidAliveMessage" },
  {   4, "invalidITSscuType" },
  { 255, "unspecFailure" },
  { 0, NULL }
};


static int
dissect_iicp_PduErrStatus(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, NULL, FALSE);

  return offset;
}



static int
dissect_iicp_T_errorStatus(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
#line 315 "../../asn1/calm-iicp/iicp.cnf"
  guint32 errStatus = -1;

  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index, 0U, 255U, &errStatus, FALSE);
  col_set_str(actx->pinfo->cinfo, COL_INFO, "IICP Response (ErrStatus: ");
  col_append_fstr(actx->pinfo->cinfo, COL_INFO, "%s)", val_to_str(errStatus, iicp_PduErrStatus_vals, "unspecFailure (%d)"));



  return offset;
}


static const per_sequence_t T_pduResponse_sequence[] = {
  { &hf_iicp_iICPpdu        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_IICPpdu },
  { &hf_iicp_errorStatus    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_errorStatus },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_T_pduResponse(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_T_pduResponse, T_pduResponse_sequence);

  return offset;
}



static int
dissect_iicp_SecRs(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_octet_string(tvb, offset, actx, tree, hf_index,
                                       0, 65535, FALSE, NULL);

  return offset;
}


static const per_sequence_t IIC_Response_sequence[] = {
  { &hf_iicp_sourceITS_scuId, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITS_scuId },
  { &hf_iicp_destinationITS_scuId, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_ITS_scuId },
  { &hf_iicp_pduCounter     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_PduCounter },
  { &hf_iicp_pduResponse    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_pduResponse },
  { &hf_iicp_secRs          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_SecRs },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_IIC_Response(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_IIC_Response, IIC_Response_sequence);

  return offset;
}


static const value_string iicp_RefIICPResp_vals[] = {
  { iicp_aliveRs, "iicp-aliveRs" },
  { iicp_mfRcmdRs, "iicp-mfRcmdRs" },
  { iicp_mfRreqRs, "iicp-mfRreqRs" },
  { iicp_mnRcmdRs, "iicp-mnRcmdRs" },
  { iicp_mnRreqRs, "iicp-mnRreqRs" },
  { iicp_miRcmdRs, "iicp-miRcmdRs" },
  { iicp_miRreqRs, "iicp-miRreqRs" },
  { iicp_miRgetRs, "iicp-miRgetRs" },
  { iicp_miRsetRs, "iicp-miRsetRs" },
  { iicp_mCmdRs, "iicp-mCmdRs" },
  { iicp_simAutCmdRs, "iicp-simAutCmdRs" },
  { iicp_simAutReqRs, "iicp-simAutReqRs" },
  { iicp_simFutCmdRs, "iicp-simFutCmdRs" },
  { iicp_simFutReqRs, "iicp-simFutReqRs" },
  { iicp_simNutCmdRs, "iicp-simNutCmdRs" },
  { iicp_simNutReqRs, "iicp-simNutReqRs" },
  { iicp_simIutCmdRs, "iicp-simIutCmdRs" },
  { iicp_simIutReqRs, "iicp-simIutReqRs" },
  { iicp_simAltCmdRs, "iicp-simAltCmdRs" },
  { iicp_simAltReqRs, "iicp-simAltReqRs" },
  { iicp_simFltCmdRs, "iicp-simFltCmdRs" },
  { iicp_simFltReqRs, "iicp-simFltReqRs" },
  { iicp_simNltCmdRs, "iicp-simNltCmdRs" },
  { iicp_simNltReqRs, "iicp-simNltReqRs" },
  { 0, NULL }
};


static int
dissect_iicp_RefIICPResp(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, &Ref_IICPResp, FALSE);

#line 129 "../../asn1/calm-iicp/iicp.cnf"
  if (tree) {
    proto_item_append_text(proto_item_get_parent_nth(actx->created_item, 2), ": %s", val_to_str(Ref_IICPResp, VALS(iicp_RefIICPResp_vals), "unknown (%d)"));
  }
  /* Set column info test */
  col_set_str(actx->pinfo->cinfo, COL_INFO, "IICP Response ");  

  return offset;
}



static int
dissect_iicp_T_iicpRes(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type_pdu_new(tvb, offset, actx, tree, hf_index, dissect_iicp_pdu_response);

  return offset;
}


static const per_sequence_t IICPresponse_sequence[] = {
  { &hf_iicp_iicpResRef     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RefIICPResp },
  { &hf_iicp_iicpRes        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_iicpRes },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_IICPresponse(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_IICPresponse, IICPresponse_sequence);

  return offset;
}


static const value_string iicp_RefMcmdRs_vals[] = {
  { iicp_pingRs, "iicp-pingRs" },
  { iicp_vCIinfoRs, "iicp-vCIinfoRs" },
  { iicp_vCIupdateRs, "iicp-vCIupdateRs" },
  { iicp_getParam24102Rs, "iicp-getParam24102Rs" },
  { iicp_setParam24102Rs, "iicp-setParam24102Rs" },
  { iicp_testIicpRs, "iicp-testIicpRs" },
  { iicp_testConfigRs, "iicp-testConfigRs" },
  { 0, NULL }
};


static int
dissect_iicp_RefMcmdRs(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_integer(tvb, offset, actx, tree, hf_index,
                                                            0U, 255U, &Ref_McmdRs, FALSE);

#line 149 "../../asn1/calm-iicp/iicp.cnf"
  if (tree) {
    proto_item_append_text(proto_item_get_parent_nth(actx->created_item, 2), ": %s", val_to_str(Ref_McmdRs, VALS(iicp_RefMcmdRs_vals), "unknown (%d)"));
  }

  return offset;
}



static int
dissect_iicp_T_mcmd_01(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_open_type_pdu_new(tvb, offset, actx, tree, hf_index, dissect_iicp_mcmd_response);

  return offset;
}


static const per_sequence_t McmdRs_sequence[] = {
  { &hf_iicp_mCmdRef_01     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_RefMcmdRs },
  { &hf_iicp_mcmd_01        , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_T_mcmd_01 },
  { NULL, 0, 0, NULL }
};

static int
dissect_iicp_McmdRs(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_sequence(tvb, offset, actx, tree, hf_index,
                                   ett_iicp_McmdRs, McmdRs_sequence);

  return offset;
}


static const per_sequence_t VCI_info_res_sequence_of[1] = {
  { &hf_iicp_VCI_info_res_item, ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_iicp_VCI_Info },
};

static int
dissect_iicp_VCI_info_res(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, actx, tree, hf_index,
                                                  ett_iicp_VCI_info_res, VCI_info_res_sequence_of,
                                                  0, 255, FALSE);

  return offset;
}



static int
dissect_iicp_IICrequestTX(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_IIC_Request(tvb, offset, actx, tree, hf_index);

  return offset;
}



static int
dissect_iicp_IICresponseTX(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_IIC_Response(tvb, offset, actx, tree, hf_index);

  return offset;
}



static int
dissect_iicp_IICrequestRX(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_IIC_Request(tvb, offset, actx, tree, hf_index);

  return offset;
}



static int
dissect_iicp_IICresponseRX(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_iicp_IIC_Response(tvb, offset, actx, tree, hf_index);

  return offset;
}

/*--- PDUs ---*/

static int dissect_ITS_scuId_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_ITS_scuId(tvb, offset, &asn1_ctx, tree, hf_iicp_ITS_scuId_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_Param24102_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_Param24102(tvb, offset, &asn1_ctx, tree, hf_iicp_Param24102_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_Param24102No_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_Param24102No(tvb, offset, &asn1_ctx, tree, hf_iicp_Param24102No_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_IN_UNITDATA_request_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_IN_UNITDATA_request(tvb, offset, &asn1_ctx, tree, hf_iicp_IN_UNITDATA_request_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_IN_DATA_ACK_request_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_IN_DATA_ACK_request(tvb, offset, &asn1_ctx, tree, hf_iicp_IN_DATA_ACK_request_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_IN_REPLY_ACK_request_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_IN_REPLY_ACK_request(tvb, offset, &asn1_ctx, tree, hf_iicp_IN_REPLY_ACK_request_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_IN_REPLY_UPDATE_request_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_IN_REPLY_UPDATE_request(tvb, offset, &asn1_ctx, tree, hf_iicp_IN_REPLY_UPDATE_request_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_IN_UNITDATA_indication_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_IN_UNITDATA_indication(tvb, offset, &asn1_ctx, tree, hf_iicp_IN_UNITDATA_indication_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_IN_UNITDATA_STATUS_indication_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_IN_UNITDATA_STATUS_indication(tvb, offset, &asn1_ctx, tree, hf_iicp_IN_UNITDATA_STATUS_indication_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_IN_DATA_ACK_indication_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_IN_DATA_ACK_indication(tvb, offset, &asn1_ctx, tree, hf_iicp_IN_DATA_ACK_indication_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_IN_DATA_ACK_STATUS_indication_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_IN_DATA_ACK_STATUS_indication(tvb, offset, &asn1_ctx, tree, hf_iicp_IN_DATA_ACK_STATUS_indication_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_IN_REPLY_indication_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_IN_REPLY_indication(tvb, offset, &asn1_ctx, tree, hf_iicp_IN_REPLY_indication_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_IN_REPLY_STATUS_indication_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_IN_REPLY_STATUS_indication(tvb, offset, &asn1_ctx, tree, hf_iicp_IN_REPLY_STATUS_indication_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_IN_REPLY_UPDATE_STATUS_indication_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_IN_REPLY_UPDATE_STATUS_indication(tvb, offset, &asn1_ctx, tree, hf_iicp_IN_REPLY_UPDATE_STATUS_indication_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_NullType_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_NullType(tvb, offset, &asn1_ctx, tree, hf_iicp_NullType_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_MF_Command_request_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_MF_Command_request(tvb, offset, &asn1_ctx, tree, hf_iicp_MF_Command_request_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_TestMF_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_TestMF(tvb, offset, &asn1_ctx, tree, hf_iicp_TestMF_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_SimFUTcmd_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_SimFUTcmd(tvb, offset, &asn1_ctx, tree, hf_iicp_SimFUTcmd_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_SimFLTcmd_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_SimFLTcmd(tvb, offset, &asn1_ctx, tree, hf_iicp_SimFLTcmd_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_LDMnotify_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_LDMnotify(tvb, offset, &asn1_ctx, tree, hf_iicp_LDMnotify_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_LegacyCIreq_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_LegacyCIreq(tvb, offset, &asn1_ctx, tree, hf_iicp_LegacyCIreq_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_StateCInotify_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_StateCInotify(tvb, offset, &asn1_ctx, tree, hf_iicp_StateCInotify_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_MF_Command_confirm_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_MF_Command_confirm(tvb, offset, &asn1_ctx, tree, hf_iicp_MF_Command_confirm_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_MF_Request_request_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_MF_Request_request(tvb, offset, &asn1_ctx, tree, hf_iicp_MF_Request_request_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_SimFUTreq_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_SimFUTreq(tvb, offset, &asn1_ctx, tree, hf_iicp_SimFUTreq_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_SimFLTreq_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_SimFLTreq(tvb, offset, &asn1_ctx, tree, hf_iicp_SimFLTreq_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_LDMregister_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_LDMregister(tvb, offset, &asn1_ctx, tree, hf_iicp_LDMregister_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_TestMFecho_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_TestMFecho(tvb, offset, &asn1_ctx, tree, hf_iicp_TestMFecho_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_MF_Request_confirm_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_MF_Request_confirm(tvb, offset, &asn1_ctx, tree, hf_iicp_MF_Request_confirm_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_MN_Command_request_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_MN_Command_request(tvb, offset, &asn1_ctx, tree, hf_iicp_MN_Command_request_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_TestMN_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_TestMN(tvb, offset, &asn1_ctx, tree, hf_iicp_TestMN_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_SimNUTcmd_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_SimNUTcmd(tvb, offset, &asn1_ctx, tree, hf_iicp_SimNUTcmd_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_SimNLTcmd_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_SimNLTcmd(tvb, offset, &asn1_ctx, tree, hf_iicp_SimNLTcmd_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_FWTset_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_FWTset(tvb, offset, &asn1_ctx, tree, hf_iicp_FWTset_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_FWTupdate_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_FWTupdate(tvb, offset, &asn1_ctx, tree, hf_iicp_FWTupdate_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_FWTdelete_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_FWTdelete(tvb, offset, &asn1_ctx, tree, hf_iicp_FWTdelete_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_MN_Command_confirm_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_MN_Command_confirm(tvb, offset, &asn1_ctx, tree, hf_iicp_MN_Command_confirm_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_FWTsetConf_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_FWTsetConf(tvb, offset, &asn1_ctx, tree, hf_iicp_FWTsetConf_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_FWTupdateConf_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_FWTupdateConf(tvb, offset, &asn1_ctx, tree, hf_iicp_FWTupdateConf_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_FWTdeleteConf_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_FWTdeleteConf(tvb, offset, &asn1_ctx, tree, hf_iicp_FWTdeleteConf_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_MN_Request_request_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_MN_Request_request(tvb, offset, &asn1_ctx, tree, hf_iicp_MN_Request_request_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_SimNUTreq_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_SimNUTreq(tvb, offset, &asn1_ctx, tree, hf_iicp_SimNUTreq_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_SimNLTreq_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_SimNLTreq(tvb, offset, &asn1_ctx, tree, hf_iicp_SimNLTreq_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_FWTsetNot_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_FWTsetNot(tvb, offset, &asn1_ctx, tree, hf_iicp_FWTsetNot_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_FWTupdateNot_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_FWTupdateNot(tvb, offset, &asn1_ctx, tree, hf_iicp_FWTupdateNot_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_FWTdeleteNot_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_FWTdeleteNot(tvb, offset, &asn1_ctx, tree, hf_iicp_FWTdeleteNot_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_VCIcreatePeerMAC_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_VCIcreatePeerMAC(tvb, offset, &asn1_ctx, tree, hf_iicp_VCIcreatePeerMAC_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_Its_ssiPeerNot_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_Its_ssiPeerNot(tvb, offset, &asn1_ctx, tree, hf_iicp_Its_ssiPeerNot_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_TestMNecho_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_TestMNecho(tvb, offset, &asn1_ctx, tree, hf_iicp_TestMNecho_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_MN_Request_confirm_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_MN_Request_confirm(tvb, offset, &asn1_ctx, tree, hf_iicp_MN_Request_confirm_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_VCIPeerMAC_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_VCIPeerMAC(tvb, offset, &asn1_ctx, tree, hf_iicp_VCIPeerMAC_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_MI_Command_request_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_MI_Command_request(tvb, offset, &asn1_ctx, tree, hf_iicp_MI_Command_request_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_SimIUTcmd_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_SimIUTcmd(tvb, offset, &asn1_ctx, tree, hf_iicp_SimIUTcmd_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_MI_Command_confirm_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_MI_Command_confirm(tvb, offset, &asn1_ctx, tree, hf_iicp_MI_Command_confirm_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_MI_Request_request_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_MI_Request_request(tvb, offset, &asn1_ctx, tree, hf_iicp_MI_Request_request_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_SimIUTreq_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_SimIUTreq(tvb, offset, &asn1_ctx, tree, hf_iicp_SimIUTreq_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_MI_Request_confirm_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_MI_Request_confirm(tvb, offset, &asn1_ctx, tree, hf_iicp_MI_Request_confirm_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_MI_Set_request_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_MI_Set_request(tvb, offset, &asn1_ctx, tree, hf_iicp_MI_Set_request_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_MI_Set_confirm_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_MI_Set_confirm(tvb, offset, &asn1_ctx, tree, hf_iicp_MI_Set_confirm_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_MI_Get_request_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_MI_Get_request(tvb, offset, &asn1_ctx, tree, hf_iicp_MI_Get_request_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_MI_Get_confirm_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_MI_Get_confirm(tvb, offset, &asn1_ctx, tree, hf_iicp_MI_Get_confirm_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_ErrStatus_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_ErrStatus(tvb, offset, &asn1_ctx, tree, hf_iicp_ErrStatus_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_DeleteFNTP_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_DeleteFNTP(tvb, offset, &asn1_ctx, tree, hf_iicp_DeleteFNTP_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_DeleteNotFNTP_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_DeleteNotFNTP(tvb, offset, &asn1_ctx, tree, hf_iicp_DeleteNotFNTP_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_SetFNTP_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_SetFNTP(tvb, offset, &asn1_ctx, tree, hf_iicp_SetFNTP_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_HostServiceInfo_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_HostServiceInfo(tvb, offset, &asn1_ctx, tree, hf_iicp_HostServiceInfo_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_SetNotFNTP_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_SetNotFNTP(tvb, offset, &asn1_ctx, tree, hf_iicp_SetNotFNTP_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_UpdateFNTP_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_UpdateFNTP(tvb, offset, &asn1_ctx, tree, hf_iicp_UpdateFNTP_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_UpdateNotFNTP_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_UpdateNotFNTP(tvb, offset, &asn1_ctx, tree, hf_iicp_UpdateNotFNTP_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_NFfntpPortRequest_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_NFfntpPortRequest(tvb, offset, &asn1_ctx, tree, hf_iicp_NFfntpPortRequest_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_NFfntpPortConfirm_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_NFfntpPortConfirm(tvb, offset, &asn1_ctx, tree, hf_iicp_NFfntpPortConfirm_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_NFfntpCommRequest_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_NFfntpCommRequest(tvb, offset, &asn1_ctx, tree, hf_iicp_NFfntpCommRequest_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_NFfntpCommConfirm_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_NFfntpCommConfirm(tvb, offset, &asn1_ctx, tree, hf_iicp_NFfntpCommConfirm_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_NFfntpCommIndication_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_NFfntpCommIndication(tvb, offset, &asn1_ctx, tree, hf_iicp_NFfntpCommIndication_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_GCctxTxCmd_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_GCctxTxCmd(tvb, offset, &asn1_ctx, tree, hf_iicp_GCctxTxCmd_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_GCperiodCmd_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_GCperiodCmd(tvb, offset, &asn1_ctx, tree, hf_iicp_GCperiodCmd_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_GCsamctx_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_GCsamctx(tvb, offset, &asn1_ctx, tree, hf_iicp_GCsamctx_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_GCsamctxConf_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_GCsamctxConf(tvb, offset, &asn1_ctx, tree, hf_iicp_GCsamctxConf_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_GCdeleteCmd_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_GCdeleteCmd(tvb, offset, &asn1_ctx, tree, hf_iicp_GCdeleteCmd_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_CTXrxNot_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_CTXrxNot(tvb, offset, &asn1_ctx, tree, hf_iicp_CTXrxNot_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_SAMrxNot_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_SAMrxNot(tvb, offset, &asn1_ctx, tree, hf_iicp_SAMrxNot_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_GCsam_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_GCsam(tvb, offset, &asn1_ctx, tree, hf_iicp_GCsam_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_GCctx_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_GCctx(tvb, offset, &asn1_ctx, tree, hf_iicp_GCctx_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_GCregServer_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_GCregServer(tvb, offset, &asn1_ctx, tree, hf_iicp_GCregServer_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_GCupdateServer_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_GCupdateServer(tvb, offset, &asn1_ctx, tree, hf_iicp_GCupdateServer_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_GCderegServer_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_GCderegServer(tvb, offset, &asn1_ctx, tree, hf_iicp_GCderegServer_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_GCregClient_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_GCregClient(tvb, offset, &asn1_ctx, tree, hf_iicp_GCregClient_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_GCupdateClient_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_GCupdateClient(tvb, offset, &asn1_ctx, tree, hf_iicp_GCupdateClient_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_GCderegClient_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_GCderegClient(tvb, offset, &asn1_ctx, tree, hf_iicp_GCderegClient_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_GCregServerConf_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_GCregServerConf(tvb, offset, &asn1_ctx, tree, hf_iicp_GCregServerConf_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_GCupdateServerConf_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_GCupdateServerConf(tvb, offset, &asn1_ctx, tree, hf_iicp_GCupdateServerConf_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_GCderegServerConf_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_GCderegServerConf(tvb, offset, &asn1_ctx, tree, hf_iicp_GCderegServerConf_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_GCregClientConf_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_GCregClientConf(tvb, offset, &asn1_ctx, tree, hf_iicp_GCregClientConf_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_GCupdateClientConf_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_GCupdateClientConf(tvb, offset, &asn1_ctx, tree, hf_iicp_GCupdateClientConf_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_GCderegClientConf_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_GCderegClientConf(tvb, offset, &asn1_ctx, tree, hf_iicp_GCderegClientConf_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_ITS_S_Appl_Reg_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_ITS_S_Appl_Reg(tvb, offset, &asn1_ctx, tree, hf_iicp_ITS_S_Appl_Reg_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static void dissect_IIC_Request_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_) {
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  dissect_iicp_IIC_Request(tvb, 0, &asn1_ctx, tree, hf_iicp_IIC_Request_PDU);
}
static int dissect_IICPrequest_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_IICPrequest(tvb, offset, &asn1_ctx, tree, hf_iicp_IICPrequest_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_ITS_SCUalive_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_ITS_SCUalive(tvb, offset, &asn1_ctx, tree, hf_iicp_ITS_SCUalive_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_McmdRq_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_McmdRq(tvb, offset, &asn1_ctx, tree, hf_iicp_McmdRq_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_PingIICP_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_PingIICP(tvb, offset, &asn1_ctx, tree, hf_iicp_PingIICP_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_VCI_info_req_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_VCI_info_req(tvb, offset, &asn1_ctx, tree, hf_iicp_VCI_info_req_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_VCI_update_req_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_VCI_update_req(tvb, offset, &asn1_ctx, tree, hf_iicp_VCI_update_req_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_TestIicp_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_TestIicp(tvb, offset, &asn1_ctx, tree, hf_iicp_TestIicp_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_TestConfigIICP_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_TestConfigIICP(tvb, offset, &asn1_ctx, tree, hf_iicp_TestConfigIICP_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static void dissect_IIC_Response_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_) {
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  dissect_iicp_IIC_Response(tvb, 0, &asn1_ctx, tree, hf_iicp_IIC_Response_PDU);
}
static int dissect_IICPresponse_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_IICPresponse(tvb, offset, &asn1_ctx, tree, hf_iicp_IICPresponse_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_McmdRs_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_McmdRs(tvb, offset, &asn1_ctx, tree, hf_iicp_McmdRs_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_VCI_info_res_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_VCI_info_res(tvb, offset, &asn1_ctx, tree, hf_iicp_VCI_info_res_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_IICrequestTX_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_IICrequestTX(tvb, offset, &asn1_ctx, tree, hf_iicp_IICrequestTX_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_IICresponseTX_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_IICresponseTX(tvb, offset, &asn1_ctx, tree, hf_iicp_IICresponseTX_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_IICrequestRX_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_IICrequestRX(tvb, offset, &asn1_ctx, tree, hf_iicp_IICrequestRX_PDU);
  offset += 7; offset >>= 3;
  return offset;
}
static int dissect_IICresponseRX_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_, void *data _U_) {
  int offset = 0;
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_PER, FALSE, pinfo);
  offset = dissect_iicp_IICresponseRX(tvb, offset, &asn1_ctx, tree, hf_iicp_IICresponseRX_PDU);
  offset += 7; offset >>= 3;
  return offset;
}


/*--- End of included file: packet-iicp-fn.c ---*/
#line 168 "../../asn1/calm-iicp/packet-iicp-template.c"

static int dissect_iicp_pdu_type(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_)
{
  return (dissector_try_uint_new(iicp_pdu_type_dissector_table, Ref_IICP, tvb, pinfo, tree, FALSE, NULL)) ? tvb_length(tvb) : 0;
}

static int dissect_iicp_pdu_request(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_)
{
  return (dissector_try_uint_new(iicp_pdu_request_dissector_table, Ref_IICPReq, tvb, pinfo, tree, FALSE, NULL)) ? tvb_length(tvb) : 0;
}

static int dissect_iicp_pdu_response(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_)
{
  return (dissector_try_uint_new(iicp_pdu_response_dissector_table, Ref_IICPResp, tvb, pinfo, tree, FALSE, NULL)) ? tvb_length(tvb) : 0;
}

static int dissect_iicp_mcmd_request(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_)
{
  return (dissector_try_uint_new(iicp_mcmdrq_dissector_table, Ref_McmdRq, tvb, pinfo, tree, FALSE, NULL)) ? tvb_length(tvb) : 0;
}

static int dissect_iicp_mcmd_response(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_)
{
  return (dissector_try_uint_new(iicp_mcmdrs_dissector_table, Ref_McmdRs, tvb, pinfo, tree, FALSE, NULL)) ? tvb_length(tvb) : 0;
}

static int dissect_msap_fa_sap_primitives_down(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_)
{
  return (dissector_try_uint_new(msap_fa_sap_primitives_down_dissector_table, Ref_COMMDOWN, tvb, pinfo, tree, FALSE, NULL)) ? tvb_length(tvb) : 0;
}

static int dissect_msap_fa_sap_primitives_up(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_)
{
  return (dissector_try_uint_new(msap_fa_sap_primitives_up_dissector_table, Ref_COMMUP, tvb, pinfo, tree, FALSE, NULL)) ? tvb_length(tvb) : 0;
}

static int dissect_msap_mf_command_request(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_)
{
  return (dissector_try_uint_new(msap_mf_command_request_dissector_table, Ref_MFCMDREQ, tvb, pinfo, tree, FALSE, NULL)) ? tvb_length(tvb) : 0;
}

static int dissect_msap_mf_command_confirm(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_)
{
  return (dissector_try_uint_new(msap_mf_command_confirm_dissector_table, Ref_MFCMDCONF, tvb, pinfo, tree, FALSE, NULL)) ? tvb_length(tvb) : 0;
}

static int dissect_msap_mf_request_request(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_)
{
  return (dissector_try_uint_new(msap_mf_request_request_dissector_table, Ref_MFREQREQ, tvb, pinfo, tree, FALSE, NULL)) ? tvb_length(tvb) : 0;
}

static int dissect_msap_mf_request_confirm(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_)
{
  return (dissector_try_uint_new(msap_mf_request_confirm_dissector_table, Ref_MFREQCONF, tvb, pinfo, tree, FALSE, NULL)) ? tvb_length(tvb) : 0;
}

static int dissect_msap_mn_command_request(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_)
{
  return (dissector_try_uint_new(msap_mn_command_request_dissector_table, Ref_MNCMDREQ, tvb, pinfo, tree, FALSE, NULL)) ? tvb_length(tvb) : 0;
}

static int dissect_msap_mn_command_confirm(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_)
{
  return (dissector_try_uint_new(msap_mn_command_confirm_dissector_table, Ref_MNCMDCONF, tvb, pinfo, tree, FALSE, NULL)) ? tvb_length(tvb) : 0;
}

static int dissect_msap_mn_request_request(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_)
{
  return (dissector_try_uint_new(msap_mn_request_request_dissector_table, Ref_MNREQREQ, tvb, pinfo, tree, FALSE, NULL)) ? tvb_length(tvb) : 0;
}

static int dissect_msap_mn_request_confirm(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_)
{
  return (dissector_try_uint_new(msap_mn_request_confirm_dissector_table, Ref_MNREQCONF, tvb, pinfo, tree, FALSE, NULL)) ? tvb_length(tvb) : 0;
}
static int dissect_msap_fwt(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_)
{
  return (dissector_try_uint_new(msap_fwt_dissector_table, Ref_FWT, tvb, pinfo, tree, FALSE, NULL)) ? tvb_length(tvb) : 0;
}
static int dissect_msap_fwtnot(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_)
{
  return (dissector_try_uint_new(msap_fwtnot_dissector_table, Ref_FWTNOT, tvb, pinfo, tree, FALSE, NULL)) ? tvb_length(tvb) : 0;
}

static int dissect_fntp_nf_sap_primitives_down(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_)
{
  return (dissector_try_uint_new(fntp_nf_sap_primitives_down_dissector_table, Ref_NFSAPDOWN, tvb, pinfo, tree, FALSE, NULL)) ? tvb_length(tvb) : 0;
}
static int dissect_fntp_nf_sap_primitives_up(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_)
{
  return (dissector_try_uint_new(fntp_nf_sap_primitives_up_dissector_table, Ref_NFSAPUP, tvb, pinfo, tree, FALSE, NULL)) ? tvb_length(tvb) : 0;
}

static int dissect_llsap_in_sap_primitives_down(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_)
{
  return (dissector_try_uint_new(llsap_in_sap_primitives_down_dissector_table, Ref_INSAPDOWN, tvb, pinfo, tree, FALSE, NULL)) ? tvb_length(tvb) : 0;
}
static int dissect_llsap_in_sap_primitives_up(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_)
{
  return (dissector_try_uint_new(llsap_in_sap_primitives_up_dissector_table, Ref_INSAPUP, tvb, pinfo, tree, FALSE, NULL)) ? tvb_length(tvb) : 0;
}

static int dissect_llsap_acc_params(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, void *data _U_)
{
  return (dissector_try_uint_new(llsap_acc_params_dissector_table, Ref_ACCPARAMS, tvb, pinfo, tree, FALSE, NULL)) ? tvb_length(tvb) : 0;
}



static void
dissect_iicp(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree)
{
  proto_item      *iicp_item = NULL;
  proto_tree      *iicp_tree = NULL;
  int             offset = 0;
  guint8          lsbPduCounter;

  /* make entry in the Protocol column on summary display */
  //if (check_col(pinfo->cinfo, COL_PROTOCOL))
    col_set_str(pinfo->cinfo, COL_PROTOCOL, PSNAME);
  //if (check_col(pinfo->cinfo, COL_INFO))
    col_set_str(pinfo->cinfo, COL_INFO, "Station-internal management communications (ISO 24102-4)");
  
  /* create the iicp protocol tree */
  if (tree) {
    iicp_item = proto_tree_add_item(tree, proto_iicp, tvb, 0, -1, FALSE);
    iicp_tree = proto_item_add_subtree(iicp_item, ett_iicp);

    tvb_get_guint8(tvb, offset++);
    tvb_get_guint8(tvb, offset++);

    tvb_get_guint8(tvb, offset++);
    tvb_get_guint8(tvb, offset++);

    tvb_get_guint8(tvb, offset++);
    lsbPduCounter = tvb_get_guint8(tvb, offset);
    if ((lsbPduCounter % 2) != 0) { // Odd value => response
      dissect_IIC_Response_PDU(tvb, pinfo, tree);	  
    } else {
      dissect_IIC_Request_PDU(tvb, pinfo, tree);
    }
  }
}
  
/*--- proto_register_iicp -------------------------------------------*/
void proto_register_iicp(void) {
  module_t *iicp_module;

  /* List of fields */
  static hf_register_info hf[] = {


/*--- Included file: packet-iicp-hfarr.c ---*/
#line 1 "../../asn1/calm-iicp/packet-iicp-hfarr.c"
    { &hf_iicp_ITS_scuId_PDU,
      { "ITS-scuId", "iicp.ITS_scuId",
        FT_UINT32, BASE_DEC, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_Param24102_PDU,
      { "Param24102", "iicp.Param24102_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_Param24102No_PDU,
      { "Param24102No", "iicp.Param24102No",
        FT_UINT32, BASE_DEC, VALS(iicp_Param24102No_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_IN_UNITDATA_request_PDU,
      { "IN-UNITDATA-request", "iicp.IN_UNITDATA_request_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_IN_DATA_ACK_request_PDU,
      { "IN-DATA-ACK-request", "iicp.IN_DATA_ACK_request_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_IN_REPLY_ACK_request_PDU,
      { "IN-REPLY-ACK-request", "iicp.IN_REPLY_ACK_request_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_IN_REPLY_UPDATE_request_PDU,
      { "IN-REPLY-UPDATE-request", "iicp.IN_REPLY_UPDATE_request_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_IN_UNITDATA_indication_PDU,
      { "IN-UNITDATA-indication", "iicp.IN_UNITDATA_indication_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_IN_UNITDATA_STATUS_indication_PDU,
      { "IN-UNITDATA-STATUS-indication", "iicp.IN_UNITDATA_STATUS_indication_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_IN_DATA_ACK_indication_PDU,
      { "IN-DATA-ACK-indication", "iicp.IN_DATA_ACK_indication_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_IN_DATA_ACK_STATUS_indication_PDU,
      { "IN-DATA-ACK-STATUS-indication", "iicp.IN_DATA_ACK_STATUS_indication_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_IN_REPLY_indication_PDU,
      { "IN-REPLY-indication", "iicp.IN_REPLY_indication_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_IN_REPLY_STATUS_indication_PDU,
      { "IN-REPLY-STATUS-indication", "iicp.IN_REPLY_STATUS_indication_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_IN_REPLY_UPDATE_STATUS_indication_PDU,
      { "IN-REPLY-UPDATE-STATUS-indication", "iicp.IN_REPLY_UPDATE_STATUS_indication_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_NullType_PDU,
      { "NullType", "iicp.NullType_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_MF_Command_request_PDU,
      { "MF-Command-request", "iicp.MF_Command_request_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_TestMF_PDU,
      { "TestMF", "iicp.TestMF",
        FT_BYTES, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_SimFUTcmd_PDU,
      { "SimFUTcmd", "iicp.SimFUTcmd_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_SimFLTcmd_PDU,
      { "SimFLTcmd", "iicp.SimFLTcmd_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_LDMnotify_PDU,
      { "LDMnotify", "iicp.LDMnotify",
        FT_UINT32, BASE_DEC, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_LegacyCIreq_PDU,
      { "LegacyCIreq", "iicp.LegacyCIreq_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_StateCInotify_PDU,
      { "StateCInotify", "iicp.StateCInotify_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_MF_Command_confirm_PDU,
      { "MF-Command-confirm", "iicp.MF_Command_confirm_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_MF_Request_request_PDU,
      { "MF-Request-request", "iicp.MF_Request_request_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_SimFUTreq_PDU,
      { "SimFUTreq", "iicp.SimFUTreq_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_SimFLTreq_PDU,
      { "SimFLTreq", "iicp.SimFLTreq_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_LDMregister_PDU,
      { "LDMregister", "iicp.LDMregister_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_TestMFecho_PDU,
      { "TestMFecho", "iicp.TestMFecho_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_MF_Request_confirm_PDU,
      { "MF-Request-confirm", "iicp.MF_Request_confirm_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_MN_Command_request_PDU,
      { "MN-Command-request", "iicp.MN_Command_request_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_TestMN_PDU,
      { "TestMN", "iicp.TestMN",
        FT_BYTES, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_SimNUTcmd_PDU,
      { "SimNUTcmd", "iicp.SimNUTcmd_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_SimNLTcmd_PDU,
      { "SimNLTcmd", "iicp.SimNLTcmd_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_FWTset_PDU,
      { "FWTset", "iicp.FWTset_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_FWTupdate_PDU,
      { "FWTupdate", "iicp.FWTupdate_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_FWTdelete_PDU,
      { "FWTdelete", "iicp.FWTdelete_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_MN_Command_confirm_PDU,
      { "MN-Command-confirm", "iicp.MN_Command_confirm_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_FWTsetConf_PDU,
      { "FWTsetConf", "iicp.FWTsetConf_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_FWTupdateConf_PDU,
      { "FWTupdateConf", "iicp.FWTupdateConf_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_FWTdeleteConf_PDU,
      { "FWTdeleteConf", "iicp.FWTdeleteConf_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_MN_Request_request_PDU,
      { "MN-Request-request", "iicp.MN_Request_request_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_SimNUTreq_PDU,
      { "SimNUTreq", "iicp.SimNUTreq_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_SimNLTreq_PDU,
      { "SimNLTreq", "iicp.SimNLTreq_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_FWTsetNot_PDU,
      { "FWTsetNot", "iicp.FWTsetNot_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_FWTupdateNot_PDU,
      { "FWTupdateNot", "iicp.FWTupdateNot_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_FWTdeleteNot_PDU,
      { "FWTdeleteNot", "iicp.FWTdeleteNot_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_VCIcreatePeerMAC_PDU,
      { "VCIcreatePeerMAC", "iicp.VCIcreatePeerMAC_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_Its_ssiPeerNot_PDU,
      { "Its-ssiPeerNot", "iicp.Its_ssiPeerNot_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_TestMNecho_PDU,
      { "TestMNecho", "iicp.TestMNecho_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_MN_Request_confirm_PDU,
      { "MN-Request-confirm", "iicp.MN_Request_confirm_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_VCIPeerMAC_PDU,
      { "VCIPeerMAC", "iicp.VCIPeerMAC_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_MI_Command_request_PDU,
      { "MI-Command-request", "iicp.MI_Command_request_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_SimIUTcmd_PDU,
      { "SimIUTcmd", "iicp.SimIUTcmd_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_MI_Command_confirm_PDU,
      { "MI-Command-confirm", "iicp.MI_Command_confirm_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_MI_Request_request_PDU,
      { "MI-Request-request", "iicp.MI_Request_request_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_SimIUTreq_PDU,
      { "SimIUTreq", "iicp.SimIUTreq_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_MI_Request_confirm_PDU,
      { "MI-Request-confirm", "iicp.MI_Request_confirm_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_MI_Set_request_PDU,
      { "MI-Set-request", "iicp.MI_Set_request_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_MI_Set_confirm_PDU,
      { "MI-Set-confirm", "iicp.MI_Set_confirm_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_MI_Get_request_PDU,
      { "MI-Get-request", "iicp.MI_Get_request_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_MI_Get_confirm_PDU,
      { "MI-Get-confirm", "iicp.MI_Get_confirm_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_ErrStatus_PDU,
      { "ErrStatus", "iicp.ErrStatus",
        FT_UINT32, BASE_DEC, VALS(iicp_ErrStatus_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_DeleteFNTP_PDU,
      { "DeleteFNTP", "iicp.DeleteFNTP_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_DeleteNotFNTP_PDU,
      { "DeleteNotFNTP", "iicp.DeleteNotFNTP_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_SetFNTP_PDU,
      { "SetFNTP", "iicp.SetFNTP_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_HostServiceInfo_PDU,
      { "HostServiceInfo", "iicp.HostServiceInfo_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_SetNotFNTP_PDU,
      { "SetNotFNTP", "iicp.SetNotFNTP_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_UpdateFNTP_PDU,
      { "UpdateFNTP", "iicp.UpdateFNTP_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_UpdateNotFNTP_PDU,
      { "UpdateNotFNTP", "iicp.UpdateNotFNTP_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_NFfntpPortRequest_PDU,
      { "NFfntpPortRequest", "iicp.NFfntpPortRequest_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_NFfntpPortConfirm_PDU,
      { "NFfntpPortConfirm", "iicp.NFfntpPortConfirm_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_NFfntpCommRequest_PDU,
      { "NFfntpCommRequest", "iicp.NFfntpCommRequest_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_NFfntpCommConfirm_PDU,
      { "NFfntpCommConfirm", "iicp.NFfntpCommConfirm_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_NFfntpCommIndication_PDU,
      { "NFfntpCommIndication", "iicp.NFfntpCommIndication_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_GCctxTxCmd_PDU,
      { "GCctxTxCmd", "iicp.GCctxTxCmd_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_GCperiodCmd_PDU,
      { "GCperiodCmd", "iicp.GCperiodCmd_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_GCsamctx_PDU,
      { "GCsamctx", "iicp.GCsamctx_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_GCsamctxConf_PDU,
      { "GCsamctxConf", "iicp.GCsamctxConf_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_GCdeleteCmd_PDU,
      { "GCdeleteCmd", "iicp.GCdeleteCmd_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_CTXrxNot_PDU,
      { "CTXrxNot", "iicp.CTXrxNot_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_SAMrxNot_PDU,
      { "SAMrxNot", "iicp.SAMrxNot_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_GCsam_PDU,
      { "GCsam", "iicp.GCsam_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_GCctx_PDU,
      { "GCctx", "iicp.GCctx_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_GCregServer_PDU,
      { "GCregServer", "iicp.GCregServer_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_GCupdateServer_PDU,
      { "GCupdateServer", "iicp.GCupdateServer_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_GCderegServer_PDU,
      { "GCderegServer", "iicp.GCderegServer_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_GCregClient_PDU,
      { "GCregClient", "iicp.GCregClient_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_GCupdateClient_PDU,
      { "GCupdateClient", "iicp.GCupdateClient_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_GCderegClient_PDU,
      { "GCderegClient", "iicp.GCderegClient_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_GCregServerConf_PDU,
      { "GCregServerConf", "iicp.GCregServerConf_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_GCupdateServerConf_PDU,
      { "GCupdateServerConf", "iicp.GCupdateServerConf_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_GCderegServerConf_PDU,
      { "GCderegServerConf", "iicp.GCderegServerConf_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_GCregClientConf_PDU,
      { "GCregClientConf", "iicp.GCregClientConf_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_GCupdateClientConf_PDU,
      { "GCupdateClientConf", "iicp.GCupdateClientConf_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_GCderegClientConf_PDU,
      { "GCderegClientConf", "iicp.GCderegClientConf_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_ITS_S_Appl_Reg_PDU,
      { "ITS-S-Appl-Reg", "iicp.ITS_S_Appl_Reg",
        FT_UINT32, BASE_DEC, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_IIC_Request_PDU,
      { "IIC-Request", "iicp.IIC_Request_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_IICPrequest_PDU,
      { "IICPrequest", "iicp.IICPrequest_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_ITS_SCUalive_PDU,
      { "ITS-SCUalive", "iicp.ITS_SCUalive_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_McmdRq_PDU,
      { "McmdRq", "iicp.McmdRq_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_PingIICP_PDU,
      { "PingIICP", "iicp.PingIICP",
        FT_BYTES, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_VCI_info_req_PDU,
      { "VCI-info-req", "iicp.VCI_info_req_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_VCI_update_req_PDU,
      { "VCI-update-req", "iicp.VCI_update_req",
        FT_UINT32, BASE_DEC, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_TestIicp_PDU,
      { "TestIicp", "iicp.TestIicp_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_TestConfigIICP_PDU,
      { "TestConfigIICP", "iicp.TestConfigIICP_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_IIC_Response_PDU,
      { "IIC-Response", "iicp.IIC_Response_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_IICPresponse_PDU,
      { "IICPresponse", "iicp.IICPresponse_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_McmdRs_PDU,
      { "McmdRs", "iicp.McmdRs_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_VCI_info_res_PDU,
      { "VCI-info-res", "iicp.VCI_info_res",
        FT_UINT32, BASE_DEC, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_IICrequestTX_PDU,
      { "IICrequestTX", "iicp.IICrequestTX_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_IICresponseTX_PDU,
      { "IICresponseTX", "iicp.IICresponseTX_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_IICrequestRX_PDU,
      { "IICrequestRX", "iicp.IICrequestRX_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_IICresponseRX_PDU,
      { "IICresponseRX", "iicp.IICresponseRX_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_reference,
      { "reference", "iicp.reference",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_65535", HFILL }},
    { &hf_iicp_remoteIP,
      { "remoteIP", "iicp.remoteIP_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "IpAddressInfo", HFILL }},
    { &hf_iicp_ciid,
      { "ciid", "iicp.ciid_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "Link_ID", HFILL }},
    { &hf_iicp_ciStatus,
      { "ciStatus", "iicp.ciStatus",
        FT_UINT32, BASE_DEC, VALS(iicp_CIstatus_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_localIP,
      { "localIP", "iicp.localIP_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "IpAddressInfo", HFILL }},
    { &hf_iicp_priority,
      { "priority", "iicp.priority",
        FT_UINT32, BASE_DEC, NULL, 0,
        "UserPriority", HFILL }},
    { &hf_iicp_timeout,
      { "timeout", "iicp.timeout",
        FT_UINT32, BASE_DEC, NULL, 0,
        "IPv6timeout", HFILL }},
    { &hf_iicp_fill,
      { "fill", "iicp.fill",
        FT_BYTES, BASE_NONE, NULL, 0,
        "BIT_STRING_SIZE_2", HFILL }},
    { &hf_iicp_hostITS_scuId,
      { "hostITS-scuId", "iicp.hostITS_scuId",
        FT_UINT32, BASE_DEC, NULL, 0,
        "ITS_scuId", HFILL }},
    { &hf_iicp_seqNumber,
      { "seqNumber", "iicp.seqNumber_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "ServiceRef", HFILL }},
    { &hf_iicp_CrCiPrioList_item,
      { "CrCiPrioReq", "iicp.CrCiPrioReq_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_linkId,
      { "linkId", "iicp.linkId_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "Link_ID", HFILL }},
    { &hf_iicp_timeout_01,
      { "timeout", "iicp.timeout",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_255", HFILL }},
    { &hf_iicp_request,
      { "request", "iicp.request",
        FT_UINT32, BASE_DEC, NULL, 0,
        "CCPrequest", HFILL }},
    { &hf_iicp_interferer,
      { "interferer", "iicp.interferer",
        FT_UINT32, BASE_DEC, NULL, 0,
        "SEQUENCE_OF_CCPpotInt", HFILL }},
    { &hf_iicp_interferer_item,
      { "CCPpotInt", "iicp.CCPpotInt_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_CCPrequest_item,
      { "CCPrequest item", "iicp.CCPrequest_item_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_reqNo,
      { "reqNo", "iicp.reqNo",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_255", HFILL }},
    { &hf_iicp_status,
      { "status", "iicp.status",
        FT_INT32, BASE_DEC, VALS(iicp_CCPstatus_vals), 0,
        "CCPstatus", HFILL }},
    { &hf_iicp_linkID,
      { "linkID", "iicp.linkID_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "Link_ID", HFILL }},
    { &hf_iicp_iTS_scuId6,
      { "iTS-scuId6", "iicp.iTS_scuId6",
        FT_UINT32, BASE_DEC, NULL, 0,
        "ITS_scuId", HFILL }},
    { &hf_iicp_its_scuType,
      { "its-scuType", "iicp.its_scuType",
        FT_UINT32, BASE_DEC, VALS(iicp_ITS_SCUtype_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_time,
      { "time", "iicp.time",
        FT_STRING, BASE_NONE, NULL, 0,
        "GeneralizedTime", HFILL }},
    { &hf_iicp_uniqueID,
      { "uniqueID", "iicp.uniqueID",
        FT_STRING, BASE_NONE, NULL, 0,
        "PrintableString", HFILL }},
    { &hf_iicp_stationType,
      { "stationType", "iicp.stationType",
        FT_UINT32, BASE_DEC, VALS(iicp_StationType_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_stationID,
      { "stationID", "iicp.stationID",
        FT_BYTES, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_stationPosition,
      { "stationPosition", "iicp.stationPosition_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "KineVectOut", HFILL }},
    { &hf_iicp_paramNo,
      { "paramNo", "iicp.paramNo",
        FT_UINT32, BASE_DEC, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_param,
      { "param", "iicp.param_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_VciList_item,
      { "VciListEntry", "iicp.VciListEntry_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_medType,
      { "medType", "iicp.medType",
        FT_UINT32, BASE_DEC, VALS(iicp_MedType_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_status_01,
      { "status", "iicp.status",
        FT_UINT32, BASE_DEC, VALS(iicp_CIstatus_vals), 0,
        "CIstatus", HFILL }},
    { &hf_iicp_connect,
      { "connect", "iicp.connect",
        FT_UINT32, BASE_DEC, VALS(iicp_Connect_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_macAddress,
      { "macAddress", "iicp.macAddress",
        FT_BYTES, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_VCIperformList_item,
      { "VCIperformance", "iicp.VCIperformance_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_channelType,
      { "channelType", "iicp.channelType",
        FT_UINT32, BASE_DEC, VALS(iicp_VarLengthNumber2_vals), 0,
        "LogicalChannelType", HFILL }},
    { &hf_iicp_channelNo,
      { "channelNo", "iicp.channelNo",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_255", HFILL }},
    { &hf_iicp_minUserPrio,
      { "minUserPrio", "iicp.minUserPrio",
        FT_UINT32, BASE_DEC, NULL, 0,
        "UserPriority", HFILL }},
    { &hf_iicp_dataRateNW,
      { "dataRateNW", "iicp.dataRateNW",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DataRate", HFILL }},
    { &hf_iicp_dataRatesNW,
      { "dataRatesNW", "iicp.dataRatesNW_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_directivity,
      { "directivity", "iicp.directivity_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_commRangeRef,
      { "commRangeRef", "iicp.commRangeRef",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_65535", HFILL }},
    { &hf_iicp_cost,
      { "cost", "iicp.cost_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "MediumCost", HFILL }},
    { &hf_iicp_reliability,
      { "reliability", "iicp.reliability",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_255", HFILL }},
    { &hf_iicp_remoteCIID,
      { "remoteCIID", "iicp.remoteCIID",
        FT_BYTES, BASE_NONE, NULL, 0,
        "EUI64", HFILL }},
    { &hf_iicp_localCIID,
      { "localCIID", "iicp.localCIID",
        FT_BYTES, BASE_NONE, NULL, 0,
        "EUI64", HFILL }},
    { &hf_iicp_CommProfile_item,
      { "I-Parameter", "iicp.I_Parameter_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_minimum,
      { "minimum", "iicp.minimum",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DataRate", HFILL }},
    { &hf_iicp_maximum,
      { "maximum", "iicp.maximum",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DataRate", HFILL }},
    { &hf_iicp_mode,
      { "mode", "iicp.mode",
        FT_UINT32, BASE_DEC, VALS(iicp_DirMode_vals), 0,
        "DirMode", HFILL }},
    { &hf_iicp_dirPredef,
      { "dirPredef", "iicp.dirPredef",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_255", HFILL }},
    { &hf_iicp_fill_01,
      { "fill", "iicp.fill",
        FT_BYTES, BASE_NONE, NULL, 0,
        "BIT_STRING_SIZE_7", HFILL }},
    { &hf_iicp_dirVar,
      { "dirVar", "iicp.dirVar",
        FT_UINT32, BASE_DEC, NULL, 0,
        "SEQUENCE_SIZE_0_1_OF_DirVar", HFILL }},
    { &hf_iicp_dirVar_item,
      { "DirVar", "iicp.DirVar_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_bsAzimuth,
      { "bsAzimuth", "iicp.bsAzimuth",
        FT_INT32, BASE_DEC, NULL, 0,
        "INTEGER_M32768_32767", HFILL }},
    { &hf_iicp_bsElevation,
      { "bsElevation", "iicp.bsElevation",
        FT_INT32, BASE_DEC, NULL, 0,
        "INTEGER_M128_127", HFILL }},
    { &hf_iicp_openHorizontal,
      { "openHorizontal", "iicp.openHorizontal",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_255", HFILL }},
    { &hf_iicp_openVertical,
      { "openVertical", "iicp.openVertical",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_255", HFILL }},
    { &hf_iicp_Errors_item,
      { "SingleError", "iicp.SingleError_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_paramNo_01,
      { "paramNo", "iicp.paramNo",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_255", HFILL }},
    { &hf_iicp_errStatus,
      { "errStatus", "iicp.errStatus",
        FT_UINT32, BASE_DEC, VALS(iicp_ErrStatus_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_dut,
      { "dut", "iicp.dut",
        FT_UINT32, BASE_DEC, VALS(iicp_Time48IAT_vals), 0,
        "Time48IAT", HFILL }},
    { &hf_iicp_lat,
      { "lat", "iicp.lat",
        FT_INT32, BASE_DEC, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_lon,
      { "lon", "iicp.lon",
        FT_INT32, BASE_DEC, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_alt,
      { "alt", "iicp.alt",
        FT_UINT32, BASE_DEC, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_gs,
      { "gs", "iicp.gs",
        FT_UINT32, BASE_DEC, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_tta,
      { "tta", "iicp.tta",
        FT_UINT32, BASE_DEC, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_fill_02,
      { "fill", "iicp.fill",
        FT_BYTES, BASE_NONE, NULL, 0,
        "BIT_STRING_SIZE_5", HFILL }},
    { &hf_iicp_options,
      { "options", "iicp.options",
        FT_UINT32, BASE_DEC, NULL, 0,
        "SEQUENCE_SIZE_0_5_OF_KineVectOptions", HFILL }},
    { &hf_iicp_options_item,
      { "KineVectOptions", "iicp.KineVectOptions",
        FT_UINT32, BASE_DEC, VALS(iicp_KineVectOptions_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_csap,
      { "csap", "iicp.csap",
        FT_UINT32, BASE_DEC, NULL, 0,
        "IN_SAPaddress", HFILL }},
    { &hf_iicp_receive,
      { "receive", "iicp.receive",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_255", HFILL }},
    { &hf_iicp_transmit,
      { "transmit", "iicp.transmit",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_255", HFILL }},
    { &hf_iicp_value,
      { "value", "iicp.value",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_1023", HFILL }},
    { &hf_iicp_unit,
      { "unit", "iicp.unit",
        FT_UINT32, BASE_DEC, VALS(iicp_TimeUnit_vals), 0,
        "TimeUnit", HFILL }},
    { &hf_iicp_Notify_item,
      { "Notify item", "iicp.Notify_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_255", HFILL }},
    { &hf_iicp_paramNo_02,
      { "paramNo", "iicp.paramNo",
        FT_UINT32, BASE_DEC, NULL, 0,
        "T_paramNo_01", HFILL }},
    { &hf_iicp_parameter,
      { "parameter", "iicp.parameter_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_LogicalChannels_item,
      { "LogicalChannelType", "iicp.LogicalChannelType",
        FT_UINT32, BASE_DEC, VALS(iicp_VarLengthNumber2_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_Properties_item,
      { "I-Parameter", "iicp.I_Parameter_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_provName,
      { "provName", "iicp.provName",
        FT_BYTES, BASE_NONE, NULL, 0,
        "OCTET_STRING_SIZE_0_255", HFILL }},
    { &hf_iicp_apn,
      { "apn", "iicp.apn",
        FT_BYTES, BASE_NONE, NULL, 0,
        "OCTET_STRING_SIZE_0_255", HFILL }},
    { &hf_iicp_username,
      { "username", "iicp.username",
        FT_BYTES, BASE_NONE, NULL, 0,
        "OCTET_STRING_SIZE_0_255", HFILL }},
    { &hf_iicp_password,
      { "password", "iicp.password",
        FT_BYTES, BASE_NONE, NULL, 0,
        "OCTET_STRING_SIZE_0_255", HFILL }},
    { &hf_iicp_level,
      { "level", "iicp.level",
        FT_UINT32, BASE_DEC, NULL, 0,
        "QueueValue", HFILL }},
    { &hf_iicp_status_02,
      { "status", "iicp.status",
        FT_UINT32, BASE_DEC, VALS(iicp_RegInfoStatus_vals), 0,
        "RegInfoStatus", HFILL }},
    { &hf_iicp_limits,
      { "limits", "iicp.limits_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "RegulatoryScheme", HFILL }},
    { &hf_iicp_reguIdent,
      { "reguIdent", "iicp.reguIdent",
        FT_UINT32, BASE_DEC, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_reguInfo,
      { "reguInfo", "iicp.reguInfo_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_VirtualCIs_item,
      { "RemoteCIID", "iicp.RemoteCIID",
        FT_BYTES, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_spRef,
      { "spRef", "iicp.spRef",
        FT_UINT32, BASE_DEC, VALS(iicp_RefINSAPDOWN_vals), 0,
        "RefINSAPDOWN", HFILL }},
    { &hf_iicp_servPrimitive,
      { "servPrimitive", "iicp.servPrimitive_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_source_addr,
      { "source-addr", "iicp.source_addr_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "LLserviceAddr", HFILL }},
    { &hf_iicp_dest_addr,
      { "dest-addr", "iicp.dest_addr_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "LLserviceAddr", HFILL }},
    { &hf_iicp_data,
      { "data", "iicp.data",
        FT_BYTES, BASE_NONE, NULL, 0,
        "INdata", HFILL }},
    { &hf_iicp_accessParams,
      { "accessParams", "iicp.accessParams_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "AccessParameters", HFILL }},
    { &hf_iicp_serviceClass,
      { "serviceClass", "iicp.serviceClass",
        FT_UINT32, BASE_DEC, VALS(iicp_MACServiceClass_vals), 0,
        "MACServiceClass", HFILL }},
    { &hf_iicp_spRef_01,
      { "spRef", "iicp.spRef",
        FT_UINT32, BASE_DEC, VALS(iicp_RefINSAPUP_vals), 0,
        "RefINSAPUP", HFILL }},
    { &hf_iicp_servPrimitive_01,
      { "servPrimitive", "iicp.servPrimitive_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "T_servPrimitive_01", HFILL }},
    { &hf_iicp_txStatus,
      { "txStatus", "iicp.txStatus",
        FT_UINT32, BASE_DEC, VALS(iicp_INtxStatus_vals), 0,
        "INtxStatus", HFILL }},
    { &hf_iicp_status_03,
      { "status", "iicp.status",
        FT_UINT32, BASE_DEC, VALS(iicp_INtxStatus_vals), 0,
        "INtxStatus", HFILL }},
    { &hf_iicp_apRef,
      { "apRef", "iicp.apRef",
        FT_UINT32, BASE_DEC, VALS(iicp_RefACCPARAMS_vals), 0,
        "RefACCPARAMS", HFILL }},
    { &hf_iicp_aParameter,
      { "aParameter", "iicp.aParameter_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_selector1,
      { "selector1", "iicp.selector1",
        FT_UINT32, BASE_DEC, VALS(iicp_OneOCTETones_vals), 0,
        "OneOCTETones", HFILL }},
    { &hf_iicp_iTS_scuId,
      { "iTS-scuId", "iicp.iTS_scuId",
        FT_UINT32, BASE_DEC, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_selector2,
      { "selector2", "iicp.selector2",
        FT_UINT32, BASE_DEC, VALS(iicp_TwoOCTETones_vals), 0,
        "TwoOCTETones", HFILL }},
    { &hf_iicp_medID,
      { "medID", "iicp.medID",
        FT_UINT32, BASE_DEC, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_vciSerialNumber,
      { "vciSerialNumber", "iicp.vciSerialNumber",
        FT_UINT32, BASE_DEC, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_oui,
      { "oui", "iicp.oui_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "MACoui", HFILL }},
    { &hf_iicp_ext,
      { "ext", "iicp.ext",
        FT_BYTES, BASE_NONE, NULL, 0,
        "MACext", HFILL }},
    { &hf_iicp_uoi1,
      { "uoi1", "iicp.uoi1",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_63", HFILL }},
    { &hf_iicp_ulBit,
      { "ulBit", "iicp.ulBit",
        FT_BOOLEAN, BASE_NONE, NULL, 0,
        "BOOLEAN", HFILL }},
    { &hf_iicp_igBIT,
      { "igBIT", "iicp.igBIT",
        FT_BOOLEAN, BASE_NONE, NULL, 0,
        "BOOLEAN", HFILL }},
    { &hf_iicp_uoi2,
      { "uoi2", "iicp.uoi2",
        FT_BYTES, BASE_NONE, NULL, 0,
        "OCTET_STRING_SIZE_2", HFILL }},
    { &hf_iicp_ucgc,
      { "ucgc", "iicp.ucgc",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_63", HFILL }},
    { &hf_iicp_mc,
      { "mc", "iicp.mc",
        FT_UINT32, BASE_DEC, VALS(iicp_T_mc_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_serial,
      { "serial", "iicp.serial",
        FT_BYTES, BASE_NONE, NULL, 0,
        "OCTET_STRING_SIZE_2", HFILL }},
    { &hf_iicp_spRef_02,
      { "spRef", "iicp.spRef",
        FT_UINT32, BASE_DEC, VALS(iicp_RefCOMMDOWN_vals), 0,
        "RefCOMMDOWN", HFILL }},
    { &hf_iicp_servPrimitive_02,
      { "servPrimitive", "iicp.servPrimitive_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "T_servPrimitive_02", HFILL }},
    { &hf_iicp_spRef_03,
      { "spRef", "iicp.spRef",
        FT_UINT32, BASE_DEC, VALS(iicp_RefCOMMUP_vals), 0,
        "RefCOMMUP", HFILL }},
    { &hf_iicp_servPrimitive_03,
      { "servPrimitive", "iicp.servPrimitive_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "T_servPrimitive_03", HFILL }},
    { &hf_iicp_commandRef,
      { "commandRef", "iicp.commandRef",
        FT_UINT32, BASE_DEC, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_ref,
      { "ref", "iicp.ref",
        FT_UINT32, BASE_DEC, VALS(iicp_RefMFCMDREQ_vals), 0,
        "RefMFCMDREQ", HFILL }},
    { &hf_iicp_command_param,
      { "command-param", "iicp.command_param_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_LDMnotify_item,
      { "RadarView", "iicp.RadarView_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_peerITS_SSI,
      { "peerITS-SSI", "iicp.peerITS_SSI_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "ITS_SSI", HFILL }},
    { &hf_iicp_cIclass,
      { "cIclass", "iicp.cIclass",
        FT_UINT32, BASE_DEC, VALS(iicp_CIclass_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_legacyOption,
      { "legacyOption", "iicp.legacyOption",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_255", HFILL }},
    { &hf_iicp_cIstatus,
      { "cIstatus", "iicp.cIstatus",
        FT_UINT32, BASE_DEC, VALS(iicp_CIstatus_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_ref_01,
      { "ref", "iicp.ref",
        FT_UINT32, BASE_DEC, VALS(iicp_RefMFCMDCONF_vals), 0,
        "RefMFCMDCONF", HFILL }},
    { &hf_iicp_cmdConfirm_param,
      { "cmdConfirm-param", "iicp.cmdConfirm_param_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_ref_02,
      { "ref", "iicp.ref",
        FT_UINT32, BASE_DEC, VALS(iicp_RefMFREQREQ_vals), 0,
        "RefMFREQREQ", HFILL }},
    { &hf_iicp_request_param,
      { "request-param", "iicp.request_param_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "T_request_param", HFILL }},
    { &hf_iicp_iTS_scuId4,
      { "iTS-scuId4", "iicp.iTS_scuId4",
        FT_UINT32, BASE_DEC, NULL, 0,
        "ITS_scuId", HFILL }},
    { &hf_iicp_reference_01,
      { "reference", "iicp.reference",
        FT_BYTES, BASE_NONE, NULL, 0,
        "OCTET_STRING_SIZE_0_65535", HFILL }},
    { &hf_iicp_sap,
      { "sap", "iicp.sap",
        FT_UINT32, BASE_DEC, VALS(iicp_T_sap_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_info,
      { "info", "iicp.info",
        FT_BYTES, BASE_NONE, NULL, 0,
        "OCTET_STRING_SIZE_0_255", HFILL }},
    { &hf_iicp_ref_03,
      { "ref", "iicp.ref",
        FT_UINT32, BASE_DEC, VALS(iicp_RefMFREQCONF_vals), 0,
        "RefMFREQCONF", HFILL }},
    { &hf_iicp_reqConfirm_param,
      { "reqConfirm-param", "iicp.reqConfirm_param_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_ref_04,
      { "ref", "iicp.ref",
        FT_UINT32, BASE_DEC, VALS(iicp_RefMNCMDREQ_vals), 0,
        "RefMNCMDREQ", HFILL }},
    { &hf_iicp_command_param_01,
      { "command-param", "iicp.command_param_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "T_command_param_01", HFILL }},
    { &hf_iicp_fwtNo,
      { "fwtNo", "iicp.fwtNo",
        FT_UINT32, BASE_DEC, VALS(iicp_RefFWT_vals), 0,
        "RefFWT", HFILL }},
    { &hf_iicp_fwt,
      { "fwt", "iicp.fwt_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_fwt_01,
      { "fwt", "iicp.fwt_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "T_fwt_01", HFILL }},
    { &hf_iicp_fwt_02,
      { "fwt", "iicp.fwt_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "T_fwt_02", HFILL }},
    { &hf_iicp_ref_05,
      { "ref", "iicp.ref",
        FT_UINT32, BASE_DEC, VALS(iicp_RefMNCMDCONF_vals), 0,
        "RefMNCMDCONF", HFILL }},
    { &hf_iicp_cmdConfirm_param_01,
      { "cmdConfirm-param", "iicp.cmdConfirm_param_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "T_cmdConfirm_param_01", HFILL }},
    { &hf_iicp_fwtNo_01,
      { "fwtNo", "iicp.fwtNo",
        FT_UINT32, BASE_DEC, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_fwt_03,
      { "fwt", "iicp.fwt_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "T_fwt_03", HFILL }},
    { &hf_iicp_fwtNo_02,
      { "fwtNo", "iicp.fwtNo",
        FT_UINT32, BASE_DEC, NULL, 0,
        "T_fwtNo_01", HFILL }},
    { &hf_iicp_fwt_04,
      { "fwt", "iicp.fwt_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "T_fwt_04", HFILL }},
    { &hf_iicp_fwtNo_03,
      { "fwtNo", "iicp.fwtNo",
        FT_UINT32, BASE_DEC, NULL, 0,
        "T_fwtNo_02", HFILL }},
    { &hf_iicp_fwt_05,
      { "fwt", "iicp.fwt_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "T_fwt_05", HFILL }},
    { &hf_iicp_ref_06,
      { "ref", "iicp.ref",
        FT_UINT32, BASE_DEC, VALS(iicp_RefMNREQREQ_vals), 0,
        "RefMNREQREQ", HFILL }},
    { &hf_iicp_request_param_01,
      { "request-param", "iicp.request_param_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "T_request_param_01", HFILL }},
    { &hf_iicp_fwtNo_04,
      { "fwtNo", "iicp.fwtNo",
        FT_UINT32, BASE_DEC, VALS(iicp_RefFWTNOT_vals), 0,
        "RefFWTNOT", HFILL }},
    { &hf_iicp_fwt_06,
      { "fwt", "iicp.fwt_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "T_fwt_06", HFILL }},
    { &hf_iicp_fwt_07,
      { "fwt", "iicp.fwt_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "T_fwt_07", HFILL }},
    { &hf_iicp_fwt_08,
      { "fwt", "iicp.fwt_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "T_fwt_08", HFILL }},
    { &hf_iicp_reference_02,
      { "reference", "iicp.reference",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_255", HFILL }},
    { &hf_iicp_peerMac,
      { "peerMac", "iicp.peerMac",
        FT_BYTES, BASE_NONE, NULL, 0,
        "MACaddress", HFILL }},
    { &hf_iicp_sap_01,
      { "sap", "iicp.sap",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_255", HFILL }},
    { &hf_iicp_mACaddress,
      { "mACaddress", "iicp.mACaddress",
        FT_BYTES, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_its_ssiData,
      { "its-ssiData", "iicp.its_ssiData_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "ITS_SSI", HFILL }},
    { &hf_iicp_sap_02,
      { "sap", "iicp.sap",
        FT_UINT32, BASE_DEC, VALS(iicp_T_sap_01_vals), 0,
        "T_sap_01", HFILL }},
    { &hf_iicp_ref_07,
      { "ref", "iicp.ref",
        FT_UINT32, BASE_DEC, VALS(iicp_RefMNREQCONF_vals), 0,
        "RefMNREQCONF", HFILL }},
    { &hf_iicp_reqConfirm_param_01,
      { "reqConfirm-param", "iicp.reqConfirm_param_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "T_reqConfirm_param_01", HFILL }},
    { &hf_iicp_ref_08,
      { "ref", "iicp.ref",
        FT_UINT32, BASE_DEC, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_command_param_02,
      { "command-param", "iicp.command_param_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "T_command_param_02", HFILL }},
    { &hf_iicp_scuId,
      { "scuId", "iicp.scuId",
        FT_UINT32, BASE_DEC, NULL, 0,
        "ITS_scuId", HFILL }},
    { &hf_iicp_reqID,
      { "reqID", "iicp.reqID_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_seqNo,
      { "seqNo", "iicp.seqNo",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_255", HFILL }},
    { &hf_iicp_status_04,
      { "status", "iicp.status",
        FT_UINT32, BASE_DEC, VALS(iicp_T_status_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_status_05,
      { "status", "iicp.status",
        FT_UINT32, BASE_DEC, VALS(iicp_T_status_01_vals), 0,
        "T_status_01", HFILL }},
    { &hf_iicp_ri,
      { "ri", "iicp.ri",
        FT_BYTES, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_VciCmd_item,
      { "VciCmd item", "iicp.VciCmd_item_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_alive,
      { "alive", "iicp.alive",
        FT_BOOLEAN, BASE_NONE, NULL, 0,
        "BOOLEAN", HFILL }},
    { &hf_iicp_Monitor_item,
      { "Monitor item", "iicp.Monitor_item_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_active,
      { "active", "iicp.active",
        FT_UINT32, BASE_DEC, VALS(iicp_T_active_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_sourceAddr,
      { "sourceAddr", "iicp.sourceAddr_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "Link_ID", HFILL }},
    { &hf_iicp_destAddr,
      { "destAddr", "iicp.destAddr_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "Link_ID", HFILL }},
    { &hf_iicp_data_01,
      { "data", "iicp.data",
        FT_BYTES, BASE_NONE, NULL, 0,
        "OCTET_STRING_SIZE_0_65535", HFILL }},
    { &hf_iicp_parameter_01,
      { "parameter", "iicp.parameter",
        FT_BYTES, BASE_NONE, NULL, 0,
        "OCTET_STRING_SIZE_0_65535", HFILL }},
    { &hf_iicp_ref_09,
      { "ref", "iicp.ref",
        FT_UINT32, BASE_DEC, NULL, 0,
        "T_ref_01", HFILL }},
    { &hf_iicp_request_param_02,
      { "request-param", "iicp.request_param_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "T_request_param_02", HFILL }},
    { &hf_iicp_interferers,
      { "interferers", "iicp.interferers",
        FT_UINT32, BASE_DEC, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_Interferers_item,
      { "MedType", "iicp.MedType",
        FT_UINT32, BASE_DEC, VALS(iicp_MedType_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_status_06,
      { "status", "iicp.status",
        FT_UINT32, BASE_DEC, VALS(iicp_T_status_02_vals), 0,
        "T_status_02", HFILL }},
    { &hf_iicp_status_07,
      { "status", "iicp.status",
        FT_UINT32, BASE_DEC, VALS(iicp_T_status_03_vals), 0,
        "T_status_03", HFILL }},
    { &hf_iicp_riAccess,
      { "riAccess", "iicp.riAccess",
        FT_BYTES, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_eventNo,
      { "eventNo", "iicp.eventNo",
        FT_UINT32, BASE_DEC, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_event,
      { "event", "iicp.event_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_sap_03,
      { "sap", "iicp.sap",
        FT_UINT32, BASE_DEC, VALS(iicp_T_sap_02_vals), 0,
        "T_sap_02", HFILL }},
    { &hf_iicp_set_param,
      { "set-param", "iicp.set_param",
        FT_UINT32, BASE_DEC, NULL, 0,
        "SEQUENCE_OF_I_Parameter", HFILL }},
    { &hf_iicp_set_param_item,
      { "I-Parameter", "iicp.I_Parameter_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_set_param_01,
      { "set-param", "iicp.set_param",
        FT_UINT32, BASE_DEC, NULL, 0,
        "SEQUENCE_OF_Errors", HFILL }},
    { &hf_iicp_set_param_item_01,
      { "Errors", "iicp.Errors",
        FT_UINT32, BASE_DEC, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_get_param_no,
      { "get-param-no", "iicp.get_param_no",
        FT_UINT32, BASE_DEC, NULL, 0,
        "SEQUENCE_OF_I_ParamNo", HFILL }},
    { &hf_iicp_get_param_no_item,
      { "I-ParamNo", "iicp.I_ParamNo",
        FT_UINT32, BASE_DEC, VALS(iicp_I_ParamNo_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_ref_10,
      { "ref", "iicp.ref",
        FT_UINT32, BASE_DEC, NULL, 0,
        "T_ref_02", HFILL }},
    { &hf_iicp_command_param_03,
      { "command-param", "iicp.command_param_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "T_command_param_03", HFILL }},
    { &hf_iicp_ref_11,
      { "ref", "iicp.ref",
        FT_UINT32, BASE_DEC, NULL, 0,
        "T_ref_03", HFILL }},
    { &hf_iicp_cmdConfirm_param_02,
      { "cmdConfirm-param", "iicp.cmdConfirm_param_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "T_cmdConfirm_param_02", HFILL }},
    { &hf_iicp_ref_12,
      { "ref", "iicp.ref",
        FT_UINT32, BASE_DEC, NULL, 0,
        "T_ref_04", HFILL }},
    { &hf_iicp_request_param_03,
      { "request-param", "iicp.request_param_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "T_request_param_03", HFILL }},
    { &hf_iicp_sap_04,
      { "sap", "iicp.sap",
        FT_UINT32, BASE_DEC, VALS(iicp_T_sap_03_vals), 0,
        "T_sap_03", HFILL }},
    { &hf_iicp_ref_13,
      { "ref", "iicp.ref",
        FT_UINT32, BASE_DEC, NULL, 0,
        "T_ref_05", HFILL }},
    { &hf_iicp_reqConfirm_param_02,
      { "reqConfirm-param", "iicp.reqConfirm_param_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "T_reqConfirm_param_02", HFILL }},
    { &hf_iicp_ref_14,
      { "ref", "iicp.ref",
        FT_UINT32, BASE_DEC, NULL, 0,
        "T_ref_06", HFILL }},
    { &hf_iicp_command_param_04,
      { "command-param", "iicp.command_param_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "T_command_param_04", HFILL }},
    { &hf_iicp_ref_15,
      { "ref", "iicp.ref",
        FT_UINT32, BASE_DEC, NULL, 0,
        "T_ref_07", HFILL }},
    { &hf_iicp_cmdConfirm_param_03,
      { "cmdConfirm-param", "iicp.cmdConfirm_param_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "T_cmdConfirm_param_03", HFILL }},
    { &hf_iicp_ref_16,
      { "ref", "iicp.ref",
        FT_UINT32, BASE_DEC, NULL, 0,
        "T_ref_08", HFILL }},
    { &hf_iicp_request_param_04,
      { "request-param", "iicp.request_param_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "T_request_param_04", HFILL }},
    { &hf_iicp_sap_05,
      { "sap", "iicp.sap",
        FT_UINT32, BASE_DEC, VALS(iicp_T_sap_04_vals), 0,
        "T_sap_04", HFILL }},
    { &hf_iicp_ref_17,
      { "ref", "iicp.ref",
        FT_UINT32, BASE_DEC, NULL, 0,
        "T_ref_09", HFILL }},
    { &hf_iicp_reqConfirm_param_03,
      { "reqConfirm-param", "iicp.reqConfirm_param_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "T_reqConfirm_param_03", HFILL }},
    { &hf_iicp_header,
      { "header", "iicp.header_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "FNTPHeader", HFILL }},
    { &hf_iicp_body,
      { "body", "iicp.body",
        FT_BYTES, BASE_NONE, NULL, 0,
        "ITSfpdu", HFILL }},
    { &hf_iicp_sourcePort,
      { "sourcePort", "iicp.sourcePort",
        FT_UINT32, BASE_DEC, VALS(iicp_PortNumber_vals), 0,
        "PortNumber", HFILL }},
    { &hf_iicp_destinationPort,
      { "destinationPort", "iicp.destinationPort",
        FT_UINT32, BASE_DEC, VALS(iicp_PortNumber_vals), 0,
        "PortNumber", HFILL }},
    { &hf_iicp_options_01,
      { "options", "iicp.options_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "FntpOptions", HFILL }},
    { &hf_iicp_intForw,
      { "intForw", "iicp.intForw_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "FNTPintForwarding", HFILL }},
    { &hf_iicp_sec,
      { "sec", "iicp.sec",
        FT_BYTES, BASE_NONE, NULL, 0,
        "FNTPsecurity", HFILL }},
    { &hf_iicp_hops,
      { "hops", "iicp.hops",
        FT_UINT32, BASE_DEC, NULL, 0,
        "FNTPhopCount", HFILL }},
    { &hf_iicp_lpp,
      { "lpp", "iicp.lpp",
        FT_BYTES, BASE_NONE, NULL, 0,
        "FNTPlpp", HFILL }},
    { &hf_iicp_cip,
      { "cip", "iicp.cip_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "FNTPCIPheader", HFILL }},
    { &hf_iicp_opt5,
      { "opt5", "iicp.opt5_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_opt6,
      { "opt6", "iicp.opt6_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_opt7,
      { "opt7", "iicp.opt7_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_link,
      { "link", "iicp.link_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "Link_ID", HFILL }},
    { &hf_iicp_counter,
      { "counter", "iicp.counter",
        FT_UINT32, BASE_DEC, NULL, 0,
        "FNTPpacketCounter", HFILL }},
    { &hf_iicp_rxCIP,
      { "rxCIP", "iicp.rxCIP",
        FT_BYTES, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_txCIP,
      { "txCIP", "iicp.txCIP",
        FT_BYTES, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_reference_03,
      { "reference", "iicp.reference",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_noFNTPfwtEntries", HFILL }},
    { &hf_iicp_remotePort,
      { "remotePort", "iicp.remotePort",
        FT_UINT32, BASE_DEC, VALS(iicp_PortNumber_vals), 0,
        "PortNumber", HFILL }},
    { &hf_iicp_linkPort,
      { "linkPort", "iicp.linkPort",
        FT_UINT32, BASE_DEC, VALS(iicp_PortNumber_vals), 0,
        "PortNumber", HFILL }},
    { &hf_iicp_serviceInfo,
      { "serviceInfo", "iicp.serviceInfo_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "HostServiceInfo", HFILL }},
    { &hf_iicp_timeout_02,
      { "timeout", "iicp.timeout",
        FT_UINT32, BASE_DEC, NULL, 0,
        "NTtimeout", HFILL }},
    { &hf_iicp_servicePort,
      { "servicePort", "iicp.servicePort",
        FT_UINT32, BASE_DEC, VALS(iicp_PortNumber_vals), 0,
        "PortNumber", HFILL }},
    { &hf_iicp_hostITSscu,
      { "hostITSscu", "iicp.hostITSscu",
        FT_UINT32, BASE_DEC, NULL, 0,
        "ITS_scuId", HFILL }},
    { &hf_iicp_servicePriority,
      { "servicePriority", "iicp.servicePriority",
        FT_UINT32, BASE_DEC, NULL, 0,
        "UserPriority", HFILL }},
    { &hf_iicp_fill_03,
      { "fill", "iicp.fill",
        FT_BYTES, BASE_NONE, NULL, 0,
        "BIT_STRING_SIZE_1", HFILL }},
    { &hf_iicp_spRef_04,
      { "spRef", "iicp.spRef",
        FT_UINT32, BASE_DEC, VALS(iicp_RefNFSAPDOWN_vals), 0,
        "RefNFSAPDOWN", HFILL }},
    { &hf_iicp_servPrimitive_04,
      { "servPrimitive", "iicp.servPrimitive_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "T_servPrimitive_04", HFILL }},
    { &hf_iicp_spRef_05,
      { "spRef", "iicp.spRef",
        FT_UINT32, BASE_DEC, VALS(iicp_RefNFSAPUP_vals), 0,
        "RefNFSAPUP", HFILL }},
    { &hf_iicp_servPrimitive_05,
      { "servPrimitive", "iicp.servPrimitive_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "T_servPrimitive_05", HFILL }},
    { &hf_iicp_serviceRef,
      { "serviceRef", "iicp.serviceRef_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_operation,
      { "operation", "iicp.operation",
        FT_UINT32, BASE_DEC, VALS(iicp_PortOp_vals), 0,
        "PortOp", HFILL }},
    { &hf_iicp_portno,
      { "portno", "iicp.portno",
        FT_UINT32, BASE_DEC, VALS(iicp_PortNumber_vals), 0,
        "PortNumber", HFILL }},
    { &hf_iicp_commRef,
      { "commRef", "iicp.commRef",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_255", HFILL }},
    { &hf_iicp_data_02,
      { "data", "iicp.data",
        FT_BYTES, BASE_NONE, NULL, 0,
        "ITSfpdu", HFILL }},
    { &hf_iicp_controlField,
      { "controlField", "iicp.controlField_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "FntpOptions", HFILL }},
    { &hf_iicp_errStatus_01,
      { "errStatus", "iicp.errStatus",
        FT_UINT32, BASE_DEC, VALS(iicp_FNTPerrorStatus_vals), 0,
        "FNTPerrorStatus", HFILL }},
    { &hf_iicp_portShort,
      { "portShort", "iicp.portShort",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_127", HFILL }},
    { &hf_iicp_portLong,
      { "portLong", "iicp.portLong",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_32767", HFILL }},
    { &hf_iicp_fmtID,
      { "fmtID", "iicp.fmtID",
        FT_UINT32, BASE_DEC, VALS(iicp_FmtID_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_version,
      { "version", "iicp.version",
        FT_UINT32, BASE_DEC, NULL, 0,
        "VersionFSAP", HFILL }},
    { &hf_iicp_serverID,
      { "serverID", "iicp.serverID",
        FT_BYTES, BASE_NONE, NULL, 0,
        "StationID", HFILL }},
    { &hf_iicp_serviceList,
      { "serviceList", "iicp.serviceList",
        FT_UINT32, BASE_DEC, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_channelList,
      { "channelList", "iicp.channelList",
        FT_UINT32, BASE_DEC, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_ipServList,
      { "ipServList", "iicp.ipServList",
        FT_UINT32, BASE_DEC, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_ServiceList_item,
      { "NonipService", "iicp.NonipService_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_ChannelList_item,
      { "SessionChannel", "iicp.SessionChannel_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_IpServList_item,
      { "IpService", "iicp.IpService_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_serviceID,
      { "serviceID", "iicp.serviceID",
        FT_UINT32, BASE_DEC, VALS(iicp_VarLengthNumber_vals), 0,
        "ITSaid", HFILL }},
    { &hf_iicp_serviceData,
      { "serviceData", "iicp.serviceData",
        FT_BYTES, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_serverPort,
      { "serverPort", "iicp.serverPort",
        FT_UINT32, BASE_DEC, VALS(iicp_PortNumber_vals), 0,
        "PortNumber", HFILL }},
    { &hf_iicp_sessionChannel,
      { "sessionChannel", "iicp.sessionChannel",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_noChannels", HFILL }},
    { &hf_iicp_serviceChannel,
      { "serviceChannel", "iicp.serviceChannel",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_255", HFILL }},
    { &hf_iicp_medium,
      { "medium", "iicp.medium",
        FT_UINT32, BASE_DEC, VALS(iicp_MedType_vals), 0,
        "MedType", HFILL }},
    { &hf_iicp_schParams,
      { "schParams", "iicp.schParams",
        FT_BYTES, BASE_NONE, NULL, 0,
        "OCTET_STRING", HFILL }},
    { &hf_iicp_serviceData_01,
      { "serviceData", "iicp.serviceData",
        FT_BYTES, BASE_NONE, NULL, 0,
        "IpServiceData", HFILL }},
    { &hf_iicp_ipInfo,
      { "ipInfo", "iicp.ipInfo_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_clientID,
      { "clientID", "iicp.clientID",
        FT_BYTES, BASE_NONE, NULL, 0,
        "StationID", HFILL }},
    { &hf_iicp_servContextList,
      { "servContextList", "iicp.servContextList",
        FT_UINT32, BASE_DEC, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_ipContextList,
      { "ipContextList", "iicp.ipContextList",
        FT_UINT32, BASE_DEC, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_ServContextList_item,
      { "NonipContext", "iicp.NonipContext_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_IpContextList_item,
      { "IpContext", "iicp.IpContext_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_contextData,
      { "contextData", "iicp.contextData",
        FT_BYTES, BASE_NONE, NULL, 0,
        "IpContextData", HFILL }},
    { &hf_iicp_link_01,
      { "link", "iicp.link_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "LLserviceAddr", HFILL }},
    { &hf_iicp_ctx,
      { "ctx", "iicp.ctx_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_applicationID,
      { "applicationID", "iicp.applicationID_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_bcVCIs,
      { "bcVCIs", "iicp.bcVCIs",
        FT_UINT32, BASE_DEC, NULL, 0,
        "SEQUENCE_SIZE_1_256_OF_LLserviceAddr", HFILL }},
    { &hf_iicp_bcVCIs_item,
      { "LLserviceAddr", "iicp.LLserviceAddr_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_gcInterval,
      { "gcInterval", "iicp.gcInterval",
        FT_UINT32, BASE_DEC, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_serviceDataReg,
      { "serviceDataReg", "iicp.serviceDataReg_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_serviceInfo_01,
      { "serviceInfo", "iicp.serviceInfo_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_port,
      { "port", "iicp.port",
        FT_UINT32, BASE_DEC, VALS(iicp_PortNumber_vals), 0,
        "PortNumber", HFILL }},
    { &hf_iicp_info_01,
      { "info", "iicp.info",
        FT_UINT32, BASE_DEC, VALS(iicp_T_info_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_nonipService,
      { "nonipService", "iicp.nonipService_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "NonipSAMctx", HFILL }},
    { &hf_iicp_ipService,
      { "ipService", "iicp.ipService_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "IpSAMctx", HFILL }},
    { &hf_iicp_providerPort,
      { "providerPort", "iicp.providerPort",
        FT_UINT32, BASE_DEC, VALS(iicp_PortNumber_vals), 0,
        "PortNumber", HFILL }},
    { &hf_iicp_sam,
      { "sam", "iicp.sam_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_serviceData_02,
      { "serviceData", "iicp.serviceData_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "SAMserviceData", HFILL }},
    { &hf_iicp_servData,
      { "servData", "iicp.servData",
        FT_UINT32, BASE_DEC, VALS(iicp_T_servData_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_nonipService_01,
      { "nonipService", "iicp.nonipService_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "NonipSAM", HFILL }},
    { &hf_iicp_ipService_01,
      { "ipService", "iicp.ipService_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "IpSAM", HFILL }},
    { &hf_iicp_sessionChannel_01,
      { "sessionChannel", "iicp.sessionChannel_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_serviceContext,
      { "serviceContext", "iicp.serviceContext_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "CTXserviceData", HFILL }},
    { &hf_iicp_servData_01,
      { "servData", "iicp.servData",
        FT_UINT32, BASE_DEC, VALS(iicp_T_servData_01_vals), 0,
        "T_servData_01", HFILL }},
    { &hf_iicp_nonipContext,
      { "nonipContext", "iicp.nonipContext_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_ipContext,
      { "ipContext", "iicp.ipContext_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_contextData_01,
      { "contextData", "iicp.contextData",
        FT_BYTES, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_userPort,
      { "userPort", "iicp.userPort",
        FT_UINT32, BASE_DEC, VALS(iicp_PortNumber_vals), 0,
        "PortNumber", HFILL }},
    { &hf_iicp_gCschedule,
      { "gCschedule", "iicp.gCschedule",
        FT_UINT32, BASE_DEC, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_serviceDataReg_01,
      { "serviceDataReg", "iicp.serviceDataReg",
        FT_UINT32, BASE_DEC, NULL, 0,
        "SEQUENCE_SIZE_0_1_OF_ServiceDataReg", HFILL }},
    { &hf_iicp_serviceDataReg_item,
      { "ServiceDataReg", "iicp.ServiceDataReg_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_GCschedule_item,
      { "GCsched", "iicp.GCsched_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_datareg,
      { "datareg", "iicp.datareg",
        FT_UINT32, BASE_DEC, VALS(iicp_T_datareg_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_nonipData,
      { "nonipData", "iicp.nonipData_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "NonipServiceReg", HFILL }},
    { &hf_iicp_ipData,
      { "ipData", "iicp.ipData_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "IpServiceReg", HFILL }},
    { &hf_iicp_serviceData_03,
      { "serviceData", "iicp.serviceData",
        FT_BYTES, BASE_NONE, NULL, 0,
        "OCTET_STRING_SIZE_0_noServiceDataOctets", HFILL }},
    { &hf_iicp_serviceData_04,
      { "serviceData", "iicp.serviceData",
        FT_BYTES, BASE_NONE, NULL, 0,
        "OCTET_STRING_SIZE_0_noIpServiceDataOctets", HFILL }},
    { &hf_iicp_address,
      { "address", "iicp.address_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "IpAddressInfo", HFILL }},
    { &hf_iicp_addressType,
      { "addressType", "iicp.addressType",
        FT_BYTES, BASE_NONE, NULL, 0,
        "TransportAddressType", HFILL }},
    { &hf_iicp_address_01,
      { "address", "iicp.address",
        FT_BYTES, BASE_NONE, NULL, 0,
        "TransportAddress", HFILL }},
    { &hf_iicp_params,
      { "params", "iicp.params",
        FT_UINT32, BASE_DEC, VALS(iicp_T_params_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_portPM,
      { "portPM", "iicp.portPM",
        FT_UINT32, BASE_DEC, VALS(iicp_PortNumber_vals), 0,
        "PortNumber", HFILL }},
    { &hf_iicp_ITSapObRegistry_item,
      { "ITSapOb", "iicp.ITSapOb_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_iTSaid,
      { "iTSaid", "iicp.iTSaid",
        FT_UINT32, BASE_DEC, VALS(iicp_VarLengthNumber_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_iTSapObName,
      { "iTSapObName", "iicp.iTSapObName",
        FT_BYTES, BASE_NONE, NULL, 0,
        "ITSObName", HFILL }},
    { &hf_iicp_iTSapObType,
      { "iTSapObType", "iicp.iTSapObType",
        FT_UINT32, BASE_DEC, VALS(iicp_ITSapObType_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_iTSapObOwner,
      { "iTSapObOwner", "iicp.iTSapObOwner_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "ITSObOwner", HFILL }},
    { &hf_iicp_iTSapObCert,
      { "iTSapObCert", "iicp.iTSapObCert_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "ITSapObCertificate", HFILL }},
    { &hf_iicp_iTSapObPorts,
      { "iTSapObPorts", "iicp.iTSapObPorts",
        FT_UINT32, BASE_DEC, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_ITSapObPorts_item,
      { "ITSapObPorts item", "iicp.ITSapObPorts_item_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_portNo,
      { "portNo", "iicp.portNo",
        FT_UINT32, BASE_DEC, VALS(iicp_VarLengthNumber2_vals), 0,
        "ITSSappRxTxPortNo", HFILL }},
    { &hf_iicp_rules,
      { "rules", "iicp.rules",
        FT_UINT32, BASE_DEC, NULL, 0,
        "SEQUENCE_OF_ITSapObPort", HFILL }},
    { &hf_iicp_rules_item,
      { "ITSapObPort", "iicp.ITSapObPort",
        FT_UINT32, BASE_DEC, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_ITSapObPort_item,
      { "ITSapObPortRule", "iicp.ITSapObPortRule_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_ruleNo,
      { "ruleNo", "iicp.ruleNo",
        FT_UINT32, BASE_DEC, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_rule,
      { "rule", "iicp.rule_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_lch,
      { "lch", "iicp.lch",
        FT_UINT32, BASE_DEC, VALS(iicp_VarLengthNumber2_vals), 0,
        "LogicalChannelType", HFILL }},
    { &hf_iicp_prio,
      { "prio", "iicp.prio",
        FT_UINT32, BASE_DEC, NULL, 0,
        "UserPriority", HFILL }},
    { &hf_iicp_ownerName,
      { "ownerName", "iicp.ownerName",
        FT_BYTES, BASE_NONE, NULL, 0,
        "ITSObOwnerName", HFILL }},
    { &hf_iicp_ownerType,
      { "ownerType", "iicp.ownerType",
        FT_UINT32, BASE_DEC, VALS(iicp_ITSObOwnerType_vals), 0,
        "ITSObOwnerType", HFILL }},
    { &hf_iicp_ownerOID,
      { "ownerOID", "iicp.ownerOID",
        FT_OID, BASE_NONE, NULL, 0,
        "OBJECT_IDENTIFIER", HFILL }},
    { &hf_iicp_issuingSA,
      { "issuingSA", "iicp.issuingSA_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_startDate,
      { "startDate", "iicp.startDate_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "CertStartDate", HFILL }},
    { &hf_iicp_endDate,
      { "endDate", "iicp.endDate_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "CertEndDate", HFILL }},
    { &hf_iicp_status_08,
      { "status", "iicp.status_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "CertStatus", HFILL }},
    { &hf_iicp_name,
      { "name", "iicp.name",
        FT_BYTES, BASE_NONE, NULL, 0,
        "SAname", HFILL }},
    { &hf_iicp_saOID,
      { "saOID", "iicp.saOID",
        FT_OID, BASE_NONE, NULL, 0,
        "OBJECT_IDENTIFIER", HFILL }},
    { &hf_iicp_csd,
      { "csd", "iicp.csd",
        FT_UINT32, BASE_DEC, VALS(iicp_T_csd_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_inactive,
      { "inactive", "iicp.inactive_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_date,
      { "date", "iicp.date",
        FT_STRING, BASE_NONE, NULL, 0,
        "NumericString_SIZE_8", HFILL }},
    { &hf_iicp_fill_04,
      { "fill", "iicp.fill",
        FT_BYTES, BASE_NONE, NULL, 0,
        "BIT_STRING_SIZE_6", HFILL }},
    { &hf_iicp_ced,
      { "ced", "iicp.ced",
        FT_UINT32, BASE_DEC, VALS(iicp_T_ced_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_never,
      { "never", "iicp.never_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_cs,
      { "cs", "iicp.cs",
        FT_UINT32, BASE_DEC, VALS(iicp_T_cs_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_active_01,
      { "active", "iicp.active_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_testActiv,
      { "testActiv", "iicp.testActiv_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_blocked,
      { "blocked", "iicp.blocked_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "CertBlocked", HFILL }},
    { &hf_iicp_ITSmsgSetRegistry_item,
      { "ITSmsgSet", "iicp.ITSmsgSet_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_iTSmsID,
      { "iTSmsID", "iicp.iTSmsID",
        FT_UINT32, BASE_DEC, VALS(iicp_VarLengthNumber_vals), 0,
        "ITSmsgSetID", HFILL }},
    { &hf_iicp_iTSmsName,
      { "iTSmsName", "iicp.iTSmsName",
        FT_BYTES, BASE_NONE, NULL, 0,
        "ITSObName", HFILL }},
    { &hf_iicp_iTSmsOwner,
      { "iTSmsOwner", "iicp.iTSmsOwner_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "ITSObOwner", HFILL }},
    { &hf_iicp_ITSregRegionRegistry_item,
      { "ITSregRegion", "iicp.ITSregRegion_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_regID,
      { "regID", "iicp.regID",
        FT_UINT32, BASE_DEC, VALS(iicp_VarLengthNumber_vals), 0,
        "ITSrrID", HFILL }},
    { &hf_iicp_regAuthority,
      { "regAuthority", "iicp.regAuthority_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "ITS_RegPolicyAuthority", HFILL }},
    { &hf_iicp_regArea,
      { "regArea", "iicp.regArea_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "ITS_RParea", HFILL }},
    { &hf_iicp_name_01,
      { "name", "iicp.name",
        FT_BYTES, BASE_NONE, NULL, 0,
        "ITSObOwnerName", HFILL }},
    { &hf_iicp_url,
      { "url", "iicp.url",
        FT_BYTES, BASE_NONE, NULL, 0,
        "URLreg", HFILL }},
    { &hf_iicp_areaTypeNo,
      { "areaTypeNo", "iicp.areaTypeNo",
        FT_UINT32, BASE_DEC, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_areaType,
      { "areaType", "iicp.areaType_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_GeoPolygon_item,
      { "GeoCoordinates", "iicp.GeoCoordinates_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_long,
      { "long", "iicp.long",
        FT_INT32, BASE_DEC, NULL, 0,
        "Lon", HFILL }},
    { &hf_iicp_ITSpolRegionRegistry_item,
      { "ITSpolRegion", "iicp.ITSpolRegion_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_polID,
      { "polID", "iicp.polID",
        FT_UINT32, BASE_DEC, VALS(iicp_VarLengthNumber_vals), 0,
        "ITSprID", HFILL }},
    { &hf_iicp_polAuthority,
      { "polAuthority", "iicp.polAuthority_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "ITS_RegPolicyAuthority", HFILL }},
    { &hf_iicp_polArea,
      { "polArea", "iicp.polArea_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "ITS_RParea", HFILL }},
    { &hf_iicp_ITSportNumberRegistry_item,
      { "ITSportNumber", "iicp.ITSportNumber_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_pn,
      { "pn", "iicp.pn",
        FT_UINT32, BASE_DEC, VALS(iicp_PortNumber_vals), 0,
        "PortNumber", HFILL }},
    { &hf_iicp_ntProt,
      { "ntProt", "iicp.ntProt_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "NTprotocol", HFILL }},
    { &hf_iicp_itssAp,
      { "itssAp", "iicp.itssAp_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "ItsAppInfo", HFILL }},
    { &hf_iicp_itsAid,
      { "itsAid", "iicp.itsAid",
        FT_UINT32, BASE_DEC, VALS(iicp_VarLengthNumber_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_rxTxPortNo,
      { "rxTxPortNo", "iicp.rxTxPortNo",
        FT_UINT32, BASE_DEC, VALS(iicp_VarLengthNumber2_vals), 0,
        "ITSSappRxTxPortNo", HFILL }},
    { &hf_iicp_name_02,
      { "name", "iicp.name",
        FT_BYTES, BASE_NONE, NULL, 0,
        "OCTET_STRING_SIZE_0_255", HFILL }},
    { &hf_iicp_protRef,
      { "protRef", "iicp.protRef_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "ProtocolReference", HFILL }},
    { &hf_iicp_sdo,
      { "sdo", "iicp.sdo",
        FT_BYTES, BASE_NONE, NULL, 0,
        "OCTET_STRING_SIZE_0_255", HFILL }},
    { &hf_iicp_docNo,
      { "docNo", "iicp.docNo",
        FT_BYTES, BASE_NONE, NULL, 0,
        "OCTET_STRING_SIZE_0_255", HFILL }},
    { &hf_iicp_ITSflowTypeRegistry_item,
      { "ITSflowType", "iicp.ITSflowType_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_id,
      { "id", "iicp.id",
        FT_UINT32, BASE_DEC, VALS(iicp_VarLengthNumber2_vals), 0,
        "FlowTypeID", HFILL }},
    { &hf_iicp_req,
      { "req", "iicp.req_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "ITSSappCPReqReg", HFILL }},
    { &hf_iicp_ITSlchRegistry_item,
      { "ITSlch", "iicp.ITSlch_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_lchID,
      { "lchID", "iicp.lchID",
        FT_UINT32, BASE_DEC, VALS(iicp_VarLengthNumber2_vals), 0,
        "LogicalChannelType", HFILL }},
    { &hf_iicp_lchPurpose,
      { "lchPurpose", "iicp.lchPurpose",
        FT_BYTES, BASE_NONE, NULL, 0,
        "OCTET_STRING_SIZE_0_255", HFILL }},
    { &hf_iicp_ITSsuRegistry_item,
      { "ITSsu", "iicp.ITSsu_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_itssuID,
      { "itssuID", "iicp.itssuID_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_ITSscuRegistry_item,
      { "ITSscu", "iicp.ITSscu_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_itsscuID,
      { "itsscuID", "iicp.itsscuID_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_ITSSappRegistry_item,
      { "ITSSapPrPr", "iicp.ITSSapPrPr_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_itssappID,
      { "itssappID", "iicp.itssappID",
        FT_UINT32, BASE_DEC, VALS(iicp_VarLengthNumber_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_itssapProv,
      { "itssapProv", "iicp.itssapProv_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "RegEntryOwner", HFILL }},
    { &hf_iicp_ownerName_01,
      { "ownerName", "iicp.ownerName",
        FT_BYTES, BASE_NONE, NULL, 0,
        "OCTET_STRING_SIZE_0_255", HFILL }},
    { &hf_iicp_ownerAddress,
      { "ownerAddress", "iicp.ownerAddress",
        FT_BYTES, BASE_NONE, NULL, 0,
        "OCTET_STRING_SIZE_0_255", HFILL }},
    { &hf_iicp_ownerURL,
      { "ownerURL", "iicp.ownerURL",
        FT_BYTES, BASE_NONE, NULL, 0,
        "URLreg", HFILL }},
    { &hf_iicp_ITSemRegistry_item,
      { "ITSem", "iicp.ITSem_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_itsemID,
      { "itsemID", "iicp.itsemID",
        FT_UINT32, BASE_DEC, VALS(iicp_VarLengthNumber2_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_equipManu,
      { "equipManu", "iicp.equipManu_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "RegEntryOwner", HFILL }},
    { &hf_iicp_ITSaooRegistry_item,
      { "ITSaoo", "iicp.ITSaoo_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_itsaooID,
      { "itsaooID", "iicp.itsaooID",
        FT_UINT32, BASE_DEC, VALS(iicp_VarLengthNumber_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_aoo,
      { "aoo", "iicp.aoo_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "RegEntryOwner", HFILL }},
    { &hf_iicp_Registry_item,
      { "ITSmso", "iicp.ITSmso_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_iTSmsoID,
      { "iTSmsoID", "iicp.iTSmsoID",
        FT_UINT32, BASE_DEC, VALS(iicp_VarLengthNumber2_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_mso,
      { "mso", "iicp.mso_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "RegEntryOwner", HFILL }},
    { &hf_iicp_ITSSapdRegistry_item,
      { "ITSSapd", "iicp.ITSSapd_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_itssapdID,
      { "itssapdID", "iicp.itssapdID",
        FT_UINT32, BASE_DEC, VALS(iicp_VarLengthNumber_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_ad,
      { "ad", "iicp.ad_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "RegEntryOwner", HFILL }},
    { &hf_iicp_suID,
      { "suID", "iicp.suID",
        FT_UINT32, BASE_DEC, VALS(iicp_VarLengthNumber_vals), 0,
        "VarLengthNumber", HFILL }},
    { &hf_iicp_scuID,
      { "scuID", "iicp.scuID_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "ITSscuID", HFILL }},
    { &hf_iicp_emID,
      { "emID", "iicp.emID",
        FT_UINT32, BASE_DEC, VALS(iicp_VarLengthNumber2_vals), 0,
        "ITSemID", HFILL }},
    { &hf_iicp_serialNo,
      { "serialNo", "iicp.serialNo",
        FT_UINT32, BASE_DEC, VALS(iicp_VarLengthNumber_vals), 0,
        "VarLengthNumber", HFILL }},
    { &hf_iicp_content,
      { "content", "iicp.content",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_127", HFILL }},
    { &hf_iicp_extension,
      { "extension", "iicp.extension",
        FT_UINT32, BASE_DEC, VALS(iicp_Ext1_vals), 0,
        "Ext1", HFILL }},
    { &hf_iicp_content_01,
      { "content", "iicp.content",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_128_16511", HFILL }},
    { &hf_iicp_extension_01,
      { "extension", "iicp.extension",
        FT_UINT32, BASE_DEC, VALS(iicp_Ext2_vals), 0,
        "Ext2", HFILL }},
    { &hf_iicp_content_02,
      { "content", "iicp.content",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_16512_2113663", HFILL }},
    { &hf_iicp_extension_02,
      { "extension", "iicp.extension",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Ext3", HFILL }},
    { &hf_iicp_shortNo,
      { "shortNo", "iicp.shortNo",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_127", HFILL }},
    { &hf_iicp_longNo,
      { "longNo", "iicp.longNo",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_32767", HFILL }},
    { &hf_iicp_rxTxPort,
      { "rxTxPort", "iicp.rxTxPort_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "ITSSappRxTxPort", HFILL }},
    { &hf_iicp_requirements,
      { "requirements", "iicp.requirements",
        FT_UINT32, BASE_DEC, NULL, 0,
        "ITSSappReq", HFILL }},
    { &hf_iicp_portType,
      { "portType", "iicp.portType",
        FT_UINT32, BASE_DEC, VALS(iicp_ITSSappRxTxPortType_vals), 0,
        "ITSSappRxTxPortType", HFILL }},
    { &hf_iicp_itsaid,
      { "itsaid", "iicp.itsaid",
        FT_UINT32, BASE_DEC, VALS(iicp_VarLengthNumber_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_instance,
      { "instance", "iicp.instance",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_255", HFILL }},
    { &hf_iicp_flowNo,
      { "flowNo", "iicp.flowNo",
        FT_UINT32, BASE_DEC, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_confDetails,
      { "confDetails", "iicp.confDetails",
        FT_UINT32, BASE_DEC, NULL, 0,
        "ITSSappReqConf", HFILL }},
    { &hf_iicp_ITSSappReq_item,
      { "ITSSappReq item", "iicp.ITSSappReq_item_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_refNo,
      { "refNo", "iicp.refNo",
        FT_UINT32, BASE_DEC, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_param_01,
      { "param", "iicp.param_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "T_param_01", HFILL }},
    { &hf_iicp_ITSSappReqConf_item,
      { "ITSSappReqConf item", "iicp.ITSSappReqConf_item_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_refNo_01,
      { "refNo", "iicp.refNo",
        FT_UINT32, BASE_DEC, NULL, 0,
        "T_refNo_01", HFILL }},
    { &hf_iicp_param_02,
      { "param", "iicp.param_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "T_param_02", HFILL }},
    { &hf_iicp_final,
      { "final", "iicp.final",
        FT_UINT32, BASE_DEC, VALS(iicp_Logic_vals), 0,
        "Logic", HFILL }},
    { &hf_iicp_type,
      { "type", "iicp.type",
        FT_UINT32, BASE_DEC, VALS(iicp_DestType_vals), 0,
        "DestType", HFILL }},
    { &hf_iicp_addressType_01,
      { "addressType", "iicp.addressType_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "AddressBasedType", HFILL }},
    { &hf_iicp_geoLocType,
      { "geoLocType", "iicp.geoLocType_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "GeoLocationBasedType", HFILL }},
    { &hf_iicp_type_01,
      { "type", "iicp.type",
        FT_UINT32, BASE_DEC, VALS(iicp_T_type_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_mcGroups,
      { "mcGroups", "iicp.mcGroups",
        FT_UINT32, BASE_DEC, NULL, 0,
        "SEQUENCE_SIZE_0_255_OF_MCgroup", HFILL }},
    { &hf_iicp_mcGroups_item,
      { "MCgroup", "iicp.MCgroup",
        FT_UINT32, BASE_DEC, VALS(iicp_VarLengthNumber_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_type_02,
      { "type", "iicp.type",
        FT_UINT32, BASE_DEC, VALS(iicp_T_type_01_vals), 0,
        "T_type_01", HFILL }},
    { &hf_iicp_duration,
      { "duration", "iicp.duration_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "TimDurationValue", HFILL }},
    { &hf_iicp_interrupt,
      { "interrupt", "iicp.interrupt",
        FT_UINT32, BASE_DEC, VALS(iicp_Logic_vals), 0,
        "Logic", HFILL }},
    { &hf_iicp_repeat,
      { "repeat", "iicp.repeat",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_255", HFILL }},
    { &hf_iicp_interval,
      { "interval", "iicp.interval_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "TimDurationValue", HFILL }},
    { &hf_iicp_minDistance,
      { "minDistance", "iicp.minDistance",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_65535", HFILL }},
    { &hf_iicp_cost_01,
      { "cost", "iicp.cost",
        FT_UINT32, BASE_DEC, NULL, 0,
        "CostObjective", HFILL }},
    { &hf_iicp_hops_01,
      { "hops", "iicp.hops",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_255", HFILL }},
    { &hf_iicp_minThP,
      { "minThP", "iicp.minThP",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DataRate", HFILL }},
    { &hf_iicp_lat_01,
      { "lat", "iicp.lat",
        FT_UINT32, BASE_DEC, VALS(iicp_T_lat_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_Policies_item,
      { "Policies item", "iicp.Policies_item_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_refNo_02,
      { "refNo", "iicp.refNo",
        FT_UINT32, BASE_DEC, NULL, 0,
        "T_refNo_02", HFILL }},
    { &hf_iicp_param_03,
      { "param", "iicp.param_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "T_param_03", HFILL }},
    { &hf_iicp_costClass,
      { "costClass", "iicp.costClass",
        FT_UINT32, BASE_DEC, VALS(iicp_CostClass_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_costAmount,
      { "costAmount", "iicp.costAmount_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_timeUnit,
      { "timeUnit", "iicp.timeUnit_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "CostTimeUnit", HFILL }},
    { &hf_iicp_amountUnit,
      { "amountUnit", "iicp.amountUnit",
        FT_UINT32, BASE_DEC, VALS(iicp_CostAmountUnit_vals), 0,
        "CostAmountUnit", HFILL }},
    { &hf_iicp_currency,
      { "currency", "iicp.currency",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_1023", HFILL }},
    { &hf_iicp_value_01,
      { "value", "iicp.value_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "CostValue", HFILL }},
    { &hf_iicp_main,
      { "main", "iicp.main",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_4095", HFILL }},
    { &hf_iicp_fraction,
      { "fraction", "iicp.fraction",
        FT_UINT32, BASE_DEC, NULL, 0,
        "INTEGER_0_1023", HFILL }},
    { &hf_iicp_ITS_S_Appl_Reg_item,
      { "ITSSappCPReqReg", "iicp.ITSSappCPReqReg_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_ITS_S_Appl_RegConf_item,
      { "ITSSappCPReqConf", "iicp.ITSSappCPReqConf_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_selectionOfCommunicationSysyem,
      { "selectionOfCommunicationSysyem", "iicp.selectionOfCommunicationSysyem_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "SelectionOfCommunicationSystem", HFILL }},
    { &hf_iicp_applicationIdentifiers,
      { "applicationIdentifiers", "iicp.applicationIdentifiers_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_address_02,
      { "address", "iicp.address_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_priority_01,
      { "priority", "iicp.priority_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_security,
      { "security", "iicp.security",
        FT_BYTES, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_applicationExecution,
      { "applicationExecution", "iicp.applicationExecution_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_responsiveness,
      { "responsiveness", "iicp.responsiveness_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_directionality,
      { "directionality", "iicp.directionality",
        FT_INT32, BASE_DEC, VALS(iicp_Directionality_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_usageEnvironment,
      { "usageEnvironment", "iicp.usageEnvironment_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_serviceArea,
      { "serviceArea", "iicp.serviceArea_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_serviceTime,
      { "serviceTime", "iicp.serviceTime_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_bandwidth,
      { "bandwidth", "iicp.bandwidth_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_connectionCost,
      { "connectionCost", "iicp.connectionCost_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_messageIdentifier,
      { "messageIdentifier", "iicp.messageIdentifier_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "EXTERNAL", HFILL }},
    { &hf_iicp_messageNumber,
      { "messageNumber", "iicp.messageNumber",
        FT_INT32, BASE_DEC, NULL, 0,
        "INTEGER", HFILL }},
    { &hf_iicp_timeOfMessageTransmission,
      { "timeOfMessageTransmission", "iicp.timeOfMessageTransmission",
        FT_STRING, BASE_NONE, NULL, 0,
        "GeneralizedTime", HFILL }},
    { &hf_iicp_addressOfOrigin,
      { "addressOfOrigin", "iicp.addressOfOrigin_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "EXTERNAL", HFILL }},
    { &hf_iicp_addressOfDestination,
      { "addressOfDestination", "iicp.addressOfDestination_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "EXTERNAL", HFILL }},
    { &hf_iicp_interruptHandling,
      { "interruptHandling", "iicp.interruptHandling",
        FT_INT32, BASE_DEC, VALS(iicp_T_interruptHandling_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_interruptHandlingLevel,
      { "interruptHandlingLevel", "iicp.interruptHandlingLevel",
        FT_INT32, BASE_DEC, NULL, 0,
        "INTEGER", HFILL }},
    { &hf_iicp_queueControl,
      { "queueControl", "iicp.queueControl",
        FT_INT32, BASE_DEC, VALS(iicp_T_queueControl_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_validTime,
      { "validTime", "iicp.validTime_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_timeStamp,
      { "timeStamp", "iicp.timeStamp",
        FT_STRING, BASE_NONE, NULL, 0,
        "GeneralizedTime", HFILL }},
    { &hf_iicp_targetArea,
      { "targetArea", "iicp.targetArea_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_responsivenessCode,
      { "responsivenessCode", "iicp.responsivenessCode",
        FT_INT32, BASE_DEC, VALS(iicp_T_responsivenessCode_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_responsivenessValue,
      { "responsivenessValue", "iicp.responsivenessValue",
        FT_STRING, BASE_NONE, NULL, 0,
        "UTCTime", HFILL }},
    { &hf_iicp_meansOfTransportation,
      { "meansOfTransportation", "iicp.meansOfTransportation",
        FT_BYTES, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_speed,
      { "speed", "iicp.speed",
        FT_INT32, BASE_DEC, VALS(iicp_T_speed_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_speedValue,
      { "speedValue", "iicp.speedValue_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "EXTERNAL", HFILL }},
    { &hf_iicp_serviceAreaCode,
      { "serviceAreaCode", "iicp.serviceAreaCode",
        FT_INT32, BASE_DEC, VALS(iicp_T_serviceAreaCode_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_serviceAreaValue,
      { "serviceAreaValue", "iicp.serviceAreaValue_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "EXTERNAL", HFILL }},
    { &hf_iicp_serviceTimeCode,
      { "serviceTimeCode", "iicp.serviceTimeCode",
        FT_INT32, BASE_DEC, VALS(iicp_T_serviceTimeCode_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_serviceTimeValue,
      { "serviceTimeValue", "iicp.serviceTimeValue_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "EXTERNAL", HFILL }},
    { &hf_iicp_capacityOfTransmissionValue,
      { "capacityOfTransmissionValue", "iicp.capacityOfTransmissionValue",
        FT_INT32, BASE_DEC, NULL, 0,
        "INTEGER", HFILL }},
    { &hf_iicp_dataExpressionCode,
      { "dataExpressionCode", "iicp.dataExpressionCode",
        FT_BYTES, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_maximumCostRequirement,
      { "maximumCostRequirement", "iicp.maximumCostRequirement",
        FT_INT32, BASE_DEC, VALS(iicp_T_maximumCostRequirement_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_maximumCostValue,
      { "maximumCostValue", "iicp.maximumCostValue_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "EXTERNAL", HFILL }},
    { &hf_iicp_validTimeCode,
      { "validTimeCode", "iicp.validTimeCode",
        FT_INT32, BASE_DEC, VALS(iicp_T_validTimeCode_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_validTimeValue,
      { "validTimeValue", "iicp.validTimeValue_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "EXTERNAL", HFILL }},
    { &hf_iicp_targetAreaCode,
      { "targetAreaCode", "iicp.targetAreaCode",
        FT_INT32, BASE_DEC, VALS(iicp_T_targetAreaCode_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_targetAreaValue,
      { "targetAreaValue", "iicp.targetAreaValue_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "EXTERNAL", HFILL }},
    { &hf_iicp_sourceITS_scuId,
      { "sourceITS-scuId", "iicp.sourceITS_scuId",
        FT_UINT32, BASE_DEC, NULL, 0,
        "ITS_scuId", HFILL }},
    { &hf_iicp_destinationITS_scuId,
      { "destinationITS-scuId", "iicp.destinationITS_scuId",
        FT_UINT32, BASE_DEC, NULL, 0,
        "ITS_scuId", HFILL }},
    { &hf_iicp_pduCounter,
      { "pduCounter", "iicp.pduCounter",
        FT_UINT32, BASE_DEC, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_pduRequest,
      { "pduRequest", "iicp.pduRequest_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "IICPpdu", HFILL }},
    { &hf_iicp_secRq,
      { "secRq", "iicp.secRq",
        FT_BYTES, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_pduRef,
      { "pduRef", "iicp.pduRef",
        FT_UINT32, BASE_DEC, VALS(iicp_RefIICP_vals), 0,
        "RefIICP", HFILL }},
    { &hf_iicp_iicpPDU,
      { "iicpPDU", "iicp.iicpPDU_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_iicpReqRef,
      { "iicpReqRef", "iicp.iicpReqRef",
        FT_UINT32, BASE_DEC, VALS(iicp_RefIICPReq_vals), 0,
        "RefIICPReq", HFILL }},
    { &hf_iicp_iicpReq,
      { "iicpReq", "iicp.iicpReq_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_message,
      { "message", "iicp.message",
        FT_UINT32, BASE_DEC, VALS(iicp_AliveMessage_vals), 0,
        "AliveMessage", HFILL }},
    { &hf_iicp_mCmdRef,
      { "mCmdRef", "iicp.mCmdRef",
        FT_UINT32, BASE_DEC, VALS(iicp_RefMcmdRq_vals), 0,
        "RefMcmdRq", HFILL }},
    { &hf_iicp_mcmd,
      { "mcmd", "iicp.mcmd_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_ciaClass,
      { "ciaClass", "iicp.ciaClass",
        FT_UINT32, BASE_DEC, VALS(iicp_CIaClass_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_ciClass,
      { "ciClass", "iicp.ciClass",
        FT_UINT32, BASE_DEC, VALS(iicp_CIclass_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_VCI_update_req_item,
      { "VCI-Info", "iicp.VCI_Info_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_action,
      { "action", "iicp.action",
        FT_UINT32, BASE_DEC, VALS(iicp_T_action_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_mfRcmd,
      { "mfRcmd", "iicp.mfRcmd_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_mnRcmd,
      { "mnRcmd", "iicp.mnRcmd_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_miRcmd,
      { "miRcmd", "iicp.miRcmd_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_destination,
      { "destination", "iicp.destination",
        FT_UINT32, BASE_DEC, NULL, 0,
        "ITS_scuId", HFILL }},
    { &hf_iicp_cmd,
      { "cmd", "iicp.cmd_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "MF_Command_request", HFILL }},
    { &hf_iicp_cmd_01,
      { "cmd", "iicp.cmd_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "MN_Command_request", HFILL }},
    { &hf_iicp_location,
      { "location", "iicp.location",
        FT_BYTES, BASE_NONE, NULL, 0,
        "BIT_STRING_SIZE_6", HFILL }},
    { &hf_iicp_lowerLayers,
      { "lowerLayers", "iicp.lowerLayers",
        FT_BYTES, BASE_NONE, NULL, 0,
        "BIT_STRING_SIZE_1", HFILL }},
    { &hf_iicp_testMode,
      { "testMode", "iicp.testMode",
        FT_BYTES, BASE_NONE, NULL, 0,
        "BIT_STRING_SIZE_1", HFILL }},
    { &hf_iicp_pduResponse,
      { "pduResponse", "iicp.pduResponse_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_iICPpdu,
      { "iICPpdu", "iicp.iICPpdu_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_errorStatus,
      { "errorStatus", "iicp.errorStatus",
        FT_UINT32, BASE_DEC, VALS(iicp_PduErrStatus_vals), 0,
        NULL, HFILL }},
    { &hf_iicp_secRs,
      { "secRs", "iicp.secRs",
        FT_BYTES, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_iicpResRef,
      { "iicpResRef", "iicp.iicpResRef",
        FT_UINT32, BASE_DEC, VALS(iicp_RefIICPResp_vals), 0,
        "RefIICPResp", HFILL }},
    { &hf_iicp_iicpRes,
      { "iicpRes", "iicp.iicpRes_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_mCmdRef_01,
      { "mCmdRef", "iicp.mCmdRef",
        FT_UINT32, BASE_DEC, VALS(iicp_RefMcmdRs_vals), 0,
        "RefMcmdRs", HFILL }},
    { &hf_iicp_mcmd_01,
      { "mcmd", "iicp.mcmd_element",
        FT_NONE, BASE_NONE, NULL, 0,
        "T_mcmd_01", HFILL }},
    { &hf_iicp_VCI_info_res_item,
      { "VCI-Info", "iicp.VCI_Info_element",
        FT_NONE, BASE_NONE, NULL, 0,
        NULL, HFILL }},
    { &hf_iicp_Security_userAuthentication,
      { "userAuthentication", "iicp.userAuthentication",
        FT_BOOLEAN, 8, NULL, 0x80,
        NULL, HFILL }},
    { &hf_iicp_Security_terminalAuthentication,
      { "terminalAuthentication", "iicp.terminalAuthentication",
        FT_BOOLEAN, 8, NULL, 0x40,
        NULL, HFILL }},
    { &hf_iicp_Security_dataAuthentication,
      { "dataAuthentication", "iicp.dataAuthentication",
        FT_BOOLEAN, 8, NULL, 0x20,
        NULL, HFILL }},
    { &hf_iicp_Security_consealment,
      { "consealment", "iicp.consealment",
        FT_BOOLEAN, 8, NULL, 0x10,
        NULL, HFILL }},
    { &hf_iicp_T_meansOfTransportation_undefined,
      { "undefined", "iicp.undefined",
        FT_BOOLEAN, 8, NULL, 0x80,
        NULL, HFILL }},
    { &hf_iicp_T_meansOfTransportation_vehicle,
      { "vehicle", "iicp.vehicle",
        FT_BOOLEAN, 8, NULL, 0x40,
        NULL, HFILL }},
    { &hf_iicp_T_meansOfTransportation_publicTransport,
      { "publicTransport", "iicp.publicTransport",
        FT_BOOLEAN, 8, NULL, 0x20,
        NULL, HFILL }},
    { &hf_iicp_T_meansOfTransportation_foot,
      { "foot", "iicp.foot",
        FT_BOOLEAN, 8, NULL, 0x10,
        NULL, HFILL }},
    { &hf_iicp_T_meansOfTransportation_bicycle,
      { "bicycle", "iicp.bicycle",
        FT_BOOLEAN, 8, NULL, 0x08,
        NULL, HFILL }},
    { &hf_iicp_T_meansOfTransportation_motorCycle,
      { "motorCycle", "iicp.motorCycle",
        FT_BOOLEAN, 8, NULL, 0x04,
        NULL, HFILL }},
    { &hf_iicp_T_meansOfTransportation_moped,
      { "moped", "iicp.moped",
        FT_BOOLEAN, 8, NULL, 0x02,
        NULL, HFILL }},
    { &hf_iicp_T_meansOfTransportation_car,
      { "car", "iicp.car",
        FT_BOOLEAN, 8, NULL, 0x01,
        NULL, HFILL }},
    { &hf_iicp_T_meansOfTransportation_truck,
      { "truck", "iicp.truck",
        FT_BOOLEAN, 8, NULL, 0x80,
        NULL, HFILL }},
    { &hf_iicp_T_meansOfTransportation_emergencyVehicle,
      { "emergencyVehicle", "iicp.emergencyVehicle",
        FT_BOOLEAN, 8, NULL, 0x40,
        NULL, HFILL }},
    { &hf_iicp_T_meansOfTransportation_buss,
      { "buss", "iicp.buss",
        FT_BOOLEAN, 8, NULL, 0x20,
        NULL, HFILL }},
    { &hf_iicp_T_meansOfTransportation_tram,
      { "tram", "iicp.tram",
        FT_BOOLEAN, 8, NULL, 0x10,
        NULL, HFILL }},
    { &hf_iicp_T_meansOfTransportation_train,
      { "train", "iicp.train",
        FT_BOOLEAN, 8, NULL, 0x08,
        NULL, HFILL }},
    { &hf_iicp_T_meansOfTransportation_ferry,
      { "ferry", "iicp.ferry",
        FT_BOOLEAN, 8, NULL, 0x04,
        NULL, HFILL }},
    { &hf_iicp_T_meansOfTransportation_taxi,
      { "taxi", "iicp.taxi",
        FT_BOOLEAN, 8, NULL, 0x02,
        NULL, HFILL }},
    { &hf_iicp_T_meansOfTransportation_other,
      { "other", "iicp.other",
        FT_BOOLEAN, 8, NULL, 0x01,
        NULL, HFILL }},
    { &hf_iicp_T_dataExpressionCode_undefined,
      { "undefined", "iicp.undefined",
        FT_BOOLEAN, 8, NULL, 0x80,
        NULL, HFILL }},
    { &hf_iicp_T_dataExpressionCode_text,
      { "text", "iicp.text",
        FT_BOOLEAN, 8, NULL, 0x40,
        NULL, HFILL }},
    { &hf_iicp_T_dataExpressionCode_audio,
      { "audio", "iicp.audio",
        FT_BOOLEAN, 8, NULL, 0x20,
        NULL, HFILL }},
    { &hf_iicp_T_dataExpressionCode_simpleGraphic,
      { "simpleGraphic", "iicp.simpleGraphic",
        FT_BOOLEAN, 8, NULL, 0x10,
        NULL, HFILL }},
    { &hf_iicp_T_dataExpressionCode_stillImage,
      { "stillImage", "iicp.stillImage",
        FT_BOOLEAN, 8, NULL, 0x08,
        NULL, HFILL }},
    { &hf_iicp_T_dataExpressionCode_video,
      { "video", "iicp.video",
        FT_BOOLEAN, 8, NULL, 0x04,
        NULL, HFILL }},
    { &hf_iicp_T_dataExpressionCode_other,
      { "other", "iicp.other",
        FT_BOOLEAN, 8, NULL, 0x02,
        NULL, HFILL }},

/*--- End of included file: packet-iicp-hfarr.c ---*/
#line 320 "../../asn1/calm-iicp/packet-iicp-template.c"
  };

  /* List of subtrees */
  static gint *ett[] = {
                  &ett_iicp,

/*--- Included file: packet-iicp-ettarr.c ---*/
#line 1 "../../asn1/calm-iicp/packet-iicp-ettarr.c"
    &ett_iicp_DeleteIPv6,
    &ett_iicp_DeleteNotIPv6,
    &ett_iicp_SetConfIPv6,
    &ett_iicp_SetIPv6,
    &ett_iicp_SetNotIPv6,
    &ett_iicp_UpdateIPv6,
    &ett_iicp_UpdateNotIPv6,
    &ett_iicp_ApplicationID,
    &ett_iicp_CrCiPrioList,
    &ett_iicp_CrCiPrioReq,
    &ett_iicp_SEQUENCE_OF_CCPpotInt,
    &ett_iicp_CCPrequest,
    &ett_iicp_CCPrequest_item,
    &ett_iicp_CCPpotInt,
    &ett_iicp_ITS_scuList,
    &ett_iicp_ITS_SSI,
    &ett_iicp_Param24102,
    &ett_iicp_VciList,
    &ett_iicp_VciListEntry,
    &ett_iicp_VCIperformList,
    &ett_iicp_VCIperformance,
    &ett_iicp_Link_ID,
    &ett_iicp_CommProfile,
    &ett_iicp_DataRatesNW,
    &ett_iicp_Directivity,
    &ett_iicp_SEQUENCE_SIZE_0_1_OF_DirVar,
    &ett_iicp_DirVar,
    &ett_iicp_Errors,
    &ett_iicp_SingleError,
    &ett_iicp_KineVectIn,
    &ett_iicp_KineVectOut,
    &ett_iicp_SEQUENCE_SIZE_0_5_OF_KineVectOptions,
    &ett_iicp_KineVectOptions,
    &ett_iicp_LLserviceAddr,
    &ett_iicp_MediumUsage,
    &ett_iicp_MedUseObsTime,
    &ett_iicp_Notify,
    &ett_iicp_I_Parameter,
    &ett_iicp_LogicalChannels,
    &ett_iicp_Properties,
    &ett_iicp_ProviderInfo,
    &ett_iicp_QueueLevel,
    &ett_iicp_RegInfo,
    &ett_iicp_RegulatoryScheme,
    &ett_iicp_VirtualCIs,
    &ett_iicp_INsapPrimitivesDown,
    &ett_iicp_IN_UNITDATA_request,
    &ett_iicp_IN_DATA_ACK_request,
    &ett_iicp_IN_REPLY_ACK_request,
    &ett_iicp_IN_REPLY_UPDATE_request,
    &ett_iicp_INsapPrimitivesUp,
    &ett_iicp_IN_UNITDATA_indication,
    &ett_iicp_IN_UNITDATA_STATUS_indication,
    &ett_iicp_IN_DATA_ACK_indication,
    &ett_iicp_IN_DATA_ACK_STATUS_indication,
    &ett_iicp_IN_REPLY_indication,
    &ett_iicp_IN_REPLY_STATUS_indication,
    &ett_iicp_IN_REPLY_UPDATE_STATUS_indication,
    &ett_iicp_AccessParameters,
    &ett_iicp_LegacyCIID,
    &ett_iicp_EUI64MAC48,
    &ett_iicp_MACoui,
    &ett_iicp_MACmcID,
    &ett_iicp_FAsapPrimitivesDown,
    &ett_iicp_FAsapPrimitivesUp,
    &ett_iicp_MF_Command_request,
    &ett_iicp_LDMnotify,
    &ett_iicp_RadarView,
    &ett_iicp_LegacyCIreq,
    &ett_iicp_StateCInotify,
    &ett_iicp_MF_Command_confirm,
    &ett_iicp_MF_Request_request,
    &ett_iicp_LDMregister,
    &ett_iicp_TestMFecho,
    &ett_iicp_MF_Request_confirm,
    &ett_iicp_MN_Command_request,
    &ett_iicp_FWTset,
    &ett_iicp_FWTupdate,
    &ett_iicp_FWTdelete,
    &ett_iicp_MN_Command_confirm,
    &ett_iicp_FWTsetConf,
    &ett_iicp_FWTupdateConf,
    &ett_iicp_FWTdeleteConf,
    &ett_iicp_MN_Request_request,
    &ett_iicp_FWTsetNot,
    &ett_iicp_FWTupdateNot,
    &ett_iicp_FWTdeleteNot,
    &ett_iicp_VCIcreatePeerMAC,
    &ett_iicp_Its_ssiPeerNot,
    &ett_iicp_TestMNecho,
    &ett_iicp_MN_Request_confirm,
    &ett_iicp_VCIPeerMAC,
    &ett_iicp_MI_Command_request,
    &ett_iicp_RegCmd,
    &ett_iicp_RTScmd,
    &ett_iicp_ReqID,
    &ett_iicp_RTSackCmd,
    &ett_iicp_RIcmd,
    &ett_iicp_VciCmd,
    &ett_iicp_VciCmd_item,
    &ett_iicp_Monitor,
    &ett_iicp_Monitor_item,
    &ett_iicp_UnitData,
    &ett_iicp_MI_Command_confirm,
    &ett_iicp_MI_Request_request,
    &ett_iicp_RegReq,
    &ett_iicp_PrioReg,
    &ett_iicp_Interferers,
    &ett_iicp_RTSreq,
    &ett_iicp_RTSackReq,
    &ett_iicp_RIreq,
    &ett_iicp_Events21218,
    &ett_iicp_E21218_0,
    &ett_iicp_TestMIecho,
    &ett_iicp_MI_Request_confirm,
    &ett_iicp_MI_Set_request,
    &ett_iicp_SEQUENCE_OF_I_Parameter,
    &ett_iicp_MI_Set_confirm,
    &ett_iicp_SEQUENCE_OF_Errors,
    &ett_iicp_MI_Get_request,
    &ett_iicp_SEQUENCE_OF_I_ParamNo,
    &ett_iicp_MI_Get_confirm,
    &ett_iicp_MS_Command_request,
    &ett_iicp_MS_Command_confirm,
    &ett_iicp_MS_Request_request,
    &ett_iicp_TestMSecho,
    &ett_iicp_MS_Request_confirm,
    &ett_iicp_MA_Command_request,
    &ett_iicp_MA_Command_confirm,
    &ett_iicp_MA_Request_request,
    &ett_iicp_TestMAecho,
    &ett_iicp_MA_Request_confirm,
    &ett_iicp_FNTPNPDU,
    &ett_iicp_FNTPHeader,
    &ett_iicp_FntpOptions,
    &ett_iicp_FNTPintForwarding,
    &ett_iicp_FNTPCIPheader,
    &ett_iicp_DeleteFNTP,
    &ett_iicp_DeleteNotFNTP,
    &ett_iicp_SetFNTP,
    &ett_iicp_SetConfFNTP,
    &ett_iicp_HostServiceInfo,
    &ett_iicp_SetNotFNTP,
    &ett_iicp_UpdateFNTP,
    &ett_iicp_UpdateNotFNTP,
    &ett_iicp_NFsapPrimitivesDown,
    &ett_iicp_NFsapPrimitivesUp,
    &ett_iicp_NFfntpPortRequest,
    &ett_iicp_NFfntpPortConfirm,
    &ett_iicp_NFfntpCommRequest,
    &ett_iicp_NFfntpCommConfirm,
    &ett_iicp_NFfntpCommIndication,
    &ett_iicp_PortNumber,
    &ett_iicp_SAM,
    &ett_iicp_ServiceList,
    &ett_iicp_ChannelList,
    &ett_iicp_IpServList,
    &ett_iicp_NonipService,
    &ett_iicp_SessionChannel,
    &ett_iicp_IpService,
    &ett_iicp_CTX,
    &ett_iicp_ServContextList,
    &ett_iicp_IpContextList,
    &ett_iicp_IpContext,
    &ett_iicp_GCctxTxCmd,
    &ett_iicp_GCperiodCmd,
    &ett_iicp_SEQUENCE_SIZE_1_256_OF_LLserviceAddr,
    &ett_iicp_GCsamctx,
    &ett_iicp_GCsamctxConf,
    &ett_iicp_GCdeleteCmd,
    &ett_iicp_ServiceInfo,
    &ett_iicp_T_info,
    &ett_iicp_NonipSAMctx,
    &ett_iicp_IpSAMctx,
    &ett_iicp_CTXrxNot,
    &ett_iicp_SAMrxNot,
    &ett_iicp_GCsam,
    &ett_iicp_SAMserviceData,
    &ett_iicp_T_servData,
    &ett_iicp_NonipSAM,
    &ett_iicp_IpSAM,
    &ett_iicp_GCctx,
    &ett_iicp_CTXserviceData,
    &ett_iicp_T_servData_01,
    &ett_iicp_NonipContext,
    &ett_iicp_GCregServer,
    &ett_iicp_GCupdateServer,
    &ett_iicp_SEQUENCE_SIZE_0_1_OF_ServiceDataReg,
    &ett_iicp_GCderegServer,
    &ett_iicp_GCregClient,
    &ett_iicp_GCupdateClient,
    &ett_iicp_GCderegClient,
    &ett_iicp_GCregServerConf,
    &ett_iicp_GCupdateServerConf,
    &ett_iicp_GCderegServerConf,
    &ett_iicp_GCregClientConf,
    &ett_iicp_GCupdateClientConf,
    &ett_iicp_GCderegClientConf,
    &ett_iicp_GCschedule,
    &ett_iicp_GCsched,
    &ett_iicp_ServiceDataReg,
    &ett_iicp_T_datareg,
    &ett_iicp_NonipServiceReg,
    &ett_iicp_IpServiceReg,
    &ett_iicp_IpInfo,
    &ett_iicp_IpAddressInfo,
    &ett_iicp_Param15628,
    &ett_iicp_T_params,
    &ett_iicp_ITSapObRegistry,
    &ett_iicp_ITSapOb,
    &ett_iicp_ITSapObPorts,
    &ett_iicp_ITSapObPorts_item,
    &ett_iicp_SEQUENCE_OF_ITSapObPort,
    &ett_iicp_ITSapObPort,
    &ett_iicp_ITSapObPortRule,
    &ett_iicp_LogicalChannelPrio,
    &ett_iicp_ITSObOwner,
    &ett_iicp_ITSapObCertificate,
    &ett_iicp_IssuingSA,
    &ett_iicp_CertStartDate,
    &ett_iicp_T_csd,
    &ett_iicp_CertEndDate,
    &ett_iicp_T_ced,
    &ett_iicp_CertStatus,
    &ett_iicp_T_cs,
    &ett_iicp_CertBlocked,
    &ett_iicp_ITSmsgSetRegistry,
    &ett_iicp_ITSmsgSet,
    &ett_iicp_ITSregRegionRegistry,
    &ett_iicp_ITSregRegion,
    &ett_iicp_ITS_RegPolicyAuthority,
    &ett_iicp_ITS_RParea,
    &ett_iicp_GeoPolygon,
    &ett_iicp_GeoCoordinates,
    &ett_iicp_ITSpolRegionRegistry,
    &ett_iicp_ITSpolRegion,
    &ett_iicp_ITSportNumberRegistry,
    &ett_iicp_ITSportNumber,
    &ett_iicp_ItsAppInfo,
    &ett_iicp_NTprotocol,
    &ett_iicp_ProtocolReference,
    &ett_iicp_ITSflowTypeRegistry,
    &ett_iicp_ITSflowType,
    &ett_iicp_ITSlchRegistry,
    &ett_iicp_ITSlch,
    &ett_iicp_ITSsuRegistry,
    &ett_iicp_ITSsu,
    &ett_iicp_ITSscuRegistry,
    &ett_iicp_ITSscu,
    &ett_iicp_ITSSappRegistry,
    &ett_iicp_ITSSapPrPr,
    &ett_iicp_RegEntryOwner,
    &ett_iicp_ITSemRegistry,
    &ett_iicp_ITSem,
    &ett_iicp_ITSaooRegistry,
    &ett_iicp_ITSaoo,
    &ett_iicp_Registry,
    &ett_iicp_ITSmso,
    &ett_iicp_ITSSapdRegistry,
    &ett_iicp_ITSSapd,
    &ett_iicp_ITSsuID,
    &ett_iicp_ITSscuID,
    &ett_iicp_VarLengthNumber,
    &ett_iicp_Ext1,
    &ett_iicp_Ext2,
    &ett_iicp_VarLengthNumber2,
    &ett_iicp_ITSSappCPReqReg,
    &ett_iicp_ITSSappRxTxPort,
    &ett_iicp_ServiceRef,
    &ett_iicp_ITSSappCPReqConf,
    &ett_iicp_ITSSappReq,
    &ett_iicp_ITSSappReq_item,
    &ett_iicp_ITSSappReqConf,
    &ett_iicp_ITSSappReqConf_item,
    &ett_iicp_ITSSappCPFinal,
    &ett_iicp_DestinationType,
    &ett_iicp_DestType,
    &ett_iicp_AddressBasedType,
    &ett_iicp_SEQUENCE_SIZE_0_255_OF_MCgroup,
    &ett_iicp_GeoLocationBasedType,
    &ett_iicp_ContConnect,
    &ett_iicp_TimDurationValue,
    &ett_iicp_NxRepeat,
    &ett_iicp_CommDistance,
    &ett_iicp_MultiHop,
    &ett_iicp_MinThP,
    &ett_iicp_MaxLat,
    &ett_iicp_Policies,
    &ett_iicp_Policies_item,
    &ett_iicp_MediumCost,
    &ett_iicp_CostAmount,
    &ett_iicp_CostValue,
    &ett_iicp_CostTimeUnit,
    &ett_iicp_ITS_S_Appl_Reg,
    &ett_iicp_ITS_S_Appl_RegConf,
    &ett_iicp_ProtocolManagementInformation,
    &ett_iicp_SelectionOfCommunicationSystem,
    &ett_iicp_ApplicationIdentifiers,
    &ett_iicp_Address,
    &ett_iicp_Priority,
    &ett_iicp_Security,
    &ett_iicp_ApplicationExecution,
    &ett_iicp_Responsiveness,
    &ett_iicp_UsageEnvironment,
    &ett_iicp_T_meansOfTransportation,
    &ett_iicp_ServiceArea,
    &ett_iicp_ServiceTime,
    &ett_iicp_Bandwidth,
    &ett_iicp_T_dataExpressionCode,
    &ett_iicp_ConnectionCost,
    &ett_iicp_ValidTime,
    &ett_iicp_TargetArea,
    &ett_iicp_IIC_Request,
    &ett_iicp_IICPpdu,
    &ett_iicp_IICPrequest,
    &ett_iicp_ITS_SCUalive,
    &ett_iicp_McmdRq,
    &ett_iicp_VCI_info_req,
    &ett_iicp_VCI_update_req,
    &ett_iicp_VCI_Info,
    &ett_iicp_TestIicp,
    &ett_iicp_T_action,
    &ett_iicp_MFrcmd,
    &ett_iicp_MNrcmd,
    &ett_iicp_MIrcmd,
    &ett_iicp_TestConfigIICP,
    &ett_iicp_IIC_Response,
    &ett_iicp_T_pduResponse,
    &ett_iicp_IICPresponse,
    &ett_iicp_McmdRs,
    &ett_iicp_VCI_info_res,

/*--- End of included file: packet-iicp-ettarr.c ---*/
#line 326 "../../asn1/calm-iicp/packet-iicp-template.c"
  };

  /* Register protocol */
  proto_iicp = proto_register_protocol(PNAME, PSNAME, PFNAME);
  /* Register dissector */
  register_dissector(PFNAME, dissect_iicp, proto_iicp);
  /* Register fields and subtrees */
  proto_register_field_array(proto_iicp, hf, array_length(hf));
  proto_register_subtree_array(ett, array_length(ett));
  /* Register CLASS dissector tables */
  iicp_pdu_type_dissector_table = register_dissector_table("iicp.proto", PNAME, FT_UINT32, BASE_DEC);

  iicp_pdu_request_dissector_table = register_dissector_table("iicp.req", "IICPpdu request", FT_UINT32, BASE_DEC);
  iicp_pdu_response_dissector_table = register_dissector_table("iicp.resp", "IICPpdu response", FT_UINT32, BASE_DEC);

  iicp_mcmdrq_dissector_table = register_dissector_table("iicp.mcmdrq", "MCMDRQ", FT_UINT32, BASE_DEC);
  iicp_mcmdrs_dissector_table = register_dissector_table("iicp.mcmdrs", "MCMDRS", FT_UINT32, BASE_DEC);

  msap_fa_sap_primitives_down_dissector_table = register_dissector_table("msap.commdown", "FA Sap Primitive Down", FT_UINT32, BASE_DEC);
  msap_fa_sap_primitives_up_dissector_table = register_dissector_table("msap.commup", "FA Sap Primitive Up", FT_UINT32, BASE_DEC);

  msap_mf_command_request_dissector_table = register_dissector_table("msap.mfcmdreq", "MF-Command-Req", FT_UINT32, BASE_DEC);
  msap_mf_command_confirm_dissector_table = register_dissector_table("msap.mfcmdconf", "MF-Command-Conf", FT_UINT32, BASE_DEC);

  msap_mf_request_request_dissector_table = register_dissector_table("msap.mfreqreq", "MF-Request-Req", FT_UINT32, BASE_DEC);
  msap_mf_request_confirm_dissector_table = register_dissector_table("msap.mfreqconf", "MF-Request-Conf", FT_UINT32, BASE_DEC);

  msap_mn_command_request_dissector_table = register_dissector_table("msap.mncmdreq", "MN-Command-Req", FT_UINT32, BASE_DEC);
  msap_mn_command_confirm_dissector_table = register_dissector_table("msap.mncmdconf", "MN-Command-Conf", FT_UINT32, BASE_DEC);

  msap_mn_request_request_dissector_table = register_dissector_table("msap.mnreqreq", "MN-Request-Req", FT_UINT32, BASE_DEC);
  msap_mn_request_confirm_dissector_table = register_dissector_table("msap.mnreqconf", "MF-Request-Conf", FT_UINT32, BASE_DEC);

  msap_fwt_dissector_table = register_dissector_table("msap.fwt", "FWT", FT_UINT32, BASE_DEC);
  msap_fwtnot_dissector_table = register_dissector_table("msap.fwtnot", "FWTNOT", FT_UINT32, BASE_DEC);

  fntp_nf_sap_primitives_down_dissector_table = register_dissector_table("fntp.nfsapdown", "NF Sap Primitive Down", FT_UINT32, BASE_DEC);
  fntp_nf_sap_primitives_up_dissector_table = register_dissector_table("fntp.nfsapup", "NF Sap Primitive Up", FT_UINT32, BASE_DEC);

  llsap_in_sap_primitives_down_dissector_table = register_dissector_table("llsap.insapdown", "IN Sap Primitive Down", FT_UINT32, BASE_DEC);
  llsap_in_sap_primitives_up_dissector_table = register_dissector_table("llsap.insapup", "IN Sap Primitive Up", FT_UINT32, BASE_DEC);

  llsap_acc_params_dissector_table = register_dissector_table("llsap.accparams", "Access Parameters", FT_UINT32, BASE_DEC);

  iicp_module = prefs_register_protocol(proto_iicp, proto_reg_handoff_iicp);

  prefs_register_uint_preference(iicp_module, "udp.port", "IICP UDP Port", "Set the default port for IICP messages (Default of 1200)", 10, &global_iicp_port);

}


/*--- proto_reg_handoff_iicp ---------------------------------------*/
void
proto_reg_handoff_iicp(void)
{
  static gboolean inited = FALSE;

  if( !inited ) {
    iicp_handle = create_dissector_handle(dissect_iicp, proto_iicp);
    inited = TRUE;

/*--- Included file: packet-iicp-dis-tab.c ---*/
#line 1 "../../asn1/calm-iicp/packet-iicp-dis-tab.c"
  dissector_add_uint("iicp.proto", iicp_Request, new_create_dissector_handle(dissect_IICPrequest_PDU, proto_iicp));
  dissector_add_uint("iicp.proto", iicp_Response, new_create_dissector_handle(dissect_IICPresponse_PDU, proto_iicp));
  dissector_add_uint("iicp.req", iicp_aliveRq, new_create_dissector_handle(dissect_ITS_SCUalive_PDU, proto_iicp));
  dissector_add_uint("iicp.req", iicp_mfRcmdRq, new_create_dissector_handle(dissect_MF_Command_request_PDU, proto_iicp));
  dissector_add_uint("iicp.req", iicp_mfRreqRq, new_create_dissector_handle(dissect_MF_Request_request_PDU, proto_iicp));
  dissector_add_uint("iicp.req", iicp_mnRcmdRq, new_create_dissector_handle(dissect_MN_Command_request_PDU, proto_iicp));
  dissector_add_uint("iicp.req", iicp_mnRreqRq, new_create_dissector_handle(dissect_MN_Request_request_PDU, proto_iicp));
  dissector_add_uint("iicp.req", iicp_miRcmdRq, new_create_dissector_handle(dissect_MI_Command_request_PDU, proto_iicp));
  dissector_add_uint("iicp.req", iicp_miRreqRq, new_create_dissector_handle(dissect_MI_Request_request_PDU, proto_iicp));
  dissector_add_uint("iicp.req", iicp_miRgetRq, new_create_dissector_handle(dissect_MI_Get_request_PDU, proto_iicp));
  dissector_add_uint("iicp.req", iicp_miRsetRq, new_create_dissector_handle(dissect_MI_Set_request_PDU, proto_iicp));
  dissector_add_uint("iicp.req", iicp_mCmdRq, new_create_dissector_handle(dissect_McmdRq_PDU, proto_iicp));
  dissector_add_uint("iicp.req", iicp_simFutCmdRq, new_create_dissector_handle(dissect_SimFUTcmd_PDU, proto_iicp));
  dissector_add_uint("iicp.req", iicp_simFutReqRq, new_create_dissector_handle(dissect_SimFUTreq_PDU, proto_iicp));
  dissector_add_uint("iicp.req", iicp_simNutCmdRq, new_create_dissector_handle(dissect_SimNUTcmd_PDU, proto_iicp));
  dissector_add_uint("iicp.req", iicp_simNutReqRq, new_create_dissector_handle(dissect_SimNUTreq_PDU, proto_iicp));
  dissector_add_uint("iicp.req", iicp_simIutCmdRq, new_create_dissector_handle(dissect_SimIUTcmd_PDU, proto_iicp));
  dissector_add_uint("iicp.req", iicp_simIutReqRq, new_create_dissector_handle(dissect_SimIUTreq_PDU, proto_iicp));
  dissector_add_uint("iicp.req", iicp_simFltCmdRq, new_create_dissector_handle(dissect_SimFLTcmd_PDU, proto_iicp));
  dissector_add_uint("iicp.req", iicp_simFltReqRq, new_create_dissector_handle(dissect_SimFLTreq_PDU, proto_iicp));
  dissector_add_uint("iicp.req", iicp_simNltCmdRq, new_create_dissector_handle(dissect_SimNLTcmd_PDU, proto_iicp));
  dissector_add_uint("iicp.req", iicp_simNltReqRq, new_create_dissector_handle(dissect_SimNLTreq_PDU, proto_iicp));
  dissector_add_uint("iicp.resp", iicp_aliveRs, new_create_dissector_handle(dissect_ITS_SCUalive_PDU, proto_iicp));
  dissector_add_uint("iicp.resp", iicp_mfRcmdRs, new_create_dissector_handle(dissect_MF_Command_confirm_PDU, proto_iicp));
  dissector_add_uint("iicp.resp", iicp_mfRreqRs, new_create_dissector_handle(dissect_MF_Request_confirm_PDU, proto_iicp));
  dissector_add_uint("iicp.resp", iicp_mnRcmdRs, new_create_dissector_handle(dissect_MN_Command_confirm_PDU, proto_iicp));
  dissector_add_uint("iicp.resp", iicp_mnRreqRs, new_create_dissector_handle(dissect_MN_Request_confirm_PDU, proto_iicp));
  dissector_add_uint("iicp.resp", iicp_miRcmdRs, new_create_dissector_handle(dissect_MI_Command_confirm_PDU, proto_iicp));
  dissector_add_uint("iicp.resp", iicp_miRreqRs, new_create_dissector_handle(dissect_MI_Request_confirm_PDU, proto_iicp));
  dissector_add_uint("iicp.resp", iicp_miRgetRs, new_create_dissector_handle(dissect_MI_Get_confirm_PDU, proto_iicp));
  dissector_add_uint("iicp.resp", iicp_miRsetRs, new_create_dissector_handle(dissect_MI_Set_confirm_PDU, proto_iicp));
  dissector_add_uint("iicp.resp", iicp_mCmdRs, new_create_dissector_handle(dissect_McmdRs_PDU, proto_iicp));
  dissector_add_uint("iicp.mcmdrq", iicp_pingRq, new_create_dissector_handle(dissect_PingIICP_PDU, proto_iicp));
  dissector_add_uint("iicp.mcmdrq", iicp_vCIinfoRq, new_create_dissector_handle(dissect_VCI_info_req_PDU, proto_iicp));
  dissector_add_uint("iicp.mcmdrq", iicp_vCIupdateRq, new_create_dissector_handle(dissect_VCI_update_req_PDU, proto_iicp));
  dissector_add_uint("iicp.mcmdrq", iicp_getParam24102Rq, new_create_dissector_handle(dissect_Param24102No_PDU, proto_iicp));
  dissector_add_uint("iicp.mcmdrq", iicp_setParam24102Rq, new_create_dissector_handle(dissect_Param24102_PDU, proto_iicp));
  dissector_add_uint("iicp.mcmdrq", iicp_testIicpRq, new_create_dissector_handle(dissect_TestIicp_PDU, proto_iicp));
  dissector_add_uint("iicp.mcmdrq", iicp_testConfigRq, new_create_dissector_handle(dissect_TestConfigIICP_PDU, proto_iicp));
  dissector_add_uint("iicp.mcmdrs", iicp_pingRs, new_create_dissector_handle(dissect_PingIICP_PDU, proto_iicp));
  dissector_add_uint("iicp.mcmdrs", iicp_vCIinfoRs, new_create_dissector_handle(dissect_VCI_info_res_PDU, proto_iicp));
  dissector_add_uint("iicp.mcmdrs", iicp_getParam24102Rs, new_create_dissector_handle(dissect_Param24102No_PDU, proto_iicp));
  dissector_add_uint("iicp.mcmdrs", iicp_setParam24102Rs, new_create_dissector_handle(dissect_ErrStatus_PDU, proto_iicp));
  dissector_add_uint("msap.commdown", iicp_gCsamctxConfFA, new_create_dissector_handle(dissect_GCsamctxConf_PDU, proto_iicp));
  dissector_add_uint("msap.commdown", iicp_gCregServerFA, new_create_dissector_handle(dissect_GCregServer_PDU, proto_iicp));
  dissector_add_uint("msap.commdown", iicp_gCupdateServerFA, new_create_dissector_handle(dissect_GCupdateServer_PDU, proto_iicp));
  dissector_add_uint("msap.commdown", iicp_gCderegServerFA, new_create_dissector_handle(dissect_GCderegServer_PDU, proto_iicp));
  dissector_add_uint("msap.commdown", iicp_gCregClientFA, new_create_dissector_handle(dissect_GCregClient_PDU, proto_iicp));
  dissector_add_uint("msap.commdown", iicp_gCupdateClientFA, new_create_dissector_handle(dissect_GCupdateClient_PDU, proto_iicp));
  dissector_add_uint("msap.commdown", iicp_gCderegClientFA, new_create_dissector_handle(dissect_GCderegClient_PDU, proto_iicp));
  dissector_add_uint("msap.commup", iicp_gCsamctxFA, new_create_dissector_handle(dissect_GCsamctx_PDU, proto_iicp));
  dissector_add_uint("msap.commup", iicp_gCregServerConfFA, new_create_dissector_handle(dissect_GCregServerConf_PDU, proto_iicp));
  dissector_add_uint("msap.commup", iicp_gCupdateServerConfFA, new_create_dissector_handle(dissect_GCupdateServerConf_PDU, proto_iicp));
  dissector_add_uint("msap.commup", iicp_gCderegServerConfFA, new_create_dissector_handle(dissect_GCderegServerConf_PDU, proto_iicp));
  dissector_add_uint("msap.commup", iicp_gCregClientConfFA, new_create_dissector_handle(dissect_GCregClientConf_PDU, proto_iicp));
  dissector_add_uint("msap.commup", iicp_gCupdateClientConfFA, new_create_dissector_handle(dissect_GCupdateClientConf_PDU, proto_iicp));
  dissector_add_uint("msap.commup", iicp_gCderegClientConfFA, new_create_dissector_handle(dissect_GCderegClientConf_PDU, proto_iicp));
  dissector_add_uint("msap.commup", iicp_gCsamFA, new_create_dissector_handle(dissect_GCsam_PDU, proto_iicp));
  dissector_add_uint("msap.commup", iicp_gCctxFA, new_create_dissector_handle(dissect_GCctx_PDU, proto_iicp));
  dissector_add_uint("msap.mfcmdreq", iicp_simFUTcmd, new_create_dissector_handle(dissect_SimFUTcmd_PDU, proto_iicp));
  dissector_add_uint("msap.mfcmdreq", iicp_simFLTcmd, new_create_dissector_handle(dissect_SimFLTcmd_PDU, proto_iicp));
  dissector_add_uint("msap.mfcmdreq", iicp_gCsamctx, new_create_dissector_handle(dissect_GCsamctx_PDU, proto_iicp));
  dissector_add_uint("msap.mfcmdreq", iicp_gCsam, new_create_dissector_handle(dissect_GCsam_PDU, proto_iicp));
  dissector_add_uint("msap.mfcmdreq", iicp_gCctx, new_create_dissector_handle(dissect_GCctx_PDU, proto_iicp));
  dissector_add_uint("msap.mfcmdreq", iicp_lDMnotifyCmd, new_create_dissector_handle(dissect_LDMnotify_PDU, proto_iicp));
  dissector_add_uint("msap.mfcmdreq", iicp_legacyCICmd, new_create_dissector_handle(dissect_LegacyCIreq_PDU, proto_iicp));
  dissector_add_uint("msap.mfcmdreq", iicp_stateCInotify, new_create_dissector_handle(dissect_StateCInotify_PDU, proto_iicp));
  dissector_add_uint("msap.mfcmdreq", iicp_gCperiodCmd, new_create_dissector_handle(dissect_GCperiodCmd_PDU, proto_iicp));
  dissector_add_uint("msap.mfcmdreq", iicp_gCctxTxCmd, new_create_dissector_handle(dissect_GCctxTxCmd_PDU, proto_iicp));
  dissector_add_uint("msap.mfcmdreq", iicp_gCdeleteCmd, new_create_dissector_handle(dissect_GCdeleteCmd_PDU, proto_iicp));
  dissector_add_uint("msap.mfcmdreq", iicp_iICrequestTX, new_create_dissector_handle(dissect_IICrequestTX_PDU, proto_iicp));
  dissector_add_uint("msap.mfcmdreq", iicp_iICresponseTX, new_create_dissector_handle(dissect_IICresponseTX_PDU, proto_iicp));
  dissector_add_uint("msap.mfcmdreq", iicp_testMF, new_create_dissector_handle(dissect_TestMF_PDU, proto_iicp));
  dissector_add_uint("msap.mfcmdconf", iicp_gCsamctxConf, new_create_dissector_handle(dissect_GCsamctxConf_PDU, proto_iicp));
  dissector_add_uint("msap.mfcmdconf", iicp_legacyCIConf, new_create_dissector_handle(dissect_HostServiceInfo_PDU, proto_iicp));
  dissector_add_uint("msap.mfreqreq", iicp_simFUTreq, new_create_dissector_handle(dissect_SimFUTreq_PDU, proto_iicp));
  dissector_add_uint("msap.mfreqreq", iicp_simFLTreq, new_create_dissector_handle(dissect_SimFLTreq_PDU, proto_iicp));
  dissector_add_uint("msap.mfreqreq", iicp_iTS_S_Appl_Reg, new_create_dissector_handle(dissect_ITS_S_Appl_Reg_PDU, proto_iicp));
  dissector_add_uint("msap.mfreqreq", iicp_gCregServer, new_create_dissector_handle(dissect_GCregServer_PDU, proto_iicp));
  dissector_add_uint("msap.mfreqreq", iicp_gCupdateServer, new_create_dissector_handle(dissect_GCupdateServer_PDU, proto_iicp));
  dissector_add_uint("msap.mfreqreq", iicp_gCderegServer, new_create_dissector_handle(dissect_GCderegServer_PDU, proto_iicp));
  dissector_add_uint("msap.mfreqreq", iicp_gCregClient, new_create_dissector_handle(dissect_GCregClient_PDU, proto_iicp));
  dissector_add_uint("msap.mfreqreq", iicp_gCupdateClient, new_create_dissector_handle(dissect_GCupdateClient_PDU, proto_iicp));
  dissector_add_uint("msap.mfreqreq", iicp_gCderegClient, new_create_dissector_handle(dissect_GCderegClient_PDU, proto_iicp));
  dissector_add_uint("msap.mfreqreq", iicp_lDMregister, new_create_dissector_handle(dissect_LDMregister_PDU, proto_iicp));
  dissector_add_uint("msap.mfreqreq", iicp_sAMrxNot, new_create_dissector_handle(dissect_SAMrxNot_PDU, proto_iicp));
  dissector_add_uint("msap.mfreqreq", iicp_cTXrxNot, new_create_dissector_handle(dissect_CTXrxNot_PDU, proto_iicp));
  dissector_add_uint("msap.mfreqreq", iicp_iICrequestRX, new_create_dissector_handle(dissect_IICrequestRX_PDU, proto_iicp));
  dissector_add_uint("msap.mfreqreq", iicp_iICresponseRX, new_create_dissector_handle(dissect_IICresponseRX_PDU, proto_iicp));
  dissector_add_uint("msap.mfreqreq", iicp_testMFecho, new_create_dissector_handle(dissect_TestMFecho_PDU, proto_iicp));
  dissector_add_uint("msap.mfreqconf", iicp_gCregServerConf, new_create_dissector_handle(dissect_GCregServerConf_PDU, proto_iicp));
  dissector_add_uint("msap.mfreqconf", iicp_gCupdateServerConf, new_create_dissector_handle(dissect_GCupdateServerConf_PDU, proto_iicp));
  dissector_add_uint("msap.mfreqconf", iicp_gCderegServerConf, new_create_dissector_handle(dissect_GCderegServerConf_PDU, proto_iicp));
  dissector_add_uint("msap.mfreqconf", iicp_gCregClientConf, new_create_dissector_handle(dissect_GCregClientConf_PDU, proto_iicp));
  dissector_add_uint("msap.mfreqconf", iicp_gCupdateClientConf, new_create_dissector_handle(dissect_GCupdateClientConf_PDU, proto_iicp));
  dissector_add_uint("msap.mfreqconf", iicp_gCderegClientConf, new_create_dissector_handle(dissect_GCderegClientConf_PDU, proto_iicp));
  dissector_add_uint("msap.mfreqconf", iicp_lDMregisterConf, new_create_dissector_handle(dissect_ITS_scuId_PDU, proto_iicp));
  dissector_add_uint("msap.mncmdreq", iicp_simNUTcmd, new_create_dissector_handle(dissect_SimNUTcmd_PDU, proto_iicp));
  dissector_add_uint("msap.mncmdreq", iicp_simNLTcmd, new_create_dissector_handle(dissect_SimNLTcmd_PDU, proto_iicp));
  dissector_add_uint("msap.mncmdreq", iicp_fWTset, new_create_dissector_handle(dissect_FWTset_PDU, proto_iicp));
  dissector_add_uint("msap.mncmdreq", iicp_fWTupdate, new_create_dissector_handle(dissect_FWTupdate_PDU, proto_iicp));
  dissector_add_uint("msap.mncmdreq", iicp_fWTdelete, new_create_dissector_handle(dissect_FWTdelete_PDU, proto_iicp));
  dissector_add_uint("msap.mncmdreq", iicp_testMN, new_create_dissector_handle(dissect_TestMN_PDU, proto_iicp));
  dissector_add_uint("msap.mncmdconf", iicp_fWTsetConf, new_create_dissector_handle(dissect_FWTsetConf_PDU, proto_iicp));
  dissector_add_uint("msap.mncmdconf", iicp_fWTupdateConf, new_create_dissector_handle(dissect_FWTupdateConf_PDU, proto_iicp));
  dissector_add_uint("msap.mncmdconf", iicp_fWTdeletConf, new_create_dissector_handle(dissect_FWTdeleteConf_PDU, proto_iicp));
  dissector_add_uint("msap.mnreqreq", iicp_simNUTreq, new_create_dissector_handle(dissect_SimNUTreq_PDU, proto_iicp));
  dissector_add_uint("msap.mnreqreq", iicp_simNLTreq, new_create_dissector_handle(dissect_SimNLTreq_PDU, proto_iicp));
  dissector_add_uint("msap.mnreqreq", iicp_fWTsetNot, new_create_dissector_handle(dissect_FWTsetNot_PDU, proto_iicp));
  dissector_add_uint("msap.mnreqreq", iicp_fWTupdateNot, new_create_dissector_handle(dissect_FWTupdateNot_PDU, proto_iicp));
  dissector_add_uint("msap.mnreqreq", iicp_fWTdeleteNot, new_create_dissector_handle(dissect_FWTdeleteNot_PDU, proto_iicp));
  dissector_add_uint("msap.mnreqreq", iicp_vCIcreatePeerMAC, new_create_dissector_handle(dissect_VCIcreatePeerMAC_PDU, proto_iicp));
  dissector_add_uint("msap.mnreqreq", iicp_its_ssiPeerNot, new_create_dissector_handle(dissect_Its_ssiPeerNot_PDU, proto_iicp));
  dissector_add_uint("msap.mnreqreq", iicp_testMNecho, new_create_dissector_handle(dissect_TestMNecho_PDU, proto_iicp));
  dissector_add_uint("msap.mnreqconf", iicp_vCIcreatePeerMACConf, new_create_dissector_handle(dissect_VCIPeerMAC_PDU, proto_iicp));
  dissector_add_uint("msap.fwt", iicp_fntpSet, new_create_dissector_handle(dissect_SetFNTP_PDU, proto_iicp));
  dissector_add_uint("msap.fwt", iicp_fntpUpdate, new_create_dissector_handle(dissect_UpdateFNTP_PDU, proto_iicp));
  dissector_add_uint("msap.fwt", iicp_fntpDelete, new_create_dissector_handle(dissect_DeleteFNTP_PDU, proto_iicp));
  dissector_add_uint("msap.fwtnot", iicp_fntpSetNot, new_create_dissector_handle(dissect_SetNotFNTP_PDU, proto_iicp));
  dissector_add_uint("msap.fwtnot", iicp_fntpUpdateNot, new_create_dissector_handle(dissect_UpdateNotFNTP_PDU, proto_iicp));
  dissector_add_uint("msap.fwtnot", iicp_fntpDeleteNot, new_create_dissector_handle(dissect_DeleteNotFNTP_PDU, proto_iicp));
  dissector_add_uint("fntp.nfsapdown", iicp_fntpPortRequest, new_create_dissector_handle(dissect_NFfntpPortRequest_PDU, proto_iicp));
  dissector_add_uint("fntp.nfsapdown", iicp_fntpCommRequest, new_create_dissector_handle(dissect_NFfntpCommRequest_PDU, proto_iicp));
  dissector_add_uint("fntp.nfsapup", iicp_fntpPortConfirm, new_create_dissector_handle(dissect_NFfntpPortConfirm_PDU, proto_iicp));
  dissector_add_uint("fntp.nfsapup", iicp_fntpCommConfirm, new_create_dissector_handle(dissect_NFfntpCommConfirm_PDU, proto_iicp));
  dissector_add_uint("fntp.nfsapup", iicp_fntpCommIndication, new_create_dissector_handle(dissect_NFfntpCommIndication_PDU, proto_iicp));
  dissector_add_uint("llsap.insapdown", iicp_inUnitdataRq, new_create_dissector_handle(dissect_IN_UNITDATA_request_PDU, proto_iicp));
  dissector_add_uint("llsap.insapdown", iicp_inDataAckRq, new_create_dissector_handle(dissect_IN_DATA_ACK_request_PDU, proto_iicp));
  dissector_add_uint("llsap.insapdown", iicp_inReplyAckRq, new_create_dissector_handle(dissect_IN_REPLY_ACK_request_PDU, proto_iicp));
  dissector_add_uint("llsap.insapdown", iicp_inReplyUpdateRq, new_create_dissector_handle(dissect_IN_REPLY_UPDATE_request_PDU, proto_iicp));
  dissector_add_uint("llsap.insapup", iicp_fntpCommIndication, new_create_dissector_handle(dissect_IN_UNITDATA_indication_PDU, proto_iicp));
  dissector_add_uint("llsap.insapup", iicp_inUnitdataStatusInd, new_create_dissector_handle(dissect_IN_UNITDATA_STATUS_indication_PDU, proto_iicp));
  dissector_add_uint("llsap.insapup", iicp_inDataAckInd, new_create_dissector_handle(dissect_IN_DATA_ACK_indication_PDU, proto_iicp));
  dissector_add_uint("llsap.insapup", iicp_inDataAckStatusInd, new_create_dissector_handle(dissect_IN_DATA_ACK_STATUS_indication_PDU, proto_iicp));
  dissector_add_uint("llsap.insapup", iicp_inReplyInd, new_create_dissector_handle(dissect_IN_REPLY_indication_PDU, proto_iicp));
  dissector_add_uint("llsap.insapup", iicp_inReplyStatusInd, new_create_dissector_handle(dissect_IN_REPLY_STATUS_indication_PDU, proto_iicp));
  dissector_add_uint("llsap.insapup", iicp_inReplyUpdateStatusInd, new_create_dissector_handle(dissect_IN_REPLY_UPDATE_STATUS_indication_PDU, proto_iicp));
  dissector_add_uint("llsap.accparams", iicp_nullAP, new_create_dissector_handle(dissect_NullType_PDU, proto_iicp));


/*--- End of included file: packet-iicp-dis-tab.c ---*/
#line 387 "../../asn1/calm-iicp/packet-iicp-template.c"
  } else {
    dissector_delete_uint("udp.port", global_iicp_port, iicp_handle);
  }

  /* Set our port number for future use */
  dissector_add_uint("udp.port", global_iicp_port, iicp_handle);
}

///////////////////////////////////////////////////////////////////////////////
// Add not generated functions due to problem into CITSapplReq ASN.1 file

static int
dissect_CITSapplReq_ITSSappCPReqReg(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  return offset + 0;
}

static int
dissect_CITSapplReq_MediumCost(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  return offset + 0;
}

static int
dissect_CITSapplReq_ITSSappRxTxPortNo(tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  return offset + 0;
}
